var nightClass;
var fontClass;
function onNightModeSwitch(nightMode) { // 0 ：night 1：day
    var body = document.getElementById('bodyID');
    if (nightMode == '0' ) {
        nightClass = 'night';
    } else {
        nightClass = 'day';
    }
    body.className = fontClass + ' ' + nightClass;
}
function onFontSwitch(fontSize) {   // 0:small  1: big
    var body = document.getElementById('bodyID');
    if (fontSize == '0') {
        fontClass = 'font0';
    } else {
        fontClass = 'font1';
    }
    body.className = fontClass + ' ' + nightClass;
}
function onWebviewInit(nightMode, fontSize) { // 0 ：night 1：day // 0:small  1: big
    var body = document.getElementById('bodyID');
    if (nightMode == '0' ) {
        nightClass = 'night';
    } else {
        nightClass = 'day';
    }
    if (fontSize == '0') {
        fontClass = 'font0';
    } else {
        fontClass = 'font1';
    }
    body.className = nightClass + ' ' + fontClass;
}

/**
 * 设置关联股票
 * @param codesJasonStr 股票信息的jason字符串
 */
function setRelativeCode(codesJasonStr){
    var codes = null;
    try{
        codes = JSON.parse(codesJasonStr);
    }catch(e){
        codes = codesJasonStr;
    }
    
    if(codes || codes.length > 0){
        var container = document.getElementById('relativeContainer');
        container.style.display = "";
        var codeSpans = document.getElementById('codeSpans');
        var codesResultStr = "";
        for (var i = 0; i < codes.length; i++) {
            codesResultStr += '<span class="linkSpan" linkType="'+codes[i].linkType+'" stockId="'+codes[i].code+'" stockType="'+codes[i].type+'" onclick="onLinkSpanClick(this)" stockName="'+codes[i].name+'">'+codes[i].name+'</span>';
        };
        
        codeSpans.innerHTML = codesResultStr;
    }
}

/**
 * 设置pdf是否在正文标题部位显示
 */
function setPDF(isTop){
    if(isTop){
        var pfdTop = document.getElementById('pdfTop');
        pfdTop.style.display = "";
    }else{
        var pfdContent = document.getElementById('contentDiv');
        pfdContent.innerHTML = '<table class="pdfOnBody" onclick="openPDF()"><tbody><tr>'+
          '<td><img src="./news_pdf_icon@3x.png"/></td>'+
          '<td class="text">查看全文</td>'+
          '</tr></tbody></table>';
    }
}

/**
 * 打开PDF文件
 */
function openPDF(){
    KDS_Native.openPDF();
}   

//图片点击会触发
function onImageClick(target){
    var targetImgId = target.id;
    // 获取所有的Img元素
    var allImage = document.getElementsByTagName('img');
    allImage = Array.prototype.slice.call(allImage, 0);
    var urls = new Array();
    var index = -1;
    var x = 0;
    var y = 0;
    var width = 0;
    var height = 0;
    var href;
    var imgType;
    var offsetRatio = 0;
    var yRatio = 0;
    allImage.forEach(function(image) {
        var imgId = image.getAttribute("id");

        // 每次点击页面，遍历页面全部的 img 标签，毎遍历一个，就将这个加到数组中。
        //  找到时，这个数组长度 就是 img 的index
        imgType = image.getAttribute("linkType");
        var newLength = urls.length;
        if(imgType){
            newLength = urls.push(imgId);
        }

        //var picUrlstr = targetImgId.target.id;

        // 判断遍历的当前节点是否是目标元素
        if(imgId == targetImgId || imgId == decodeURIComponent(targetImgId)) {

            index = newLength-1; 
            if(image.parentNode.href){
                href = image.parentNode.href;
                image.setAttribute("source", href);
                image.parentNode.href="javascript:void(0)"; //阻止页面跳转或页面刷新
            }else{
                href = image.getAttribute("source");
            }
            x = image.getBoundingClientRect().left;
            y = image.getBoundingClientRect().top;
            x = x + document.documentElement.scrollLeft;
            y = y + document.documentElement.scrollTop;
            width = image.width;
            height = image.height;
            yRatio = y / window.innerHeight;
            offsetRatio = image.offsetTop / window.innerHeight;
        }
    });

    //四种关系图表之第2种
    // bridge.callHandler('imageDidClicked',
    //     {'index':index,'x':x,'y':y,'width':width,'height':height , 'linkType': imgType, 'href': href},
    //     function(response) {});

 	index = "" + index;
 	x = "" + x;
 	y = "" + y;
 	width = "" + width;
 	height = "" + height;
 	imgType = "" + imgType;
 	href = "" + href;
 	yRatio = "" + yRatio;
 	offsetRatio = "" + offsetRatio;
 
    var jsonObj = JSON.stringify({
      'index':index,
      'x':x,'y':y,
      'width':width,'height':height,
      'linkType': imgType,
      'href': href,
      'yRatio': yRatio,
      'offsetRatio' : offsetRatio
    });

    KDS_Native.imageDidClicked("",jsonObj);
}

//链接点击事件
function onLinkSpanClick(target){
    console.log("------------------------------------------"+target);
    var linkType = target.getAttribute("linkType")+"";
     var stockType = target.getAttribute("stockType");
    var linkUrl = target.getAttribute("linkUrl")+"";
    var parentNodeId = target.getAttribute("stockId") || (target.parentNode.id+"");
    var stockName = target.getAttribute("stockName");

    var jsonObj = JSON.stringify({
        'linkType': linkType,
        'stockType': stockType,
        'linkUrl': linkUrl,
        'stockId': parentNodeId,
        'stockName': stockName
    });

    KDS_Native.linkDidClicked("",jsonObj);
}

// message: replaceimage#01,http://www.baidu.com/ni/123.png
function updateImgSrc(message){
    if (message.match("replaceimage")) {
        //先截取图片id
        var index = message.indexOf(",")
        var messagereplace = message.substring(0, index)

        //截取到本地图片的路径
        var messagepath = message.substring(index + 1)
        messagereplace = messagereplace.replace(/replaceimage/, "")
        
        // 每个图片加了不同的 id
        element = document.getElementById(messagereplace)
        // 这里 判断下是否是 预处理过的 image。直接设置本地 image 给 html 页面
       // if (element.src.match("loading")) {
        
         console.log("messagereplacemessagereplace ="+messagereplace);
            element.src = messagepath
       // }
    }
}

//优化表格样式
function formatTable(){
    var oldTables = document.getElementsByTagName('table');// 获取table节点
    if(!oldTables ){
        return false;
    }
    
    for(var i = 0;i<oldTables.length;i++){
        var newDiv = document.createElement('div');// 创建新节点
        newDiv.id = 'divA' + i;
        newDiv.className = "table-container";
        var oldTable = oldTables[i];
        oldTable.parentNode.insertBefore(newDiv,oldTable.nextSibling); // 新节点加入到文档中，保证table在文档的原来位置上，不会跑到最后面去
        newDiv.appendChild(oldTable);
    }
    
    return true;
}

/**
 * 显示视频
 * @param {string} [imgSrc] [图片地址]
 * @param {string} [vedioSrc] [视频地址]
 * @param {string} [imgWidth] [图片宽度]
 * @param {string} [imgHeight] [图片高度]
 */
function showVedio(imgSrc, vedioSrc, imgWidth, imgHeight){
    var x = 0;
    var y = 0;
    var width = 0;
    var height = 0;
    var yRatio = 0;

    //./kds_news_empty_icon.png
    var vedioArea = document.getElementById("vedioArea");
    vedioArea.style.display = "block";

    var imgStart = document.getElementById("img_start");
    var imgThumb = document.getElementById("img_vedio_thumb");
    var contentDiv = document.getElementById("contentDiv");
    //contentDiv.style.marginTop = "-110px";

    imgThumb.src = imgSrc;
    var thumbHeight=100;

    if(imgHeight && imgWidth){
        imgHeight = parseFloat(imgHeight);
        imgWidth = parseFloat(imgWidth);
        thumbHeight = imgThumb.clientWidth / imgWidth * imgHeight;
        console.log(thumbHeight);
        imgThumb.style.height = thumbHeight + "px";
        vedioArea.style.height = thumbHeight + "px";
        imgStart.style.top = ((thumbHeight / 2 + imgStart.clientHeight / 2) * -1) + "px";
    }

    x = imgThumb.getBoundingClientRect().left;
    y = imgThumb.getBoundingClientRect().top;
    x = x + document.documentElement.scrollLeft;
    y = y + document.documentElement.scrollTop;
    width = imgThumb.width;
    height = thumbHeight;
    yRatio = y / window.innerHeight;

  	var clickFuntion = function(){
        //调用原生方法，传入视频地址，坐标，高宽，高与屏幕高度的比例值，打开视频

        var jsonObj = JSON.stringify({
          'x':x,'y':y,
          'width':width,'height':height,
          'yRatio': yRatio,
          'src' : vedioSrc
        });

        KDS_Native.openVedio("", jsonObj);
    };
clickFuntion();
    //imgStart.onclick = clickFuntion;
    //imgThumb.onclick = clickFuntion;
}
formatTable();

/**
 *推荐阅读跳转页面
 */
function jumpFun(dom) {
  var type = dom.getAttribute("type");
  var jumpId = dom.getAttribute("jumpId");

  KDS_Native.jumpZixunPage(jumpId,type);


}
/**
 *推荐阅读图片跳转页面
 */
function jumpImgFun(dom) {
  var jumpurl = document.getElementById('img1').getAttribute('jumpurl');
  KDS_Native.jumpImgZixunPage(jumpurl);


}