window.currentDZS = 0; //当前点赞数
window.currentTCS = 0; //当前点赞数
window.isMarketClose = false; //当前是否休市

/**
 * 客户端传递数据设置
 * @infoDataStr Json字符串，包括以下内容
	{
	  //投顾网络地址
	  netAddress: "http://172.16.210.200:21800",
	  //资讯网络地址
	  infoNetAddress: "http://120.24.99.9:21800",
	  //page页面
	  //排名,用来显示页面左上角的金银铜牌
	  rank: "1",
	  //当前手机登录的用户ID
	  currentUserId: "1",

      "id" : "54",
      "isMarketClose" : "1", //0或者不传指未休市，传1表示休市
      "totalIncomeRate" : "0.4020",//组合收益率
   	}
 */
window.setGroupData = function (infoDataStr) {
	try{
		window.currentGroupData = JSON.parse(infoDataStr);
	}catch(e){
		window.currentGroupData = infoDataStr;
	}

    window.currentGoodBadStatus = 0;
    // //初始化从客户端传来的数据
    initDetailsFromDevice();
    callWebService();
};

/**
 * 刷新页面请求的方法
 */
window.refresh = function (dataStr) {
	var resultData;
	try{
		resultData = JSON.parse(dataStr);
	}catch(e){
		resultData = dataStr;
	}

	resultData = resultData || {};

	var isMarketClose = (resultData.isMarketClose == 1);
	setMarketStatus(isMarketClose);

	callWebService();
}

/**
 * 刷新页面请求的方法
 */
window.setGroupConfig = function (datas, codes, settingstr) {
	var resultData, settingData;
	try{
		resultData = JSON.parse(datas);
	}catch(e){
		resultData = datas;
	}

	try{
		settingData = JSON.parse(settingstr);
	}catch(e){
		settingData = settingstr;
	}

	settingData = settingData || {};
	var isMarketClose = (settingData.isMarketClose == 1);
	setMarketStatus(isMarketClose);

	initGroupConfig(resultData, codes)
}

/**
 * 设置市场状态
 */
function setMarketStatus(isMarketClose, dontCloseTip){
	window.isMarketClose = isMarketClose;
	var warningTip = document.getElementById("warningTip");
	var waitDeal = document.getElementById("waitDeal");
	if(!isMarketClose){
		warningTip.style.display = "none";
		if(!dontCloseTip){
			waitDeal.style.display = "none";
		}
	}else{
		var doughnutChart = document.getElementById('doughnutChart');
		if(doughnutChart.clientHeight != 0){
			waitDeal.style.display = "block";
		}
		warningTip.style.display = "block";
	}
}

/**
 * 初始化从客户端传来的数据
 */
function initDetailsFromDevice(){
	var currentGroupData = window.currentGroupData;

	var zsyl = parsePercent(currentGroupData.totalIncomeRate || 0, true);
	var rootDiv = document.getElementById("rootDiv");
	if(zsyl < 0){
		rootDiv.setAttribute("data-color","die");
	} else if(zsyl > 0){
		rootDiv.setAttribute("data-color","zhang");
	} else{
		rootDiv.setAttribute("data-color","ping");
	}

	var imgrank = document.getElementById("imgrank");
	imgrank.style.visibility = "visible";
	if(currentGroupData.rank == 1){
		imgrank.src = "../../img/detail_golden.png";
	} else if(currentGroupData.rank == 2){
		imgrank.src = "../../img/silver.png";
	} else if(currentGroupData.rank == 3){
		imgrank.src = "../../img/medal.png";
	} else {
		imgrank.style.visibility = "hidden";
	}

	//总收益率
	touGuUtils.setValue("zsyl", zsyl);

	var isMarketClose = (currentGroupData.isMarketClose == 1);
	setMarketStatus(isMarketClose);
}

/**
 * 初始化组合明细中的详情
 */
function initDetailsFromService(response){
	var result = initDetails(response);
	if(result.sfdz == "1"){
		setGoodOrBad(1);
	}

	if(result.sftc == "1"){
		setGoodOrBad(2);
	}
}

/**
 * 初始化组合详情
 */
function initGroupConfig(response, codes){
	var relativeCodes = codes||"";
	if(!response){
		return;
	}

	drawGroupConfig(response);

    // 获取相关资讯
    callRelativeInfos({start: 0, end: 19, code: relativeCodes}, function(response){
    	touGuUtils.generateInfoList(response.news);
    });

    var btnShowMore = document.getElementById("btnShowMore");
	btnShowMore.onclick = function(){
		touGuUtils.gotoMoreInfos(relativeCodes);
	};
}

/**
 * 请求网络数据
 */
function callWebService (argument) {
	var userID, groupID;
	// window.tg_service_address = "http://172.16.210.200:21800/";
	// window.info_service_address = "http://120.24.99.9:21800/";

	if(window.currentGroupData) {
		userID = window.currentGroupData.currentUserId;
		groupID = window.currentGroupData.id;
		window.tg_service_address = window.currentGroupData.netAddress || "";
		window.info_service_address = window.currentGroupData.infoNetAddress || "";
	}

	if(window.tg_service_address.charAt(window.tg_service_address.length - 1) != "/"){
		window.tg_service_address += "/";
	}
	if(window.info_service_address.charAt(window.info_service_address.length - 1) != "/"){
		window.info_service_address += "/";
	}

	//初始化收益走势
	initProfitTrend(groupID, function(tjsj, curid){
		//初始化走势图表
		getProfitTrend(tjsj, curid);
	});

	//取组合详情数据
	callGroupDetail({userID: userID, groupID: groupID },function(response){
		//初始化详情
		var resultData = response[0];
		if(!resultData){
			return;
		}
		resultData.createdate = resultData.cjsj;
		resultData.createTime = resultData.cjsj;
		resultData.lastUpdateTime = resultData.gxsj;
		resultData.dayIncomeRate = resultData.rsy;
		resultData.totalIncomeRate = parseFloat(resultData.zsy||resultData.zsyl) * 100;
		resultData.netWorth = resultData.jz;
		resultData.monthIncomeRate= resultData.ysy;
		resultData.beatPercent = resultData.syph;
		resultData.name = resultData.zhmc;
		resultData.likeCount = resultData.dzrs;
		resultData.mockCount = resultData.tcrs;

		resultData.user={
			strav_small:resultData.yhtx,
			strnickName:resultData.yhnc
		};
		//将总收益率返回给客户端
		touGuUtils.setTGTotalIncomeRate(resultData.zsy||resultData.zsyl);
		initDetailsCreated(resultData);
		initDetailsFromService(response);

		//获取调仓记录
		callStorageRecords({userID: resultData.userId, groupID: groupID, count: 3, page: 1 },function(response){
			//初始化调仓记录
			initStorageRecords(response);
		});
	});

	//获取组合配置
	//callGroupConfig({groupID: groupID}, function(response){
		////初始化组合配置
		//initGroupConfig(response);
	//});

	//初始化走势图表
	getProfitTrend(3, groupID);
}

//点赞和吐槽点击，并设置点赞或吐槽
//点赞为1 吐槽为2 无状态为0
window.currentGoodBadStatus = 0;
function setGoodOrBad(status, update){
	var opinionGood = document.getElementById("opinionGood");
	var opinionBad = document.getElementById("opinionBad");

	if(!status){
		//当前是点赞
		if(window.currentGoodBadStatus == 1){
			opinionGood.setAttribute("data-value", "normal");
			if(update){
				window.currentDZS--;
			}
		}else if(window.currentGoodBadStatus == 2){
			//当前是吐槽
			opinionBad.setAttribute("data-value", "normal");
			if(update){
				window.currentTCS--;
			}
		}

		window.currentGoodBadStatus = 0;
	}else if(status == 1){
		//当前是点赞
		if(window.currentGoodBadStatus == 1){
			opinionGood.setAttribute("data-value", "normal");
			window.currentGoodBadStatus = 0;
			if(update){
				window.currentDZS--;
			}
		}else if(window.currentGoodBadStatus == 2){
			//当前是吐槽
			opinionGood.setAttribute("data-value", "highlight");
			opinionBad.setAttribute("data-value", "normal");
			window.currentGoodBadStatus = 1;
			if(update){
				window.currentDZS++;
				window.currentTCS--;
			}
		} else {
			opinionGood.setAttribute("data-value", "highlight");
			window.currentGoodBadStatus = 1;
			if(update){
				window.currentDZS++;
			}
		}
	} else if(status == 2){
		//当前是点赞
		if(window.currentGoodBadStatus == 1){
			opinionGood.setAttribute("data-value", "normal");
			opinionBad.setAttribute("data-value", "highlight");
			window.currentGoodBadStatus = 2;
			if(update){
				window.currentDZS--;
				window.currentTCS++;
			}
		}else if(window.currentGoodBadStatus == 2){
			//当前是吐槽
			opinionBad.setAttribute("data-value", "normal");
			window.currentGoodBadStatus = 0;
			if(update){
				window.currentTCS--;
			}
		} else {
			opinionBad.setAttribute("data-value", "highlight");
			window.currentGoodBadStatus = 2;
			if(update){
				window.currentTCS++;
			}
		}
	}

	if(update){
		if(window.currentTCS < 0){
			window.currentTCS = 0;
		}
		if(window.currentDZS < 0){
			window.currentDZS = 0;
		}
		//点赞人数
		touGuUtils.setValue("goodNumber", window.currentDZS);
		//吐槽人数
		touGuUtils.setValue("badNumber", window.currentTCS);
	}
}

(function(){
	FastClick.attach(document.body);
	var titleGroupHeader = document.getElementById("titleGroupHeader");
	titleGroupHeader.onclick=function(){
		touGuUtils.gotoGroupConfig(window.currentGroupData.id);//跳转至组合配置界面
	};

	var titleStorageHeader = document.getElementById("titleStorageHeader");
	titleStorageHeader.onclick=function(){
		touGuUtils.gotoTransferRecord(window.currentGroupData.id);//跳转至调仓记录页面
	};

	var infoitembody = document.getElementById("infoitembody");
	infoitembody.onclick = function(ev){
		var ev = ev || window.event;
		var target  = ev.target || ev.srcElement;
		var clickedTr = target.parentNode;
		var titleID = clickedTr.getAttribute("data-value");
		touGuUtils.gotoInfoDetail(titleID);
	}

	var opinionGood = document.getElementById("opinionGood");
	var opinionBad = document.getElementById("opinionBad");
	opinionGood.onclick = function(){
		//用户未登录时跳转至登录界面
		if(window.currentGroupData && window.currentGroupData.currentUserId == -1) {
			touGuUtils.gotoLoginPage();
			return;
		}

		callSetGoodOrBad(1, function(response){
			if(response.errCode == "0"){
				setGoodOrBad(1, true)
			}
		});
	}
	opinionBad.onclick = function(){
		//用户未登录时跳转至登录界面
		if(window.currentGroupData && window.currentGroupData.currentUserId == -1) {
			touGuUtils.gotoLoginPage();
			return;
		}

		callSetGoodOrBad(2, function(response){
			if(response.errCode == "0"){
				setGoodOrBad(2, true)
			}
		});
	}
})();
