var KmcEnv = require('./kmc-env');
var JS = KmcEnv.getOsJs();
var $ = require('jquery');

window.handleKeyBoard = null;

// function fillInputContent(data)
window.fillInputContent = function(data, marketId, subtype){
    console.log(['fillInputContent', data, marketId, subtype].join(", "));
    window.handleKeyboard(data, marketId, subtype);
};

window.handlePageBack = null;

module.exports = {

    /*--------------------Begin: H5调用原生的请求--------------------*/

    /**
     *    URL 跳转界面
     *    @param url    url地址
     *    @param hasRefresh    标识有无刷新按钮 0：显示，4：隐藏(占空间),8:隐藏(不占空间)
     *    @param direction    1：下一级界面；-1：返回上一级界面  0：在原生覆盖掉当前页面  -100：直接成为顶层页面
     */
    switchWebView: function(url, hasRefresh, direction, handlePageBack){
        console.log("KmcEnv.platform.isBrower", KmcEnv.platform.isBrower);
        if(handlePageBack){
            window.handlePageBack = handlePageBack;
        }
        if(KmcEnv.platform.isPhone){
            // 未传第2个参数时默认为0
            hasRefresh = hasRefresh == undefined ? 0 : hasRefresh;
            // 未传第3个参数时默认为1
            direction = direction == undefined ? 1 : direction;
            // hasRefresh 参数值不是数字，使用默认值 0
            hasRefresh = !isNaN(hasRefresh) ? parseInt(hasRefresh) : 0;
            // direction 参数值不是数字，使用默认值 1
            direction = !isNaN(direction) ? parseInt(direction) : 1;

            this.sendInteraction("switchWebView", [url, hasRefresh, direction]);
        }else{
            url = this.getFirstHref() + url;
            console.log("跳转地址：" + url);
            // 平级页面之间的跳转
            if(direction == 0) {
                location.replace(url)
            } else {
                location.href = url;
            }
        }
    },

    openNewWindow: function(linkUrl){
        if(KmcEnv.platform.isPhone){
            this.sendInteraction("openNewWindow", [linkUrl]);
        }else{
            location.href = linkUrl;
        }
    },

    //调用自定义键盘
    showKeyBoard: function(id, type, handleKeyBoardClick, getY){
        window.handleKeyboard = handleKeyBoardClick;

        if(id == undefined) {
            console.log("文本输入框 id 不能为空!");
            return;
        }
        var inputObj = $("[id='" + id + "']");
        if (inputObj.length == 0) {
            console.log("文本输入框 id 不存在! id=" + id);
            return;
        }else{
            console.log("文本输入框 id=" + id);
        }
        inputObj.focus();
        if(type == undefined) {
            console.log("键盘类型不存在!");
            return;
        }

        var X = inputObj.offset().left;
        var Y = inputObj.offset().top;

        // 兼容 ios，获取弹框可见区域的位置
        if (KmcEnv.platform.isPhone && !KmcEnv.platform.isAndroid) {
            var e = event || window.event;
            Y = e.clientY || Y;
        }

        Y += inputObj.height();            // 加上文本框高度
        Y += 80;                           // 额外加 80 像素, 可以显示出下一个输入框或按钮

        // 系数 = 输入框底部到页面顶部的高度 / 页面可见区域高度
        if (KmcEnv.platform.isAndroid) {
            Y = Y / (window.document.body.clientHeight == 0 ? screen.availHeight : window.document.body.clientHeight);
            // 检测是否是需要处理的特殊设备型号
            if (this.specialDeviceDisplay()) {
                Y = 0;
            }
        }

        if (typeof getY === 'function') {
            Y = getY(id);
        }

        this.sendInteraction("showKeyBoard", [type,Y]);
    },

    // 检测是否是需要处理的特殊设备型号，是则反回 true , 否则返回 false
    specialDeviceDisplay: function(){
        var ua, start_index, version;
        ua = navigator.userAgent.toLowerCase();
        if (ua.indexOf("huawei")) {
            start_index = ua.indexOf('huawei');
            version = ua.substring(start_index, start_index + 15);
        } else if (ua.indexOf("zte")) {
            start_index = ua.indexOf('zte');
            version = ua.substring(start_index, start_index + 8);
        }

        version = version.replace("/", " ");
        if (version == "huawei p6 s-u06" || version == "zte v975") {
            return true;
        }
        return false;
    },

    //隐藏自定义键盘
    hideKeyBoard: function(){
        this.sendInteraction("hideKeyBoard");
    },

    //记录日志
    //提示：由于IOS平台限制，该方法需在页面跳转之后调用，否则会阻止页面跳转
    log: function(content){
        this.sendInteraction("log", [content]);
    },

    // 设置顶部栏个性化样式
    setActionBarStyle: function(funKey, barBgColor, titleColor, paramsJson) {
        this.sendInteraction("setActionBarStyle", [funKey, barBgColor, titleColor, paramsJson]);
    },

    // 点击/页面事件统计（埋点）
    onAgentEvent: function(eventId, eventLabel, kvJson) {
        console.log(['onAgentEvent', eventId, eventLabel, kvJson].join(','));
        this.sendInteraction('onAgentEvent', [eventId, eventLabel, kvJson]);
    },

    //获取本地存储
    getLocalData: function(key) {
        this.sendInteraction("getLocalData",[key]);
    },

    //回调 APP 方法
    callbackTradeFunction: function(functionKey, jsonStr) {
        console.log(['callbackTradeFunction', functionKey, jsonStr].join(","));
        this.sendInteraction("callbackTradeFunction",[functionKey, jsonStr]);
    },

    //回调 APP 方法
    callbackAppTradeFunction: function(functionKey, jsonStr) {
        console.log(['callbackAppTradeFunction', functionKey, jsonStr].join(","));
        this.sendInteractionNew("callbackAppTradeFunction",[functionKey, jsonStr]);
    },

    /**
     * JS调用打开在二级页面加载第三方Web页面, 并传递用户数据
     * @param  {String} isCloseCurrent [是否关闭当前已有WebActivity[0: 不关闭 1: 关闭]]
     * @param  {String} functionCode   [功能Code]
     *    以 KDS_TICKET_NO_JSSWITCH 为前缀: 跳转时不不需要先登录资⾦金金账号等,在⻚页⾯面loadUrl 完成后调⽤用JS⽅方法( setUserData函数 ), 传递相关⽤用户数据;
     *    以 KDS_TICKET_NO_LOGINED_JSSWITCH 为前缀: 跳转前先登录资⾦金金账号及获取Ticket等 , 在⻚页⾯面loadUrl完成后调⽤用JS⽅方法( setUserData函数 ), 传递相关⽤用户数据;
     *    传 KDS_WEB_STOCK_WARN : 需要先登录⼿手机号, 跳转第三⽅方Web⻚页⾯面, 在⻚页⾯面loadUrl完 成时, 调⽤用JS⽅方法( setDeviceAndMobileData函数 ), 传递deviceId(设备号)、mobileNO(⼿手 机号);
     *    传 KDS_F10_NEWS_DETAILS : 供个股详情 F10 Web 跳转⾄至资讯详情界⾯面(传递接⼝口 url 及⼊入参供请求解析);
     *    以 KDS_Trade_Web_SwitchStack 为前缀: 供内部交易易H5调⽤用的功能Key,在⼆二级交易易Web 界⾯面打开指定H5⻚页⾯面(传递内部交易易H5的相对url路路径);
     * @param  {String} loadUrl        [要加载的第三方Web页面]
     * @param  {String} userDataJson   [需要转发的用户信息JSON数据]
     *    扩展参数示例例: {"custid":"客户 代码","fundid":"资⾦金金账号","userrole":"⽤用户⻆角⾊色","orgid":"操作机构","ticket":"tick et票据"}
     */
    openThirdPartyWebInSubPage: function(isCloseCurrent, functionCode, loadUrl, userDataJson) {
        console.log(['openThirdPartyWebInSubPage', isCloseCurrent, functionCode, loadUrl, userDataJson].join(', '));
        this.sendInteraction('openThirdPartyWebInSubPage', [isCloseCurrent, functionCode, loadUrl, userDataJson]);
    },

    /**
     * 本地地址传给app
     */
    setDefaultHostUrl: function(url) {
        console.log('setDefaultHostUrl', url);
        this.sendInteraction('setDefaultHostUrl', [url]);
    },

    /**
     * 把F10分享的信息传给原生
     */
    getF10ShareMessage: function(shareParams) {
        this.sendInteraction("getF10ShareMessage", [shareParams]);
    },

    /**
     * 设置页面高度给原生
     */
    setCurrentWebPageHeight: function(height) {
        console.log('setCurrentWebPageHeight', height);
        this.sendInteraction('setCurrentWebPageHeight', [height]);
    },

    /*--------------------End: H5调用原生的请求--------------------*/

    //H5提供给原生的接口
    // fillInputContent: function(data){
    //     handleKeyBoard(data);
    //     console.log("fillInputContent,data", data);
    // },

    /**
     * 发送与原生接口的交互请求
     * @param  {String} methodName 方法名
     * @param  {Array} parameters 参数数组
     */
    sendInteraction: function(methodName, parameters){
        // 微信上不需要与原生 APP 接口交互
        if (KmcEnv.platform.isWeixin) {
            return;
        }
        // 判断如果是 PC, 则不处理
        if (KmcEnv.platform.isBrower) {

        }
        //判断如果是IOS平台则发送IOS请求，是Android平台则发送Android请求
        else if(KmcEnv.platform.isAndroid) {
            if(methodName == "log"){
                console.log.apply(console, parameters);
            } else {
                try {
                    // Android 平台
                    KDS_Native[methodName].apply(KDS_Native, parameters);
                } catch (e) {}
            }
        } else if(KmcEnv.platform.isPhone) {
            //IOS 平台
            //组装方法
            var iosMethod = "KDS_Native://" + methodName;

            //组装参数
            var iosParams = "";
            if(parameters){
                for (var i = 0; i < parameters.length; i++) {
                    iosParams += ":" + parameters[i];
                };
            }

            //与IOS端交互
            this.loadURL(iosMethod + iosParams);
        }
    },

    /**
     * 发送与原生接口的交互请求
     *
     * 统一了调用原生方法的方式，使用之前 android 的调用方式
     *
     * @param  {[String]} methodName [方法名]
     * @param  {[Array]}  parameters [参数数组]
     */
    sendInteractionNew: function(methodName, parameters){
        // 微信上不需要与原生 APP 接口交互
        if (KmcEnv.platform.isWeixin) {
            return;
        }
        // 判断如果是 PC, 则不处理
        if (KmcEnv.platform.isBrower) {

        }
        // 移动端就调用，不区分 iOS 和 android
        else if(KmcEnv.platform.isPhone) {
            KDS_Native[methodName].apply(KDS_Native, parameters);
        }
    },

    /**
     * 函数功能：获取当前URL地址前半部分
     */
    getFirstHref: function() {
        var searchKey = ["view/", "views/"];
        var _url = window.location.href;
        var _index = _url.indexOf(searchKey[0]);
        if (_index > -1) {
            _url = _url.substring(0, _index + searchKey[0].length);
            return _url;
        }
        _index = _url.indexOf(searchKey[1]);
        if (_index > -1) {
            _url = _url.substring(0, _index + searchKey[1].length);
            return _url;
        }
    },

    /**
     * 函数功能：获取当前URL地址后半部分
     */
    getlasthref: function() {
        var searchKey = ["view/", "views/"];
        var _url = window.location.href;
        var _index = _url.indexOf(searchKey[0]);
        if (_index > -1) {
            _url = _url.substring(_index + 5);
            return _url;
        }
        _index = _url.indexOf(searchKey[1]);
        if (_index > -1) {
            _url = _url.substring(_index + 6);
            return _url;
        }
    },

    /**
     * Javascript语言
     * 通知iPhone UIWebView 加载url对应的资源
     * @param url
     */
    loadURL: function(url) {
        var iFrame;
        iFrame = document.createElement("iframe");
        iFrame.setAttribute("src", url);
        iFrame.setAttribute("style", "display:none;");
        iFrame.setAttribute("height", "0px");
        iFrame.setAttribute("width", "0px");
        iFrame.setAttribute("frameborder", "0");
        document.body.appendChild(iFrame);
        // 发起请求后这个iFrame就没用了，所以把它从dom上移除掉
        iFrame.parentNode.removeChild(iFrame);
        iFrame = null;
    }
};
