export default {
    /**
     * 本地存储数据
     * @param {键} key
     * @param {值} value
     */
    setLocalData(key, value) {
        var preStr = key;
        if(key.indexOf('KDS_ZXJT_F10_') == -1) {
            preStr = 'KDS_ZXJT_F10_' + key;
        }
        value = typeof(value) == "string" ? value : JSON.stringify(value);
        window.localStorage.setItem(preStr, value);
    },

    /**
     * 获取本地存储数据
     * @param {键} key
     */
    getLocalData(key) {
        var preStr = key;
        if(key.indexOf('KDS_ZXJT_F10_') == -1) {
            preStr = 'KDS_ZXJT_F10_' + key;
        }
        return window.localStorage.getItem(preStr) || '';
    },

    /**
     * 删除本地存储数据
     */
    removeLocalData(key) {
        var preStr = key;
        if(key.indexOf('KDS_ZXJT_F10_') == -1) {
            preStr = 'KDS_ZXJT_F10_' + key;
        }
        window.localStorage.removeItem(preStr);
    },

    /**
    * 清空本地存储数据
    */
    clearLocalData: function () {
        window.localStorage.clear();
    },

}