import KmcCommon from './kmc-common';
import KmcLocalStorage from './kmc-localStorage';

//***************给原生提供的调用方法********************//

// 设置app主题皮肤
window.setApptheme = function (value) {
    document.documentElement.setAttribute('apptheme', value)
}
/**
 * 获取app主题皮肤
 */
window.getApptheme = function () {
    return KmcCommon.getAppTheme();
}

/**
 * 设置本地存储
 */
window.setLocalData = function (key, value) {
    KmcLocalStorage.setLocalData(key, value);
}

/**
 * 获取本地存储
 */
window.getLocalData = function (key) {
    return KmcLocalStorage.getLocalData(key);
}

/**
 * 删除本地存储
 */
window.removeLocalData = function (key) {
    KmcLocalStorage.removeLocalData(key);
}

/**
 * 清空本地存储
 */
window.clearLocalData = function () {
    KmcLocalStorage.clearLocalData();
}

/**
 * 原生提供给H5的信息(old)
 * @param appVerion 客户端版本号 ( 用于后期版本客户端接口升级, Web判断做兼容提示等 )
 * @param appType   客户端类型 ( Web用于判断是调用App Android/iOS 哪端的方法 )
 * @param phoneNum  手机号
 * @param deviceId  Android设备号 或 iOS UUID
 * @param paramJson 扩展参数JSON格式(资金账号fundid，或者股票代码 )
 */
window.callBackUserData = function (appVerion, appType, phoneNum, deviceID, paramsJson) {
    KmcCommon.callBackUserData(appVerion, appType, phoneNum, deviceID, paramsJson);
}

/**
 * 设置站点域名
 */
window.setRequestHostUrls = function(hostUrls) {
    KmcCommon.setRequestHostUrls(hostUrls);
}

/**
 * 设置详情页字体大小
 */
window.onFontSwitch = function(value) {
    KmcCommon.onFontSwitch(value);
}