var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var keyboardConfig = {
    borderBlur: { "border-style": "solid", "border-color": "#ffffff", "border-width": "1px" },
    borderFocus: { "border-style": "solid", "border-color": "#ffffff", "border-width": "1px" }
};
/*

console. 开头的注释信息开发者自行根据需要 进行删除.
*/
(function (root, factory) {
    if ((typeof exports === "undefined" ? "undefined" : _typeof(exports)) === "object") {
        // CommonJS
        module.exports = exports = factory();
    } else if (typeof define === "function" && define.amd) {
        // AMD
        define([], factory);
    } else {
        // Global (browser)
        root.MyKeyboard = factory();
    }
})(window, function () {
    var MyKeyboard = MyKeyboard || function () {

        var MyObj = {
            echoInfo: function echoInfo() {
                console.warn("wellcome use , this is js with native interactive keyboard project");
                return false;
            }, //从原生调用 让我们的js输入框获取焦点
            setInputFocusFromNative: function setInputFocusFromNative(inputId) {
                console.debug("setInputFocusFromNative");
                var realInput = window.document.getElementById(inputId);
                if (typeof realInput == "undefined" || realInput == null) {
                    console.error("Unable to set inputFocus!");
                } else {
                    realInput.focus();
                }
            } //从原生调用 让我们的js输入框获取焦点
            , setInputBlurFromNative: function setInputBlurFromNative(inputId) {
                console.debug("setInputBlurFromNative");
                var realInput = window.document.getElementById(inputId);
                if (typeof realInput == "undefined" || realInput == null) {
                    console.error("Unable to set inputBlur!");
                } else {
                    realInput.blur();
                }
            },
            //从原生调用 设置输入框的内容 str为传递过来的内容通常为*号。
            setInputValueByIdFromNative: function setInputValueByIdFromNative(inputId, str) {
                //原生调用js的封装。
                console.debug("setInputValueByIdFromNative");
                // console.info("原生请求设置输入框   id:" + inputId + "内容为" + str);
                var realInput = window.document.getElementById(inputId);
                var result = $("#" + inputId).parent().find(".fake_text");
                if (result.length == 0) {
                    console.error("Unable to find fake text element");
                    return;
                }

                var strLength = parseInt(str.length);
                var strEncrypt = "";
                for (var i = 0; i < strLength; i++) {
                    strEncrypt = strEncrypt + "•";
                }
                var findInput = $("#" + inputId);
                if (findInput.length == 0) {
                    console.error("Unable to find inputid " + inputId + ",make sure you have defined it!");
                    return;
                }

                if (strEncrypt.length == 0) {
                    realInput.value = "";
                } else {
                    realInput.value = " ";
                }
                findInput.parent().find(".fake_text").html(strEncrypt);
            },

            //IOS原生专用 控制js输入框设置光标显示因此已经修改边框样式
            setInputCursorFromNative: function setInputCursorFromNative(inputId, showCursor) {
                var result = $("#" + inputId);
                if (result.length > 0) {

                    result = result.parent().find(".fake_cursor");
                    if (result.length == 0) {
                        console.error(" Unable to find fake_cursor ,make sure you have defined it![inputid:" + inputId + "]");
                    } else {
                        result.css("display", showCursor ? "block" : "none");
                        if (showCursor) {
                            result.css(keyboardConfig.borderFocus);
                        } else {
                            result.css(keyboardConfig.borderBlur);
                        }
                    }
                } else {
                    console.error("changeCursor fail, to find input id " + inputId + "  ,make sure you have defined it! ");
                }
            },

            isNull: function isNull(obj) {
                if (obj == null || obj == undefined || typeof obj == "undefined") {
                    return true;
                } else {
                    return false;
                }
            },

            isFunction: function isFunction(obj) {
                if (obj != null && typeof obj == "function") {
                    return true;
                } else {
                    return false;
                }
            },
            onBindFocusJSBridge: function onBindFocusJSBridge(e) {
                //获得焦点或者被点击的封装
                var inputId = e.id;
                var shouldChanageCursor = !window.webkit;
                var result = $("#" + inputId);
                if (shouldChanageCursor && result.length > 0) {
                    result = result.parent().find(".fake_cursor");
                    if (result.length == 0) {
                        console.error(" Unable to find fake_cursor ,make sure you have defined it![inputid:" + inputId + "]");
                    } else {
                        result.css("display", "block");
                        // this.setInputCursorFromNative(inputId, true);
                    }
                } else {
                    console.error(" Unable to find input id " + inputId + "  ,make sure you have defined it! should?" + shouldChanageCursor);
                }

                if (window.webkit) {
                    if (window.webkit.messageHandlers.onNativeBindFocus) {
                        window.webkit.messageHandlers.onNativeBindFocus.postMessage(e.id + '');
                    } else {
                        alert("Unable to call native method onNativeBindFocus");
                    }
                } else if (typeof onNativeBindFocus == "function") {
                    onNativeBindFocus(e.id);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用onBindFocusJSBridge  尚未绑定AndroidJavaScriptBridge id:" + e.id);
                } else {
                    NKeyboard.onNativeBindFocus(e.id);
                }
            },

            onBindBlurJSBridge: function onBindBlurJSBridge(e) {
                //失去焦点的封装
                var shouldChanageCursor = !window.webkit;
                var inputId = e.id;
                console.info("inputId blur " + inputId);
                var result = $("#" + inputId);
                if (shouldChanageCursor && result.length > 0) {

                    result = result.parent().find(".fake_cursor");
                    if (result.length == 0) {
                        console.error(" Unable to find fake_cursor ,make sure you have defined it![inputid:" + inputId + "]");
                    } else {
                        result.css("display", "none");
                        // this.setInputCursorFromNative(inputId, false);
                    }
                } else {
                    console.error(" Unable to find input id " + inputId + "  ,make sure you have defined it! should?" + shouldChanageCursor);
                }

                if (window.webkit) {
                    if (window.webkit.messageHandlers.onNativeBindBlur) {
                        window.webkit.messageHandlers.onNativeBindBlur.postMessage(e.id + '');
                    } else {
                        alert("Unable to call native method onNativeBindFocus");
                    }
                } else if (typeof onNativeBindBlur == "function") {
                    onNativeBindBlur(e.id);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用onBindBlurJSBridge  尚未绑定AndroidJavaScriptBridge id:" + e.id);
                } else {
                    NKeyboard.onNativeBindBlur(e.id);
                }
            }, setInputConfigJSBridge: function (_setInputConfigJSBridge) {
                function setInputConfigJSBridge(_x, _x2) {
                    return _setInputConfigJSBridge.apply(this, arguments);
                }

                setInputConfigJSBridge.toString = function () {
                    return _setInputConfigJSBridge.toString();
                };

                return setInputConfigJSBridge;
            }(function (inputId, configJSONStr) {
                //设置输入框数据, 已经被转换为字符串的json。

                if (window.webkit && window.webkit.messageHandlers) {
                    var body = JSON.stringify({
                        "id": inputId,
                        "config": JSON.parse(configJSONStr)
                    });
                    window.webkit.messageHandlers.setInputConfigJSBridge.postMessage(body);
                } else if (typeof setInputConfigJSBridge == "function") {
                    setInputConfigJSBridge(inputId, configJSONStr);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用setInputConfigJSBridge 设置输入框相关参数  尚未绑定setInputConfigJSBridge id:" + inputId);
                } else {
                    NKeyboard.setInputConfigJSBridge(inputId, configJSONStr);
                }
            }), callNativeQueryKeyboardText: function callNativeQueryKeyboardText(inputId) {
                //获取原生的密码串，

                if (window.webkit && window.webkit.messageHandlers) {
                    var temp = window.prompt("getNativeKeyboardText", inputId);
                    return temp;
                } else if (typeof setInputConfigJSBridge == "function") {
                    return getNativeKeyboardText(inputId);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用 getNativeKeyboardText 设置输入框相关参数  尚未绑定 getNativeKeyboardText id:" + inputId);
                } else {
                    return NKeyboard.getNativeKeyboardText(inputId);
                }
            }, callNativeQueryConfigByAction: function callNativeQueryConfigByAction(inputId, action, argarr) {
                //获取原生的信息，根据action查询 如果原生键盘没有初始化则返回null (网页加载后马上通过网页端设置某个输入框那么这个输入框没有被点击也会被初始化。) 否则返回字符串，请根据具体情况进行类型转换为不同的类型。

                if (window.webkit && window.webkit.messageHandlers) {
                    var temp = window.prompt("getNativeConfigByAction", JSON.stringify({
                        "id": inputId,
                        "action": action,
                        "argarr": argarr
                    }));
                    return temp;
                } else if (typeof getNativeConfigByAction == "function") {
                    return getNativeConfigByAction(inputId, action, argarr);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用 getNativeConfigByAction 设置输入框相关参数  尚未绑定 getNativeConfigByAction action:" + inputId);
                    return undefined;
                } else {
                    return NKeyboard.getNativeConfigByAction(inputId, action, argarr);
                }
            }, callNativeQueryKeyboardLength: function callNativeQueryKeyboardLength(inputId) {
                //通过id获取原生字符串的长度 监听原生的字符串长度
                if (window.webkit && window.webkit.messageHandlers) {
                    var temp = window.prompt("getNativeKeyboardLength", inputId);
                    return temp;
                } else if (typeof getNativeKeyboardLength == "function") {
                    return getNativeKeyboardLength(inputId);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用 getNativeKeyboardLength 设置输入框相关参数  尚未绑定 getNativeKeyboardLength id:" + inputId);
                } else {
                    return NKeyboard.getNativeKeyboardLength(inputId);
                }
            },
            callNativeQueryKeyboardEmpty: function callNativeQueryKeyboardEmpty(inputId) {
                if (window.webkit && window.webkit.messageHandlers) {
                    window.webkit.messageHandlers.setNativeKeyboardEmpty.postMessage(inputId + '');
                } else if (typeof setNativeKeyboardEmpty == "function") {
                    setNativeKeyboardEmpty(inputId);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用 setNativeKeyboardEmpty 设置输入框相关参数  尚未绑定 getNativeKeyboardLength id:" + inputId);
                } else {
                    NKeyboard.setNativeKeyboardEmpty(inputId);
                }
            },
            onBindKeyboardEmpty: function onBindKeyboardEmpty(inputId) {
                //清空原生输入框
                this.callNativeQueryKeyboardEmpty(inputId);
            },
            callNativeQueryKeyboardHide: function callNativeQueryKeyboardHide(inputId) {
                if (window.webkit && window.webkit.messageHandlers) {
                    window.webkit.messageHandlers.setNativeKeyboardHide.postMessage(inputId + '');
                } else if (typeof setNativeKeyboardHide == "function") {
                    setNativeKeyboardHide(inputId);
                } else if (typeof NKeyboard == "undefined" || NKeyboard == null) {
                    console.error("无法调用 setNativeKeyboardHide 设置输入框相关参数  尚未绑定 setNativeKeyboardHide id:" + inputId);
                } else {
                    NKeyboard.setNativeKeyboardHide(inputId);
                }
            }
        };
        return MyObj;
    }();
    return MyKeyboard;
});

//暂时不支持webview的使用
MyKeyboard.echoInfo();
$(document).ready(function () {

    $(".fake_input_wrap").children("input").click(function () {
        var id = $(this).attr("id");
        var obj = { id: id };
        console.info("input click:" + id);
        MyKeyboard.onBindFocusJSBridge(obj);
    });

    $(".fake_input_wrap").children("input").focus(function () {
        var id = $(this).attr("id");
        var obj = { id: id };
        console.info("input focus:" + id);
        MyKeyboard.onBindFocusJSBridge(obj);

        if (window.webkit && window.webkit.messageHandlers) {
            console.info("ios border style");
        } else {
            $(this).css(keyboardConfig.borderFocus);
        }
    });
    $(".fake_input_wrap").children("input").blur(function () {
        var id = $(this).attr("id");
        var obj = { id: id };
        console.info("jquery  bulurid:" + id);
        MyKeyboard.onBindBlurJSBridge(obj);
        if (window.webkit && window.webkit.messageHandlers) {
            console.info("ios border style");
        } else {
            $(this).css(keyboardConfig.borderBlur);
        }
    });
});