var APP_HQ = new function () {
    /**
     * 获取五档行情
     * @param  {[type]} scope [description]
     * @return {[type]}       [description]
     */
    this.getWdhq = function (scope, callback) {
        var type = 'wdhq';
        var zqdm = scope.state.zqdm;
        var marketId = scope.state.marketId;
        if (marketId != "") {
            window.setStockData = this.setStockData.bind(window, scope, callback);
            console.log(['getWdhq', type, zqdm, marketId].join(', '));
            if (params.browser == "android") {
                KDS_Native.getStockData(type, zqdm, marketId);
            } else if (params.browser == "ios") {
                loadURL("KDS_Native://getStockData:" + type + ":" + zqdm + ":" + marketId);
            } else {
                // TODO PC 测试代码
                this.setTestData(zqdm);
            }
            return true;
        }
        return false;
    };

    /**
     * 获取十档行情
     * @param  {[type]} scope [description]
     * @return {[type]}       [description]
     */
    this.getSdhqNew = function (scope, callback) {
        var type = 'sdhq';
        var zqdm = scope.state.zqdm;
        var marketId = scope.state.marketId;

        if (marketId != "") {
            window.setStockData = this.setStockData.bind(window, scope, callback);
            console.log(['getSdhqNew', type, zqdm, marketId].join(', '));
            if (params.browser == "android") {
                KDS_Native.getStockData(type, zqdm, marketId);
            } else if (params.browser == "ios") {
                loadURL("KDS_Native://getStockData:" + type + ":" + zqdm + ":" + marketId);
            } else {
                // TODO PC 测试代码
                this.setTestData(zqdm);
            }
            return true;
        }
        return false;
    };

    // 五档 || 十档
    this.hqDegree = function () {
        return isLevel2() ? 10 : 5;
    };

    /**
     * 原生回调此方法来更新行情数据
     * @param  {Object} scope       angularJS 作用域, 不需要传，这是 bind 绑定的值
     * @param  {Object} callback    回调方法, 不需要传，这是 bind 绑定的值
     * @param  {Object} data        行情数据 [PS: 这才是第一个参数值]
     */
    this.setStockData = function (scope, callback, data) {
        data = data !== undefined ? data : {};
        var response = {};
        try {
            console.info('setStockData(' + JSON.stringify(data) + ')');
            response = data.data || {};

            var curzqdm = $("#zqdm").val();

            // 如果请求的数据与当前的证券代码不符，则放弃更新数据
            if (curzqdm != response.stockCode) {
                return;
            }
            var scope = controller["scope"];
            var priceList = [];
            var degree = APP_HQ.hqDegree();
            var sellItems = response.sellItems;
            var buyItems = response.buyItems;

            var buyVolPer = [];
            var sellVolPer = [];
            for (var i = 0; i < degree; i++) {
                buyVolPer.push(buyItems[i].buyVolume == '--' ? '0' : buyItems[i].buyVolume);
                sellVolPer.push(sellItems[i].sellVolume == '--' ? '0' : sellItems[i].sellVolume);
            }

            var bs = buyVolPer.concat(sellVolPer);
            buyVolPer = calPrecent(bs, buyVolPer);
            sellVolPer = calPrecent(bs, sellVolPer);

            for (var i = 0; i < degree; i++) {
                var priceInfo = {
                    sellColor: setPriceColor(sellItems[i].sellPrice, response.closePrice),
                    sellOrder: "卖" + (i + 1),
                    sell: ZeroCheck(sellItems[i].sellPrice),
                    sellRatio: sellVolPer[i],
                    sellVol: sellItems[i].sellVolume,
                    buyColor: setPriceColor(buyItems[i].buyPrice, response.closePrice),
                    buyOrder: "买" + (i + 1),
                    buy: ZeroCheck(buyItems[i].buyPrice),
                    buyRatio: buyVolPer[i],
                    buyVol: buyItems[i].buyVolume
                };
                priceList.push(priceInfo);
            }

            // 科创板参考价上下限开关（"true"/"false"）
            data.kcbLimitSwitch = data.kcb_limitSwitch === 'true' ? true : false;
            // 科创板参考价上限
            data.kcbLimitUpper = data.kcb_limitUpper || '';
            // 科创板参考价下限
            data.kcbLimitLower = data.kcb_limitLower || '';
            // 科创板参考价上下限提示语
            data.kcbLimitMessage = (data.kcb_limitMessage || '').split('$\n');
        } catch (e) {}

        if (typeof callback === 'function') {
            callback(scope, data, priceList);
        }
    };

    this.setTestData = function (zqdm) {
        // var data = this.getTestData(zqdm);
        // setTimeout(() => { data != null && setStockData(data); }, 1000);
    };

    this.getTestData = function (zqdm) {
        var data = null;
        switch (zqdm) {
            case '000685':
                {
                    data = { "hq_subtype": "1", "hq_stage": "3", "data": { "stockCode": "000685", "nZdf": "0.00", "closePrice": "9.06", "currentPrice": "9.06", "saleMount": "0", "buyMount": "0", "marketID": "1", "sellItems": [{ "name": "卖1", "sellPrice": "9.07", "sellVolume": "33" }, { "name": "卖2", "sellPrice": "9.08", "sellVolume": "322" }, { "name": "卖3", "sellPrice": "9.09", "sellVolume": "231" }, { "name": "卖4", "sellPrice": "9.10", "sellVolume": "70" }, { "name": "卖5", "sellPrice": "9.11", "sellVolume": "78" }], "buyItems": [{ "name": "买10", "buyPrice": "9.06", "buyVolume": "176" }, { "name": "买9", "buyPrice": "9.05", "buyVolume": "556" }, { "name": "买8", "buyPrice": "9.04", "buyVolume": "528" }, { "name": "买7", "buyPrice": "9.03", "buyVolume": "1072" }, { "name": "买6", "buyPrice": "9.02", "buyVolume": "2041" }] }, "hq_limitUp": "9.97", "hq_limitDown": "8.15", "hq_name": "中山公用", "hq_status": "0" };
                    break;
                }
            case '600000':
                {
                    data = { "data": { "stockCode": "600000", "marketID": "2", "sellItems": [{ "name": "卖10", "sellPrice": "13.03", "sellVolume": "743" }, { "name": "卖9", "sellPrice": "13.02", "sellVolume": "1262" }, { "name": "卖8", "sellPrice": "13.01", "sellVolume": "317" }, { "name": "卖7", "sellPrice": "13.00", "sellVolume": "883" }, { "name": "卖6", "sellPrice": "12.99", "sellVolume": "671" }, { "name": "卖5", "sellPrice": "--", "sellVolume": "--" }, { "name": "卖4", "sellPrice": "--", "sellVolume": "--" }, { "name": "卖3", "sellPrice": "--", "sellVolume": "--" }, { "name": "卖2", "sellPrice": "--", "sellVolume": "--" }, { "name": "卖1", "sellPrice": "--", "sellVolume": "--" }], "buyItems": [{ "name": "买1", "buyPrice": "489.27", "buyVolume": "4542" }, { "name": "买2", "buyPrice": "12.97", "buyVolume": "3093" }, { "name": "买3", "buyPrice": "12.96", "buyVolume": "2561" }, { "name": "买4", "buyPrice": "12.95", "buyVolume": "3834" }, { "name": "买5", "buyPrice": "12.94", "buyVolume": "2010" }, { "name": "买6", "buyPrice": "--", "buyVolume": "--" }, { "name": "买7", "buyPrice": "--", "buyVolume": "--" }, { "name": "买8", "buyPrice": "--", "buyVolume": "--" }, { "name": "买9", "buyPrice": "--", "buyVolume": "--" }, { "name": "买10", "buyPrice": "--", "buyVolume": "--" }], "currentPrice": "489.27", "closePrice": "13.07" }, "hq_name": "浦发银行" };
                    break;
                }
            // 科创板
            case '688995':
                {
                    data = { "hq_subtype": "129", "hq_stage": "5", "data": { "stockCode": "688995", "nZdf": "0.00", "closePrice": "3.25", "currentPrice": "8.45", "saleMount": "0", "buyMount": "0", "marketID": "2", "sellItems": [{ "name": "卖1", "sellPrice": "", "sellVolume": "--" }, { "name": "卖2", "sellPrice": "", "sellVolume": "--" }, { "name": "卖3", "sellPrice": "", "sellVolume": "--" }, { "name": "卖4", "sellPrice": "", "sellVolume": "--" }, { "name": "卖5", "sellPrice": "", "sellVolume": "--" }], "buyItems": [{ "name": "买10", "buyPrice": "8.45", "buyVolume": "7.69万" }, { "name": "买9", "buyPrice": "", "buyVolume": "--" }, { "name": "买8", "buyPrice": "", "buyVolume": "--" }, { "name": "买7", "buyPrice": "", "buyVolume": "--" }, { "name": "买6", "buyPrice": "", "buyVolume": "--" }] }, "hq_limitUp": "3.85", "hq_limitDown": "3.25", "hq_name": "LCK995", "hq_status": "0" };
                    break;
                }
        }
        return data;
    };
}();