var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * 常用变量与函数的定义
 */
/*============================ 本地存储数据一览表 =======================================

 Account:                                                       普通业务多账户信息
 ActivePTJYUser:                                                普通业务当前用户信息
 ActiveRZRQUser:                                                融资融券业务当前用户信息

 page:                                                          跳转界面
 zqdm:                                                          行情, 持仓界面保存的证券代码

 apiUrl                                                         交易服务器地址
 timeOut                                                        设置请求超时时间
 dataList                                                       页面传值对象

 khbsList                                                       普通交易登录的客户账号集合(下拉框显示需要)
 remember                                                       普通交易记录账号

 rzrq_khbzList                                                  融资融券登录的客户账号集合(下拉框显示需要)
 rzrq_remember                                                  融资融券记录账号

 kds_ywxt                                                       业务系统(0: 普通交易; 1: 融资融券)

 kdsAppThemeName                                                皮肤名称

 ipandport                                                      微信商城 URL
 ====================================================================================*/

/*============================ common.js 普通函数功能列表 =================================

 loadding.run()                                                 页面弹框显示加载状态
 loadding.stop()                                                去掉加载状态

 ajaxPost(url, jsonData, method, errorMethod)                   web前后端通信

 getformdata()                                                  获取表单数据 文本框添加属性： isSub = "true"

 IsSuccess(response, errorMethod)                               是否成功

 Logout()                                                       注销用户登录信息

 showMessageTips(obj)                                           模拟APP显示提示信息

 setNotIOSSystemTouch()                                         设置非ios系统的滑屏滚动

 RecordCheckBox(obj)                                            记录复选框的状态

 getBrowser()                                                   获取浏览器类型 pc / android / ios

 trim(str)                                                      去除字符串中的空格回车

 setLocalListData(listName, value)                              存储列表数据

 removeLocalListData(listName, value)                           清除列表中指定字段

 getLocalData(key)                                              获取本地存储数据

 removeLocalData(key)                                           清除本地存储数据

 clearLocalData()                                               清空本地存储数据

 QuickJump(viewKey)                                             快捷跳转

 getfirsthref()                                                 获取当前URL地址前半部分
 getlasthref()                                                  获取当前URL地址后半部分

 plusMinus(id, type, step, fixed)                               加减

 create_modal($scope, $compile, modal)                          创建模态框

 formatDate(date, format)                                       格式化字符串日期

 getMarkInfo()                                                  获取留痕信息

 saveLog(str)                                                   保存日志到本地数据库
 selectLog()                                                    查询本地数据库里的日志信息
 clearLog()                                                     清空数据库表数据

 formatResponseData(response)                                   对返回数据中的列表数据进行非空处理

 getHqTime()                                                    获取行情刷新时间

 updateClass(fileName, className, method)                       修改文件样式

 resetScroll()                                                  重置滚动条

 haveLogged()                                                   已经登录

 HereDoc(f)                                                     返回注释里的内容

 toRXT()                                                        跳转到融信通

 initialAppTheme()                                              初始化app主题皮肤

=====================================================================================*/

/*============================ 与原生 APP 交互的函数 ==================================

 showKeyboard(id, type)                                         显示 APP 自定义键盘
 hideKeyBoard()                                                 隐藏 APP 自定义键盘
 closeKeyBoard()                                                关闭 APP 自定义键盘回调函数

 fillInputContent(param)                                        自定义键盘回调函数

 JumpInterface(url, hasRefresh, direction)                      跳转界面

 jumpToView()                                                   快捷跳转页面

 setApiUrl(apiUrl)                                              设置交易服务器地址
 getApiUrl()                                                    获取交易服务器地址

 setTimeOut(timeOut)                                            设置请求超时时间(无效)

 getTimeOut()                                                   获取请求超时时间(无效)

 selfserviceAccount()                                           自助开户

 getLoginAccount(ywlx)                                          获取资金账号

 setMarkInfo(obj)                                               设置留痕信息

 setIsRegister(phone)                                           设置是否注册
 getIsRegister()                                                获取是否注册
 showRegisterView()                                             显示注册界面

 addUserStock(stockName, stockCode, marketId)                   添加自选股

 saveOrUpdateLocalData(key, value)                              保存或修改本地存储

 getVersion()                                                   获取版本号

 setLocalData(key, value)                                       设置本地存储数据

 setHqTime(time)                                                设置行情时间(单位: 秒)

 CloseModal()                                                   移除模态框

 setAppVersion(version)                                         设置 App 版本号

 setDgPersonalIpAndPort(json)                                   设置数据的IP和端口， 比如： 商城、 个人中心的IP部分

 initSaleInfo(value)                                            设置营业部信息

 onLoginTrade(value)                                            传递用户交易登录信息(姓名， 电话) 给原生

 closeApp()                                                     函数功能: 关闭原生App

 handlePageBack()                                               原生 APP 回调函数, 用于刷新页面数据

 passRXTUrlString(url)                                          调用原生 APP 的融信通接口

 openThirdPartyWebInterface(closeCurrent, url)                  打开第三方 WEB 界面

 jumpStockDetailInterface(stockCode, marketId)                  跳转到个股行情接口

 openThirdPartyWebSuperInterface(...)                           打开第三方 WEB 超级接口

 jumpToStockSysncInterface(isCloseCurrent)                      JS 跳到自选股云同步界面

 setAppTheme(themeName, notStore)                               设置App的主题皮肤

 setShareIp(urlIp)                                              设置分享的服务器地址
 getShareIp()                                                   获取分享的服务器地址

 logoutTrade(tradeType)                                         交易退出时回调原生的方法

 setRiskLevel(fundKey, json)                                    设置风险等级

 openThirdPartyWebInSubPage(isCloseCurrent, ...)                JS调用打开在二级页面加载第三方Web页面, 并传递用户数据

 onAgentEvent(eventId, eventLabel, kvJson)                      点击/页面事件统计（埋点）

 callbackJumpToView(functionKey)                                当调用 jumpToView 时，传入的 KEY 值是自定义的，登录完成后，则回调该方法

callbackTradeFunction(functionKey, jsonStr)                     回调 APP 方法
 ======================================================================================*/

var order = {
    multiGD: false, //多股东标志位
    mmlb: "", //买卖类别
    gznhg: false, //国债逆回购
    curzqdm: "", //证券代码当前值和历史值
    lastzqdm: "",
    curgddm: "", //股东代码当前值和历史值
    lastgddm: "",
    curjysdm: "", //交易所代码当前值和历史值
    lastjysdm: "",
    isNeverInputPrice: true, //是否输入过价格
    isHideLoad: false, //隐藏加载动画
    isMouseLeavePriceInput: true, //光标是否离开了输入框
    isStopAutoQuery: false, //是否停止自动刷新
    isFirstInputPrice: false /* 首次输入价格
                              *       点击证券代码输入框后，才将值设置成 true
                              *       可买卖数量查询完成后，如果委托价格输入框没有值，则会设置委托价格，有值则不处理；
                              *       后面代码会调用 setWTJG(marketlist) 修改委托价格（主要用自动刷新），
                              *       当 isFirstInputPrice 为 false 时，则不修改委托价格的值
                              *       当 isFirstInputPrice 为 true 时，才能修改委托价格的值，且将 isFirstInputPrice 设置成 false
                              */
};

var params = {};

//----------证券公司常量----------
/** 中信建投*/
var ZQGS_ZHONGXIN = "zhongXinJianTou";

// 证券公司
params["zqgs"] = ZQGS_ZHONGXIN;

// 版本号	重大版本更新 / 年 / 月 / 日 / 累计更新版本次数 ( 打包文件格式为 zip )
params['version'] = "v 1.0.0.0.10";
// 控件ID(调用键盘时保存的ID)
params['id'] = "";
// 模态框类型
params['modaltype'] = 0;
// 普通交易定时器名称
params['ptjytimer'] = "ptjy";
// 融资融券定时器名称
params['rzrqtimer'] = "rzrq";
//服务器返回的成功状态
params['code'] = "0";
// 请求行数
params['qqhs'] = "50";
// 是否自动刷新委托数量输入框提示语
params['isNeverInputVolume'] = true;
// 查询方向
params['cxfx'] = "1";
// 业务类型 ptjy: 普通交易; rzrq: 融资融券

params['ywlx'] = document.body == undefined ? "" : document.body.getAttribute("data-ywlx") || "";

// 新股申购请求地址
params['apiUrlNews'] = "";

// 是否是低版本
params['lowVersion'] = false;
// 浏览器	pc/android/ios
params['browser'] = getBrowser();
// 请求超时时间(默认,PC浏览器测试需要),单位分钟
params['timeOut'] = 11;
// 是否隐藏 DIV 下拉框
params['isHideDivSelect'] = false;
// 重置滚动条位置
params['scrollTop'] = 0;
// 滚动条位置偏移量
params['topPyl'] = 0;
// 切换站点切换计数（正常交易请求时会将计数重置为 1）
params['switchingStationCount'] = 1;
// 切换站点切换当前的 URL（正常交易请求时会将计数重置为 1）
params['switchingStationNowUrl'] = "";
// URL 临时地址
params['urltmp'] = "";
// 银行代码(主流的)
params['yhdms'] = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '12', '13', '14', '19', '20'];

params['querytitle'] = {
    "jjcc": "基金持仓",
    "zjls": "资金流水",
    "wtcj": "委托成交",
    "day": "当日",
    "week": "一周内",
    "month": "一个月内",
    "year": "半年内",
    "custom": "»", //用户自行填选
    "wtcx": "委托查询",
    "cjcx": "成交查询"
};

// 客户代码-币种 对应关系
params['bz'] = {
    "0": "RMB",
    "1": "HKD",
    "2": "USD"
};
// 货币代码-货币名称 对应关系
params['bzmc'] = {
    "0": "元",
    "1": "港元",
    "2": "美元"
};
// 客户代码-买卖方向 对应关系
params['mmfx'] = {
    "0": "买入",
    "1": "卖出"
};
// 客户代码-委托状态 对应关系
params['wtzt'] = {
    "0": "未报",
    "1": "正报",
    "2": "已报",
    "3": "已报待撤",
    "4": "部成待撤",
    "5": "部撤",
    "6": "已撤",
    "7": "部成",
    "8": "已成",
    "9": "废单",
    "A": "待报",
    "B": "正报"
};

// H5 向 APP 存数据的 KEY 值
params['APP_LOCALDATA_KEY'] = ['KMS_WTMM_BHXJ'];

// H5 向 APP 取数据的 KEY 值
params['appKey'] = ['ActivePTJYUser', // 普通交易用户登录信息
'ActiveRZRQUser', // 融资融券用户登录信息
'KMS_WTMM_BHXJ', // 保护限价设置完成的数据
'hqtime', // 行情刷新时间
'lhxx', // 留痕信息
'apiUrlSystem', // 认证服务器地址
'apiUrlNews', // 资讯服务器地址
'KMS_OPEN_FENSHI_ZHAIQUAN', // 债券类的分时及五档十档闭市延迟到 15:30
'KDS_JT_ACCESS_TOKEN', // 交易固定入参：access_token
'KDS_ENCRYPT_KEY', // 密钥 (sm4、安全键盘)
'cellPhoneNumber'];

// 本地存储中存在就使用本地存储中的值, 不存在则从 android 中获取
params['H5_OR_APP_KEY'] = ['apiUrl' // 站点列表
],

// 页面快捷跳转入口	[与APP交互使用,key值不能随意修改]
params["viewKey"] = {

    "KDS_SM_WTJY": "ptjy/home/home.html" // 普通交易-委托交易
    , "KDS_SM_ZCCX": "ptjy/home/home.html" // 普通交易-资产查询
    , "KDS_Buy": "ptjy/wtxd/wtmr.html" // 普通交易-买入
    , "KDS_Sell": "ptjy/wtxd/wtmc.html" // 普通交易-卖出
    , "KDS_CheDan": "ptjy/wtcd/wtcd.html" // 普通交易-撤单
    , "KDS_SM_CCQuery": "ptjy/cccx/cccx.html" // 普通交易-持仓查询
    , "KDS_Query": "ptjy/zjls/zjls.html" // 普通交易-查询
    , "KDS_QueryIndex": "ptjy/cx/cx.html" // 普通交易-查询列表页
    , "KDS_SM_RXT": "common/rxt.html" // 融信通
    , "KDS_SM_TXB": "common/txb.html" // 添鑫宝
    , "KDS_MyBusinessManagement": "common/ywbl.html" // 业务办理
    , "KDS_SM_RZRQ": "rzrq/home/rzrq_index.html" // 融资融券-主页
    , "KDS_SM_KFSJJ": "kfsjj/home/kfsjj_index.html" // 开放式基金-主页
    , "KDS_Ticket": "common/ticket.html" // 动态 KEY 值 （中台动态配置的功能）

    // 内部跳转界面
    , "KDS_PTJYLogin": "ptjy/login/ptjy_login.html" // 普通交易-登录
    , "KDS_PTJYHeader": "ptjy/home/home.html" // 普通交易-首页
    , "KDS_PTJYIndex": "ptjy/home/home.html" // 普通交易-主页
    , "KDS_PTJYHome": "ptjy/home/home.html" // 普通交易-主页-react


    , "KDS_PTJY_ZCCX": "ptjy/zccx/ptjy_zccx.html" // 普通交易-资产查询
    , "KDS_PTJY_XGMM": "ptjy/xgmm/ptjy_xgmm.html" // 普通交易-修改密码
    , "KDS_PTJY_ZJDD": "ptjy/zjdd/ptjy_zjgj.html" // 普通交易-资金调度
    , "KDS_PTJY_ZJDB": "ptjy/zjdd/ptjy_zjdb.html" // 普通交易-资金调拨
    , "KDS_PTJY_ZJLS": "ptjy/zjdd/ptjy_dbls.html" // 普通交易-资金流水

    , "KDS_PTJY_CCQueryDetail": "ptjy/chache/ptjy_cccx_detail.html" // 普通交易-持仓查询-详情

    , "KDS_PTJY_ZZCX": 'ptjy/yzzz/ptjy_zzcx.html' // 普通交易-转账查询
    , "KDS_SM_XGSG": "ptjy/xgsg/ptjy_xgsg.html" // 普通交易-新股申购
    , "KDS_PTJY_XGCX": "ptjy/xgsg/ptjy_xgcx.html" // 普通交易-新股申购查询
    , "KDS_PTJY_XZSG": "ptjy/xgsg/ptjy_xzsg.html" // 普通交易-新债申购
    , "KDS_PTJY_KCBSG": "ptjy/xgsg/ptjy_kcbsg.html" // 普通交易-科创板申购

    , "KDS_PTJY_SGRL": "ptjy/xgsg/sgrl/ptjy_sgrl.html" // 普通交易-新股申购-申购日历
    , "KDS_PTJY_SGXQ": "ptjy/xgsg/xgxq/ptjy_xgxq.html" // 普通交易-新股申购-详情
    , "KDS_PTJY_YJSG": "ptjy/xgsg/yjsg/ptjy_yjsg.html" // 普通交易-新股申购-一键申购
    , "KDS_PTJY_SGGZ": "ptjy/xgsg/yjsg/ptjy_sggz.html" // 普通交易-新股申购-申购规则
    , "KDS_PTJY_WDSG": "ptjy/xgsg/wdsg/ptjy_wdsg.html" // 普通交易-新股申购-我的申购

    , "KDS_RZRQLogin": "rzrq/home/rzrq_login.html" // 融资融券-登录
    , "KDS_RZRQHeader": "rzrq/home/rzrq_header.html" // 融资融券-首页
    , "KDS_RZRQIndex": "rzrq/home/rzrq_index.html" // 融资融券-主页

    , "KDS_RZRQ_ZCCX": "rzrq/zccx/rzrq_zccx.html" // 融资融券-资产查询
    , "KDS_RZRQ_RZMR": "rzrq/rzrqxd/rzmr.html" // 融资融券-融资买入
    , "KDS_RZRQ_RQMC": "rzrq/rzrqxd/rqmc.html" // 融资融券-融券卖出
    , "KDS_RZRQ_PTMR": "rzrq/dbpmm/dbpmr.html" // 融资融券-普通买入
    , "KDS_RZRQ_PTMC": "rzrq/dbpmm/dbpmc.html" // 融资融券-普通卖出
    , "KDS_RZRQHuanKuan": "rzrq/hkhq/hk.html" // 融资融券-还款
    , "KDS_RZRQHuanQuan": "rzrq/hkhq/hq.html" // 融资融券-还券
    , "KDS_RZRQ_DBPHZ": "rzrq/dbphz/dbphz.html" // 融资融券-担保品划转

    , "KDS_RZRQ_CCCX": "rzrq/cccx/cccx.html" // 融资融券-持仓查询
    , "KDS_RZRQ_WTCD": "rzrq/wtcd/wtcd.html" // 融资融券-委托撤单

    // , "KDS_RZRQ_WTCJ_ZJLS_Query": "rzrq/chache/rzrq_wtcj_zjls_query.html"    // 融资融券-委托成交 资金流水查询
    , "KDS_RZRQ_ZJLS": "rzrq/zjls/zjls.html" // 融资融券-资金流水查询
    , "KDS_RZRQ_WTCX": "rzrq/wtcx/wtcx.html" // 融资融券-委托查询
    , "KDS_RZRQ_CJCX": "rzrq/cjcx/cjcx.html" // 融资融券-成交查询
    , "KDS_RZRQ_DBP_KRZRQ_Query": "rzrq/chache/rzrq_dbp_krzrq_query.html" // 融资融券-担保品   可融资 融券查询
    , "KDS_RZRQ_RZRQFZ_HYCX_Query": "rzrq/chache/rzrq_rzrqfz_hycx_query.html" // 融资融券-融资融券负债 已了结合约查询
    , "KDS_RZRQ_HYCX_Query": "rzrq/hycx/hycx.html" // 融资融券-合约查询
    , "KDS_RZRQ_XYZC_HYXQ_Query": "rzrq/chache/rzrq_xyzc_hyxq_query.html" // 融资融券-信用资产 合约详情查询
    // , "KDS_RZRQ_XYFZCX_Win_Query": "rzrq/chache/rzrq_xyfzcx_win_query.html"  // 融资融券-信用负债资产查询(win版)
    , "KDS_RZRQ_XYZCFZ": "rzrq/xyzcfz/xyzcfz.html" // 融资融券-信用资产负债
    , "KDS_RZRQ_HYCHSXSX_Query": "rzrq/hychsxsz/hychsxsz.html" // 融资融券-合约偿还顺序设置
    , "KDS_RZRQ_HYZQ_Query": "hyzq/home/home.html" // 融资融券-合约展期

    , "KDS_RZRQ_XGMM": 'rzrq/xgmm/xgmm.html' // 融资融券-修改密码
    , "KDS_RZRQ_YZZZ": 'rzrq/yzzz/yzzz.html' // 融资融券-银证转账
    , "KDS_RZRQ_ZZCX": 'rzrq/yzzz/rzrq_zzcx.html' // 融资融券-转账查询
    , "KDS_RZRQ_XGCX": 'rzrq/xgsg/cx/cx.html' // 融资融券-新股查询
    , "KDS_RZRQ_XGSG": 'rzrq/xgsg/xgsg/xgsg.html' // 融资融券-新股申购
    , "KDS_JGDCX": 'rzrq/jgdcx/jgdcx.html' // 融资融券-交割单查询
    , "KDS_RZRQ_EDSQ": 'rzrq/edsq/edsq.html' // 融资融券-额度申请
    , "KDS_RZRQ_XZSG": "rzrq/xgsg/xzsg/xzsg.html" // 融资融券-新债申购
    , "KDS_RZRQ_KCBSG": "rzrq/xgsg/kcbsg/kcbsg.html" // 融资融券-科创板申购

    , "KDS_KFSJJ_Index": "kfsjj/home/kfsjj_index.html" // 开放式基金-主页

    , "KDS_KFSJJ_JJSG": 'kfsjj/jjjy/kfsjj_jjsg.html' // 开放式基金-基金申购
    , "KDS_KFSJJ_JJRG": 'kfsjj/jjjy/kfsjj_jjrg.html' // 开放式基金-基金认购
    , "KDS_KFSJJ_JJSH": 'kfsjj/jjjy/kfsjj_jjsh.html' // 开放式基金-基金赎回
    , "KDS_KFSJJ_JJZH": 'kfsjj/jjjy/kfsjj_jjzh.html' // 开放式基金-基金转换
    , "KDS_KFSJJ_FHSZ": 'kfsjj/jjjy/kfsjj_fhsz.html' // 开放式基金-分红设置

    , "KDS_KFSJJ_JJCD": 'kfsjj/jycx/kfsjj_jjcd.html' // 开放式基金-基金撤单
    , "KDS_KFSJJ_JJXX": 'kfsjj/jycx/kfsjj_jjxx.html' // 开放式基金-基金信息
    , "KDS_KFSJJ_JJCC": 'kfsjj/jjcc/jjcc.html' // 开放式基金-基金持仓
    , "KDS_KFSJJ_JYCX": 'kfsjj/jycx/kfsjj_wtcj_cccx.html' // 开放式基金-交易查询
    , "KDS_KFSJJ_ZHCX": 'kfsjj/jycx/kfsjj_zhcx.html' // 开放式基金-基金账户查询
    , "KDS_KFSJJ_JJKH": 'kfsjj/jjkh/kfsjj_jjkh.html' // 开放式基金-基金开户
    , "KDS_KFSJJ_FXTS": 'kfsjj/jjkh/kfsjj_fxts.html' // 开放式基金-风险提示

    , "KDS_KFSJJ_JJDTS": 'kfsjj/jjdts/jjdts.html' // 开放式基金-基金定投/基金定赎
    , "KDS_KFSJJ_DTSSQ": 'kfsjj/jjdts/dtssq.html' // 开放式基金-基金定投申请/基金定赎申请
    , "KDS_KFSJJ_DTSXQ": 'kfsjj/jjdts/dtsxq.html' // 开放式基金-基金定投详情/基金定赎详情

    , "KDS_KFSJJ_FXJSS": 'kfsjj/cwzcn/kfsjj_fxjss.html' // 开放式基金-基金场外转场内-风险揭示书
    , "KDS_KFSJJ_CWZCN": 'kfsjj/cwzcn/kfsjj_cwzcn.html' // 开放式基金-基金场外转场内

    //电子签约
    , "KDS_DZQY_FXCP_START": 'ptjy/dzqy/fxcp/dzqy_evaluationStart.html' // 电子签约-风险测评
    , "KDS_DZQY_RISK_TIP": 'ptjy/dzqy/fxts/dzqy_riskTip.html' // 电子签约-签约（撤销）
    , "KDS_DZQY_RISK_START": 'ptjy/dzqy/fxcp/dzqy_evaluationStart.html' // 电子签约-开始答题提示
    , "KDS_DZQY_RISK_EVALUATION": 'ptjy/dzqy/fxcp/dzqy_riskEvaluation.html' // 电子签约-答题
    , "KDS_DZQY_RTSK_CKJG": 'ptjy/dzqy/ckjg/ckjg.html' // 电子签约-查看答题结果
    , "KDS_DZQY_RISK_RESULT": 'ptjy/dzqy/cpjg/dzqy_evaluationResult.html' // 答题结果
    , "KDS_DZQY_LIST": 'ptjy/dzqy/xylb/dzqy_agreementList.html' // 签约列表
    , "KDS_DZQY_GZH": 'ptjy/dzqy/cpjg/dzqy_evaluationResultGzh.html' // 告知函

    //电子签约
    , "KDS_RZRQ_DZQY_FXCP_START": 'rzrq/dzqy/fxcp/start.html' // 电子签约-风险测评
    , "KDS_RZRQ_DZQY_RISK_START": 'rzrq/dzqy/fxcp/start.html' // 电子签约-开始答题提示
    , "KDS_RZRQ_DZQY_RISK_EVALUATION": 'rzrq/dzqy/fxcp/answer.html' // 电子签约-答题
    , "KDS_RZRQ_DZQY_GZH": 'rzrq/dzqy/cpjg/gzh.html' // 告知函
    , "KDS_RZRQ_DZQY_RTSK_CKJG": 'rzrq/dzqy/ckjg/ckjg.html' // 电子签约-查看答题结果
    , "KDS_RZRQ_DZQY_RISK_RESULT": 'rzrq/dzqy/cpjg/result.html' // 答题结果

    //港股通
    , "KDS_GGT_BUY": "ggt/wtmm/wtmr.html" // 港股通 - 买入
    , "KDS_GGT_SELL": "ggt/wtmm/wtmc.html" // 港股通 - 卖出
    , "KDS_GGT_WTCD": "ggt/kcdwtcx/kcdwtcx.html" // 港股通 - 委托撤单

    // 股份转让
    , "KDS_GFZR_DJMM_Buy": "gfzr/djmm/djmr.html" // 股份转让 - 定价买入
    , "KDS_GFZR_DJMM_Sell": "gfzr/djmm/djmc.html" // 股份转让 - 定价卖出
    , "KDS_GFZR_CJQRMM_Buy": "gfzr/cjqrmm/cjqrmr.html" // 股份转让 - 成交确认买入
    , "KDS_GFZR_CJQRMM_Sell": "gfzr/cjqrmm/cjqrmc.html" // 股份转让 - 成交确认卖出
    , "KDS_GFZR_HBQRMM_BUY": "gfzr/hbqrmm/hbqrmr.html" // 股份转让 - 互报确认-大宗买入
    , "KDS_GFZR_HBQRMM_SELL": "gfzr/hbqrmm/hbqrmc.html" // 股份转让 - 互报确认-大宗卖出
    , "KDS_GFZR_ZSMM_Buy": "gfzr/zsmm/zsmr.html" // 股份转让 - 做市买入
    , "KDS_GFZR_ZSMM_Sell": "gfzr/zsmm/zsmc.html" // 股份转让 - 做市卖出
    , "KDS_GFZR_CheDan": "gfzr/wtcd/wtcd.html" // 股份转让 - 撤单

    // 我的资产
    , "KDS_SM_WDZC": "ptjy/zcfx/home/home.html" // 我的资产 - 首页
};

// 第三方 WEB 地址
params['THIRD_PARTY_WEB_URL'] = {
    // 业务办理
    YWBL_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}#index',
    // 沪伦通
    HLT_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#hlt-index-controller',
    // 固收宝(开通权限)
    GSB_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true&urlType=gsb#authopen-protocol-controller',
    // 固收宝(菜单)
    GSB_MENU_KEY_URL: 'https://e.csc108.com/bmall/main?appType={KDS_APPTYPE}#gsb-main-view',
    // 我的理财
    WDLC_KEY_URL: 'https://e.csc108.com/mallCenter/main?appType={KDS_APPTYPE}#my-product',
    // 添鑫宝
    TXB_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}#emall-index-controller',
    // 警示股票
    JSGP_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&appVer={KDS_APPVER}&urlType=jsgp#protocol-controller',
    // 公募基金
    GMJJ_KEY_URL: 'https://e.csc108.com/gmjj/main?appType={KDS_APPTYPE}#main-view-controller',
    // 定期理财
    DQLC_KEY_URL: 'https://e.csc108.com/dqlc/main?appType={KDS_APPTYPE}#main-view-controller',
    // 集合理财
    JHLC_KEY_URL: 'https://e.csc108.com/dqlc/main?appType={KDS_APPTYPE}&instType=4#list-page-controller',
    // 现金管理 (PS: 与添鑫宝地址相同)
    XJGL_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}#emall-index-controller',
    // 沪港通
    HGT_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}#hgt-index-controller',
    // 深港通
    SGT_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}#sgt-index-controller',
    // 忘记资金账号
    WJZJZH_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#forget-fundid-controller',
    // 个人资料修改页
    GRZLXGY_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#modify-personaldata-controller',
    // 风险测评
    FXCP_KEY_URL: 'https://e.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#risk-index-controller',
    // 个人资料
    GRZL_KEY_URL: 'https://e.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#modify-personaldata-controller',
    // 修改密码
    XGMM_KEY_URL: 'https://e.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#modify-password-controller',
    // 添鑫宝快速取款
    TXB_YJQK_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}&procode=002260&single=true#yjqk-controller',
    // 智多鑫快速取款
    ZDX_YJQK_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}&procode=B50008&single=true#yjqk-controller',
    // 添鑫宝预约取款
    TXB_YYQK_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}&procode=002260&single=true#yyqk-controller',
    // 智多鑫预约取款
    ZDX_YYQK_KEY_URL: 'https://e.csc108.com/xjlc/main?appType={KDS_APPTYPE}&procode=B50008&single=true#yyqk-controller',
    // 贵金属
    GJS_KEY_URL: 'https://e.csc108.com/gold/main?appType={KDS_APPTYPE}#/',
    // 科创板
    KCB_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#technology-index',
    // 科创板重新签约
    RESIGN_KEY_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#technology-bdqs',
    // 股权激励
    GQJL_KEY_URL: 'https://soi.csc108.com/app',
    // 交易规则
    JYGZ_KEY_URL: 'https://e.csc108.com/appkcb/kcbjxgz.html',
    // 资产分布_理财
    ZCFB_LC_KEY_URL: 'https://e.csc108.com/mallCenter/main?appType={KDS_APPTYPE}#my-product',
    // 默认站点地址
    DEFAULT_TRADE_URL: 'https://sjzqdefault.csc108.com:9801/api/trade/',
    //股份转让新三版
    GFZR_XSB_URL: 'https://vmall.csc108.com/ywbl/main?appType={KDS_APPTYPE}&single=true#xsb-investor-controller',
    //询价规则
    GFZR_XJGZ_URL: 'https://e.csc108.com/app/gfzrxjgz.html',
    //申购规则
    GFZR_SGGZ_URL: 'https://e.csc108.com/app/gfzrsggz.html',
    // 两融计算器说明页
    RZRQ_JSQ_SM_URL: 'https://e.csc108.com/app/jsqSm.html'
};

// 需要加密的字段
params['ENCRYPTED_FIELD'] = ['ActivePTJYUser', 'ActiveRZRQUser', 'ptjyAccount', 'rzrqAccount', 'ptjyJZZH', 'rzrqJZZH', 'ptjyLszhList', 'rzrqLszhList', 'cellPhoneNumber', 'lhxx'];

// 消息提示
params['message'] = {};
params['message']['yzzz_success'] = "转账请求已提交，请在“查流水”中查看转账结果！"; // 银证转账_成功
params['message']['xgmm_success'] = "修改密码成功";
params['message']['xgsg_success'] = "委托下单成功"; // 新股申购 委托下单成功
params['message']['zjhz_success'] = "委托下单成功"; // 资金划转 委托下单成功

/**
 * ajax 请求时，显示 loadding 加载状态
 * loadding.run();    页面弹框显示加载状态
 * loadding.stop();    去掉加载状态
 */
var loadding = {
    // 当前请求次数，每请求一次请求次数加1，请求结束后请求次数减1
    // 当次数为0时，移除加装状态
    // 此功能用于当页面同时请求多个api时，请中一个请求结束，其余仍在
    // 请求时，加载状态仍需要显示的情景
    requestCount: 0,

    /**
     * 开始加载状态
     * @param  {[type]} isloaddingrunNoEvent [是否显示遮盖层]
     */
    run: function run(isloaddingrunNoEvent, options) {
        options = options || {};
        this.requestCount++;
        if ($("#loading").length == 0) {
            // $("body").append('<div id="loading"><div class="loading-circle"></div></div>');
            $("body").append('<div id="loading"><div>请稍候...</div></div>');
            $("#loading").show();
            if (isloaddingrunNoEvent) {
                //弹出一层，挡住界面，点击不了
                var translucent = options.translucent ? 'translucent' : '';
                $("body").append('<div id="bodyMask" class="' + translucent + '"></div>');
            }
        } else {
            if (isloaddingrunNoEvent && $('#bodyMask').length === 0) {
                var translucent = options.translucent ? 'translucent' : '';
                $("body").append('<div id="bodyMask" class="' + translucent + '"></div>');
            }
        }
    },

    /**
     * 停止加载状态
     * @param  {Boolean} isMandatory [是强制停止]
     */
    stop: function stop(isMandatory) {
        this.requestCount--;
        if (this.requestCount < 1 || isMandatory) {
            $("#loading").remove();
            $("#bodyMask").remove();
        }
    }
};

/*====================================================================
 函数功能: 	web 前后端通信
 传入参数: 	url 			: 请求地址
 jsonData		: 传递参数
 method 			: 处理函数
 errorMethod		: 错误处理函数(不传则使用默认处理)
 options 		: 其它参数的一个对象(使用第5个入参时,第四个入参不需要则传null)
 =======================================================================*/
function ajaxPost(url, jsonData, method, errorMethod, options) {
    // 如果 APP 没有传交易服务器地址过来, 则弹出提示信息
    // if (params.browser != "pc" && getLocalData("apiUrl") == null) {
    //     Dialog.customAlert("当前没有可用的交易站点", "提示信息");
    //     return;
    // }

    if (errorMethod == null) errorMethod = undefined;

    if (options == undefined) options = {};

    var defaults = {
        isloaddingrun: true, // 是否执行 loadding.run(), 默认会执行 loadding.stop()
        isloaddingrunNoEvent: false, // londingRun期间是否禁用点击事件（默认是有的）
        translucent: false, // 半透明，需要与 isloaddingrunNoEvent 一起使用才生效
        iserror: true, // 是否弹出错误提示
        async: true, // 请求方式 true: 异步请求 false: 同步请求
        issuccess: true, // 是否需要成功校验 true: 需要 false: 不需要
        isQHZD: false, // 是否是切换站点
        isQHZD_Z: false, // 是否是主动登录有的导致切换站点（主动切换场景有：登录界面、解锁）
        isLOGIN: false, // 是否是登录请求
        completeMethod: null, // ajax 执行完成后回调的函数
        timeout: getAjaxTimeOut(), // ajax 请求超时的时间
        isFixedParam: true, // 是否使用固定参数
        headers: getPostHeaders(), // 添加额外的请求头
        error: null, // 报错后执行的方法 （不再执行 http 统一报错提示）
        url: url, // 将 URL 放到 options，在业务错误时需要用到
        specifyServerErrorCode: [], // 指定服务器的错误码 (支持多个错误码，如：['410411001', '410411002'])
        specifyServerErrorCodeMethod: null // 出现指定服务器的错误码后执行的方法 （此配置不能单独出现，必须与 specifyServerErrorCode 一起使用）
    };

    var options = $.extend(defaults, options);

    // 使用固定入参
    if (options.isFixedParam) {
        // 除操作超时,普通交易登录,融资融券交易登录 请求需要提取保存的用户信息
        if (window.location.href.indexOf("ptjy_login") == -1 && window.location.href.indexOf("rzrq_login") == -1 && options.isLOGIN == false) {
            jsonData = setDefaultJsonData(jsonData);
            // 用户登录信息已经不存在了，不能再发起 ajax 请求
            if (jsonData == null) {
                return;
            }
        }

        jsonData['lhxx'] = getMarkInfo(); // 留痕信息
        jsonData['access_token'] = getLocalData('KDS_JT_ACCESS_TOKEN') || '0'; // 用于 auth 服务器做鉴权操作
        // 客户端版本号 (其实这个是服务器版本号)
        jsonData['khdbbh'] = h5Version;
    }

    // 敏感字段加密
    jsonData = sensitiveFieldEncryption(jsonData);

    var headers = options.headers;
    var data = JSON.stringify(jsonData);

    // 对 postbody 进行加密
    data = { cTxt: SM4.encryptDataECB(data) };
    data = JSON.stringify(data);

    // HTTP 请求头信息增加签名
    headers = headersAddServiceToken(url, headers, data);

    // console.log("发送请求时间:"+new Date());
    console.log("[请求] " + url);
    console.log("[入参] " + data);

    $.ajax({
        type: "POST",
        url: url,
        data: data,
        headers: headers,
        timeout: options.timeout,
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        async: defaults.async,
        cache: false,
        beforeSend: function beforeSend() {
            //请求之前加载
            if (options.isloaddingrun) {
                loadding.run(options.isloaddingrunNoEvent, options);
            }
        },

        success: function success(response) {
            console.log("[出参] " + JSON.stringify(response));

            // 是否需要成功返回校验
            if (options.issuccess) {
                // 成功返回执行回调函数, 否则统一处理失败返回
                if (IsSuccess(response, errorMethod, options)) {
                    angular.element($("body")).scope().$apply(function () {
                        method(response);
                    });
                }
            } else {
                angular.element($("body")).scope().$apply(function () {
                    method(response);
                });
            }
        },

        error: function error(request, status, _error) {
            // 当前界面已经跳转, 不再弹出错误提示信息
            if (params.isJumpInterface) {
                return;
            }

            var ZDQH_HTTP_STATUS = [0, 404, 408, 500, 501, 502, 503, 504];
            // 顺序切换到下一个交易站点，不再自动重新发请求
            if (ZDQH_HTTP_STATUS.indexOf(request.status) > -1 && url.indexOf('api/trade') > 0) {
                SwitchingStation.start2();
            }

            // 执行回调方法，不再执行 http 统一报错提示
            if (options.error != null) {
                angular.element($("body")).scope().$apply(function () {
                    options.error(request, status, _error);
                });
                return;
            }

            console.log("[报错] " + request.status, request.statusText, "error:" + _error);

            var errorText = "";

            if (request.status == 0) {
                if (request.statusText == "timeout") {
                    errorText = "您的网络不给力，请稍后再试。";
                } else {
                    errorText = "网络请求失败，请稍后再试。";
                }
            } else if (request.status == 400 || request.status == 404) {
                errorText = "网络连接失败。";
            } else if (request.status == 500 || request.status == 502) {
                errorText = "服务器繁忙，请稍后再试。";
            } else {
                errorText = "网络请求失败，稍后再试。";
            }

            errorText = [errorText, '[', request.status, ']'].join('');

            if (options.iserror) {
                Dialog.customAlert(errorText, "提示信息");
            }

            // 防止在请求报错后，因为其它原因导致没有去掉。
            loadding.stop(true);
        },

        complete: function complete(xhr, textStatus) {
            // 回调函数执行后加载
            if (options.isloaddingrun) {
                loadding.stop();
            }

            // 回调函数
            if (options.completeMethod != null) {
                options.completeMethod(xhr, textStatus);
            }
        }
    });
}

/**
 * 获取 HTTP 请求头信息
 */
function getPostHeaders() {
    // 从 KDS_HEADERS 中取得 deviceId
    var kdsHeaders = JSON.parse(getLocalData('KDS_HEADERS') || '{}');
    var headers = {};
    var ActiveUse = {};

    // 设置默认值，防止值为 NULL 导致字段不存在
    headers.msgId = '';
    headers.deviceId = '';
    headers.agent = '';
    headers.tradeToken = '';
    headers.khbz = '';

    if (params.ywlx == "ptjy" || params.ywlx == "kfsjj") {
        ActiveUse = JSON.parse(getLocalData("ActivePTJYUser") || '{}');
    } else if (params.ywlx == "rzrq") {
        ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser") || '{}');
    }

    try {
        headers.msgId = new GUID().newGUID();
        headers.deviceId = kdsHeaders.deviceId || '';
        headers.agent = params.browser + '-' + h5Version;
        headers.tradeToken = ActiveUse.body.tradetoken || '';
        headers.khbz = SM4.encryptDataECB(ActiveUse.head.khbz);
    } catch (e) {}

    return headers;
}

// HTTP 请求头信息增加签名
function headersAddServiceToken(url, headers, data) {
    var subUrl = url.substr(url.indexOf('/api/'));
    var index = subUrl.indexOf("?");
    if (index > 0) {
        var subUrl = subUrl.substring(0, index);
    }
    var stringToSign = subUrl + md5(data) + headers.msgId;
    headers.appSign = sha256(stringToSign);
    return headers;
}

//设置默认的ajax参数
function setDefaultJsonData(jsonData) {
    jsonData = jsonData || {};
    // 担保品划转
    if (document.title.trim() == "担保品划转") {
        if ($("#DBPHZType button.active").text().trim() == "普通转信用") {
            var ActiveUse = JSON.parse(getLocalData("dbphzPTJYUser"));
        } else if ($("#DBPHZType button.active").text().trim() == "信用转普通") {
            var ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser"));
        }
    } // 融资融券
    else if (params.ywlx == "rzrq" && getLocalData("ActiveRZRQUser")) {
            var ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser"));
        }
        // 普通交易和开放式基金使用的账号相同
        else if ((params.ywlx == "kfsjj" || params.ywlx == "ptjy") && getLocalData("ActivePTJYUser")) {
                var ActiveUse = JSON.parse(getLocalData("ActivePTJYUser"));
            } else {
                console.log("[ajaxPost] 用户信息丢失");
                return null;
            }

    jsonData['signToken'] = ActiveUse.head.signToken || '';
    jsonData['userId'] = ActiveUse.head.userId || '';
    jsonData['khbz'] = ActiveUse.body.dlxx[0].zjzh;
    jsonData['khbzlx'] = ActiveUse.head.khbzlx; // 客户标志类型

    jsonData['jymm'] = jsonData.jymm == undefined ? ActiveUse.head.jymm : jsonData.jymm; // 交易密码
    jsonData['sessionid'] = jsonData['sessionid'] ? jsonData['sessionid'] : "0"; // 移动证券系统 APP 注册 ID, 由金慧盈通颁发和认证  [目前该字段服务器还未下发]

    jsonData['token'] = ActiveUse.body.dlxx[0].token || "0"; // 账户会话ID，用户登录后由柜台下发和认证，首次登陆填空 [目前该字段服务器还未下发]
    jsonData['yybdm'] = ActiveUse.body.dlxx[0].yybdm; // 营业部代码
    jsonData['khdm'] = ActiveUse.body.dlxx[0].khdm; // 客户代码               // 客户端版本号 (其实这个是服务器版本号)

    return jsonData;
}

/**
 * 敏感字段加密
 * @param   {JSON} jsonData 源 JSON
 * @return  {JSON}          加密后的 JSON
 */
function sensitiveFieldEncryption(jsonData) {
    var newJsonData = {};
    var encryptKey = JSON.parse(getLocalData("KDS_ENCRYPT_KEY") || '{}').sm4Key || '';
    if (encryptKey === '') {
        return jsonData;
    }
    var fields = ['jymm', 'yhmm', 'zjmm', 'xjymm', 'yzjmm', 'xzjmm', 'zczjmm', 'khbz', 'khdm', 'dyzjzh', 'lhxx'];
    for (var key in jsonData) {
        if (fields.indexOf(key) !== -1 && typeof jsonData[key] === 'string') {
            newJsonData[key] = SM4.encryptDataECB(jsonData[key], encryptKey);
        } else {
            newJsonData[key] = jsonData[key];
        }
    }

    // "0" 时为不加密状态, "1" 时采用国密4加密方式
    newJsonData.mmjmlx = '1';

    return newJsonData;
}

/**
 * 获取表单数据
 */
function getformdata() {
    // 将表单数据JSON对象化
    var dataJson = $("*[isSub=true]").serializeArray();

    // 将表单JSON对象转换成常规JSON对象
    dataJson = convertToJson(dataJson);

    dataJson.lhxx = getMarkInfo();

    // JSON对象转换成JSON字符串
    // dataJson = JSON.stringify(dataJson);
    // console.log(dataJson);
    return dataJson;
}

/**
 *    是否成功, 失败的提示信息由该函数统一处理
 *    @param 返回数据
 */
function IsSuccess(response, errorMethod, options) {
    var code = response.cljg[0].code;

    // 兼容处理 MP1B000000 也是成功返回标识
    if (code != params.code && code != "MP1B000000") {
        var message = response.cljg[0].message;

        // 过虑信息
        message = filterMessage(message);

        // 指定服务器错误码的处理
        if (options.specifyServerErrorCode.indexOf(code) != -1) {
            // 执行出现指定服务器错误码后的方法
            if (options.specifyServerErrorCodeMethod) {
                options.specifyServerErrorCodeMethod(response, options, code);
            }
            loadding.stop(true);
            return false;
        }

        // 默认处理
        if (errorMethod != null) {
            angular.element($("body")).scope().$apply(function () {
                errorMethod(response);
            });
        }

        if (errorMethod == null) {
            Dialog.customAlert(message, "提示信息");
        }

        // 防止在请求报错后，因为其它原因导致没有去掉。
        loadding.stop(true);

        return false;
    } else {
        return true;
    }
}

/**
 * 过滤过失败信息中不需要显示的内容
 * @param message 失败信息的内容
 */
function filterMessage(message) {
    var param_index0 = message.indexOf("流水号");

    if (param_index0 >= 0) {
        message.replace("流水号", "");
    }

    // 相关参数出现的位置
    var param_index1 = message.indexOf("[相关参数");

    // 只有当相关参数出现的位置不在第首位才过滤相关参数
    if (param_index1 > 0) {
        message = message.substring(0, param_index1);
    }

    return message;
}

/**
 * 切换站点
 */
var SwitchingStation = function () {
    // 记录切换站点错误信息的 KEY
    var SWITCHING_STATION_ERROR_INFO_PTJY_KEY = "switchingStationErrorInfoPTJY";
    var SWITCHING_STATION_ERROR_INFO_RZRQ_KEY = "switchingStationErrorInfoRZRQ";
    // 记录切换站点错误信息的条数
    var SWITCHING_STATION_ERROR_INFO_SIZE = 6;
    // 切换站点登录时传送的错误信息的入参字段名
    var SWITCHING_STATION_ERROR_REQ_PARAM = "switchTrace";
    // 是否出错弹出提示框（只有最后一次切换站点后才需要弹出提示框）
    var isErrorAlert = false;

    /**
     * 开始站点切换流程
     */
    function start(errorCode, errorURL) {
        // 防止重复切换站点 (同一个站点下，不能进行多次站点切换)
        var errorIP = errorURL.split("/api/trade")[0];
        if (params.switchingStationNowUrl == errorIP) {
            return;
        } else {
            params.switchingStationNowUrl = errorIP;
        }

        // 获取站点信息
        var apiUrl = JSON.parse(getLocalData("apiUrl") || "{}");
        // 因为进入到该函数肯定是请求下一个站点, 所第一次调用函数肯定是从 2 开始
        params.switchingStationCount++;
        console.log("switchingStation => switchingStationCount: " + params.switchingStationCount);
        // 添加错误信息
        addErrorInfo(errorCode, errorURL);

        // 下列情况不需要站点切换
        if (apiUrl.index == null) {
            console.log("站点信息不存，无法进行切换站点");
            // 弹出提示框，显示错误信息
            showErrorAlert();
            return;
        } else if (params.urltmp == "") {
            console.log("本页面没有进行过正常业务请求，无法直接进行站点切换");
            // 弹出提示框，显示错误信息
            showErrorAlert();
            return;
        } else if (apiUrl.testurl != "") {
            resetCount();
            console.log("正在使用超级用户设置的站点, 不需要进行切换站点");
            // 弹出提示框，显示错误信息
            showErrorAlert();
            return;
        } else if (apiUrl.index == "" || apiUrl.urllist.length == 0) {
            resetCount();
            console.log("没有站点列表信息记录，无法进行切换站点");
            // 弹出提示框，显示错误信息
            showErrorAlert();
            return;
        } else if (params.switchingStationCount > apiUrl.urllist.length) {
            resetCount();
            console.log("本轮切换站点的次数已经大于站点列表的总数，故全部站点已经切换完成，本轮站点切换已完成！");
            // 弹出提示框，显示错误信息
            showErrorAlert();
            return;
        }

        // 当循环请求站点列表中的最后一个站点时, 如果异常，需要报错误提示信息, 多站点切换的过程中是不需要弹出提示框.
        isErrorAlert = params.switchingStationCount == apiUrl.urllist.length ? true : false;

        // 尝试在下一个站点进行登录，如果登录成功则切换到该站点，否继续再下一个站点，所有站点都失败则弹出提示框
        // 在登录界面，触发了站点切换，完成下一个站点的登录后，需要跳转到对应的页面去
        if (params.urltmp.indexOf("login") > -1 && getlasthref().indexOf("login") > -1) {
            showMessageTips("交易登录中, 请稍候...", null, 0);
            login();
        }
        // 普通交易与融资融券都需要重新登录
        else if (getLocalData("ActivePTJYUser") && getLocalData("ActiveRZRQUser")) {
                // 这里是先执行普通交易
                // 登录成功后，则进行融资融券登录
                // 都登录成功后，才会进行切换交易站点
                ptjy(rzrq);
            }
            // 普通交易重新登录
            else if (getLocalData("ActivePTJYUser")) {
                    ptjy();
                }
                // 融资融券重新登录
                else if (getLocalData("ActiveRZRQUser")) {
                        rzrq();
                    } else {
                        console.log("未知情况，可能是登录信息已经不存在，没有登录信息无法进行自动去登录！");
                    }
    }

    /**
     * 站点切换 - 顺序切换到下一个交易站点
     */
    function start2() {
        var apiUrlKey = 'apiUrl';
        var apiUrl = JSON.parse(getLocalData(apiUrlKey) || '{}');
        if (apiUrl.index) {
            var nextIndex = (parseInt(apiUrl.index) + 1) % apiUrl.urllist.length;

            apiUrl.index = nextIndex.toString();

            setLocalData(apiUrlKey, apiUrl);
        }
    }

    /**
     * 普通交易切换站点时进行下一个站点登录
     */
    function ptjy(method) {
        CloseAlert();

        if (getLocalData("ActivePTJYUser")) {
            console.log("切换站点 - 普通交易重新登录");

            var lastUrl = "ptjy/ptyw/login2";
            var ptjyquest = JSON.parse(getLocalData("ActivePTJYUser"));

            ptjyrequest = ptjyquest.head;
            // 将错误信息通过入参送给交易服务器，方便以后日志查看
            ptjyrequest[SWITCHING_STATION_ERROR_REQ_PARAM] = getPtjyErrorInfo();

            ajaxPost(getApiUrl() + lastUrl, ptjyrequest, function (response) {
                if (method != undefined) {
                    method();
                } else {
                    // 成功后的处理
                    success();
                    // 弹出提示框，显示错误信息
                    showErrorAlert();
                }
            }, null, {
                isloaddingrun: false,
                iserror: isErrorAlert,
                isQHZD: true,
                isLOGIN: true
            });
        }
    }

    /**
     * 融资融券切换站点时进行下一个站点登录
     */
    function rzrq(method) {
        CloseAlert();

        if (getLocalData("ActiveRZRQUser")) {
            console.log("切换站点 - 融资融券重新登录");

            var lastUrl = "rzrq/ptyw/login";
            var rzrqquest = JSON.parse(getLocalData("ActiveRZRQUser"));

            rzrqrequest = rzrqquest.head;
            // 将错误信息通过入参送给交易服务器，方便以后日志查看
            rzrqrequest[SWITCHING_STATION_ERROR_REQ_PARAM] = getRzrqErrorInfo();

            ajaxPost(getApiUrl() + lastUrl, rzrqrequest, function (response) {
                if (method != undefined) {
                    method();
                } else {
                    // 成功后的处理
                    success();
                    // 弹出提示框，显示错误信息
                    showErrorAlert();
                }
            }, null, {
                isloaddingrun: false,
                iserror: isErrorAlert,
                isQHZD: true,
                isLOGIN: true
            });
        }
    }

    /**
     * 登录切换站点时进行下一个站点登录
     */
    function login() {
        console.log("切换站点 - 登录界面处理");

        CloseAlert();

        var lastUrl = params.ywlx == "ptjy" ? "ptjy/ptyw/login2" : "rzrq/ptyw/login";
        var loginrequest = getformdata();
        // 将错误信息通过入参送给交易服务器，方便以后日志查看
        loginrequest[SWITCHING_STATION_ERROR_REQ_PARAM] = params.ywlx == "ptjy" ? getPtjyErrorInfo() : getRzrqErrorInfo();

        // 登录界面
        ajaxPost(getApiUrl() + lastUrl, loginrequest, function (response) {
            var handleMethod = function handleMethod() {
                var userInfo = {};

                if (response.dlxx) {
                    // 要从表单中提取出交易密码
                    userInfo["head"] = getformdata();
                    userInfo["body"] = response;
                    parseUserInfo(params.ywlx, userInfo, response.dlxx[0].khdm, funBeforeJumpToHomePage);
                }

                // 保存登录账号
                addKhbs(getformdata().khbz);

                // 操作完成后进行
                success();
            };

            // 在普通交易登录页面，如果存在融资融券已登录，则需要融资融券在下一个交易站点下进行登录
            if (params.ywlx == "ptjy" && getLocalData("ActiveRZRQUser")) {
                rzrq(handleMethod);
            }
            // 在融资融券登录页面，如果存在普通交易已登录，则需要普通交易在下一个交易站点下进行登录
            else if (params.ywlx == "rzrq" && getLocalData("ActivePTJYUser")) {
                    ptjy(handleMethod);
                } else {
                    handleMethod();
                }
        }, controller.scope.loginError, {
            isQHZD: true,
            isQHZD_Z: true,
            completeMethod: function completeMethod() {
                $(".messageTips").remove();
            }
        });
    }

    /**
     * 获取下一个交易站点的索引
     */
    function getNextIndex() {
        var apiUrl = JSON.parse(getLocalData("apiUrl") || "{}");
        var nextIndex = parseInt(apiUrl.index);
        var urllistLength = apiUrl.urllist.length;
        // 下一个交易站点 = (当前站点 + 站点切换的次数) % 站点总数
        nextIndex = (nextIndex + (params.switchingStationCount - 1)) % urllistLength;
        console.log("nextIndex: " + nextIndex);
        return nextIndex.toString();
    }

    /**
     * 更新交易站点的索引
     */
    function updateIndex() {
        var apiUrl = JSON.parse(getLocalData("apiUrl") || "{}");
        apiUrl.index = getNextIndex();
        setLocalData("apiUrl", apiUrl);
    }

    /**
     * 添加/追加错误信息
     * @param {[type]} errorCode [错误码]
     * @param {[type]} errorURL  [错误站点的IP和功能号]
     */
    function addErrorInfo(errorCode, errorURL) {
        var key = SWITCHING_STATION_ERROR_INFO_PTJY_KEY;
        if (errorURL.indexOf("rzrq/") > -1) {
            key = SWITCHING_STATION_ERROR_INFO_RZRQ_KEY;
        }
        // 获取站点切换的错误信息 （没有则默认为空数组）
        var errorInfo = JSON.parse(getLocalData(key) || "[]");
        // 判断错误信息数量是否达到设置的最大值，达到后则删除最先添加的值，再添加新值
        if (errorInfo.length >= SWITCHING_STATION_ERROR_INFO_SIZE) {
            errorInfo.shift();
        }
        // 错误信息添加到数组中
        errorInfo.push([errorURL, errorCode].join(","));
        // 保存数据
        setLocalData(key, errorInfo);
    }

    /**
     * 删除错误信息
     */
    function deleteErrorInfo() {
        removeLocalData(SWITCHING_STATION_ERROR_INFO_PTJY_KEY);
        removeLocalData(SWITCHING_STATION_ERROR_INFO_RZRQ_KEY);
    }

    /**
     * 获取错误信息
     */
    function getPtjyErrorInfo() {
        var errorInfo = JSON.parse(getLocalData(SWITCHING_STATION_ERROR_INFO_PTJY_KEY) || "[]");
        return errorInfo.join(";");
    }

    /**
     * 获取错误信息
     */
    function getRzrqErrorInfo() {
        var errorInfo = JSON.parse(getLocalData(SWITCHING_STATION_ERROR_INFO_RZRQ_KEY) || "[]");
        return errorInfo.join(";");
    }

    /**
     * 弹出提示框，显示错误信息
     */
    function showErrorAlert() {
        CloseAlert();
        Dialog.customAlert("您的网络不给力，请稍后再试", "提示信息");
    }

    /**
     * 成功后的处理
     */
    function success() {
        // 删除错误信息
        deleteErrorInfo();
        // 进行切换站点 （之后正常业务交易请求都将使用新站点）
        updateIndex();
        // 重置站点切换的计数
        resetCount();
    }

    /**
     * 重置站点切换的计数
     */
    function resetCount() {
        params.switchingStationCount = 1;
        params.switchingStationNowUrl = "";
    }

    // 提供对外访问的方法或属性
    return {
        start: start,
        start2: start2,
        getNextIndex: getNextIndex,
        resetCount: resetCount
    };
}();

/**
 * 将表单对象转为json对象
 * @param formValues
 * @returns
 */
function convertToJson(formValues) {
    var result = {};

    for (var formValue, j = 0; j < formValues.length; j++) {
        formValue = formValues[j];
        var name = formValue.name;
        var value = formValue.value;

        if (name.indexOf('.') < 0) {
            result[name] = value;
            continue;
        } else {
            var simpleNames = name.split('.');

            // 构建命名空间
            var obj = result;
            for (var i = 0; i < simpleNames.length - 1; i++) {
                var simpleName = simpleNames[i];

                if (simpleName.indexOf('[') < 0) {
                    if (obj[simpleName] == null) {
                        obj[simpleName] = {};
                    }
                    obj = obj[simpleName];
                } else {
                    // 数组
                    // 分隔
                    var arrNames = simpleName.split('[');
                    var arrName = arrNames[0];
                    var arrIndex = parseInt(arrNames[1]);
                    if (obj[arrName] == null) {
                        obj[arrName] = []; // new Array();
                    }
                    obj = obj[arrName];
                    multiChooseArray = result[arrName];
                    if (obj[arrIndex] == null) {
                        obj[arrIndex] = {}; // new Object();
                    }
                    obj = obj[arrIndex];
                }
            }

            if (obj[simpleNames[simpleNames.length - 1]]) {
                var temp = obj[simpleNames[simpleNames.length - 1]];
                obj[simpleNames[simpleNames.length - 1]] = temp;
            } else {
                obj[simpleNames[simpleNames.length - 1]] = value;
            }
        }
    }
    return result;
}

/**
 * 输入解锁界面的密码
 * */
function inputUnlockPassword(pw) {
    if (isSystemKeyboard) {
        $("#jymm").removeAttr("readonly");
        $("body").on("keyup", "#jymm", function () {
            judegSystemKeyboardInput($("#jymm")[0], "unlockLogin");
        });
    } else {
        showKeyboard('jymm', 3);
    }
}

/**
 *  系统键盘输入，字符检验处理
 */
//合法字符范围
var legalStrs = "abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,-_()/=+?!&*<>;:@%|";
//不合法的密码输入，针对json
var illegalPwdChars = "\"'{}";
/**
 * 判断系统键盘输入
 */
function judegSystemKeyboardInput(textInput, tag) {
    var text = $(textInput).val();
    var addStr;
    var haveStr = params[textInput.id];
    if (!haveStr) {
        if (text.length == 1) {
            if (illegalPwdChars.indexOf(text) != -1) {
                //第一输入，是不合法的，跳出
                $(textInput).val("");
                return;
            }
        }
        addStr = params[textInput.id] = text;
    } else {
        if (text.length < haveStr.length) {
            //按删除键
            params[textInput.id] = text;
            return;
        }
        addStr = text.replace(haveStr, "");
    }
    if (addStr == "") {
        //空串返回
        return;
    }
    if (addStr.length > 1) {
        var splits = addStr.split("");
        for (var i = 0; i < splits.length; i++) {
            if (!chechLegal(textInput, splits[i])) {
                return;
            }
        }
    } else {
        if (!chechLegal(textInput, addStr)) {
            return;
        }
    }

    params[textInput.id] = text;
    if (tag == "login") {
        //登录
        if (textInput.id == "vertifyCode") {
            if (text.length == 4) {
                $("#vertifyCode").blur();
            }
        }
    }

    if (isSystemKeyboard) {
        // 登录界面的密码输入框、解锁框、银证转账中的密码输入框密码长度限制
        if ((tag == "login" || tag == "unlockLogin" || tag == "yzzz") && (textInput.id == "jymm" || textInput.id == "yhmm" || textInput.id == "zjmm" || textInput.id == "yhmms" || textInput.id == "zjmms")) {
            if (text.length > limitNewPasswordLength) {
                text = text.substr(0, limitNewPasswordLength);
                textInput.value = text;
                params[textInput.id] = text;
                showMessageTips("密码最长为" + limitNewPasswordLength + "位!", "7");
            }
        }

        if (tag == "ptjy_xgmm" || tag == "rzrq_xgmm") {
            // 对原密码、新密码、确认密码长度进行限制  2016.06.17 update
            if (textInput.id == "newPwd" || textInput.id == "oldPwd" || textInput.id == "confirmPwd") {
                if (text.length > limitNewPasswordLength) {
                    params[textInput.id] = haveStr;
                    $(textInput).val(haveStr);
                    showMessageTips("密码最长为" + limitNewPasswordLength + "位!", "7");
                }
            }
        }
    }

    function chechLegal(obj, char) {
        if (tag == "login") {
            //登录
            if (obj.id == "khbz") {
                //账号
                if (legalStrs.indexOf(char) == -1) {
                    //不合法的账号输入
                    showMessageTips("账号格式不正确，请重新输入");
                    $(obj).val(haveStr);
                    return false;
                }
            } else if (obj.id == "jymm") {
                //密码
                if (illegalPwdChars.indexOf(char) != -1) {
                    showMessageTips("输入的字符有误，请重新输入");
                    $(obj).val(haveStr);
                    return false;
                }
            }
        } else if (tag == "ptjy_xgmm" || tag == "rzrq_xgmm" || tag == "unlockLogin" || tag == "yzzz") {
            //修改密码
            if (illegalPwdChars.indexOf(char) != -1) {
                showMessageTips("输入的字符有误，请重新输入");
                $(obj).val(haveStr);
                return false;
            }
        }
        return true;
    }
}
/*********************************************************************************************/
/********************************* 与 APP 交互的函数 start ***********************************/
/*********************************************************************************************/
/**
 *    显示键盘
 *    @param        id    触发显示键盘事件的文本框ID
 *    @param        type    键盘类型
 *                      1. 只有数字 （左下角什么都没有）
                        2. 数字+小数点 （左下角是小数点“.”）
                        3. 数字，字母，符号
                        4. 数字+最左边一列是仓库选项  eg: 全仓 1/2仓库  1/3仓库  1/4仓库
                        5. 数字，字母, 系统中文
                        6. 数字，字母，系统中文，数字键盘的左边有一栏 eg: 000 200 300 600
                        9. 键盘精灵只包含港股数据
                        10. 键盘精灵
 */
function showKeyboard(id, type) {
    if (id == undefined) {
        console.log("文本输入框 id 不能为空!");
        return;
    }

    if ($('#' + id).length == 0) {
        console.log("文本输入框 id 不存在! id=" + id);
        return;
    }

    $("#" + id).focus();

    if (type == undefined) {
        console.log("键盘类型不存在!");
        hideKeyBoard();
        return;
    }

    var X = $('#' + id).offset().left;
    var Y = $('#' + id).offset().top;

    // 兼容 ios，获取弹框可见区域的位置
    if (params.browser == 'ios') {
        var e = event || window.event;
        Y = e.clientY || Y;
    }

    Y += $('#' + id).height(); // 加上文本框高度
    Y += 80; // 额外加 80 像素, 可以显示出下一个输入框或按钮

    // 是否是相同的 ID
    var sameid = id == params.id;

    params.id = id;

    if (params.id == "zqdm" || params.id == "hqzqdm" || params.id == "zrzqdm") {
        if (_typeof(controller.scope) === "object" && typeof controller.scope.clear === 'function') {
            controller.scope.clear();
        } else {
            // 输入内容时,停止自动刷新
            order.isStopAutoQuery = true;
            // 设置成首次输入委托价格
            order.isFirstInputPrice = true;

            $("#" + params.id).val("");

            if (params.id == "zqdm") {
                $("#zqmc").text("");

                if (params.ywlx == "kfsjj") {
                    clearJJJYForm(params.id);
                } else {
                    clearBargainPageFullData("NoAjax");
                }
            } else if (params.id == "zrzqdm") {
                clearJJJYForm(params.id);
            } else if (params.id == "hqzqdm") {
                clearZQDMVolumeForm("请输入还券数量", "hq");
            }
        }
    } else if (params.id == "price") {
        order.isMouseLeavePriceInput = false;
    }

    console.log("[" + params.id + "] [键盘类型:" + type + "] 当前文本框的坐标 X:" + X + " Y:" + Y);

    if (params.browser == 'android') {
        var pageHeight = window.document.body.clientHeight || window.innerHeight;
        // 偏移量 ( 页面可见区域高度 - 输入框底部到页面顶部的高度 )
        params.topPyl = Y - pageHeight / 2;
        // 系数 = 输入框底部到页面顶部的高度 / 页面可见区域高度
        Y = Y / pageHeight;

        // 低版本, 不需要上推
        if (params.lowVersion) {
            if (params.topPyl > 0 && !sameid) {
                $("body").css("margin-top", -params.topPyl + "px");
            } else {
                params.topPyl = 0;
            }

            Y = 0;
        }

        var pageup = $("#" + id).attr("pageup") || "true";
        // 页面不需要向上移动
        if (pageup == "false") {
            Y = 0;
        }

        KDS_Native.showKeyBoard(type, Y);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://showKeyBoard:" + type + ":" + Y);
    } else {
        // console.log("只能在IOS系统与Android系统显示自定义键盘");
        // 使用系统键盘
        useSysKeyboard(id);
    }
}

/**
 * 使用系统键盘
 * @param  {[string]} id [input id]
 */
function useSysKeyboard(id) {
    params.id = id;
    var keyupId = "keyup_" + id;
    // 点击页面 input, 只有第一次点击时才会绑定事件
    if (!window[keyupId]) {
        window[keyupId] = true;
        // 增加方便在 PC 调试的代码
        $("#" + id).removeAttr("readonly");
        $("body").on("keyup", "#" + id, function (event) {
            var ventWhich = event.which;
            console.log("键盘对应的 key 值: " + event.which);

            var _inputId = $("#" + id);
            var _type = _inputId.attr("type");
            var _toFixed = _inputId.attr("data_tofixed") || "";
            var _value = _inputId.val();
            var _haveStr = params[id] || "";

            // 数字类型的输入框, 回退时不需要再校验
            if ("number" == _type && ventWhich != 8) {
                // 验证是否是正实数, 不是就删除最后输入的那一位
                if (!/^[0-9]+(.[0-9]*)?$/.test(_value)) {
                    _inputId.val(_haveStr);
                    return;
                }

                // 需要校验小数点后的位数
                if ("" != _toFixed) {
                    var _value_ = _value.split(".")[1] || "";
                    if (_value_.length > _toFixed) {
                        _inputId.val(_haveStr);
                        return;
                    }
                }
            }

            // 当前的值与上次输入的不一样, 则进行下一步
            if (_value != _haveStr) {
                fillInputContent("");
                params[id] = _value;
            }
        });
    }
}

/**
 *    隐藏APP自定义键盘
 */
function hideKeyBoard() {
    try {
        if (params.browser == 'android') {
            KDS_Native.hideKeyBoard();
        } else if (params.browser == 'ios') {
            loadURL("KDS_Native://hideKeyBoard");
        }
    } catch (e) {
        console.error(e);
    }
    closeKeyBoard();
}

/**
 *    自定义键盘回调函数    [与APP交互使用,函数名不能随意修改]
 *    @param param    键盘输入的值
 *    @param jysdm    交易所代码
 */
function fillInputContent(param, jysdm) {
    if (param == "del") {
        var _value = $("#" + params.id).val();

        $("#" + params.id).val(_value.substring(0, _value.length - 1));
    } else {
        $("#" + params.id).val($("#" + params.id).val() + param);
    }
}

/**
 * 关闭自定义键盘回调函数
 */
function closeKeyBoard() {
    // android 4.4 以下的手机
    if (params.lowVersion) {
        // 重置滚动条
        resetScroll();
    }
}

/**
 *    URL 跳转界面
 *    @param url            url地址
 *    @param hasRefresh     标识有无刷新按钮 0：显示，4：隐藏(占空间),8:隐藏(不占空间)
 *    @param direction      1：下一级界面；2：重定向；0: 平级切换；-1：返回上一级界面； -100：返回到最上级界面；
 */
function JumpInterface(url, hasRefresh, direction) {
    // 跳转前隐藏自定键盘
    hideKeyBoard();

    console.log("[URL] " + url);

    // 未传第3个参数时默认为1
    direction = direction == undefined ? 1 : direction;

    if (!isNaN(hasRefresh)) {
        hasRefresh = parseInt(hasRefresh);
    } else {
        console.log("hasRefresh参数值不是数字，使用默认值 0 ");
        hasRefresh = 0;
    }

    if (!isNaN(direction)) {
        direction = parseInt(direction);
    } else {
        console.log("direction参数值不是数字，使用默认值 1 ");
        direction = 1;
    }

    if (params.browser == 'android') {
        KDS_Native.switchWebView(url, hasRefresh, direction);
    } else if (params.browser == 'ios') {
        // location.href="KDS_Native://switchWebView:"+url+":"+hasRefresh+":"+direction;
        loadURL("KDS_Native://switchWebView:" + url + ":" + hasRefresh + ":" + direction);
    } else {
        url = getfirsthref() + url;

        console.log("跳转地址：" + url);

        // 平级页面之间的跳转
        if (direction == 0) location.replace(url);else location.href = url;
    }

    // 界面已跳转
    params.isJumpInterface = true;
}

function startAppPage(parameters) {
    if (params.browser == 'android') {
        KDS_Native.startAppPage.apply(KDS_Native, parameters);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://startAppPage:" + parameters.join(':'));
    }
}

/**
 * go原生交易登录
 * @param  {[String]}   url     [登录完成之后跳转的链接地址]
 * @param  {[String]}   type    [0: 无需登录, 1: 手机号登录, 2: 普通交易登录 3: 融资融券登录]
 * @param  {[String]}   json    [传递的扩展参数，保留字段]
 */
function loginToLocalWeb(url, type, json) {
    // 跳转前隐藏自定键盘
    hideKeyBoard();
    json = json === void 0 ? '{}' : json;

    if (params.browser == 'android') {
        KDS_Native.loginToLocalWeb(url, type, json);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://loginToLocalWeb:" + url + ":" + type + ":" + json);
    } else {
        url = getfirsthref() + 'rzrq/home/rzrq_login.html';
        // 平级页面之间的跳转
        location.href = url;
    }

    // 界面已跳转
    params.isJumpInterface = true;
}

/**
 * Javascript语言
 * 通知iPhone UIWebView 加载url对应的资源
 * @param url
 */
function loadURL(url) {
    var iFrame;
    iFrame = document.createElement("iframe");
    iFrame.setAttribute("src", url);
    iFrame.setAttribute("style", "display:none;");
    iFrame.setAttribute("height", "0px");
    iFrame.setAttribute("width", "0px");
    iFrame.setAttribute("frameborder", "0");
    document.body.appendChild(iFrame);
    // 发起请求后这个iFrame就没用了，所以把它从dom上移除掉
    iFrame.parentNode.removeChild(iFrame);
    iFrame = null;
}

/**
 * 获取版本号
 */
function getVersion() {
    return params.version;
}

/**
 *设置本地存储数据
 * @param key   键名
 * @param value 键值
 * @param from  来源 0: android 1: ios
 */
function setLocalData(key, value, from) {
    value = typeof value == "string" ? value : JSON.stringify(value);

    try {
        if (params.ENCRYPTED_FIELD.indexOf(key) === -1) {
            window.localStorage.setItem(key, value);
        } else if ((typeof SM4 === "undefined" ? "undefined" : _typeof(SM4)) === 'object') {
            // console.log('H5-debugger => SM4 encryptData!, key=' + key);
            window.localStorage.setItem(key, SM4.encryptData(value));
        } else {
            console.log('H5-debugger => SM4 encryptData find not!, key=' + key);
        }
    } catch (e) {
        // 存储数据大小超过限制
        if (e.name === 'QuotaExceededError') {
            // 删除非必须的本地存储
            deletingNonEssentialLocalStorage();

            // 重新保存数据到本地存储
            if ((typeof SM4 === "undefined" ? "undefined" : _typeof(SM4)) === 'object') {
                // console.log('H5-debugger => SM4 encryptData!, key=' + key);
                window.localStorage.setItem(key, SM4.encryptData(value));
            } else {
                console.log('H5-debugger => SM4 encryptData find not!, key=' + key);
            }
        }
    }

    // 非 APP 调用该接口时, 需要把特殊键值保存到APP里去.
    if (from === void 0 && $.inArray(key, params.APP_LOCALDATA_KEY) > -1) {
        saveOrUpdateLocalData(key, value);
    }

    // 检查数据是否保存成功，并将检查结果返回（ios能获取到，android获取不到）
    if (params.browser == 'ios') {
        if (window.localStorage.getItem(key)) {
            return '1';
        } else {
            return '0';
        }
    }
}

/**
 * 保存或修改 APP 里面的本地存储; 当 value 值为空字符串时, 则删除该键
 * @param key   键
 * @param value 值
 */
function saveOrUpdateLocalData(key, value) {
    if (params.browser == "android") {
        KDS_Native.saveOrUpdateLocalData(key, value);
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://SaveOrUpdateLocalData:" + key + ":" + value);
    }
}

/**
 * 设置行情刷新时间
 * @parma time 时间 (单位: 秒)
 */
function setHqTime(time) {
    time = typeof time == "number" ? time : parseInt(time);

    setLocalData("hqtime", time);
}

/**
 * 重置滚动条
 */
function resetScroll() {
    if (params.topPyl > 0) {
        $("body").css("margin-top", "0px");
        params.id = '';
        params.topPyl = 0;
    }
}

/**
 * 设置 ajax 请求超时时间
 * param time 时间 单位: 毫毛
 */
function setAjaxTimeOut(time) {
    setLocalData("ajaxtimeout", time + "");
}

/**
 * 设置 App 版本号
 * param version 版本号
 */
function setAppVersion(version) {
    setLocalData("appversion", version + "");
}

/**
 * 设置数据的IP和端口，比如：商城、个人中心的IP部分
 * @param json {"dgWxdl": "http:ip:port", "dgScdl": "http:ip:port"}
 */
function setDgPersonalIpAndPort(json) {
    setLocalData("ipandport", json);
}

/**
 * 设置App的主题皮肤
 * @param {String} themeName 主题的名称
 * @param {boolean} notStorage 不存储当前值
 */
function setAppTheme(themeName, notStore) {
    // 不使用黑色皮肤的地址
    if (getlasthref().indexOf("ptjy/dzqy/") > -1 // 电子签约
    || getlasthref().indexOf("kfsjj/") > -1 // 开放式基金
    || getlasthref().indexOf("common/") > -1 // 加载第三方 WEB 页面
    ) {
            return;
        }

    //1.0.4版本使用黑色皮肤地址
    if ("ptjy" == params.ywlx || "kfsjj" == params.ywlx || getlasthref().indexOf("home/rzrq_index.html") > -1 || getlasthref().indexOf("home/rzrq_header.html") > -1 || getlasthref().indexOf("home/rzrq_login.html") > -1) {
        document.documentElement.setAttribute("apptheme", themeName);
    }

    if (!notStore) {
        setLocalData("kdsAppThemeName", themeName);
    }
}

/**
 * 设置分享的服务器地址
 * @param {[type]} urlIp 分享的服务器地址
 */
function setShareIp(urlIp) {
    setLocalData("shareIp", urlIp);
}

/**
 * 获取分享的服务器地址
 */
function getShareIp() {
    return getLocalData("shareIp");
}

/**
 * 交易退出时回调原生的方法
 * @param  {[type]} tradeType [交易类型]    [ptjy: 普通交易, rzrq: 融资融券]
 */
function logoutTrade(tradeType) {
    if (params.browser == "android") {
        KDS_Native.logoutTrade(tradeType);
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://logoutTrade:" + tradeType);
    }
}

/**
 * 设置风险等级
 * @param {[type]} fundKey [功能 KEY 值]
 * @param {[type]} json    [风险等级的 JSON 数据]
 *    {
 *        'fxcpType': '0',      // 风险测评标识 [0: 首次或重新测试, 1: 登录时]
 *        ...                   // 交易服务器返回的字段
 *    }
 */
function setRiskLevel(fundKey, json) {
    console.log(['setRiskLevel', fundKey, json].join(":"));
    if (params.browser == "android") {
        try {
            KDS_Native.setRiskLevel(fundKey, json);
        } catch (e) {}
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://setRiskLevel:" + [fundKey, json].join(":"));
    }
}

/**
 * JS调用打开在二级页面加载第三方Web页面, 并传递用户数据
 * @param  {String} isCloseCurrent [是否关闭当前已有WebActivity[0: 不关闭 1: 关闭]]
 * @param  {String} functionCode   [功能Code]
 *    以 KDS_TICKET_NO_JSSWITCH 为前缀: 跳转时不不需要先登录资⾦金金账号等,在⻚页⾯面loadUrl 完成后调⽤用JS⽅方法( setUserData函数 ), 传递相关⽤用户数据;
 *    以 KDS_TICKET_NO_LOGINED_JSSWITCH 为前缀: 跳转前先登录资⾦金金账号及获取Ticket等 , 在⻚页⾯面loadUrl完成后调⽤用JS⽅方法( setUserData函数 ), 传递相关⽤用户数据;
 *    传 KDS_WEB_STOCK_WARN : 需要先登录⼿手机号, 跳转第三⽅方Web⻚页⾯面, 在⻚页⾯面loadUrl完 成时, 调⽤用JS⽅方法( setDeviceAndMobileData函数 ), 传递deviceId(设备号)、mobileNO(⼿手 机号); *    传 KDS_F10_NEWS_DETAILS : 供个股详情 F10 Web 跳转⾄至资讯详情界⾯面(传递接⼝口 url 及⼊入参供请求解析);
 *    以 KDS_Trade_Web_SwitchStack 为前缀: 供内部交易易H5调⽤用的功能Key,在⼆二级交易易Web 界⾯面打开指定H5⻚页⾯面(传递内部交易易H5的相对url路路径);
 * @param  {String} loadUrl        [要加载的第三方Web页面]
 * @param  {String} userDataJson   [需要转发的用户信息JSON数据]
 *    扩展参数示例例: {"custid":"客户 代码","fundid":"资⾦金金账号","userrole":"⽤用户⻆角⾊色","orgid":"操作机构","ticket":"tick et票据"}
 */
function openThirdPartyWebInSubPage(isCloseCurrent, functionCode, loadUrl, userDataJson) {
    console.log(['openThirdPartyWebInSubPage', isCloseCurrent, functionCode, loadUrl, userDataJson].join(', '));
    if (params.browser == "android") {
        KDS_Native.openThirdPartyWebInSubPage(isCloseCurrent, functionCode, loadUrl, userDataJson);
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://openThirdPartyWebInSubPage:" + [isCloseCurrent, functionCode, loadUrl, userDataJson].join(":"));
    }
}

/**
 * 点击/页面事件统计（埋点）
 *
 * @param  {[type]} eventId    [可为简单事件, 或以Event ID为目录名，而Label标签用于区分事件]
 * @param  {[type]} eventLabel [事件标签(子事件)]
 * @param  {[type]} kvJson     [数据统计记录 Map 格式的 JSON 字符串数据]
 *
 * 调用示例：
 *     onAgentEvent('普通交易', '公募基金', '');
 *     onAgentEvent('普通交易', '公募基金', '{"TradeAccount": "xxxxxx", "BuyMoney":"888.88"}');
 */
function onAgentEvent(eventId, eventLabel, kvJson) {
    console.log(['onAgentEvent', eventId, eventLabel, kvJson].join(', '));
    if (params.browser == "android") {
        try {
            KDS_Native.onAgentEvent(eventId, eventLabel, kvJson);
        } catch (e) {
            console.log("不支持该方法");
        }
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://onAgentEvent:" + [eventId, eventLabel, kvJson].join(":"));
    }
}

/**
 * 当调用 jumpToView 时，传入的 KEY 值是自定义的，登录完成后，则回调该方法
 * @param  {[type]} functionKey [功能 KEY 值]
 */
function callbackJumpToView(functionKey) {
    if (params.browser == "android") {
        try {
            KDS_Native.callbackJumpToView(functionKey);
        } catch (e) {}
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://callbackJumpToView:" + functionKey);
    }
}

/**
 * 手机浏览器打开第三方 Url 页面(适用于大型文件地址下载)
 * @param  {[type]} url [description]
 */
function openWebUrlInMobileBrowser(url) {
    if (params.browser == "android") {
        try {
            KDS_Native.openWebUrlInMobileBrowser(url);
        } catch (e) {}
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://openWebUrlInMobileBrowser:" + url);
    }
}

function getTradeFunction(functionKey, json) {
    if (typeof json === 'string') {
        try {
            json = JSON.parse(json);
        } catch (e) {
            callbackTradeFunction(functionKey, JSON.stringify({ 'textStatus': 'json parse error', 'errorThrown': e.message }));
            return;
        }
    } else if (Object.prototype.toString.call(json) !== '[object Object]') {
        callbackTradeFunction(functionKey, JSON.stringify({ 'textStatus': ' json error', 'errorThrown': 'not json!' }));
        return;
    }

    if ((typeof TRADE_FUNCTION === "undefined" ? "undefined" : _typeof(TRADE_FUNCTION)) === 'object') {
        TRADE_FUNCTION.getTradeFunction(functionKey, json);
    } else {
        // 防止 APP 调用时， tradeFunction.js 文件还没有加载完成
        setTimeout(function () {
            if ((typeof TRADE_FUNCTION === "undefined" ? "undefined" : _typeof(TRADE_FUNCTION)) === 'object') {
                TRADE_FUNCTION.getTradeFunction(functionKey, json);
            }
        }, 100);
    }
}

/**
 * 回调 APP 方法
 * 这是一个通用方法，根据 functionKey 来区分功能，jsonStr 动态传参
 * @param  {[type]} functionKey [功能KEY]
 * @param  {[type]} jsonStr     [JSON 字符串对象]
 */
function callbackTradeFunction(functionKey, jsonStr) {
    console.log(['callbackTradeFunction', functionKey, jsonStr].join(","));
    if (params.browser == "android") {
        try {
            KDS_Native.callbackTradeFunction(functionKey, jsonStr);
        } catch (e) {}
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://callbackTradeFunction:" + [functionKey, jsonStr].join(':'));
    }
}

/**
 * 回调 APP 方法
 * 这是一个通用方法，根据 functionKey 来区分功能，jsonStr 动态传参
 * @param  {[type]} functionKey [功能KEY]
 * @param  {[type]} jsonStr     [JSON 字符串对象]
 */
function callbackAppTradeFunction(functionKey, jsonStr) {
    console.log(['callbackAppTradeFunction', functionKey, jsonStr].join(","));
    if (params.browser == "android" || params.browser == "ios") {
        try {
            KDS_Native.callbackAppTradeFunction(functionKey, jsonStr);
        } catch (e) {}
    }
}

var APP = function () {
    return {
        // 点击盈亏分析调用原生
        jumpToNativeInterface: function jumpToNativeInterface(isCloseCurrent, pageKey, paramJson) {
            console.log(['jumpToNativeInterface', isCloseCurrent, pageKey, paramJson].join(', '));
            this.sendInteraction('jumpToNativeInterface', [isCloseCurrent, pageKey, paramJson]);
        },

        /**
         * 发送与原生接口的交互请求
         * @param  {String} methodName 方法名
         * @param  {Array} parameters 参数数组
         */
        sendInteraction: function sendInteraction(methodName, parameters) {
            if (params.browser == "android") {
                try {
                    KDS_Native[methodName].apply(KDS_Native, parameters);
                } catch (e) {}
            } else if (params.browser == "ios") {
                loadURL("KDS_Native://" + [methodName].concat(parameters || []).join(':'));
            }
        }
    };
}();
/*********************************************************************************************/
/********************************* 与 APP 交互的函数 end *************************************/
/*********************************************************************************************/

/*********************************************************************************************/
/************************************* JS 原型 start *****************************************/
/*********************************************************************************************/
/**
 * 检查字符串是否以另一个字符串开头
 * @param  {String} hasPrefix [开头的字符串]
 * @return {[boolean]}
 */
if (typeof String.prototype.hasPrefix != 'function') {
    String.prototype.hasPrefix = function (prefix) {
        return this.indexOf(prefix) == 0;
    };
}

// filter() 方法创建一个新数组, 其包含通过所提供函数实现的测试的所有元素
if (!Array.prototype.filter) {
    Array.prototype.filter = function (func, thisArg) {
        'use strict';

        if (!((typeof func === 'Function' || typeof func === 'function') && this)) throw new TypeError();

        var len = this.length >>> 0,
            res = new Array(len),
            // preallocate array
        t = this,
            c = 0,
            i = -1;
        if (thisArg === undefined) {
            while (++i !== len) {
                // checks to see if the key was set
                if (i in this) {
                    if (func(t[i], i, t)) {
                        res[c++] = t[i];
                    }
                }
            }
        } else {
            while (++i !== len) {
                // checks to see if the key was set
                if (i in this) {
                    if (func.call(thisArg, t[i], i, t)) {
                        res[c++] = t[i];
                    }
                }
            }
        }

        res.length = c; // shrink down array to proper size
        return res;
    };
}

// map() 方法创建一个新数组，结果是对调用数组中的每个元素调用一个提供的函数
if (!Array.prototype.map) {
    Array.prototype.map = function (callback /*, thisArg*/) {
        var T, A, k;
        if (this == null) {
            throw new TypeError('this is null or not defined');
        }
        var O = Object(this);
        var len = O.length >>> 0;
        if (typeof callback !== 'function') {
            throw new TypeError(callback + ' is not a function');
        }

        if (arguments.length > 1) {
            T = arguments[1];
        }

        A = new Array(len);
        k = 0;

        while (k < len) {
            var kValue, mappedValue;
            if (k in O) {
                kValue = O[k];
                mappedValue = callback.call(T, kValue, k, O);
                A[k] = mappedValue;
            }
            k++;
        }

        return A;
    };
}

// findIndex()方法返回数组中满足提供的测试函数的第一个元素的索引。否则返回-1。
if (!Array.prototype.findIndex) {
    Array.prototype.findIndex = function (predicate) {
        if (this == null) {
            throw new TypeError('"this" is null or not defined');
        }

        var o = Object(this);

        var len = o.length >>> 0;

        if (typeof predicate !== 'function') {
            throw new TypeError('predicate must be a function');
        }

        var thisArg = arguments[1];

        var k = 0;

        while (k < len) {
            var kValue = o[k];
            if (predicate.call(thisArg, kValue, k, o)) {
                return k;
            }
            k++;
        }

        return -1;
    };
}
/*********************************************************************************************/
/************************************* JS 原型 end *******************************************/
/*********************************************************************************************/

/**
 * 获取第三方 WEB 的 URL 地址
 * 从本地存储中获取对应 functionKey 的地址，如果存在则返回，不存在则使用默认地址
 * {KDS_APPTYPE} 根据不同的手机系统设置对应的值 ['android', 'ios', 'pc']
 *
 * @param  {[String]} functionKey [功能 KEY]
 * @param  {[String]} url         [默认地址]
 * @return {[String]}             [跳转使用的 URL 地址]
 */
function getThirdPartyWebUrl(functionKey, url) {
    var list = [];
    try {
        list = JSON.parse(getLocalData('thirdPartyWebKey')) || [];
    } catch (e) {}

    for (var i = 0, len = list.length; i < len; i++) {
        if (list[i].functionKey === functionKey) {
            list[i].url = list[i].url.replace('{KDS_APPTYPE}', params.browser);
            return list[i].url;
        }
    }

    return url.replace('{KDS_APPTYPE}', params.browser);
}

/**
 * 获取 App 版本号
 */
function getAppVersion() {
    if (getLocalData("appversion")) {
        return getLocalData("appversion");
    }
    // 如果 App 没有设置版本号, 则使用该默认版本号
    else {
            return "3.0.3";
        }
}
/**
 * 获取行情刷新时间
 */
function getHqTime() {
    if (getLocalData("hqtime")) {
        return parseInt(getLocalData("hqtime")) * 1000;
    }

    return 10 * 1000;
}

/*============================================
 函数功能:       去除字符串中的空格回车
 传入参数:         str:原字符串
 =============================================*/
function trim(str) {
    return str.replace(/(^\s*)|(\s*$)/g, '');
}

/*============================================
 函数功能:       获取本地存储数据
 传入参数:         key:键值
 =============================================*/
function getLocalData(key) {
    // 如果是在 App 里保存的数据, 且版本号要大于 3.0.3, 则从 App 里面获取
    if (params.browser == "android" && $.inArray(key, params.appKey) > -1) {
        // 优选使用 APP 内保存的数据
        var value = null;
        try {
            value = KDS_Native.getLocalData(key);
        } catch (error) {
            console.log("原生 APP 没有定义 getLocalData 函数");
        }
        // console.log(`H5 ===> android, getLocalData, key = ${key}, value = ${value}`);
        return value;
    } else {
        return get(key);
    }

    function get(key) {
        if (window.localStorage.getItem(key)) {
            // 不需要解密的字段直接返回
            if (params.ENCRYPTED_FIELD.indexOf(key) === -1) {
                return trim(window.localStorage[key]);
            } else if ((typeof SM4 === "undefined" ? "undefined" : _typeof(SM4)) === 'object') {
                // console.log('H5-debugger => SM4 decryptData!,key=' + key);
                return trim(SM4.decryptData(window.localStorage[key]));
            } else {
                console.log('H5-debugger => SM4 decryptData find not!,key=' + key);
            }
        }
        // 本地存储 KEY 对应的数据不存在, android 下需要从原生获取数据
        else if (params.browser == "android" && $.inArray(key, params.H5_OR_APP_KEY) > -1) {
                var value = null;
                try {
                    value = KDS_Native.getLocalData(key);
                    setLocalData(key, value);
                } catch (e) {
                    console.log("[H5 LOG] android getLocalData(' " + key + "') 失败, ", e);
                }
                return value;
            }

        return null;
    }
}
/*============================================
 函数功能:       清除本地存储数据
 传入参数:         key:键值
 =============================================*/
function removeLocalData(key) {
    window.localStorage.removeItem(key);
}
/*============================================
 函数功能:       清空本地存储数据
 =============================================*/
function clearLocalData() {
    window.localStorage.clear();
}

//===========================================================
//函数功能:       清除登录信息
//===========================================================
function ClearLoginInfo() {
    // alert("ClearLoginInfo");

    removeLocalData("page");
    removeLocalData("zqdm");

    // 融资融券模块界面登录超时,则清除融资融券登录账号信息
    if (params.ywlx == "rzrq") {
        removeLocalData('lockRZRQUser');
        removeLocalData("ActiveRZRQUser");

        // 非多账号登录-----更新用户列表
        if (getLocalData("rzrqMultiAccountLogin") == undefined) {
            Account = JSON.parse(getLocalData("rzrqAccount"));
        }

        logoutTrade('rzrq');
    } // 普通业务界面登录超时,则清除普通交易登录账号信息
    else if (params.ywlx == "ptjy") {
            removeLocalData("ActivePTJYUser");
            removeLocalData('lockPTJYUser');

            if (getLocalData("ptjyMultiAccountLogin") == undefined) {
                Account = JSON.parse(getLocalData("ptjyAccount"));
            }

            logoutTrade('ptjy');
        }
}
//===========================================================
//函数功能:         跳转到登录页
//===========================================================
function JumpHeaderPage() {
    // var curURL=document.location.href.slice(document.location.href.lastIndexOf("/")+1);

    // 如果登录超时时停留在融资融券模块界面,则跳转到融资融券首页
    if (params.ywlx == "rzrq") {
        JumpInterface(params.viewKey.KDS_RZRQHeader, 4, -100);
    } // 如果登录超时时停留在普通业务模块界面,则跳转到普通业务首页
    else if (params.ywlx == "ptjy" || params.ywlx == "kfsjj") {
            JumpInterface(params.viewKey.KDS_PTJYHeader, 4, -100);
        }
}
//===========================================================
//函数功能:        注销用户登录信息
//===========================================================
function Logout() {
    ClearLoginInfo();
    JumpHeaderPage();
}
//===========================================================
//函数功能:        多账号登录判断
//===========================================================
function MultiAccountLogin() {
    //==========设置多账号跳转标记=============
    setLocalData("MultiAccountLogin", "true");
    Logout();
}

/*============================================
 函数功能:         是否登录
 =============================================*/
function IsLogin() {

    // 如果登录的是融资融券模块
    if (params.ywlx == "rzrq") {

        if (getLocalData("ActiveRZRQUser") == undefined) {
            Logout();
            return false;
        }
    } // 如果登录的是普通业务模块模块
    else if (params.ywlx == "ptjy") {
            //==========判断用户是否登录===========
            if (getLocalData("ActivePTJYUser") == undefined) {
                Logout();
                return false;
            }
        }

    return true;
}
/*============================================
 函数功能:         记录复选框的设置状态
 =============================================*/
function RecordCheckBox(obj) {
    if ($(obj).attr("checked") == undefined) {
        setLocalData(ID, true);
        $(obj).attr({
            "checked": true
        });
    } else {
        removeLocalData(ID);
        $(obj).removeAttr("checked");
    }
}
/*============================================
 函数功能:         设置复选框状态
 =============================================*/
function setCheckBox(ID) {
    if (getLocalData(ID)) {
        $("#" + ID).attr({
            "checked": true
        });
    } else {
        $("#" + ID).removeAttr("checked");
    }
}

/*============================================
 函数功能:         设置留痕信息
 =============================================*/
function setMarkInfo(obj) {
    setLocalData("lhxx", obj);
}

/*============================================
 函数功能:         设置留痕信息
 =============================================*/
function getMarkInfo() {
    var lhxx = getLocalData("lhxx") || '';
    return lhxx.length == 0 ? "未知,未知,+" + h5Version + "+zxjt" : lhxx;
}

/*=====================================================
 函数功能: 添加自选股
 入参说明: stockName 股票名称
 stockCode 股票代码
 marketId  市场代码
 =====================================================*/
function addUserStock(stockName, stockCode, marketId) {
    console.log("调用添加自选股函数 [stockName=" + stockName + ", stockCode=" + stockCode + ", marketId=" + marketId + "]");

    if (params.browser == "android") {
        KDS_Native.addUserStock(stockName, stockCode, marketId);
    } else if (params.browser == "ios") {
        location.href = "KDS_Native://addUserStock:" + stockName + ":" + stockCode + ":" + marketId;
    }
}

/*============================================
 函数功能：对返回数据中的列表数据进行非空处理
 =============================================*/
function formatResponseData(response, str) {
    // 判断入参是对象还是集合, 然后不同的处理
    var cxlb = response.toString() == "[object Object]" ? response.cxlb : toString.apply(response) == "[object Array]" ? response : [];
    str = str == undefined ? "--" : str;

    for (var i = 0, len = cxlb.length; i < len; i++) {
        for (var j = 0, len2 = cxlb[i].length; j < len2; j++) {
            cxlb[i][j] = cxlb[i][j] == undefined || cxlb[i][j] == null || cxlb[i][j].trim() == "" ? str : cxlb[i][j];
        }
    }
}

/**
 *  函数功能：对返回的新股列表数据进行非空处理
 * @param  {[type]} response 数据源
 * @param  {[type]} str      替换成
 * @param  {[type]} filter   不需要替换的字段
 * @param  {[type]} datatype 数据类型
 */
function formatNewStockData(response, str, filter, datatype) {
    datatype = datatype == undefined ? "" : datatype;

    if (datatype == "array") {
        var cxlb = response;
    } else {
        // 判断入参是对象还是集合, 然后不同的处理
        var cxlb = response.toString() == "[object Object]" ? response.cxlb : toString.apply(response) == "[object Array]" ? response : [];
    }

    str = str == undefined ? "--" : str;
    filter = filter == undefined ? [] : filter;
    var iscontinue = false;
    var len = cxlb.length;
    var len2 = filter.length;

    for (var i = 0; i < len; i++) {
        for (var j in cxlb[i]) {
            iscontinue = false;

            // 过滤一些不需要非空或 0 处理字段
            for (var k = 0; k < len2; k++) {
                if (j == filter[k]) {
                    iscontinue = true;
                    break;
                }
            }

            if (iscontinue) continue;

            cxlb[i][j] = cxlb[i][j] == undefined || cxlb[i][j] == null || cxlb[i][j].trim() == "" || cxlb[i][j].trim() == "0" || cxlb[i][j].trim() == "0.00" ? str : cxlb[i][j];
        }
    }
}

/*============================================
 函数功能：设置是否注册
 入参说明：手机号码
 =============================================*/
function setIsRegister(phone, access_token, phone_num_enc1, phone_num_enc2) {
    var cellPhoneNumberEnc = JSON.stringify({ phone_num_enc1: phone_num_enc1, phone_num_enc2: phone_num_enc2 });
    setLocalData("cellPhoneNumber", phone);
    setLocalData("cellPhoneNumberEnc", cellPhoneNumberEnc);
    setLocalData("KDS_JT_ACCESS_TOKEN", access_token);
    // loadding.stop();
}

/*============================================
 函数功能：获取是否注册
 =============================================*/
function getIsRegister() {
    var cellPhoneNumber = getLocalData('cellPhoneNumber') || null;
    var access_token = getLocalData('KDS_JT_ACCESS_TOKEN') || null;
    // 手机号码 为空时需要重新注册手机号码
    // access_token 为空或为 0 时需要重新注册手机号码
    var isRegister = cellPhoneNumber == null || access_token == null || access_token === '0' ? false : true;
    return isRegister;
}

/*============================================
 函数功能：显示注册界面
 =============================================*/
function showRegisterView() {
    if (params.browser == "android") {
        KDS_Native.ShowRegisterView();
    } else if (params.browser == "ios") {
        location.href = "KDS_Native://ShowRegisterView";
    }
}

/*=========================================
 函数功能：获取当前URL地址前半部分
 =========================================*/
function getfirsthref(len) {
    len = len == undefined || len == null ? 5 : len;

    var _url = window.location.href;

    var _index = _url.indexOf("view/");
    _url = _url.substring(0, _index + len);

    return _url;
}

/*=========================================
 函数功能：获取当前URL地址后半部分
 =========================================*/
function getlasthref() {
    var _url = window.location.href;

    var _index = _url.indexOf("view/");
    _url = _url.substring(_index + 5);

    return _url;
}
/*=========================================
 函数功能：获取浏览器类型
 =========================================*/
function getBrowser() {
    var type = "pc";
    var ua = navigator.userAgent.toLowerCase();

    if (ua.indexOf('android') > -1) {
        type = "android";

        var start_index = ua.indexOf('android');

        var version = ua.substring(start_index, start_index + 12);

        version = version.replace("/", " ");

        // 低于 android 4.4 版本
        if (version < "android 4.4") {
            params.lowVersion = true;

            updateClass("common.css", ".modal-dialog", function (cssRule) {
                cssRule.style.top = "2%";
                cssRule.style.marginTop = "0px";
            });
        }
    } else if (ua.indexOf('iphone') > -1 || ua.indexOf('ipad') > -1) {
        type = "ios";
    }

    return type;
}

/**
 *    消除 inpunt 的属性 readonly
 */
function clearReadonly() {
    if (params.browser == 'android') {

        $("input[type=text],input[type=password]").attr("readonly", "readonly");
    } else if (params.browser == 'ios') {
        $("input[type=text],input[type=password]").attr("readonly", "readonly");
    } else {
        $("input").removeAttr("readonly");
    }
}

/*========================================
 函数功能:    快捷跳转
 传入参数:   viewKey:跳转界面
 ========================================*/
function QuickJump(viewKey) {
    //=====清除快捷跳转判断标志位=====
    removeLocalData("quickJump");

    if (viewKey == "KDS_SM_WTJY") {
        // 委托交易

        JumpInterface(params.viewKey.KDS_SM_WTJY, 8, -100);
    } else if (viewKey == "KDS_SM_ZCCX") {
        // 资产查询

        JumpInterface(params.viewKey.KDS_SM_ZCCX, 8, -100);
    } else if (viewKey == "KDS_Buy") {
        // 买入
        setLocalData("page", "买入");
        JumpInterface(params.viewKey.KDS_Buy, 8, -100);
    } else if (viewKey == "KDS_Sell") {
        // 卖出
        setLocalData("page", "卖出");
        JumpInterface(params.viewKey.KDS_Sell, 8, -100);
    } else if (viewKey == "KDS_CheDan") {
        // 撤单
        setLocalData("page", "撤单");
        JumpInterface(params.viewKey.KDS_CheDan, 8, -100);
    } else if (viewKey == "KDS_Query") {
        // 查询
        setLocalData("page", "查询");
        JumpInterface(params.viewKey.KDS_Query, 0, -100);
    } else if (viewKey == "KDS_SM_XGSG") {
        // 新股申购
        JumpInterface(params.viewKey.KDS_SM_XGSG, 0, -100);
    } else if (viewKey == "KDS_SM_YJDX") {
        // 申购日历
        JumpInterface(params.viewKey.KDS_PTJY_SGRL, 0, -100);
    } else if (viewKey == "KDS_SM_CCQuery") {
        // 持仓查询
        setLocalData("page", "持仓");
        JumpInterface(params.viewKey.KDS_SM_CCQuery, 8, -100);
    } else if (viewKey == "KDS_SM_KFSJJ") {
        // 开放式基金
        //setLocalData("page","开放式基金");
        JumpInterface(params.viewKey.KDS_SM_KFSJJ, 8, -100);
    } //=================担保品划转==========
    else if (viewKey == "KDS_RZRQ_DBPHZ") {
            JumpInterface(params.viewKey.KDS_RZRQ_DBPHZ, 8, 0);
        } else if (viewKey == "KDS_Bind_ZJZH") {
            // 资金账号绑定
            var ActiveUse = JSON.parse(getLocalData("ActivePTJYUserTmp"));

            if (params.browser == "android") {

                var zjzh = ActiveUse.body.dlxx.length == 0 || ActiveUse.body.dlxx[0].zjzh == undefined ? "" : ActiveUse.body.dlxx[0].zjzh;
                console.log(ActiveUse.body.dlxx[0].zjzh);

                KDS_Native.backZjzhBinde(zjzh);
            } else if (getBrowser() == "ios") {
                loadURL("KDS_Native://backZjzhBinde:" + ActiveUse.body.dlxx[0].zjzh);
            }

            // 删除登录信息的临时数据
            removeLocalData("ActivePTJYUserTmp");
        } else if (viewKey == "KDS_SM_RXT") {
            // 融信通
            JumpInterface(params.viewKey.KDS_SM_RXT, 8, -100);
        } else if (viewKey == "KDS_MyBusinessManagement") {
            // 业务办理
            JumpInterface(params.viewKey.KDS_MyBusinessManagement, 8, -100);
        } else if (viewKey == "KDS_STOCK_SYSNC") {
            // JS 跳到自选股云同步界面
            jumpToStockSysncInterface("1");
        } else if (viewKey == "KDS_SM_RZRQ") {
            // 融资融券主页
            JumpInterface(params.viewKey.KDS_SM_RZRQ, 8, -100);
        } else if (viewKey == "KDS_GGT_BUY") {
            JumpInterface(params.viewKey.KDS_GGT_BUY, 8, -100);
        } else if (viewKey == "KDS_GGT_SELL") {
            JumpInterface(params.viewKey.KDS_GGT_SELL, 8, -100);
        } else if (viewKey == "KDS_SM_YJSG") {
            JumpInterface(params.viewKey.KDS_PTJY_YJSG, 8, -100);
        } else if (viewKey == "KDS_RZRQ_PTMR") {
            // 担保品买入
            setLocalData("page", "担保物买入");
            JumpInterface(params.viewKey.KDS_RZRQ_PTMR, 8, -100);
        } else if (viewKey == "KDS_RZRQ_RZMR") {
            // 融资买入
            setLocalData("page", "融资买入");
            JumpInterface(params.viewKey.KDS_RZRQ_RZMR, 8, -100);
        } else if (viewKey == "KDS_RZRQHuanQuan") {
            // 买券还券
            JumpInterface(params.viewKey.KDS_RZRQHuanQuan, 8, -100);
        } else if (viewKey == "KDS_RZRQ_PTMC") {
            // 担保品卖出
            setLocalData("page", "担保物卖出");
            JumpInterface(params.viewKey.KDS_RZRQ_PTMC, 8, -100);
        } else if (viewKey == "KDS_RZRQ_RQMC") {
            // 融券卖出
            setLocalData("page", "融券卖出");
            JumpInterface(params.viewKey.KDS_RZRQ_RQMC, 8, -100);
        } else if (viewKey == "KDS_RZRQHuanKuan") {
            // 卖券还款
            JumpInterface(params.viewKey.KDS_RZRQHuanKuan, 8, -100);
        } else if (viewKey == "KDS_RZRQ_WTCD") {
            // 融券撤单
            setLocalData("page", "撤单");
            JumpInterface(params.viewKey.KDS_RZRQ_WTCD, 8, -100);
        } else if (viewKey == "KDS_GFZR_DJMM_Buy") {
            // 股份转让 - 定价买入
            JumpInterface(params.viewKey.KDS_GFZR_DJMM_Buy, 8, -100);
        } else if (viewKey == "KDS_GFZR_DJMM_Sell") {
            // 股份转让 - 定价卖出
            JumpInterface(params.viewKey.KDS_GFZR_DJMM_Sell, 8, -100);
        } else if (viewKey == "KDS_GFZR_CJQRMM_Buy") {
            // 股份转让 - 成交确认买入
            JumpInterface(params.viewKey.KDS_GFZR_CJQRMM_Buy, 8, -100);
        } else if (viewKey == "KDS_GFZR_CJQRMM_Sell") {
            // 股份转让 - 成交确认卖出
            JumpInterface(params.viewKey.KDS_GFZR_CJQRMM_Sell, 8, -100);
        } else if (viewKey == "KDS_GFZR_HBQRMM_BUY") {
            // 股份转让 - 互报确认-大宗买入
            JumpInterface(params.viewKey.KDS_GFZR_HBQRMM_BUY, 8, -100);
        } else if (viewKey == "KDS_GFZR_HBQRMM_SELL") {
            // 股份转让 - 互报确认-大宗卖出
            JumpInterface(params.viewKey.KDS_GFZR_HBQRMM_SELL, 8, -100);
        } else if (viewKey == "KDS_GFZR_ZSMM_Buy") {
            // 股份转让 - 做市买入
            JumpInterface(params.viewKey.KDS_GFZR_ZSMM_Buy, 8, -100);
        } else if (viewKey == "KDS_GFZR_ZSMM_Sell") {
            // 股份转让 - 做市卖出
            JumpInterface(params.viewKey.KDS_GFZR_ZSMM_Sell, 8, -100);
        } else if (viewKey == "KDS_GFZR_CheDan") {
            // 股份转让 - 撤单
            JumpInterface(params.viewKey.KDS_GFZR_CheDan, 8, -100);
        } else if (viewKey == "KDS_GGT_WTCD") {
            // 港股通 - 撤单
            JumpInterface(params.viewKey.KDS_GGT_WTCD, 8, -100);
        } else if (viewKey == "KDS_SM_WDZC") {
            // 我的资产 - 首页
            JumpInterface(params.viewKey.KDS_SM_WDZC, 8, -100);
        } else {
            // 动态 KEY 值
            if (viewKey.hasPrefix('KDS_TICKET') || viewKey.hasPrefix('KDS_PHONE_TICKET')) {
                setLocalData('KDS_TICKET', viewKey);
                JumpInterface(params.viewKey.KDS_Ticket, 8, -100);
            } else {
                callbackJumpToView(viewKey);
            }
        }
}

/**
 * 快捷跳转页面    [与APP交互使用,函数名与viewKey值不能随意修改]
 * @param  {[String]} viewKey   [功能 KEY 值] [Y]
 * @param  {[String]} zqdm      [证券代码]    [N]
 * @param  {[String]} marketId  [市场代码]    [N]
 * @param  {[String]} subtype   [商品代码]    [N]
 */
function jumpToView(viewKey, zqdm, marketId, subtype) {
    if (viewKey == "") {
        removeLocalData("quickJump");
        return;
    } else {
        // 设置快捷跳转标志位
        setLocalData("quickJump", viewKey);
        // 在设置快捷跳转的 Key 值时，需要清除重定向 Key 值
        removeLocalData("JUMP_PARAMS");
    }

    // Key 值列表，这个列表中的值将保存证券代码及交易所代码
    var viewKeys = ['KDS_Buy', // 普通交易 - 买入
    'KDS_Sell', // 普通交易 - 卖出

    'KDS_RZRQ_PTMR', // 融资融券 - 担保物买入
    'KDS_RZRQ_PTMC', // 融资融券 - 担保物卖出
    'KDS_RZRQ_RZMR', // 融资融券 - 融资买入
    'KDS_RZRQ_RQMC', // 融资融券 - 融资卖出
    'KDS_RZRQHuanQuan', // 融资融券 - 买券还券
    'KDS_RZRQHuanKuan', // 融资融券 - 卖券还款

    'KDS_GFZR_DJMM_Buy', // 普通交易 - 股份转让 - 定价买入
    'KDS_GFZR_DJMM_Sell', // 普通交易 - 股份转让 - 定价卖出
    'KDS_GFZR_CJQRMM_Buy', // 普通交易 - 股份转让 - 成交确认买入
    'KDS_GFZR_CJQRMM_Sell', // 普通交易 - 股份转让 - 成交确认卖出
    'KDS_GFZR_HBQRMM_BUY', // 普通交易 - 股份转让 - 互报确认-大宗买入
    'KDS_GFZR_HBQRMM_SELL', // 普通交易 - 股份转让 - 互报确认-大宗卖出
    'KDS_GFZR_ZSMM_Buy', // 普通交易 - 做市买入
    'KDS_GFZR_ZSMM_Sell', // 普通交易 - 做市卖出
    'KDS_GFZR_XJMM_Buy', // 普通交易 - 限价买入
    'KDS_GFZR_XJMM_Sell'];

    if (viewKeys.indexOf(viewKey) != -1) {
        setLocalData("zqdm", [zqdm, marketId, subtype].join("|"));
    }

    // 如果该页面是快捷跳转目标页面, 则删除快捷跳转标志位
    if (params['viewKey'][viewKey] == getlasthref()) {
        removeLocalData("quickJump");
    }
}

//设置交易服务器地址	[与APP交互使用,函数名不能随意修改]
function setApiUrl(apiUrl) {
    apiUrl = filterApiUrl(apiUrl);
    setLocalData("apiUrl", apiUrl);
}

/**
 * 获取交易服务器地址	[与APP交互使用,函数名不能随意修改]
 */
function getApiUrl(type) {
    // APP 如果没有设置交易服务器地址, 则给 APP 返回空字符串
    if (!getLocalData("apiUrl")) {
        // 手机端, 如果没有找到站点信息, 则使用默认的站点
        if (params.browser !== "pc") {
            return params.THIRD_PARTY_WEB_URL.DEFAULT_TRADE_URL;
        }
        return "";
    }

    var apiUrl = JSON.parse(getLocalData("apiUrl"));

    // 超级用户里面设置的交易服务器测试地址
    if (apiUrl.testurl != "") {
        console.log("正在使用超级用户里面设置的交易服务器测试地址");
        return apiUrl.testurl;
    }
    // 站点列表无数据
    else if (isNaN(apiUrl.index) || apiUrl.index == "" || apiUrl.urllist.length == 0) {
            console.log("站点列表无数据");
            return "";
        }

    // 从站点列表中选取最优的站点
    return apiUrl.urllist[apiUrl.index];
}

/**
 * 过滤掉交易站点列表中空的数据
 */
function filterApiUrl(data) {
    try {
        data = typeof data === 'string' ? JSON.parse(data) : data;

        var i = 0,
            l = data.urllist.length,
            o = data.urllist[data.index],
            array = [],
            item = null;
        for (; i < l; i++) {
            item = data.urllist[i];
            if (item != null && item != '') {
                array.push(item);
            }
        }

        data.index = array.indexOf(o) < 0 ? '0' : array.indexOf(o) + '';
        data.urllist = array;
    } catch (e) {}
    return data;
}

/**
 * 与原生交互的接口 (新增加的接口都写在这里面，方便查找)
 */
(function () {
    /**
     * 设置广告位信息
     * @param array [{"imgAddress": "图片地址", "linkAddress": "链接地址"}]
     */
    function setAds(array) {
        if (array != undefined && array != "") {
            setLocalData("adsArray", array);
        } else {
            if (array == "") {
                removeLocalData("adsArray");
            }

            console.log("setAds param array is null!");
        }
    }
    window["setAds"] = setAds;
})();

// 设置请求超时时间
function setTimeOut(timeOut) {
    console.log("设置系统交易超时时间: " + timeOut);
    setLocalData("timeOut", timeOut);
}

// 设置新股申购地址
function setApiUrlNews(apiUrlNews) {
    setLocalData("apiUrlNews", apiUrlNews);
}

// 获取新股申购地址	[与APP交互使用,函数名不能随意修改]
function getApiUrlNews() {
    // APP 如果没有设置新股申购地址, 则给 APP 返回空字符串
    // if( params.browser != "pc")
    // {
    // 	return getLocalData("apiUrlNews") != null ? getLocalData("apiUrlNews") : "";
    // }

    return getLocalData("apiUrlNews") != null ? getLocalData("apiUrlNews") : params.apiUrlNews;
}

//获取请求超时时间
function getTimeOut() {
    var _timeout = getLocalData("timeOut");

    if (_timeout == null || _timeout == undefined) {
        console.log("系统交易超时时间本地存储不存在");
    }

    return _timeout != null ? parseInt(getLocalData("timeOut")) : params.timeOut;
}

/**
 * 获取 ajax 请求超时时间
 */
function getAjaxTimeOut() {
    var _timeout = getLocalData("ajaxtimeout");

    if (_timeout == null || _timeout == undefined) {
        // 默认一分钟
        return 1000 * 45;
    }

    return parseInt(getLocalData("ajaxtimeout"));
}

/**
 * 函数功能：获取登录账号  [与APP交互使用,函数名不能随意修改]
 * # ADD 2016.03.14 增加在融资融券下获取登录账号
 * @return 登录成功返回“资金账号”， 没有登录返回空字符串
 */
function getLoginAccount(ywlx) {
    ywlx = ywlx == undefined ? "ptjy" : ywlx;
    _tmp = ywlx == "ptjy" ? "ActivePTJYUser" : "ActiveRZRQUser";

    var khbs = "";
    if (getLocalData(_tmp)) {
        //登录时入参
        var ActiveUse = JSON.parse(getLocalData(_tmp));
        // 登录后返回的资金账号
        khbs = ActiveUse['body'].dlxx[0].zjzh;
    }

    // 回调 android 函数, 把登录账号传过去.	空字符串表示没有登录
    if (getBrowser() == "android") {
        KDS_Native.onLoginAccount(khbs);
        return;
    }

    return khbs;
}

/*========================================
 函数功能：传递用户普通交易登录信息给原生"我的界面使用"	[与APP交互使用,函数名不能随意修改]
 交易登录后，会将登录参数传递给原生(json格式:{name:"凯特琳",tel:"5252522"})
 =========================================*/
function onLoginTrade(array) {
    if ("ptjy" != params.ywlx) {
        return;
    }
    if (array.length == 0) {
        return;
    }
    var json = {
        name: array[0].khxm,
        yybjc: array[0].yybjc
    };
    json = JSON.stringify(json);
    var browser = params.browser;
    try {
        if ('android' == browser) {
            try {
                KDS_Native.onLoginTrade(json);
            } catch (e) {
                console.log(e.message);
            }
        } else if ('ios' == browser) {
            loadURL("KDS_Native://onLoginTrade:" + json);
        }
    } catch (error) {
        console.log(error.name, error.message);
        console.log("原生代码没有'onLoginTrade'方法");
    }
}

//===============================
// 函数功能: 关闭原生App
//===============================
function closeApp() {
    var browser = params.browser;
    try {
        if ('android' == browser) {
            KDS_Native.closeApp();
        } else if ('ios' == browser) {
            loadURL("KDS_Native://closeApp");
        }
    } catch (error) {
        console.log(error.name, error.message);
        console.log("原生代码没有'closeApp'方法");
    }
}

/*====================================
 原生 APP 回调函数, 用于刷新页面数据。
 在需要的界面里覆写此方法
 =====================================*/
function handlePageBack() {}

/*====================================
 函数功能：自助开户	[与APP交互使用,函数名不能随意修改]
 =====================================*/
function selfserviceAccount() {
    if (params.browser == 'android') {
        KDS_Native.selfserviceAccount();
    } else if (params.browser == 'ios') {
        location.href = "KDS_Native://selfserviceAccount";
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 跳转到融信通
 */
function toRXT() {
    var lastUrl = "ptjy/zhyw/hqurl";

    // 请求交易服务器，获取融信通的地址
    ajaxPost(getApiUrl() + lastUrl, { "urlid": "rxt" }, function (response) {
        var rxtUrl = response.list[0].url;
        passRXTUrlString(rxtUrl);
    });
}

/**
 * 初始化App主题皮肤
 */
function initialAppTheme() {
    var themeName = getLocalData("kdsAppThemeName");
    setAppTheme(themeName, true);
}

/**
 * 删除非必须的本地存储
 * @return {[type]} [description]
 */
function deletingNonEssentialLocalStorage() {
    for (var key in localStorage) {
        // 删除F10股票缓存的数据
        if (key.indexOf('F10') > 0) {
            localStorage.removeItem(key);
        }
    }
}

/**
 * 调用原生 APP 的融信通接口
 * @param  url 融信通的 URL 地址
 */
function passRXTUrlString(url) {
    if (params.browser == 'android') {
        KDS_Native.passRXTUrlString(url);
    } else if (params.browser == 'ios') {
        location.href = "KDS_Native://passRXTUrlString:" + url;
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 打开第三方 WEB 界面
 * @param  {[String]} closeCurrent [关闭当前界面 0: 不关闭 1: 关闭]
 * @param  {[string]} url          [第三方应用的地址]
 */
function openThirdPartyWebInterface(closeCurrent, url) {
    console.log(['openThirdPartyWebInterface', closeCurrent, url].join(', '));
    if (params.browser == 'android') {
        KDS_Native.openThirdPartyWebInterface(closeCurrent, url);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://openThirdPartyWebInterface:" + closeCurrent + ":" + url);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 打开一个第三方 WEB 界面
 * # iOS 原生说以后调用第三方 WEB 接口，就使用这个接口, openThirdPartyWebUrl 没有对 URL 做特殊处理  2016.10.19 add
 * @param  {[String]} closeCurrent [关闭当前界面 0: 不关闭 1: 关闭]
 * @param  {[String]} url [第三方应用的地址]
 */
function openNewWindow(closeCurrent, url) {
    if (params.browser == 'android') {
        openThirdPartyWebInterface(closeCurrent, url);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://openThirdPartyWebUrl:" + closeCurrent + ":" + url);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 打开第三方 WEB 超级接口
 * @param isCloseCurrent    是否关闭当前已有WebActivity[0: 不关闭 1: 关闭]
 * @param loadUrl           要加载的第三方Web页面;
 * @param functionCode      功能Code
 * @param custid            客户代码
 * @param fundid            资金账号
 * @param userrole          用户角色
 * @param orgid             操作机构
 * @param ticket            ticket票据
 * @param targetUrl         目的地址
 */
function openThirdPartyWebSuperInterface(isCloseCurrent, loadUrl, functionCode, custid, fundid, userrole, orgid, ticket, targetUrl) {
    if (params.browser == 'android') {
        KDS_Native.openThirdPartyWebSuperInterface(isCloseCurrent, loadUrl, functionCode, custid, fundid, userrole, orgid, ticket, targetUrl);
    } else if (params.browser == 'ios') {
        var lastParams = [isCloseCurrent, loadUrl, functionCode, custid, fundid, userrole, orgid, ticket, targetUrl].join(":");
        loadURL("KDS_Native://openThirdPartyWebSuperInterface:" + lastParams);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 跳转到个股行情接口
 * @param  {[String]} stockCode [证券代码]
 * @param  {[String]} marketId  [交易所代码]
 */
function jumpStockDetailInterface(stockCode, marketId) {
    if (params.browser == 'android') {
        KDS_Native.JumpStockDetailInterface(stockCode, marketId);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://JumpStockDetailInterface:" + stockCode + ":" + marketId);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * JS 跳到自选股云同步界面
 * @param  String   isCloseCurrent 是否关闭当前已有WebActivity[0: 不关闭 1: 关闭]
 */
function jumpToStockSysncInterface(isCloseCurrent) {
    if (params.browser == 'android') {
        KDS_Native.jumpToStockSysncInterface(isCloseCurrent);
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://jumpToStockSysncInterface:" + isCloseCurrent);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 交易客户号接口
 * # 调用原生接口，将客户号传给原生
 *     * 传参是数组：数组内的对象是字典，字典有两组 key/value
 *     * 字典：普通交易的客户号、融资融券的客户号
 */
function tradeClientId() {
    var ActivePTJYUser = getLocalData("ActivePTJYUser");
    var ActiveRZRQUser = getLocalData("ActiveRZRQUser");

    var ptjy_khdm = ""; // 普通交易客户号
    var rzrq_khdm = ""; // 融资融券客户号

    if (ActivePTJYUser) {
        ptjy_khdm = JSON.parse(ActivePTJYUser).body.dlxx[0].khdm;
    }
    if (ActiveRZRQUser) {
        rzrq_khdm = JSON.parse(ActiveRZRQUser).body.dlxx[0].khdm;
    }

    // 原生接口需要的参数值
    var clientId = [{
        "ptjy": ptjy_khdm,
        "rzrq": rzrq_khdm,
        "ywlx": params.ywlx
    }];

    clientId = JSON.stringify(clientId);

    if (params.browser == 'android') {
        try {
            KDS_Native.tradeClientId(clientId);
        } catch (e) {
            console.log(e.message);
        }
    } else if (params.browser == 'ios') {
        loadURL("KDS_Native://tradeClientId:" + clientId);
    } else {
        console.log("只能在IOS系统与Android系统下点击自助开户");
    }
}

/**
 * 已经登录
 */
function haveLogged(step) {
    var lasthref = getlasthref();

    // 白名单
    var whiteList = ['common/sdmm/sdmm.html'];
    for (var i = 0, len = whiteList.length; i < len; i++) {
        if (lasthref.indexOf(whiteList[i]) > 0) {
            return true;
        }
    }

    // 黑名单
    var blacklist = ['ptjy_header.html', 'ptjy_login.html', 'rzrq_header.html',
    // 加载的空白界面，不需要显示锁屏框
    'common/'];
    for (var i = 0, len = blacklist.length; i < len; i++) {
        if (lasthref.indexOf(blacklist[i]) > 0) {
            return false;
        }
    }

    return true;
}

/*=======================================================
 函数功能：保存日志到本地数据库
 =======================================================*/
function saveLog(str) {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);

    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    // 创建表
    db.transaction(function (tx) {
        tx.executeSql("CREATE TABLE if not exists log (createtime TEXT, content TEXT)");
    });

    // 插入记录
    db.transaction(function (tx) {
        tx.executeSql("INSERT INTO log (createtime, content) values(?, ?)", [new Date().Format("yyyyMMdd hh:mm:ss"), str], null, null);
    });
}

/*=======================================================
 函数功能：查询本地数据库里的日志信息
 =======================================================*/
function selectLog(sql) {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);
    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    // 查询数据
    db.transaction(function (tx) {

        if (sql == undefined || sql == "") {
            sql = "SELECT * FROM log";
        }

        tx.executeSql(sql, [], function (tx, result) {
            for (var i = 0; i < result.rows.length; i++) {
                console.warn(result.rows.item(i)['content']);
            }
        }, function () {
            console.error("查询失败! 原因：1、没有创建表; 2、表中无数据");
        });
    });
}

/*=======================================================
 函数功能：清空数据库表数据
 =======================================================*/
function clearLog() {
    var db = window.openDatabase("web", "1.1", "log", 1024 * 1024);
    // 创建或打开数据库失败
    if (!db) {
        return;
    }

    db.transaction(function (tx) {
        tx.executeSql("DROP TABLE log");
    });
}

/**
 *  获取array两个索引之间累加的字符串(不包含后面一个索引)
 * @param startIndex
 * @param endIndex
 * @returns {string}
 */
Array.prototype.getBetweenStr = function (startIndex, endIndex) {
    startIndex = startIndex < 0 ? 0 : startIndex;
    endIndex = endIndex > this.length ? this.length : endIndex;
    var result = "";
    for (var i = startIndex; i < endIndex; i++) {
        result += this[i];
    }
    return result;
};

/* 调用示例
 var now = new Date();
 now.addMonths(-1);//加减日期操作
 console.log(now.Format("yyyyMMdd"));
 */
// 时间日期格式化
Date.prototype.Format = function (fmt) {
    //author: meizz
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o) {
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
    }return fmt;
};

// 加减天数
Date.prototype.addDays = function (d) {
    this.setDate(this.getDate() + d);
    return this;
};

// 加减星期
Date.prototype.addWeeks = function (w) {
    this.addDays(w * 7);
    return this;
};

// 加减月份
Date.prototype.addMonths = function (m) {
    var d = this.getDate();
    this.setMonth(this.getMonth() + m);

    if (this.getDate() < d) this.setDate(0);
    return this;
};

// 加减年份
Date.prototype.addYears = function (y) {
    var m = this.getMonth();
    this.setFullYear(this.getFullYear() + y);

    if (m < this.getMonth()) {
        this.setDate(0);
    }
    return this;
};

/*====================================================
 函数功能：模拟APP显示提示信息
 函数入参：obj	显示文字信息
 top 距离顶部的位置(百分比,可不传)
 time 设置时间, 0 永不隐藏
 ====================================================*/
function showMessageTips(obj, top, time) {
    top = top == null ? undefined : top;

    time = time == undefined ? 1000 * 3 : time;

    if ($(".messageTips").length > 0) {
        $(".messageTips").remove();
    }

    $("body").append('<div class="messageTips"><div>' + obj + '</div></div>');

    var left = (document.body.clientWidth - $(".messageTips").width()) / 2;

    $(".messageTips").css("left", left + "px");

    // 设置 top 距离时
    if (top != undefined) {
        $(".messageTips").css("top", top + "%");
    }

    if (time != 0) {
        setTimeout(function () {
            $(".messageTips").remove();
        }, time); //1000为1秒钟,设置为1分钟。
    }
}

/*================================================
 函数功能：加减
 入参说明：id	控件ID
 type 类型,加(plus)与减(minus)	默认加
 step 步长,默认1
 fixed	保留小数点位数 默认0
 =================================================*/
function plusMinus(id, type, step, fixed) {
    if (id == undefined || id == null) {
        showMessageTips("plusMinus 函数未传入ID");
        return;
    }

    step = step == undefined || step == null ? 1 : step;
    fixed = fixed == undefined || fixed == null ? 0 : fixed;
    type = type == undefined || type == null ? "plus" : type;

    var price = $("#" + id).val() || 0;

    if (type == "plus") {
        $("#" + id).val(Inc(price, step, fixed));
    } else if (type == "minus") {
        $("#" + id).val(Dec(price, step, fixed));
    }
}

/*====================================================================
 函数功能：                动态创建angular节点
 入参说明：$scope				  angular 的作用域
 $compile 			  angular 的编译参数
 node                节点
 nodeName        动态加载内容对象名
 modalValue		  动态加载内容
 ====================================================================*/
function dynGenerateNode($scope, $compile, node, nodeName, modalValue) {

    var template = angular.element(node);

    mobileDialogElement = $compile(template)($scope);

    //==================动态创建模态框=========================
    angular.element(document.body).append(mobileDialogElement);

    if (nodeName) {
        angular.element($("body")).scope().$apply(function () {

            $scope[nodeName] = modalValue;
        });
    }
}

/*=================================================
 函数功能：创建模态框
 入参说明：$scope				angular 的作用域
 $compile 			angular 的编译参数
 modal 				模态框需要显示内容对象
 FirstBtnHide	隐藏第一个按钮 (取消按钮)
 ==================================================*/
function create_modal($scope, $compile, modal, FirstBtnHide) {
    $scope.modal = modal;

    var template = angular.element(Modal);

    mobileDialogElement = $compile(template)($scope);

    //==================动态创建模态框=========================
    angular.element(document.body).append(mobileDialogElement);

    if (FirstBtnHide != undefined && FirstBtnHide != null && FirstBtnHide) {
        // 隐藏取消按钮
        $(".modal-footer > .btn-default").hide();
        $(".modal-footer > .btn-ensure").css("width", "70%");
    }

    return false;
}

/*=================================
 函数功能:  移除模态框
 =================================*/
function CloseModal() {
    // 有些模态框中有输入框,关闭模态框时关闭自定义键盘
    hideKeyBoard();

    // 判断模态框节点是否存在
    if (mobileDialogElement) {
        mobileDialogElement.remove();
    }
}

/**
 * 返回注释里的内容
 * @param function f [description]
 */
function HereDoc(f) {
    var doc = String(f).replace(/^[^\/]+\/\*!?\s?/, '').replace(/\*\/[^\/]+$/, '');
    return doc;
}

/*==================================================
 函数功能：格式化字符串日期
 入参说明：data   字符串日期
 format 格式
 ===================================================*/
function formatDate(date, format) {
    if (date == undefined || date == null || date == "") return;

    format = format == undefined || format == null ? "yyyyMMdd" : format;

    date = date.split("");
    format = format.split("");

    var newdate = [];
    var item = "";

    for (var key in format) {
        if (key > date.length - 1) break;

        if (!(format[key] == "y" || format[key] == "M" || format[key] == "d" || format[key] == "H" || format[key] == "h" || format[key] == "m" || format[key] == "s")) {
            date.splice(key, 0, format[key]);
        }

        newdate[key] = date[key];
    }

    // 数组日期转为字符串
    newdate = newdate.join("");

    return newdate;
}

/**
 * 修改文件样式
 * @param fileName  文件名称
 * @param className 样式名称
 * @param method    回调函数, 在回调函数内修改样式
 */
function updateClass(fileName, className, method) {
    var styleSheet = null,
        cssRule = null;

    for (var i = 0, len = document.styleSheets.length; i < len; i++) {
        if (document.styleSheets[i].href != null && document.styleSheets[i].href.indexOf(fileName) >= 0) {
            styleSheet = document.styleSheets[i];
            break;
        }
    }

    if (styleSheet == null) {
        return;
    }

    for (var i = 0, len = styleSheet.cssRules.length; i < len; i++) {
        if (styleSheet.cssRules[i].selectorText && styleSheet.cssRules[i].selectorText.indexOf(className) >= 0) {
            cssRule = styleSheet.cssRules[i];

            method(cssRule);
            return;
        }
    }
}

/*=================================================
 函数功能：点击页面非文本输入框区域关闭软键盘
 ==================================================*/
function CloseKeyBoard() {
    $("body input:not(:text,:password)").click(function () {
        hideKeyBoard();
    });
}

/** 营业部本地缓存key*/
var SALE_DEPARTMENT_INFO_KEY = "saleDepartmentInfoKey";
/**
 *  原生传递营业部代码
 * @param value (数据格式：[{"deptName":"北京陶然亭路营业部","deptCode":"1101"},{"deptName":"河北香河府前街营业部","deptCode":"1302"}])
 *
 */
function initSaleInfo(value) {
    setLocalData(SALE_DEPARTMENT_INFO_KEY, value);
}

/** 2016.04.07 add
 * 重定向功能
 * # 未登录首页，点击功能菜单，登录成功后，跳转到功能页面去。
 */
var REDIRECT = function (window) {
    // 初始化数据
    // # jumpParams = [null, null, null]
    function init() {
        var jumpParams = getJumpInterfaceParams();
        setLocalData("JUMP_PARAMS", jumpParams);
    }

    // 重定向
    function redirect() {
        var jumpParams = JSON.parse(getLocalData("JUMP_PARAMS") || "[null, null, null]");

        removeLocalData("JUMP_PARAMS");

        if (jumpParams[0] != null) {
            if (jumpParams[3] != null) {
                openThirdPartyWebInSubPage(jumpParams[2], jumpParams[3], jumpParams[0], '');
                return true;
            } else {
                jumpParams[2] = jumpParams[2] == '0' ? '0' : '2';
                JumpInterface(jumpParams[0], jumpParams[1], jumpParams[2]);
                return true;
            }
        }

        return false;
    }

    return {
        init: init,
        redirect: redirect
    };
}(window);

//======为了禁止android ios弹出系统键盘,必须将input文本,密码输入框的属性设置为只读
clearReadonly();

/**
 * 动态加载 CSS 和 JS 文件
 */
var dynamicLoading = function () {
    return {
        css: function css(path) {
            if (!path || path.length === 0) {
                throw new Error('argument "path" is required !');
            }
            var head = document.getElementsByTagName('head')[0];
            var link = document.createElement('link');
            link.href = path;
            link.rel = 'stylesheet';
            link.type = 'text/css';
            head.appendChild(link);
        },
        js: function js(path) {
            // 修改后，加载速度更快一些了
            document.write("<script src=" + path + "><" + '/' + "script>");
        }
    };
}();

// RemoveIOSHoverEvent();
dynamicLoading.js(getfirsthref(0) + "js/fastclick.js");
// 加载弹出框 CSS 文件
dynamicLoading.css(getfirsthref(0) + "css/dialog.css");
// 加载弹出框 JS 文件
dynamicLoading.js(getfirsthref(0) + "js/dialog.js");
if (params.ywlx === 'ptjy') {
    if (getlasthref(0).indexOf('sdmm/') > -1) {
        // 适当性改造 - 场内交易 - 闪电买卖特殊处理
        dynamicLoading.js(getfirsthref(0) + "js/sdxgz/cnjy-sdmm.js");
    } else {
        // 适当性改造 - 场内交易
        dynamicLoading.js(getfirsthref(0) + "js/sdxgz/cnjy.js");
    }
}
if (params.ywlx === 'kfsjj') {
    // 适当性改造 - 开放式基金
    dynamicLoading.js(getfirsthref(0) + "js/sdxgz/kfsjj.js");
}
if (params.ywlx === 'rzrq') {
    // 适当性改造 - 场内交易
    dynamicLoading.js(getfirsthref(0) + "js/sdxgz/cnjy-rzrq.js");
}
// 加载交易行情转APP行情
dynamicLoading.js(getfirsthref(0) + "js/apphq/apphq.js");
// 加载处理原生调用H5方法
dynamicLoading.js(getfirsthref(0) + "js/tradeFunction.js");
// 加密解决的封装类
dynamicLoading.js(getfirsthref(0) + 'js/sm4/encrypt.js');
// MD5
dynamicLoading.js(getfirsthref(0) + 'js/md5.min.js');
// sha256
dynamicLoading.js(getfirsthref(0) + 'js/sha256.min.js');
// 测试环境打开H5调式工具
// if ('@target' === 'test') {
//     dynamicLoading.js(getfirsthref(0) + 'js/vconsole.min.js');
//     setTimeout(function() {
//         new VConsole();
//     }, 2000);
// }

$(window).load(function () {
    FastClick.attach(document.body);

    //初始化APP主题皮肤
    initialAppTheme();
});

/**
 * 低版本登录
 * # 禁止 APP 低版本登录
 * # 禁止 H5 低版本登录 (现在实现第一阶段)
 *     * 第一阶段实现，交易登录检测到H5版本过低的，升级处理方式：弹出如下提示，提示用户退出APP重启进行检查升级。 点击“退出应用”按钮，退出APP
 *     * 第二阶段实现，中台增加在APP启动后可以下发H5升级包的接口 ， “退出应用”按钮改为“升级更新”，实现在当前页面进行H5版本包升级
 */
var LOW_VERSION_LOGIN = function () {
    /**
     * 显示更新 APP 的弹出框
     */
    function showUpdataAppModal(code) {
        // APP 版本过高
        if (code == "101") {
            showUpdataH5Modal(code);
            return;
        }

        var modal = {};
        modal["title"] = "";
        modal["msg"] = [{ "value": "当前客户版本过低，进行交易前需要升级最新版本" }];
        Dialog.alert(controller.scope, controller.compile, modal);
        $(".btn.btn-ensure").text("升级更新");

        // “升级更新” 按钮的绑定事件
        UpdateApp();
    }

    /**
     * 显示更新 H5 的弹出框
     */
    function showUpdataH5Modal(code) {
        var msg = "当前交易模块版本过低，进行交易前需要升级最新版本，是否退出重启应用进行升级 ？";
        // APP 版本过高
        if (code == "101") {
            msg = "当前客户端版本过高交易受限制，请拨打电话95587或与当地营业部联系";
        }
        // H5 版本过高
        else if (code == "201") {
                msg = "当前交易版本过高交易受限制，请拨打电话95587或与当地营业部联系";
            }

        var modal = {};
        modal["title"] = "";
        modal["msg"] = [{ "value": msg }];
        Dialog.alert(controller.scope, controller.compile, modal);
        $(".btn.btn-ensure").text("退出应用");

        // “退出应用” 按钮的绑定事件
        UpdateH5();
    }

    /**
     * “升级更新” 按钮的绑定事件
     */
    function UpdateApp() {
        var tempMethod = controller.scope.Ensure;
        controller.scope.Ensure = function () {
            if (params.browser == 'android') {
                KDS_Native.UpdateApp();
            } else if (params.browser == 'ios') {
                loadURL("KDS_Native://UpdateApp");
            }
            controller.scope.Ensure = tempMethod;
        };
    }

    /**
     * “退出应用” 按钮的绑定事件
     */
    function UpdateH5() {
        var tempMethod = controller.scope.Ensure;
        controller.scope.Ensure = function () {
            if (params.browser == 'android') {
                KDS_Native.UpdateH5();
            } else if (params.browser == 'ios') {
                loadURL("KDS_Native://UpdateH5");
            }
            controller.scope.Ensure = tempMethod;
        };
    }

    return {
        showUpdataAppModal: showUpdataAppModal,
        showUpdataH5Modal: showUpdataH5Modal
    };
}();

/**
 * 短信注册流程
 * # H5 调用 getDeveiceID 接口获取 “设备 ID”，原生回调 setDeveiceID 接口进行传值
 * # H5 调用 getIsHaveSIM 接口判断是否安装 SIM 卡，原生回调 setIsHaveSIM 接口进行传值
 */
var SMS_REGISTRATION_PROCESS = function (window, browser) {
    var systemURL = null; // 系统服务器地址
    var phone_num = null; // 手机号码
    var device_id = null; // 设备 ID
    var isHaveSIM = null; // 是否安装 SIM 卡

    // 登录完成后，执行的方法 （短信注册流程验证通过后执行的方法）
    var loginHandlerMethod = null;

    /**
     * 初始化
     */
    function init(method) {
        // 登录完成后，执行的方法
        loginHandlerMethod = method;

        // 系统服务器地址
        systemURL = getLocalData("apiUrlSystem") || null;

        // 手机号码
        phone_num = getLocalData("cellPhoneNumber");

        // 获取设备 ID
        getDeveiceID();
    }

    /**
     * 开始进行短信注册流程
     * @des
     *     该方法会在原生传入设备 ID 时调用
     *     该方法会在原生传入 SIM 状态时调用
     */
    function start() {
        if (device_id == null) {
            console.log("原生还没有将设备 ID 传入给 H5");
            return;
        } else {
            // 检测设备号
            deviceCheck(loginHandlerMethod);
        }
    }

    /**
     * 设置系统服务器地址
     */
    window["setApiUrlSystem"] = function (url) {
        setLocalData("apiUrlSystem", url);
    };

    /**
     * 获取设备 ID
     */
    function getDeveiceID() {
        if (browser == 'android') {
            KDS_Native.getDeveiceID();
        } else if (browser == 'ios') {
            loadURL("KDS_Native://getDeveiceID");
        }
    }

    /**
     * 设置设备 ID
     * @param   id 设备 ID
     */
    window["setDeveiceID"] = function (id) {
        device_id = id;
        updateHeaders({ deviceId: id });
        start();
    };

    /**
     * 获取是否安装 SIM 卡的状态
     */
    function getIsHaveSIM() {
        if (browser == 'android') {
            KDS_Native.getIsHaveSIM();
        } else if (browser == 'ios') {
            loadURL("KDS_Native://getIsHaveSIM");
        }
    }

    /**
     * 设置是否安装 SIM 卡的状态
     * @param state 状态 ["true": 已安装, "false": 未安装]
     */
    window["setIsHaveSIM"] = function (state) {
        isHaveSIM = state;
        start();
    };

    /**
     * 显示没有 SIM 卡时的弹出框
     */
    function showNoSIMAlert() {
        Dialog.customAlert("你的手机未安装SIM卡不能进行手机注册，请先安装SIM卡", "提示");
    }

    /**
     * 检测设备号
     */
    function deviceCheck(method) {
        if (phone_num == null || device_id == null) {
            console.log("手机号码或设备 ID 不存在! phone_num=" + phone_num + ", device_id=" + device_id);
            return;
        }

        var cellPhoneNumberEnc = JSON.parse(getLocalData("cellPhoneNumberEnc") || "{}");
        var request = {
            "phone_num": phone_num,
            "device_id": device_id,
            "phone_num_enc1": cellPhoneNumberEnc.phone_num_enc1,
            "phone_num_enc2": cellPhoneNumberEnc.phone_num_enc2
        };

        // 校验成功的条件：http status = 200 或 errCode = 0
        ajaxPost(systemURL + "/api/system/login/devicecheck/0001/", request, function (response) {
            method();
        }, null, {
            // 不使用固定入参
            isFixedParam: false,
            // 服务器成功返回信息不需要统一报错处理
            issuccess: false,
            // 执行报错回调方法
            error: function error(xhr) {
                // 客户要求：明确收到不让登录的才不让登录，其他的都让登录
                // 服务器返回 errCode 只有 "0" 或 "1"， 0 是成功，1 是失败
                try {
                    var res = JSON.parse(xhr.responseText);
                    if (res.errCode == "0") {
                        method();
                    } else {
                        var modal = {};
                        modal["title"] = "提示信息";
                        modal["msg"] = [{ "value": "你的手机号在另一台设备上注册登录了，交易前请重新注册登录你的手机号" }];
                        Dialog.alert(controller.scope, controller.compile, modal);
                        $("#modalTips .btn.btn-ensure").text("重新注册");
                        // 手机号码重新注册
                        registration();
                    }
                } catch (error) {
                    // Dialog.errorAlert('系统服务器错误', '提示信息');
                    method();
                }
            }
        });
    }

    /**
     * 手机号码重新注册
     */
    function registration() {
        var tempMethod = controller.scope.Ensure;
        controller.scope.Ensure = function () {
            // 显示重新注册界面
            showRegisterView();
            // 还原 Ensure 的处理事件
            controller.scope.Ensure = tempMethod;
            // 关闭模态框
            Dialog.closeAlert("modalTips");
        };
    }

    if (browser == "pc") {
        isHaveSIM = "true";
        device_id = "PCPCPC";
        getDeveiceID = function getDeveiceID() {
            start();
        };
        getIsHaveSIM = function getIsHaveSIM() {
            start();
        };
        deviceCheck = function deviceCheck(method) {
            method();
        };
    }

    return {
        init: init
    };
}(window, params.browser);

/**
 * 标题栏背景颜色的 URL 列表
 */
(function (browser) {
    // 标题栏背景颜色设置为：灰色
    var GRAY_URLS = ['view/ptjy/more/', 'view/ptjy/zccx/', 'view/wltp/', 'view/gfzr/', 'ptjy/dzqy/',
    // 'view/szbjhg/',  因为该功能从更多移到首页，不需要设置背景颜色
    'view/ptjy/xgmm/'];

    var ALL_URLS = {
        'gray': GRAY_URLS
    };

    /**
     * 获取需要设置标题栏背景颜色的 URL 列表 【原生调用】
     */
    window['getActionBarUrls'] = function () {
        console.log('getActionBarUrls - ' + JSON.stringify(ALL_URLS));
        setActionBarUrls(JSON.stringify(ALL_URLS));
    };

    /**
     * 设置标题栏背景颜色的 URL 列表
     */
    function setActionBarUrls(urls) {
        if (browser == 'android') {
            KDS_Native.setActionBarUrls(urls);
        } else if (browser == 'ios') {
            loadURL("KDS_Native://setActionBarUrls:" + urls);
        }
    }
})(params.browser);

/*******************************
level 2 相关函数
*******************************/
/**
 * 设置 level 函数，由原生调用
 * @param {string} level 1 || 2
 */
function setLevel(level) {
    setLocalData("level", level);
}

/**
 * 是否已购买 level 2
 * @return {Boolean} [description]
 */
function isLevel2() {
    return getLocalData("level") == "2";
}

/**
 * 是否 level 1
 * 当 APP 设置成 1 时，从 APP 那里获取五档行情
 * @return {Boolean} [description]
 */
function isLevel1() {
    return getLocalData("level") == "1";
}

/**
 * 添加中文单位
 * @param "false": 不补全小数位
 */
function addChineseUnit(value, isDecimal) {
    if (!isNaN(value) && value !== '') {
        var value = parseInt(value);
        var unit = " ";
        var len = (value + "").length;
        if (len > 4 && len < 8) {
            value = value / 10000;
            value = Math.floor(value * 100) / 100;
            unit = " 万";
        }
        if (len > 7 && len < 9) {
            value = value / 10000000;
            value = Math.floor(value * 100) / 100;
            unit = " 千万";
        }
        if (len > 8) {
            value = value / 100000000;
            value = Math.floor(value * 100) / 100;
            unit = " 亿";
        }
        if (isDecimal != false) {
            // 如没有小数位则补全二位小数位
            var value = value + "";
            var rs = value.indexOf('.');
            if (rs < 0) {
                rs = value.length;
                value += '.';
            }
            while (value.length <= rs + 2) {
                value += '0';
            }
        }
        return value + unit;
    } else {
        return value;
    }
}

function getChineseUnit(value) {
    if (value == null) {
        return '';
    }

    try {
        // 取小数点前的金额
        value = value.split('.')[0] || '0';
        // 通过转换数据解决数字前带 0 的问题
        value = parseFloat(value);
        value = value.toString();
    } catch (e) {
        value = '';
    }

    var unit = '';
    switch (value.length) {
        case 5:
            unit = '万';
            break;
        case 6:
            unit = '十万';
            break;
        case 7:
            unit = '百万';
            break;
        case 8:
            unit = '千万';
            break;
        case 9:
            unit = '亿';
            break;
        case 10:
            unit = '十亿';
            break;
        case 11:
            unit = '百亿';
            break;
        case 12:
            unit = '千亿';
            break;
    }
    return unit;
}

/*
 * 功能：生成一个GUID码，其中GUID以14个以下的日期时间及18个以上的16进制随机数组成，GUID存在一定的重复概率，但重复概率极低，理论上重复概率为每10ms有1/(16^18)，即16的18次方分之1，重复概率低至可忽略不计
 */
function GUID() {
    this.date = new Date();

    /* 判断是否初始化过，如果初始化过以下代码，则以下代码将不再执行，实际中只执行一次 */
    if (typeof this.newGUID != 'function') {

        /* 生成GUID码 */
        GUID.prototype.newGUID = function () {
            this.date = new Date();
            var guidStr = '';
            var sexadecimalDate = this.hexadecimal(this.getGUIDDate(), 16);
            var sexadecimalTime = this.hexadecimal(this.getGUIDTime(), 16);
            for (var i = 0; i < 9; i++) {
                guidStr += Math.floor(Math.random() * 16).toString(16);
            }
            guidStr += sexadecimalDate;
            guidStr += sexadecimalTime;
            while (guidStr.length < 32) {
                guidStr += Math.floor(Math.random() * 16).toString(16);
            }
            return this.formatGUID(guidStr);
        };

        /*
         * 功能：获取当前日期的GUID格式，即8位数的日期：19700101
         * 返回值：返回GUID日期格式的字条串
         */
        GUID.prototype.getGUIDDate = function () {
            return this.date.getFullYear() + this.addZero(this.date.getMonth() + 1) + this.addZero(this.date.getDay());
        };

        /*
         * 功能：获取当前时间的GUID格式，即8位数的时间，包括毫秒，毫秒为2位数：12300933
         * 返回值：返回GUID日期格式的字条串
         */
        GUID.prototype.getGUIDTime = function () {
            return this.addZero(this.date.getHours()) + this.addZero(this.date.getMinutes()) + this.addZero(this.date.getSeconds()) + this.addZero(parseInt(this.date.getMilliseconds() / 10));
        };

        /*
         * 功能: 为一位数的正整数前面添加0，如果是可以转成非NaN数字的字符串也可以实现
         * 参数: 参数表示准备再前面添加0的数字或可以转换成数字的字符串
         * 返回值: 如果符合条件，返回添加0后的字条串类型，否则返回自身的字符串
         */
        GUID.prototype.addZero = function (num) {
            if (Number(num).toString() != 'NaN' && num >= 0 && num < 10) {
                return '0' + Math.floor(num);
            } else {
                return num.toString();
            }
        };

        /*
         * 功能：将y进制的数值，转换为x进制的数值
         * 参数：第1个参数表示欲转换的数值；第2个参数表示欲转换的进制；第3个参数可选，表示当前的进制数，如不写则为10
         * 返回值：返回转换后的字符串
         */
        GUID.prototype.hexadecimal = function (num, x, y) {
            if (y != undefined) {
                return parseInt(num.toString(), y).toString(x);
            } else {
                return parseInt(num.toString()).toString(x);
            }
        };

        /*
         * 功能：格式化32位的字符串为GUID模式的字符串
         * 参数：第1个参数表示32位的字符串
         * 返回值：标准GUID格式的字符串
         */
        GUID.prototype.formatGUID = function (guidStr) {
            var str1 = guidStr.slice(0, 8) + '-',
                str2 = guidStr.slice(8, 12) + '-',
                str3 = guidStr.slice(12, 16) + '-',
                str4 = guidStr.slice(16, 20) + '-',
                str5 = guidStr.slice(20);
            return str1 + str2 + str3 + str4 + str5;
        };
    }
}

/**
 * 更新本地存储中 Header 请求需要的信息
 * @param  {[type]} json [description]
 * @return {[type]}      [description]
 */
function updateHeaders(json) {
    var key = 'KDS_HEADERS';
    var headers = JSON.parse(getLocalData(key) || '{}');
    headers = Object.assign(headers, json);
    console.log('[updateHeaders] ' + JSON.stringify(headers));
    setLocalData(key, JSON.stringify(headers));
    return headers;
}

if (typeof Object.assign != 'function') {
    (function () {
        Object.assign = function (target) {
            'use strict';

            if (target === undefined || target === null) {
                throw new TypeError('Cannot convert undefined or null to object');
            }

            var output = Object(target);
            for (var index = 1; index < arguments.length; index++) {
                var source = arguments[index];
                if (source !== undefined && source !== null) {
                    for (var nextKey in source) {
                        if (source.hasOwnProperty(nextKey)) {
                            output[nextKey] = source[nextKey];
                        }
                    }
                }
            }
            return output;
        };
    })();
}