var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var Dialog = function () {
    function alert($scope, $compile, modal, options) {
        var defaults = {
            // 是否在 angular 控制器内调用该方法
            isController: true,
            // 是否隐藏第一个按钮
            firstBtnHide: false,
            // 添加成功 ico 图标
            rightIcoHide: false,
            // 添加失败 ico 图标
            wrongIcoHide: false,
            // 添加感叹号 ico 图标
            exclamatoryIcoHide: false,
            leftButtonText: '取消',
            rightButtonText: '确认',
            // 弹出框中底部右边的按钮是否被禁用
            isRightButtonDisabled: false,
            leftButtonClick: function leftButtonClick() {
                closeAlert("modalTips");
            },
            rightButtonClick: function rightButtonClick() {
                $scope.Ensure();
            },
            // 滚动条滚动时触发的方法
            onScroll: null,
            // 滚动条滚动到底部时触发的方法
            onScrollBottom: null,
            // 底部按钮区域是否显示
            footerShow: true,
            // html内容按钮区域是否显示
            htmlContentFooterShow: false,
            // body 是否支持滑动
            isBodyScroll: false
        };

        options = $.extend(defaults, options || {});

        modal['leftButtonText'] = options.leftButtonText;
        modal['rightButtonText'] = options.rightButtonText;

        modal['isRightButtonDisabled'] = options.isRightButtonDisabled;

        modal['leftButtonClick'] = options.leftButtonClick;
        modal['rightButtonClick'] = options.rightButtonClick;

        modal['leftBtnShow'] = !options.firstBtnHide;
        modal['modalFooterIdName'] = modal.leftBtnShow ? 'modal-footer-middle-border' : '';

        modal['footerShow'] = options.footerShow;
        modal['htmlContentFooterShow'] = options.htmlContentFooterShow;
        modal['bodyClass'] = options.isBodyScroll ? 'body-scroll' : '';

        modal['icoClassName'] = '';
        if (options.rightIcoHide) {
            modal.icoClassName = 'SuccessAlert';
        }
        if (options.wrongIcoHide) {
            modal.icoClassName = 'ErrorAlert';
        }
        if (options.exclamatoryIcoHide) {
            modal.icoClassName = 'ExclamatoryAlert';
        }

        DialogBind.onScroll = function (e) {
            if (options.onScroll) {
                options.onScroll(e);
            }
            if (options.onScrollBottom) {
                if (e.scrollTop + e.clientHeight == e.scrollHeight) {
                    options.onScrollBottom(e);
                }
            }
        };

        var atertHTML = DialogDynamicTemplate.loading(modal.dynamic, DialogTemplate.alert);

        // 按钮上面的动态模板  (需要传对象)
        if (_typeof(modal.btnBeforeDynamic) === 'object') {
            atertHTML = DialogDynamicTemplate.btnBeforeDynamic(atertHTML, modal.btnBeforeDynamic);
        }

        var template = angular.element(atertHTML);
        mobileDialogElement = $compile(template)($scope);
        // 动态创建模态框
        angular.element(document.body).append(mobileDialogElement);

        if (options.isController) {
            $scope.modal = modal;
        } else {
            // 如果不是在控制器内则需要在该方法内执行
            angular.element($("body")).scope().$apply(function () {
                $scope.modal = modal;
            });
        }

        return false;
    }

    function customAlert(msg, title, showCancelBtn, options) {
        // 显示信息提示框时,关闭自定义键盘
        hideKeyBoard();

        var defaults = {
            // 添加感叹号 ico 图标
            exclamatoryIcoHide: false,
            // 隐藏标题
            titleHide: false,
            rightButtonText: ''
        };

        options = $.extend(defaults, options || {});

        // 经验证，$("#CustomAlert") 可能会现等于 undefined 情况，当等于 undefined 时，也需要弹出提示框
        if ($("#CustomAlert") == undefined || $("#CustomAlert").length == 0) {

            $(document.body).append(DialogTemplate.customAlert);

            // 提示语超过一行则设置文字居中对齐
            if ($(".modal-body > table > tbody > tr.msg > td").height > 20) {
                $(".modal-body > table > tbody > tr.msg > td").css({
                    "text-align": "left"
                });
            } else //提示语超过一行则设置文字左对齐
                {
                    $(".modal-body > table > tbody > tr.msg > td").css({
                        "text-align": "center"
                    });
                }

            $("#CustomAlert .modal-footer").removeAttr("id");
            showCancelBtn = showCancelBtn ? showCancelBtn : "";
            // 是否显示取消按钮
            if (showCancelBtn) {
                $("#CustomAlert .btn-default").show();
                $(".modal-footer").attr("id", "modal-footer-middle-border");
            }

            if (options.exclamatoryIcoHide) {
                // 添加图标显示属性
                $(".modal").addClass('ExclamatoryAlert');
            }

            // 标题
            $("#CustomAlert #title").text(title);
            // 信息内容
            if (Object.prototype.toString.call(msg) === '[object Array]') {
                var i = 0,
                    len = msg.length;
                for (; i < len; i++) {
                    $("#CustomAlert .info").append("<p>" + msg[i] + "</p>");
                }
                $("#CustomAlert .info").css({ textAlign: 'justify' });
            } else {
                $("#CustomAlert .info").text(msg);
            }

            if (options.titleHide) {
                $("#CustomAlert .modal-header").hide();
            }

            if (options.rightButtonText != '') {
                $("#CustomAlert .btn.btn-ensure").text(options.rightButtonText);
            }

            // 使提示框居中显示
            moveToCenter("dialog");
        }
    }

    function successAlert(msg, title, showCancelBtn) {
        commonAlert(msg, title, showCancelBtn, DialogTemplate.successAlert);
    }

    function errorAlert(msg, title, showCancelBtn) {
        commonAlert(msg, title, showCancelBtn, DialogTemplate.errorAlert);
    }

    function dateAlert($scope, $compile) {
        ;
        var template = angular.element(DialogTemplate.queryTimeView);

        mobileDialogElement = $compile(template)($scope);

        //==================动态创建模态框=========================
        angular.element(document.body).append(mobileDialogElement);

        $(".modal-footer").attr("id", "modal-footer-middle-border");
    }

    function timeOutAlert(msg, title, jumpText, status) {
        // 显示信息提示框时,关闭自定义键盘
        hideKeyBoard();

        // 经验证，$("#CustomAlert") 可能会现等于 undefined 情况，当等于 undefined 时，也需要弹出提示框
        if ($("#TimeOutAlert") == undefined || $("#TimeOutAlert").length == 0) {
            var settime = function settime() {
                if (timeStep == 0) {
                    Dialog.countDownAlert();
                    return;
                }
                setTimeout(function () {
                    $('#jumpTime').text(timeStep--);
                    settime();
                }, 1000);
            };

            //执行showTime()


            $(document.body).append(DialogTemplate.TimeOutAlert);

            // 标题
            $("#TimeOutAlert #title").text(title);
            // 信息内容
            $("#TimeOutAlert .info").text(msg);
            // 跳转信息
            $("#TimeOutAlert .jumpText").text(jumpText);

            // 使提示框居中显示
            moveToCenter("dialog");

            // 设定倒数秒数
            var timeStep = 9;
            settime();
        }
    }

    // successAlert 公用部分
    function commonAlert(msg, title, showCancelBtn, statusType) {
        // 显示信息提示框时, 关闭自定义键盘
        hideKeyBoard();

        // 经验证，$("#CustomAlert") 可能会现等于 undefined 情况，当等于 undefined 时，也需要弹出提示框
        if ($("#CustomAlert") == undefined || $("#CustomAlert").length == 0) {
            $(document.body).append(statusType);

            // 提示语超过一行则设置文字居中对齐
            if ($(".modal-body > table > tbody > tr.msg > td").height > 20) {
                $(".modal-body > table > tbody > tr.msg > td").css({
                    "text-align": "left"
                });
            } else {
                // 提示语超过一行则设置文字左对齐
                $(".modal-body > table > tbody > tr.msg > td").css({
                    "text-align": "center"
                });
            }

            showCancelBtn = showCancelBtn ? showCancelBtn : "";
            // 是否显示取消按钮
            if (showCancelBtn) {
                $("#CustomAlert .btn-default").show();
            }

            // 标题
            $("#CustomAlert #title").text(title);
            // 信息内容
            $("#CustomAlert .info").text(msg);
            // 使提示框居中显示
            moveToCenter("dialog");
        }
    }

    /**
     * 短信验证码
     *
     * @param {[String]}    title            标题 - NULL
     * @param {[String]}    row1Label        第一行标签显示的文字 - NULL
     * @param {[String]}    row2Label        第一行标签显示的文字 - NULL
     * @param {[function]}  getCode          点击获取验证时回调的方法 - NOT NULL
     * @param {[function]}  rightButtonClick 点击弹框底部右边按钮时回调的方法 - NOT NULL
     * @param {[boolean]}   isCache          是否有缓存ID (获取挑战码接口返回) - NULL
     *
     * @description
     * 输入手机号后，才能获取短信验证码
     * 点击 “获取验证码” 按钮时
     *     - 触发回调事件，执行下发短信验证的方法
     *     - 该按钮进入倒计时状态，默认设置 60s
     * 点击 “取消”、“提交” 按钮时执行相应的回调方法
     *
     * @ps
     * 点击 “获取验证码” 后，点出 “取消” 按钮，没有清空基金代码就点击 “申购” 按钮，当再次弹出验证码弹框时，
     * 修改手机号码并输入之前下发的手机验证码点击 “提交” 按钮，这时必然报错，这个报错由服务器(或柜台)控制。
     *
     * @test
     * Dialog.SMSAuthenticationCodeAlert()
     *
     */
    function SMSAuthenticationCodeAlert(title, row1Label, row2Label, getCode, _rightButtonClick, isCache) {
        // 发送成功（挑战码）
        var sendSuccessfully = false;
        var isTime = false;
        var fixedTime = 60;
        var time = fixedTime;
        var interval = null;
        var intervalFun = function intervalFun() {
            if (time > 0) {
                controller.scope.modal.inputContent[1].inputRightButtonText = time-- + 's';
            } else {
                clearInterval(interval);
                time = fixedTime;
                controller.scope.modal.inputContent[1].inputRightButtonText = '获取验证码';
            }

            controller.scope.$digest();
        };

        var modal = {
            'title': title || '请输入验证码以确认购买',
            'inputTextStyle': 'sms',
            'inputContent': [{
                'key': row1Label || '手机号：',
                'rowId': 'dialogPhoneNumber',
                'showInputRightButton': false,
                'defaultValue': getLocalData('cellPhoneNumber') || ''
            }, {
                'key': row2Label || '验证码：',
                'rowId': 'dialogVerificationCode',
                'showInputRightButton': true,
                'inputRightButtonText': '获取验证码',
                'inputRightButtonClick': function inputRightButtonClick() {
                    if (time < fixedTime) {
                        return;
                    }

                    console.log('---inputRightButtonClick');
                    var phoneNumber = document.getElementById('dialogPhoneNumber').value;
                    if (phoneNumber === '') {
                        showMessageTips(modal.inputContent[0].key.replace('：', '').concat('不能为空！'), 45);
                    } else {
                        if (getCode) {
                            sendSuccessfully = false;
                            getCode(phoneNumber, function (tzm, hcid) {
                                if (hcid != null) {
                                    sendSuccessfully = true;
                                }
                                if (tzm != null) {
                                    document.getElementById('dialogVerificationCode').value = tzm;
                                }
                            });
                        }

                        setTimeout(intervalFun);
                        interval = setInterval(intervalFun, 1000);
                    }
                }
            }]
        };

        var options = {
            'isController': true,
            'rightButtonText': '提交',
            'leftButtonClick': function leftButtonClick() {
                closeAlert('modalTips');
                clearInterval(interval);
            },
            'rightButtonClick': function rightButtonClick() {
                var code = document.getElementById('dialogVerificationCode').value;
                if (code === '') {
                    showMessageTips(modal.inputContent[1].key.replace('：', '').concat('不能为空！'), 45);
                }
                // 缓存ID不存在且还没有发送成功时，需要提醒
                else if (!isCache && !sendSuccessfully) {
                        showMessageTips('您输入的验证码错误，请您核实后重新输入。', 45);
                    } else {
                        closeAlert('modalTips');
                        clearInterval(interval);
                        if (_rightButtonClick) {
                            _rightButtonClick(code);
                        }
                    }
            }
        };
        alert(controller.scope, controller.compile, modal, options);

        if (!controller.scope.showKeyboard) {
            console.log('控制器内不存在 showKeyboard 方法, 创建该方法。');
            controller.scope.showKeyboard = function (id, type) {
                showKeyboard(id, type);
            };
        }
    }

    /**
     * 关闭弹框
     * @param   alertIdName     弹出框的 ID 名称，如果入参不为 null，则只关闭该弹出框，否则关闭所有弹出框
     */
    function closeAlert(alertIdName) {
        // 有些模态框中有输入框,关闭模态框时关闭自定义键盘
        hideKeyBoard();

        if (alertIdName != null) {
            if ($("#" + alertIdName).length > 0) {
                $("#" + alertIdName).remove();
            }
        } else {
            if ($(".modal").length > 0) {
                $(".modal").remove();
            }
        }
    }

    // 点击 “确认” 关闭弹框
    function confirm() {
        closeAlert("CustomAlert");
    }

    // 倒计时 > 点击快捷关闭弹框
    function countDownAlert() {
        closeAlert("TimeOutAlert");
    }

    // 时间弹框取值
    function onQueryTimeViewClick(type) {
        if (type == 0) {
            $("#queryDateView").hide();
        } else {
            var startDate = $("input[name='startDate']").val();
            var endDate = $("input[name='endDate']").val();

            if (startDate == "" || endDate == "") {
                $("#queryDateView").hide();
                return;
            }

            var array = startDate.split("-");
            var sDate = new Date(array[0], parseInt(array[1]) - 1, array[2]);
            array = endDate.split("-");
            var eDate = new Date(array[0], parseInt(array[1]) - 1, array[2]);

            if (sDate.getTime() > eDate.getTime()) {
                Dialog.customAlert("起始时间在截止时间后，请调整查询日期", "提示");
                return;
            }
            var maxDate = sDate.addMonths(selfQueryDateLimit);
            if (eDate.getTime() > maxDate.getTime()) {
                var datePrompt = "二";
                if (selfQueryDateLimit == 1) {
                    datePrompt = "一";
                }
                Dialog.customAlert("最多只能" + datePrompt + "个月的数据记录，请调整查询日期", "提示");
                return;
            }
            setLocalData("queryDate", {
                start: startDate,
                end: endDate
            });
            $("#queryDateView").hide();
            queryForDate([maxDate.addMonths(-selfQueryDateLimit).Format("yyyyMMdd"), eDate.Format("yyyyMMdd")]);
        }
    }

    // 下拉框
    // Dialog.selectAlert({options: [{'label': '0002387218', 'checked': true}, {'label': '0186484092'}]});
    function selectAlert(object) {
        var defaultObject = {};
        defaultObject.selectId = 'select-'.concat(Math.random().toString(36).substr(2, 5));
        defaultObject.imgPath = '../../../images/login_tick.png';
        defaultObject.title = '股东代码列表';
        defaultObject.options = [];
        defaultObject.click = null;
        object = $.extend(defaultObject, object || {});

        var element = DialogTemplate.selectAlert(object.selectId, object.title, object.options, object.imgPath);
        document.body.appendChild(element);

        // 点击遮盖层时，移除下拉框
        element.onclick = function () {
            element.parentNode.removeChild(element);
        };

        // 点击下拉框列表项时，触发的回调事件
        var lis = element.getElementsByTagName('li');
        for (var i = 0, len = lis.length; i < len; i++) {
            lis[i].onclick = function (index) {
                if (typeof object.click === 'function') {
                    object.click(index, this.innerText, this);
                }
            }.bind(lis[i], i);
        }
    }

    return {
        alert: alert,
        customAlert: customAlert,
        errorAlert: errorAlert,
        successAlert: successAlert,
        dateAlert: dateAlert,
        dynGenerateNode: dynGenerateNode,
        closeAlert: closeAlert,
        confirm: confirm,
        onQueryTimeViewClick: onQueryTimeViewClick,
        timeOutAlert: timeOutAlert,
        countDownAlert: countDownAlert,
        SMSAuthenticationCodeAlert: SMSAuthenticationCodeAlert,
        selectAlert: selectAlert
    };
}();

/**
 * 提示框模板
 */
var DialogTemplate = function () {
    return {
        // 普通弹出框模板--angula循环数据
        alert: HereDoc(function () {/*
                                    <div class='modal flexClass {{modal.icoClassName}}' id='modalTips'>
                                    <div class='modal-backdrop in'></div>
                                    <div class='modal-dialog'>
                                    <div class='modal-content'>
                                    <div class='modal-header'>
                                    <h4 class='modal-title'>{{modal.title}}</h4>
                                    </div>
                                    <div class='modal-body {{modal.bodyClass}}'>
                                    <table>
                                    <tbody>
                                     <tr class='content {{row.class}}' ng-repeat='row in modal.content'>
                                         <td>{{row.key}}</td>
                                         <td>{{row.value}}<label ng-if="row.value == ''">&nbsp;</label></td>
                                     </tr>
                                      <tr class='longContent' ng-repeat='row in modal.longContent'>
                                         <td>{{row.key}}</td>
                                         <td>{{row.value}}</td>
                                     </tr>
                                      <tr class='single' ng-repeat='row in modal.single'>
                                         <td colspan='2'>{{row.value}}</td>
                                     </tr>
                                      <tr class='msg' ng-repeat='row in modal.msg'>
                                         <td colspan='2' class='{{row.class}}'>{{row.value}}</td>
                                     </tr>
                                      <tr class='inputText {{modal.inputTextStyle}}' ng-repeat='row in modal.inputContent'>
                                         <td>{{row.key}}</td>
                                         <td>
                                             <input type='text' value='{{row.defaultValue}}' id='{{row.rowId}}' ng-click='showKeyboard(row.rowId, 1);' readonly='readonly' />
                                             <button ng-if='row.showInputRightButton' ng-click='row.inputRightButtonClick()'>
                                                 {{row.inputRightButtonText}}
                                             </button>
                                         </td>
                                     </tr>
                                      <tr class='inputbox' ng-repeat='row in modal.inputbox'>
                                         <td colspan='2'>
                                             <div data_index='{{$index}}'>
                                                 <div class='w35per'>
                                                     <label>{{row.key}}</label>
                                                 </div>
                                                  <div class='w65per'>
                                                     <input type='password' placeholder='{{row.value}}' id='{{row.id}}' ng-click='showKeyboard(row.id);' autocomplete='off' readonly='readonly' />
                                                 </div>
                                             </div>
                                         </td>
                                     </tr>
                                      <tr class='inputbox' ng-repeat='row in modal.inputbox2'>
                                         <td colspan='2'>
                                             <div data_index='{{$index}}'>
                                                 <div class='w35per'>
                                                     <label>{{row.key}}</label>
                                                 </div>
                                                  <div class='w65per'>
                                                     <div class="fake_input_wrap">
                                                         <input type="text" id='{{row.id}}' placeholder='{{row.value}}' value=""  readonly  />
                                                         <div class="fake_curosr_with_text_wrap" data-inputid='{{row.id}}'>
                                                             <label class="fake_text" data-inputid='{{row.id}}'></label>
                                                             <div class="fake_cursor" data-inputid='{{row.id}}' style=""></div>
                                                         </div>
                                                     </div>
                                                 </div>
                                             </div>
                                         </td>
                                     </tr>
                                      <tr class='select' ng-repeat='row in modal.select'>
                                         <td>{{ row.key }}</td>
                                         <td><select ng-model='row.options.selectVal' ng-options='option.value as option.text for option in row.options' ng-change='selectChange($index)' dir='rtl'></select>&nbsp;</td>
                                     </tr>
                                      <tr class='numbers' ng-repeat='row in modal.numbers'>
                                         <td colspan='2'>
                                             <div>
                                                 <div>
                                                     <button class='{{row.minus}} btn-price' ng-click='minus()'></button>
                                                 </div>
                                                 <div>
                                                     <input type='text' id='{{row.id}}' ng-click='showKeyboard(row.id);' ng-model='numbers.number' class='price' placeholder='{{row.value}}' readonly='readonly' />
                                                 </div>
                                                 <div>
                                                     <button class='{{row.plus}} btn-price' ng-click='plus()'></button>
                                                 </div>
                                             </div>
                                         </td>
                                     </tr>
                                      <tr class='numbers-msg' ng-repeat='row in modal.numbersMsg'>
                                         <td colspan='2'>
                                             {{row.key}}
                                             <label class='price'>{{row.value}}</label>
                                         </td>
                                     </tr>
                                      <tr class='btnBeforeMsg' ng-repeat='row in modal.btnBeforeMsg'>
                                         <td  colspan='2'>{{row.value}}</td>
                                     </tr>
                                      <tr class='explaintion' ng-repeat='row in modal.explaintion'>
                                         <td colspan='2'>{{row.value}}</td>
                                     </tr>
                                      <tr class='htmlContent' ng-if='modal.htmlContent != null && modal.htmlContent != ""'>
                                         <td colspan='2'>
                                             <div onScroll='DialogBind.onScroll(this)'>
                                                 <div yt-string-html='modal.htmlContent'></div>
                                                  <div class='modal-footer' id='{{modal.modalFooterIdName}}' ng-if='modal.htmlContentFooterShow'>
                                                     <button class='btn btn-default' ng-click='modal.leftButtonClick()' ng-show='modal.leftBtnShow'>
                                                         {{modal.leftButtonText}}
                                                     </button>
                                                     <button class='btn btn-ensure' ng-class="{true: 'disabled'}[modal.isRightButtonDisabled]" ng-click='modal.isRightButtonDisabled || modal.rightButtonClick()'>
                                                         {{modal.rightButtonText}}
                                                     </button>
                                                 </div>
                                             </div>
                                         </td>
                                     </tr>
                                      <dynamic></dynamic>
                                    </tbody>
                                    </table>
                                    <btnBeforeDynamic></btnBeforeDynamic>
                                    </div>
                                    <div class='modal-footer' id='{{modal.modalFooterIdName}}' ng-if='modal.footerShow'>
                                    <button class='btn btn-default' ng-click='modal.leftButtonClick()' ng-show='modal.leftBtnShow'>
                                    {{modal.leftButtonText}}
                                    </button>
                                    <button class='btn btn-ensure' ng-class="{true: 'disabled'}[modal.isRightButtonDisabled]" ng-click='modal.isRightButtonDisabled || modal.rightButtonClick()'>
                                    {{modal.rightButtonText}}
                                    </button>
                                    </div>
                                    <div class='modal-footer-msg' ng-repeat='row in modal.footerMsg'>{{row.value}}</div>
                                    </div>
                                    </div>
                                    </div>
                                    */}),

        // 普通提示弹框
        customAlert: HereDoc(function () {/*
                                          <div class='modal flexClass' id='CustomAlert'>
                                          <div class='modal-backdrop in'></div>
                                          <div class='modal-dialog'>
                                          <div class='modal-content'>
                                          <div class='modal-header'>
                                          <h4 class='modal-title' id='title'></h4>
                                          </div>
                                          <div class='modal-body body-scroll'>
                                          <table>
                                          <tbody>
                                          <tr class='msg'>
                                          <td colspan='2' class='info'></td>
                                          </tr>
                                          </tbody>
                                          </table>
                                          </div>
                                          <div class='modal-footer'>
                                          <button class='btn btn-default' onclick='Dialog.closeAlert("CustomAlert");' style='display:none'>取消</button>
                                          <button class='btn btn-ensure' onclick='Dialog.confirm();'>确定</button>
                                          </div>
                                          </div>
                                          </div>
                                          </div>
                                          */}),

        // 提交成功弹框
        successAlert: HereDoc(function () {/*
                                           <div class='modal SuccessAlert flexClass' id='CustomAlert'>
                                           <div class='modal-backdrop in'></div>
                                           <div class='modal-dialog'>
                                           <div class='modal-content'>
                                           <div class='modal-header'>
                                           <h4 class='modal-title' id='title'></h4>
                                           </div>
                                           <div class='modal-body'>
                                           <table>
                                           <tbody>
                                           <tr class='msg'>
                                           <td colspan='2' class='info'></td>
                                           </tr>
                                           </tbody>
                                           </table>
                                           </div>
                                           <div class='modal-footer'>
                                           <button class='btn btn-default' onclick='Dialog.closeAlert("CustomAlert");' style='display:none'>取消</button>
                                           <button class='btn btn-ensure' onclick='Dialog.confirm();'>确定</button>
                                           </div>
                                           </div>
                                           </div>
                                           </div>
                                           */}),

        // 提交失败弹框
        errorAlert: HereDoc(function () {/*
                                         <div class='modal ErrorAlert flexClass' id='CustomAlert'>
                                         <div class='modal-backdrop in'></div>
                                         <div class='modal-dialog'>
                                         <div class='modal-content'>
                                         <div class='modal-header'>
                                         <h4 class='modal-title' id='title'></h4>
                                         </div>
                                         <div class='modal-body'>
                                         <table>
                                         <tbody>
                                         <tr class='msg'>
                                          <td colspan='2' class='info'></td>
                                         </tr>
                                         </tbody>
                                         </table>
                                         </div>
                                         <div class='modal-footer'>
                                         <button class='btn btn-default' onclick='Dialog.closeAlert("CustomAlert");' style='display:none'>取消</button>
                                         <button class='btn btn-ensure' onclick='Dialog.confirm()'>确定</button>
                                         </div>
                                         </div>
                                         </div>
                                         </div>
                                         */}),

        // 定时关闭弹框效果
        TimeOutAlert: HereDoc(function () {/*
                                           <div class='modal flexClass' id='TimeOutAlert'>
                                           <div class='modal-backdrop in'></div>
                                           <div class='modal-dialog'>
                                           <div class='modal-content'>
                                           <div class='modal-header'>
                                           <h4 class='modal-title' id='title'></h4>
                                           </div>
                                           <div class='modal-body'>
                                           <div class='info'></div>
                                           <div>
                                           弹窗将在<span id='jumpTime'>10</span>s后自动<span class='jumpText'></span>
                                           </div>
                                           </div>
                                           <div class='modal-footer'>
                                           <button class='btn' onclick='Dialog.countDownAlert()'>我知道了，跳转>></button>
                                           </div>
                                           </div>
                                           </div>
                                           </div>
                                           */}),

        // 时间关闭弹框效果
        queryTimeView: HereDoc(function () {/*
                                            <div class='modal DateAlert flexClass' id='queryDateView' ng-cloak>
                                            <div class='modal-backdrop in'></div>
                                            <div class='modal-dialog'>
                                            <div class='modal-content'>
                                            <div class='modal-header'>
                                            <h4 class='modal-title'>选择时间区间</h4>
                                            </div>
                                            <div class='modal-body'>
                                            <div class="DateAlert-box">
                                            <div class="DateAlert-inputWithLabel">
                                            <div class="DateAlert-inputWithLabel-label">
                                            <label>起始日期</label>
                                            </div>
                                            <div class="DateAlert-inputWithLabel-input">
                                            <input type='{{dateView.type}}'name='startDate' id='startDate' onclick='showDateDialog(0, this)' value='{{dateView.startDate}}' ng-readonly='dateView.isReadonly' />
                                            </div>
                                            </div>
                                            <div class="DateAlert-inputWithLabel">
                                            <div class="DateAlert-inputWithLabel-label">
                                            <label>终止日期</label>
                                            </div>
                                            <div class="DateAlert-inputWithLabel-input">
                                            <input type='{{dateView.type}}'name='endDate' id='endDate' onclick='showDateDialog(0, this)' value='{{dateView.endDate}}' ng-readonly='dateView.isReadonly' />
                                            </div>
                                            </div>
                                            </div>
                                            </div>
                                            <div class='modal-footer'>
                                            <button class='btn btn-default' onclick='Dialog.onQueryTimeViewClick(0)'>取消</button>
                                            <button class='btn btn-ensure' onclick='Dialog.onQueryTimeViewClick(1)'>查询</button>
                                            </div>
                                            </div>
                                            </div>
                                            </div>
                                            */}),

        // 下拉框列表
        selectAlert: function selectAlert(id, title, options, imgPath) {
            // <div id="select-m2rj5" class="dialog-select-cover">
            var dialogSelectCover = document.createElement("div");
            dialogSelectCover.setAttribute('id', id);
            dialogSelectCover.setAttribute('class', 'dialog-select-cover');
            // <div class="dialog-select">
            var dialogSelect = document.createElement("div");
            dialogSelect.setAttribute('class', 'dialog-select');
            // <div class="title">title</div>
            var titleEle = document.createElement("div");
            titleEle.setAttribute('class', 'title');
            titleEle.appendChild(document.createTextNode(title));

            dialogSelect.appendChild(titleEle);

            for (var i = 0, len = options.length; i < len; i++) {
                var option = options[i];
                // <li class="dialog-select-option">0002387218<img src="../../../images/login_tick.png"></li>
                // <li class="dialog-select-option">0002387218</li>
                var li = document.createElement("li");
                li.setAttribute('class', 'dialog-select-option');
                li.appendChild(document.createElement("label").appendChild(document.createTextNode(option.label)));
                if (option.checked) {
                    var img = document.createElement("img");
                    img.setAttribute('src', imgPath);
                    li.appendChild(img);
                }
                dialogSelect.appendChild(li);
            }

            dialogSelectCover.appendChild(dialogSelect);

            return dialogSelectCover;
        }
    };
}();

/**
 * 提示框模板
 * @param  {[type]} ) {}          [description]
 * @return {[type]}   [description]
 */
var DialogDynamicTemplate = function () {
    /**
     * 加载动态模板
     * @param  {[type]} dynamicArray   [动态模板数组]
     * @param  {[type]} sourceTemplate [源模板]
     * @return {[type]}                [新模板]
     */
    function loading(dynamicArray, sourceTemplate) {
        var isArray = (typeof dynamicArray === 'undefined' ? 'undefined' : _typeof(dynamicArray)) === 'object' && !isNaN(dynamicArray.length);
        if (!isArray) {
            return sourceTemplate;
        }

        var keyWord = '<dynamic></dynamic>';
        var dynamicTemplate = '';

        for (var i = 0, len = dynamicArray.length; i < len; i++) {
            dynamicTemplate += getTemplate(dynamicArray[i].type, i);
        }

        var newTemplate = sourceTemplate.replace(/<dynamic><\/dynamic>/g, dynamicTemplate);
        return newTemplate;
    }

    /**
     * 加载按钮前面的动态模板
     *
     * @param {String} sourceTemplate   [源模板]
     */
    function btnBeforeDynamic(sourceTemplate, obj) {
        var btnBeforeDynamicTemplate = getTemplate(obj.type);
        var newTemplate = sourceTemplate.replace(/<btnBeforeDynamic><\/btnBeforeDynamic>/g, btnBeforeDynamicTemplate);
        return newTemplate;
    }

    function getTemplate(type, index) {
        var template = '';

        switch (type) {
            case 'tipAndlink':
                template = getTipAndlink();
                template = template.replace(/templateIndex/g, index);
                break;
            case 'cageTips':
                template = getCageTips();
                break;
            case 'cageTipsAndYswt':
                template = getCageTipsAndYswtts();
                break;
            case 'default':

                break;
        }

        return template;
    }

    /**
     * 提示和链接
     *
     * 数据结构示例：
     * {
     *     'type': 'tipAndlink',
     *     'tip': '购买前请阅读以下内容：',
     *     'linkArr': [
     *         {
     *             'text': '《产品合同》',
     *             'onClick': function(row) {},
     *             ...
     *         },
     *         ...
     *     ]
     * }
     */
    function getTipAndlink() {
        return HereDoc(function () {/*
                                    <tr class='tipAndlink'>
                                    <td colspan='2'>
                                    <div>
                                    <span>{{modal.dynamic[templateIndex].tip}}</span>
                                    <div>
                                    <span ng-repeat='row in modal.dynamic[templateIndex].linkArr'>
                                    <a ng-click='row.onClick(row)'>{{row.text}}</a>
                                    </span>
                                    </div>
                                    </div>
                                    </td>
                                    </tr>
                                    */});
    }

    /**
     * 价格笼子提示
     *
     * 数据结构
     *      modal.btnBeforeDynamic.type = 'cageTips'
     */
    function getCageTips() {
        return HereDoc(function () {/*
                                    <div class='modal-btn-before-dynamic'>
                                    <div class='hr'><div></div></div>
                                    <div class='cage-tips'>
                                    <img class='tip-icon' src='../../../images/icon_gantanhao.png' />
                                    <label>友情提示</label>
                                    <br/>
                                    <label class='text'>场内买卖委托是否申报成功与委托品种的交易规则相关，若您的委托违反交易规则，可能被交易所判为废单。为保障您的合法权益，建议您提前了解交易规则，并在委托后及时查询成交情况。</label>
                                    </div>
                                    </div>
                                    */});
    }

    /**
     * 价格笼子提示和夜市委托的提示
     *
     * 数据结构
     *      modal.btnBeforeDynamic.type = 'cageTipsAndYswt'
     *      modal.btnBeforeDynamic.yswtts = '夜市委托的提示话术'
     */
    function getCageTipsAndYswtts() {
        return HereDoc(function () {/*
                                    <div class='modal-btn-before-dynamic'>
                                    <div class='hr'><div></div></div>
                                    <div class='cage-tips'>
                                    <img class='tip-icon' src='../../../images/icon_gantanhao.png' />
                                    <label>友情提示</label>
                                    <br/>
                                    <label class='text'>场内买卖委托是否申报成功与委托品种的交易规则相关，若您的委托违反交易规则，可能被交易所判为废单。为保障您的合法权益，建议您提前了解交易规则，并在委托后及时查询成交情况。</label>
                                    <br/>
                                    <br/>
                                    <label>重要提示</label>
                                    <br/>
                                    <label ng-bind='modal.btnBeforeDynamic.yswtts'></label>
                                    </div>
                                    </div>
                                    */});
    }

    return {
        loading: loading,
        btnBeforeDynamic: btnBeforeDynamic
    };
}();

var DialogBind = new function () {
    this.onScroll = function (e) {};
}();