/**
 * 适当改造 - 场内交易
 *
 * @description
 * 不适当警示的错误码    PROPER_RECONSTRUCTION_FLOOR_TRADING.SPECIFY_SERVER_ERROR_CODE
 * 不适当警示时的处理    PROPER_RECONSTRUCTION_FLOOR_TRADING.start()
 *
 */
var PROPER_RECONSTRUCTION_FLOOR_TRADING = function () {
    // 不适当警示的错误码
    var SPECIFY_SERVER_ERROR_CODE = ['410411001'];
    // 填充模板key
    // var CNSDX_TCMBZ = 'custname:fundid:productcode:productRiskLevel:custRiskLevel:custConfirmName:custConfirmDate';
    var CNSDX_TCMBZ = '{{name}}:{{account}}:{{service}}:{{risklevel}}:{{myrisklevel}}:{{name}}:{{signdate}}';

    state = {
        // 错误信息返回的字段
        errorMessage: {
            // 产品的风险等级
            'risklevel': '',
            // 用户的风险等级
            'myrisklevel': ''
        },
        // 影像 (相关的信息保存在这里面，方便传值)
        yx: {
            // 保存入参信息
            'input': {},
            // 保存出参信息
            'output': {}
        }

        /**
         * 开始流程
         */
    };function start(response) {
        console.log('STEP-1：不适当警示时开始处');
        getSdxxxcx();
    }

    /**
     * 获取适当性信息查询（融资融券新增的流程）
     */
    function getSdxxxcx() {
        ajaxPost(getApiUrl() + "rzrq/ptyw/sdxxxcx", {}, function (response) {
            var cxlb = (response.cxlb || [])[0] || {};
            state.errorMessage.myrisklevel = cxlb.khfxdj || '';
            state.errorMessage.risklevel = cxlb.cpfxdj || '';

            submitErrorAlert();
        });
    }

    /**
     * 委托提交失败后的弹出框
     */
    function submitErrorAlert() {
        var modal = {
            'title': '提示',
            'msg': [{
                'class': 'align-left',
                'value': '委托提交失败：您的风险等级与所购买的产品不匹配，请签署《不适当警示函》以继续交易。'
            }]
        };
        var options = {
            'isController': true,
            'leftButtonText': '不签署',
            'rightButtonText': '去签署',
            'rightButtonClick': function rightButtonClick() {
                Dialog.closeAlert('modalTips');
                getInappropriateWarningLetter();
            }
        };
        Dialog.alert(controller.scope, controller.compile, modal, options);
    }

    /**
     * 获取模板的参数
     */
    function getTemplateField() {
        // 用户登录信息
        var dlxx = null;
        try {
            dlxx = JSON.parse(getLocalData('ActiveRZRQUser')).body.dlxx[0];
        } catch (e) {
            showMessageTips('用户登录信息已失效，请您退出交易，重新进行交易登录！');
            return '';
        }

        // 姓名/名称
        var name = dlxx.khxm;
        // 资金账号
        var account = dlxx.zjzh;
        var service = '';
        // 产品的风险等级
        var risklevel = state.errorMessage.risklevel;
        // 我的风险等级
        var myrisklevel = state.errorMessage.myrisklevel;
        // 日 期
        var signdate = new Date().Format('yyyy年MM月dd日');

        return [name, account, service, risklevel, myrisklevel, name, signdate].join(":");
    }

    /**
     * 获取不适当警示函
     */
    function getInappropriateWarningLetter() {
        // 客户属性（'0'：个人  '1'：机构）
        var khsx = JSON.parse(getLocalData("ActiveRZRQUser"))["body"]["dlxx"][0].khsx;
        var postData = {
            // 适当性业务类型 ['0': '场内基金', '1': '开放式基金']
            'ywlx': '0',
            // 影像类别 ['1': '个人场内不适当确认书']
            'yxlb': '1',
            'khsx': khsx,
            'tcmbk': CNSDX_TCMBZ,
            'tcmbz': getTemplateField()
        };

        // 保存影像的入参，方便后面流程使用
        state.yx.input = postData;

        ajaxPost(getApiUrl() + "rzrq/yxxt/hqyx", postData, function (response) {
            var fhxx = (response.fhxx || [])[0] || {};
            var content = fhxx.xy || '';

            state.yx.output = fhxx;

            inappropriateWarningLetterAlert(content);
        });
    }

    /**
     * 不适当警示函弹出框
     *
     * 依赖的自定义指令 yt-string-html
     * 警示函内容是动态加载 HTML 的代码，AngularJS 会将 HTML 以文本的方式显示，不会进行 HTML 标签转义；
     * 下面示例将增加自定义指令，完成 HTML 标签的转义，这段代码需要放在 angular.module 下面执行。
       app.directive('ytStringHtml', function() {
           return function(scope, el, attr) {
               if (attr.ytStringHtml) {
                   scope.$watch(attr.ytStringHtml, function(html) {
                       el.html(html || '');
                   });
               }
           };
       });
     */
    function inappropriateWarningLetterAlert(content) {
        console.log('STEP-5：进行显示警示函内容的弹框');
        var isTime = false;
        var fixedTime = 10;
        var butText = '签署({{s}}s)';
        var time = fixedTime;
        var interval = null;
        var isScrollBottom = false;
        var isIntervalDone = false;
        var intervalFun = function intervalFun() {
            if (time > 0) {
                controller.scope.modal.rightButtonText = butText.replace('{{s}}', time--);
            } else {
                clearInterval(interval);
                time = fixedTime;
                controller.scope.modal.rightButtonText = '签署';

                isIntervalDone = true;
                // 强制 10S 阅读且下拉至底部时才能点击 `签署` 按钮
                if (isScrollBottom) {
                    controller.scope.modal.isRightButtonDisabled = false;
                }
            }

            controller.scope.$digest();
        };
        interval = setInterval(intervalFun, 1000);

        var modal = {
            'title': '签署警示函',
            'isHtmlContent': true,
            'htmlContent': content
        };
        var options = {
            'isController': true,
            'leftButtonText': '拒绝',
            'isRightButtonDisabled': true,
            'rightButtonText': butText.replace('{{s}}', time--),
            'footerShow': false,
            'htmlContentFooterShow': true,
            leftButtonClick: function leftButtonClick() {
                Dialog.closeAlert('modalTips');
                onAgentEvent('融资融券>适当性改造>场内交易', '签署警示函>拒绝');
                clearInterval(interval);
            },
            rightButtonClick: function rightButtonClick() {
                Dialog.closeAlert('modalTips');
                onAgentEvent('融资融券>适当性改造>场内交易', '签署警示函>签署');
                saveWarningLetter(content);
            },
            onScrollBottom: function onScrollBottom(e) {
                isScrollBottom = true;
                // 强制 10S 阅读且下拉至底部时才能点击 `签署` 按钮
                if (isIntervalDone) {
                    controller.scope.modal.isRightButtonDisabled = false;
                    controller.scope.$digest();
                }
                console.log('滚动条已滚动到底部！');
            }
        };
        Dialog.alert(controller.scope, controller.compile, modal, options);
    }

    /**
     * 保存警示函内容
     */
    function saveWarningLetter(content) {
        console.log('STEP-6：请求交易服务器，进行保存警示函内容');
        var postData = state.yx.input;
        postData.ywlsh = state.yx.output.ywlsh;
        postData.jssbs = state.errorMessage.risklevel;
        ajaxPost(getApiUrl() + 'rzrq/yxxt/cnbcyx', postData, function (response) {
            console.log('STEP-7：不适当警示处理完成！');
            var modal = {
                'title': '提示',
                'msg': [{ class: 'align-left', 'value': '尊敬的客户：' }, { class: 'align-left', 'value': '您已确认上述不适当内容并完成签署《金融产品或金融服务不适当警示及客户投资确认书》。如您坚持投资该项产品，请您重新下单委托，在操作后及时查询委托状态进行确认。' }]
            };
            var options = {
                'isController': true,
                'firstBtnHide': true,
                'rightButtonClick': function rightButtonClick() {
                    Dialog.closeAlert('modalTips');
                }
            };
            Dialog.alert(controller.scope, controller.compile, modal, options);
        }, function (response) {
            var message = response.cljg[0].message;
            Dialog.errorAlert(message, '提示');
        });
    }

    return {
        SPECIFY_SERVER_ERROR_CODE: SPECIFY_SERVER_ERROR_CODE,
        start: start,
        submitErrorAlert: submitErrorAlert
    };
}();