var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * 国密加密解决
 */
console.log('H5-debugger => sm4 => encrypt.js');
// 添加 tripledes 加密库
dynamicLoading.js(getfirsthref(0) + 'js/sm4/tripledes.js');
// 添加 Base64 加密库
dynamicLoading.js(getfirsthref(0) + 'js/sm4/enc-base64-min.js');
// 添加 SM4 加密库
dynamicLoading.js(getfirsthref(0) + 'js/sm4/KmsSM4.js');
// 添加 Base64、UTF-8 转码库
dynamicLoading.js(getfirsthref(0) + 'js/sm4/encodeUtil.js');

(function (root, factory) {
    root.SM4 = factory();
})(window, function () {
    //SM4 加密密钥
    var encryptKey = "QvAyLz5QqqCHut3vi9hZKzUPrT3Wq5Ab";
    var encryptIV = "QvAyLz5QqqCHut3vi9hZK8IAraDsbQFNpwXWXXn+rb4=";
    var encryptType = 2; //0 表示不加密，1 表示3des加密， 2 表示SM4_ECB加密，3 表示SM4_CBC加密
    var KDS_ENCRYPT_KEY = 'KDS_ENCRYPT_DATA';

    /**
     * 数据加密
     * @param data 加密数据
     * @param key 加密密钥
     * @param iv 初始化向量
     * @param type 加密类型：0 表示不加密，1 表示3des加密， 2 表示SM4_ECB加密，3 表示SM4_CBC加密
     */
    function encryptData(data, key, iv, type) {
        if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) == 'object') {
            data = JSON.stringify(data);
        }
        var result;
        switch (type) {
            case 0:
                //不加密
                return data;
                break;
            case 1:
                //3DES加密
                if (key != null && key.length > 0 && typeof CryptoJS != "undefined") {
                    //对密钥进行Base64解密
                    //Converts a Base64 string to a word array
                    key = CryptoJS.enc.Base64.parse(key);
                } else {
                    return data;
                }
                //Converts a UTF-8 string to a word array
                var iv = CryptoJS.enc.Utf8.parse("");
                //进行3DES加密
                result = CryptoJS.TripleDES.encrypt(data, key, { iv: iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7 }).toString();
                break;
            case 2:
                //SM4_ECB加密
                //对密钥进行Base64解密
                key = window.atob(key);
                result = KmsSM4.crypt_ecb(Encode.parse(data), Encode.parse(key), true);
                //将字节数组进行Base64编码
                result = Base64.fromByteArray(result);
                break;
            case 3:
                //SM4_CBC加密
                //对密钥进行Base64解密
                key = window.atob(key);
                //对初始化向量进行Base64解密
                iv = window.atob(iv);
                result = KmsSM4.crypt_cbc(Encode.parse(data), Encode.parse(key), Encode.parse(iv), true);
                //将字节数组进行Base64编码
                result = Base64.fromByteArray(result);
                break;
        }

        // console.log("[入参密文] " + result);
        return result;
    }

    /**
     * 数据解密
     * @param data 解密数据
     * @param key 加密密钥
     * @param iv 初始化向量
     * @param type 加密类型：0 表示不加密，1 表示3des加密， 2 表示SM4_ECB加密，3 表示SM4_CBC加密
     */
    function decryptData(data, key, iv, type) {
        // console.log("[出参密文] " + data);
        var result;
        switch (type) {
            case 0:
                //不解密
                return data;
                break;
            case 1:
                //3DES解密
                if (key != null && key.length > 0 && typeof CryptoJS != "undefined") {
                    //对密钥进行Base64解密
                    //Converts a Base64 string to a word array
                    key = CryptoJS.enc.Base64.parse(key);
                } else {
                    return data;
                }
                //Converts a UTF-8 string to a word array
                var iv = CryptoJS.enc.Utf8.parse("");
                //进行3DES解密
                result = CryptoJS.TripleDES.decrypt(data, key, { iv: iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7 }).toString(CryptoJS.enc.Utf8);
                break;
            case 2:
                //SM4_ECB解密
                //对密钥进行Base64解密
                key = window.atob(key);
                //对密文进行Base64解密
                data = Base64.toByteArray(data);
                result = KmsSM4.crypt_ecb(data, Encode.parse(key), false);
                var index = result.indexOf(0);
                if (index != -1) {
                    result = result.slice(0, index);
                }
                //将字节数组转成字符串
                result = Encode.stringify(result);
                break;
            case 3:
                //SM4_CBC解密
                //对密钥进行Base64解密
                key = window.atob(key);
                //对初始化向量进行Base64解密
                iv = window.atob(iv);
                //对密文进行Base64解密
                data = Base64.toByteArray(data);
                result = KmsSM4.crypt_cbc(data, Encode.parse(key), Encode.parse(iv), false);
                var index = result.indexOf(0);
                if (index != -1) {
                    result = result.slice(0, index);
                }
                //将字节数组转成字符串
                result = Encode.stringify(result);
                break;
        }
        return result;
    }

    function SM4() {}

    SM4.prototype.init = function () {
        // 保存加密信息供 React 使用
        window.localStorage.setItem(KDS_ENCRYPT_KEY, JSON.stringify({ key: encryptKey, iv: encryptIV, type: encryptType }));

        // 进入未登录首页后，遍历 localStorage，如果不能进行解密，则对它进行加密
        if (getlasthref().indexOf('header.html') > -1) {
            var keys = params.ENCRYPTED_FIELD;
            for (var i = 0, len = localStorage.length - 1; i <= len; i++) {
                var key = localStorage.key(i);
                if (keys.indexOf(key) > -1) {
                    try {
                        decryptData(localStorage.getItem(key), encryptKey, encryptIV, encryptType);
                    } catch (e) {
                        console.log('第' + (i + 1) + '条数据解密失败，键值为：' + key + '，数据为：' + localStorage.getItem(key));
                        localStorage.setItem(key, encryptData(localStorage.getItem(key), encryptKey, encryptIV, encryptType));
                    }
                } else {
                    console.log('第' + (i + 1) + '条数据不需要加密解密，键值为：' + key + '，数据为：' + localStorage.getItem(key));
                }
            }
        }
    };

    SM4.prototype.encryptData = function (data) {
        return encryptData(data, encryptKey, encryptIV, encryptType);
    };

    SM4.prototype.decryptData = function (data) {
        return decryptData(data, encryptKey, encryptIV, encryptType);
    };

    SM4.prototype.encryptDataECB = function (data, key) {
        var result = '';
        var encryptKey = key || JSON.parse(getLocalData("KDS_ENCRYPT_KEY") || '{}').sm4Key || '';

        if (encryptKey !== '') {
            result = KmsSM4.crypt_ecb(Encode.parse(data), Encode.parse(encryptKey), true);
            //将字节数组进行Base64编码
            result = Base64.fromByteArray(result);
        } else {
            result = data;
        }

        return result;
    };

    // 需求没有要求解密，代码暂不实现
    // SM4.prototype.decryptDataECB = function(data, encryptKey) {
    //     var result = '';
    //     //对密文进行Base64解密
    //     data = Base64.toByteArray(data);
    //     result = KmsSM4.crypt_ecb(data, Encode.parse(encryptKey), false);
    //     var index = result.indexOf(0);
    //     if (index != -1) {
    //         result = result.slice(0, index);
    //     }
    //     //将字节数组转成字符串
    //     result = Encode.stringify(result);
    //     return result;
    // }

    return new SM4();
});

setTimeout(function () {
    SM4.init();
}, 100);