var nowDate = new Date().Format("yyyyMMdd"); // 当天日期
var app = angular.module('sgrl', []);
app.controller('sgrlController', function ($rootScope, $scope, $http, $compile, $filter) {
    getControllerMethod($rootScope, $scope, $http, $compile);
    $scope.drksgsl = 0; // 当日申购数量
    $scope.appliedTotal = 0; // 当日已申购数量
    $scope.zqsl = 0; // 中签数量
    $scope.sgrlAlert = false; // 显示中签弹出框
    $scope.todayShow = false;
    $scope.statusShow = false;
    $scope.alertBlc = 'alert-blc';

    // 是否显示我要筹款弹框
    $scope.isShowRaiseMoneyDialog = false;

    // 额度信息
    $scope.ed = {
        ss: '0 股', // 深市的额度
        hs: '0 股', // 沪市的额度
        kcb: '0 股' // 科创板的额度
    };

    if (sgrlApi.isLogin()) {
        $scope.statusShow = true;
    };

    // 设置导航栏的显示
    appXgsgApi.setTitleType("1", "0");

    // 显示申购日历列表数据
    sgrlApi.show($scope);

    // 获取当天日期
    $scope.getDateNow = function () {
        return nowDate;
    };

    // 点击展开数据内容
    $scope.rowClick = function (row) {
        if (row.show) {
            row.show = false;
        } else {
            row.show = true;
        }
    };

    // 中签弹框，我知道按钮
    $scope.Iknow = function () {
        $scope.sgrlAlert = false;
    };

    // 点击查看中签跳转到我的申购页
    $scope.lookZQ = function () {
        setLocalData('lookZQ', 'true');
        JumpInterface(params.viewKey.KDS_PTJY_WDSG, 8, 0);
    };

    // 跳转到新股详情
    $scope.JumpXGXQ = function (row) {
        row['isSGRL'] = true;
        // 本存储行数据
        setLocalData("SGRL_ROW", row);
        JumpInterface(params.viewKey.KDS_PTJY_SGXQ, 8, 1);
    };

    $scope.wqckAlert = function () {
        $scope.isShowRaiseMoneyDialog = true;
    };

    // 跳转到一键申购
    $scope.JumpYJSG = function () {
        JumpInterface(params.viewKey.KDS_PTJY_YJSG, 8, 1);
    };

    // 转到银证转账
    $scope.JumpYZZZ = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        var userdata = {
            type: 'amrPackage',
            loginType: 'ptjy_3',
            amrId: '11110004',
            amrUrl: '/view/yzzz/yzzz.html',
            param: {}
        };
        startAppPage([1, '', JSON.stringify(userdata)]);
    };

    // 转到委托卖出
    $scope.JumpSell = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        JumpInterface(params.viewKey.KDS_Sell, 8, 1);
    };

    // 取消关闭我要筹款弹框
    $scope.Cancel = function () {
        $scope.isShowRaiseMoneyDialog = false;
    };

    // 看行情
    $scope.JupmStock = function (zqdm, jysdm) {
        jumpStockDetailInterface(zqdm, jysdm);
    };

    // 设置内容区域的高度
    $scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var sgrltopHeight = document.getElementById("sgrl-top").clientHeight;
        $scope.topHeightStyle = "height:" + (totalHeight - sgrltopHeight) + "px";
    });
});

/**
 * 申购日历 API
 */
var sgrlApi = function (xgsgApi) {
    /**
     * 显示申购日历列表
     */
    function show($scope) {
        xgsgApi.showSgrl($scope, componentWillMountSGRL);
    }

    /**
     * 是否登录
     * @return true: 已登录 false: 未登录
     */
    function isLogin() {
        if (params.ywlx == "ptjy" && getLocalData("ActivePTJYUser")) {
            return true;
        } else if (params.ywlx == "rzrq" && getLocalData("ActiveRZRQUser")) {
            return true;
        }
        return false;
    }

    /**
     * 申购日历渲染前的执行方法
     */
    function componentWillMountSGRL($scope, method) {
        // 数据归类 - 按年月
        dataClassification($scope);

        $scope["sgrlData"] = $scope.queryData;

        // 隐藏所有行二级信息
        allRowShow($scope, false);

        // 显示中签弹出框
        showZQModal($scope);

        // 显示用户额度信息
        showEdInfo($scope);
    }

    /*
     * 数据归类 - 按年月
     */
    function dataClassification($scope) {
        var len = $scope.queryData.length;
        var monthData = [];
        var monthTemp = {};
        var monthDataList = [];
        var futureData = [];
        var historyData = [];

        for (var i = 0; i < len; i++) {
            var data = $scope.queryData[i];
            // 给长数换算添加中文单位
            data["zdsgs"] = addChineseUnit(data["sgsx"]); // 申购上限
            data["fxzlF"] = addChineseUnit(data["fxzl"]); // 总发行量
            data["sgzdslF"] = addChineseUnit(data["sgzdsl"]); // 申购上限
            data["sgzdslxgF"] = addChineseUnit(data["sgzdslxg"]); // 申购最大数量新股
            data["sgzxslF"] = addChineseUnit(data["sgzxsl"]); // 最小申购
            data["zqslF"] = addChineseUnit(data["zqsl"]); // 中签股数
            data["zqjeF"] = addChineseUnit(data["zqje"]); // 应缴款
            data["jkjeF"] = addChineseUnit(data["jkje"]); // 已缴款
            data["isKCB"] = xgsgApi.checkKCB(data["stktype"]);
            var fxrq = data['fxrq'];
            if (fxrq > nowDate) {
                futureData.push(data);
            } else {
                historyData.push(data);
            }
        }

        // 获取待申购列表中最后 2 条数据
        var spliceData = futureData.splice(futureData.length - 2, 2);
        var ResultSet = historyData.concat(spliceData);

        // 如当日新股有数据存在刚只留二条数据
        if ($scope.drksgslTotal) {
            datasource = ResultSet;
        } else {
            datasource = $scope.queryData;
        }

        // 按月归类
        for (var i = 0; i < datasource.length; i++) {
            var row = datasource[i];
            if (row.fxrq == nowDate && row.xgzt == '6') {
                $scope.appliedTotal++;
            }

            var fxrq = row.fxrq.substr(0, 6);
            if (monthData.indexOf(fxrq) == -1) {
                monthData.push(fxrq);
                monthTemp[fxrq] = [];
                monthTemp[fxrq].push(row);
            } else {
                monthTemp[fxrq].push(row);
            }
        }

        // 计算今日可申购新股数量
        $scope.drksgsl = $scope.drksgslTotal - $scope.appliedTotal;
        // 容错处理，防止今日可申购数量为负数
        $scope.drksgsl = $scope.drksgsl < 0 ? 0 : $scope.drksgsl;

        // 先正序排序数组
        monthData.sort();
        // 反转数组项的顺序
        monthData.reverse();

        // 按月归类，将 2 个对象组合成一个
        len = monthData.length;
        for (var i = 0; i < len; i++) {
            monthDataList.push({
                "month": monthData[i].substr(4, 2),
                "data": monthTemp[monthData[i]]
            });
        }

        $scope.queryData = monthDataList;
    }

    /**
     * 所有行的显示
     */
    function allRowShow($scope, state) {
        var len = $scope.sgrlData.length;
        for (var i = 0; i < len; i++) {
            var months = $scope.sgrlData[i].data;
            var monthsLength = months.length;
            for (var j = 0; j < monthsLength; j++) {
                var row = months[j];
                row["show"] = state;
            }
        }
    }

    /**
     * 显示中签弹出框
     */
    function showZQModal($scope) {
        var nowDate = new Date().Format('yyyyMMdd');
        // 中签弹出框一天仅显示一次
        if (getLocalData('showZQModalDate') == null || getLocalData('showZQModalDate') < nowDate) {
            if ($scope.zqsl > 0) {
                $scope.sgrlAlert = true;
                setLocalData('showZQModalDate', nowDate);
            }
        }
    }

    /**
     * 显示额度信息
     */
    function showEdInfo($scope) {
        // 深市的额度
        $scope.ed.ss = ($scope['edcxobj']['0'] != null ? $scope['edcxobj']['0'].ksged : '0') + " 股";
        // 没有对应市场股东账户需要显示 “未开通权限”
        $scope.ed.ss = xgsgApi.isExistGDDM('0') ? $scope.ed.ss : "未开通权限";
        // 沪市的额度
        $scope.ed.hs = ($scope['edcxobj']['1'] != null ? $scope['edcxobj']['1'].ksgedsh : '0') + " 股";
        // 没有对应市场股东账户需要显示 “未开通权限”
        $scope.ed.hs = xgsgApi.isExistGDDM('1') ? $scope.ed.hs : "未开通权限";
        // 科创板额度
        $scope.ed.kcb = ($scope['edcxobj']['kcbksged'] || '0') + ' 股';

        console.log($scope.ed);
    }

    return {
        show: show,
        isLogin: isLogin
    };
}(xgsgApi);