var nowDate = new Date().Format("yyyyMMdd"); // 当天日期
var app = angular.module('sgxq', []);
app.controller('sgxqController', function ($rootScope, $scope, $http, $compile) {
    // 是否显示我要筹款弹框
    $scope.isShowRaiseMoneyDialog = false;
    // 是否显示我要筹款按钮
    $scope.isWYCKBtn = false;
    // 是否显示一键申购按钮
    $scope.isYJSGBtn = true;
    // 显示公司简介 (默认不默示)
    $scope.showGSJJ = false;
    // 显示申购详情 (默认不默示)
    $scope.showSGXQ = false;
    // 显示中签详情 (默认不默示)
    $scope.showZQXQ = false;

    // 设置导航栏的显示
    appXgsgApi.setTitleType("0", "0");

    // 初始化数据
    sgxqApi.initData($scope);

    // 跳转到一键申购
    $scope.JumpYJSG = function () {
        JumpInterface(params.viewKey.KDS_PTJY_YJSG, 8, 1);
    };

    // 转到银证转账
    $scope.JumpYZZZ = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        var userdata = {
            type: 'amrPackage',
            loginType: 'ptjy_3',
            amrId: '11110004',
            amrUrl: '/view/yzzz/yzzz.html',
            param: {}
        };
        startAppPage([1, '', JSON.stringify(userdata)]);
    };

    // 转到委托卖出
    $scope.JumpSell = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        JumpInterface(params.viewKey.KDS_Sell, 8, 1);
    };

    // 点击弹框
    $scope.wqckAlert = function () {
        $scope.isShowRaiseMoneyDialog = true;
    };

    // 取消关闭我要筹款弹框
    $scope.Cancel = function () {
        $scope.isShowRaiseMoneyDialog = false;
    };
});

var sgxqApi = function () {
    /**
     * 初始化数据
     */
    function initData($scope) {
        var SGRL_ROW = JSON.parse(getLocalData("SGRL_ROW") || "{}");
        var id = SGRL_ROW.id || "";

        $('title').text(SGRL_ROW.gpmc || SGRL_ROW.zqmc || "--");

        // 申购日历，当日新股已申购，不一定当即生效，所以详情状态还是设置为申购中
        if (SGRL_ROW.fxrq == nowDate && SGRL_ROW.xgzt == "6" && SGRL_ROW.isSGRL) {
            $scope.isYJSGBtn = false;
            SGRL_ROW.xgzt = 2;
        }
        // removeLocalData("SGRL_ROW");

        if (id != '' && id != "待定") {
            NavStatus($scope, SGRL_ROW);

            var ipoURL = getApiUrlNews() + "xgsg?id=" + id;
            ajaxPost(ipoURL, {}, function (response) {
                $('title').text(response.gpmc || "--");
                $scope.gsjj = response.gsjj;
                $scope.sgrq = formatDate(response.sgrq, "待定");
                $scope.zqrq = formatDate(SGRL_ROW.zqrq || response.zqrq, "待定");
                $scope.ssrq = formatDate(response.ssrq, "待定");

                $scope.jysdmsm = response.jysdm == 0 ? "深圳证券交易市场" : "上海证券交易市场";
                $scope.sgdm = response.sgdm;
                $scope.gpmc = response.gpmc;
                $scope.gpdm = response.gpdm;
                $scope.fxlx = response.fxlx ? response.fxlx : "待定";
                $scope.sgrqs = formatDate(response.sgrq, "待定", true);
                $scope.sgjg = SGRL_ROW.fxjg ? SGRL_ROW.fxjg + "元/股" : "待定";
                $scope.sgdw = SGRL_ROW.sgdw ? SGRL_ROW.sgdw + "股" : "待定";
                $scope.sgxx = SGRL_ROW.sgzxsl ? SGRL_ROW.sgzxsl + "股" : "待定";
                if (SGRL_ROW.sgzdsl == null) {
                    $scope.sgsx = response.sgsx ? response.sgsx + "股" : "待定";
                } else {
                    $scope.sgsx = SGRL_ROW.sgzdsl ? SGRL_ROW.sgzdsl + "股" : "待定";
                }

                // 资讯返回的值带有 %，所以不再格式化后 %
                $scope.wszql = response.wszql || "待定";
                $scope.syl = response.syl ? response.syl + "倍" : "待定";
                $scope.fxzl = response.fxzl ? response.fxzl + "股" : "待定";
                $scope.fxjg = response.fxjg ? response.fxjg + "元/股" : "待定";
                $scope.sgzjsx = response.sgzjsx ? response.sgzjsx + "股" : "待定";
            }, null, {
                issuccess: false,
                // 不需要使用固定入参
                isFixedParam: false
            });
        } else {
            NavStatus($scope, SGRL_ROW);

            $scope.gsjj = SGRL_ROW.gsjj;
            $scope.sgrq = formatDate(SGRL_ROW.fxrq, "待定");
            $scope.zqrq = formatDate(SGRL_ROW.zqrq, "待定");
            $scope.ssrq = formatDate(SGRL_ROW.ssrq, "待定");

            $scope.jysdmsm = SGRL_ROW.jysdm == 0 ? "深圳证券交易市场" : "上海证券交易市场";
            $scope.sgdm = SGRL_ROW.sgdm || SGRL_ROW.zqdm;
            $scope.gpmc = SGRL_ROW.gpmc || SGRL_ROW.zqmc;
            $scope.gpdm = SGRL_ROW.sgdm;
            $scope.fxlx = SGRL_ROW.fxlx ? SGRL_ROW.fxlx : "待定";
            $scope.sgrqs = formatDate(SGRL_ROW.fxrq, "待定", true);
            $scope.sgjg = SGRL_ROW.fxjg ? SGRL_ROW.fxjg + "元/股" : "待定";
            $scope.sgdw = SGRL_ROW.sgdw ? SGRL_ROW.sgdw + "股" : "待定";

            if (!$scope.wszql) {
                $scope.wszql = "0%";
            }

            $scope.syl = SGRL_ROW.syl ? SGRL_ROW.syl : "待定";
            $scope.fxzl = SGRL_ROW.fxzl ? SGRL_ROW.fxzl + "股" : "待定";
            $scope.fxjg = SGRL_ROW.fxjg ? SGRL_ROW.fxjg + "元/股" : "待定";
            $scope.sgxx = SGRL_ROW.sgzxsl ? SGRL_ROW.sgzxsl + "股" : "待定";
            if (SGRL_ROW.dgsgsz == null) {
                $scope.sgsx = SGRL_ROW.sgsx ? SGRL_ROW.sgsx + "股" : "待定";
            } else {
                $scope.sgsx = SGRL_ROW.dgsgsz ? SGRL_ROW.dgsgsz + "股" : "待定";
            }
        }
    }

    /**
     * 状态位置
     */
    function NavStatus($scope, row) {
        var xgzt = row.xgzt;
        // 当天日期
        var nowDate = new Date().Format("yyyyMMdd");

        if (xgzt == "1") {
            $("#dsg").addClass("active currenting");
            $("#dsg em").show().text("待申购");
            $scope.xgzt = "1";
            $scope.showGSJJ = true;
        } else if (xgzt == "2") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active current");
            $("#sgz em").show().text("申购中");
            $scope.xgzt = "2";
            $scope.showSGXQ = true;
        } else if (xgzt == "4") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active currenting");
            $("#sgz em").show().text("申购结束");
            $scope.xgzt = "4";
            $scope.showGSJJ = true;
        } else if (xgzt == "6") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active currenting");
            $("#sgz em").show().text("已申购");
            if (row.fxrq == nowDate) {
                $("#sgz").removeClass("active currenting");
                $("#sgz").addClass("active current");
            }
            $scope.xgzt = "6";
            $scope.showGSJJ = true;
        } else if (xgzt == "7") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").addClass("active current");
            $("#zqr em").show().text("今日中签");
            $scope.xgzt = "7";
            $scope.isWYCKBtn = true;
            $scope.showZQXQ = true;
        } else if (xgzt == "8") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").addClass("active current");
            $("#zqr em").show().text("未中签");
            $scope.xgzt = "8";
            $scope.showZQXQ = true;
        } else if (xgzt == "16") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").removeClass("active current");
            $("#zqr").addClass("active currenting");
            $("#zqr em").show().text("已中签");
            $scope.xgzt = "16";
            $scope.showGSJJ = true;
        } else if (xgzt == "3") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").addClass("active");
            $("#zqr em").hide().text("");
            if (row.ssrq == nowDate) {
                $("#ssr").addClass("active");
                $("#ssr em").show().text("今日上市");
                $scope.xgzt = "3";
            }
        } else if (xgzt == "14") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").removeClass("active current");
            $("#zqr").addClass("active currenting");
            $("#zqr em").show().text("待上市");
            $scope.xgzt = "14";
            $scope.showGSJJ = true;
        } else if (xgzt == "15") {
            $("#dsg").addClass("active");
            $("#dsg em").hide().text("");
            $("#sgz").addClass("active");
            $("#sgz em").hide().text("");
            $("#zqr").addClass("active current");
            $("#zqr em").show().text("未申购");
            $scope.xgzt = "15";
            $scope.showGSJJ = true;
        }
    }

    /**
     * 格式化日期
     * @param date          日期
     * @param defaultValue  默认显示值
     * @param isYear        显示年
     * @return 2016年10月10 或 10月10号
     */
    function formatDate(date, defaultValue, isYear) {
        if (date == undefined || date == "" || date == "待定" || date.length < 8) {
            return defaultValue;
        }

        if (isYear) {
            return date.substr(0, 4) + "年" + date.substr(4, 2) + "月" + date.substr(6, 2) + "日";
        } else {
            return date.substr(4, 2) + "月" + date.substr(6, 2) + "日";
        }
    }

    return {
        initData: initData
    };
}();