var app = angular.module('wdsg', []);
app.controller('wdsgController', function ($rootScope, $scope, $http, $compile) {
    // 是否显示我要筹款弹框
    $scope.isShowRaiseMoneyDialog = false;
    // 今日中签总数，默认为零
    $scope.drzqsl = 0;
    $scope.jkjeCountW = 0;
    // 全部/中签切换
    $scope.IsActive = false;
    $scope.isAll = true;
    $scope.isZQ = false;
    //代码正确时页面默认为显示
    $scope.wdsgBlc = "wdsg-blc";
    // 设置导航栏的显示
    appXgsgApi.setTitleType("2", "1");

    // 显示我的申数据
    wdslApi.show($scope);

    // 提供原生回调刷新页面数据
    window.handlePageBack = function () {
        // 设置导航栏的显示
        appXgsgApi.setTitleType("2", "1");
        wdslApi.show($scope);
    };

    // 跳转到新股详情
    $scope.JumpXGXQ = function (row) {
        // 本存储行数据
        setLocalData("SGRL_ROW", row);
        JumpInterface(params.viewKey.KDS_PTJY_SGXQ, 8, 1);
    };

    // 点击弹出筹款方法框
    $scope.raiseFunds = function () {
        $scope.isShowRaiseMoneyDialog = true;
    };

    // 转到银证转账
    $scope.JumpYZZZ = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        var userdata = {
            type: 'amrPackage',
            loginType: 'ptjy_3',
            amrId: '11110004',
            amrUrl: '/view/yzzz/yzzz.html',
            param: {}
        };
        startAppPage([1, '', JSON.stringify(userdata)]);
    };

    // 转到委托卖出
    $scope.JumpSell = function (id) {
        $scope.isShowRaiseMoneyDialog = false;
        appXgsgApi.setTitleType("0", "0");
        JumpInterface(params.viewKey.KDS_Sell, 8, 1);
    };

    // 取消关闭我要筹款弹框
    $scope.Cancel = function () {
        $scope.isShowRaiseMoneyDialog = false;
    };

    // 看行情
    $scope.JupmStock = function (zqdm, jysdm) {
        jumpStockDetailInterface(zqdm, jysdm);
    };

    // 点击展开数据内容
    $scope.rowClick = function (row) {
        if (row.show) {
            row.show = false;
        } else {
            row.show = true;
        }
    };

    // 获取当天日期
    $scope.getDateNow = function () {
        var now = new Date().Format("yyyyMMdd");
        return now;
    };

    // 设置内容区域的高度
    $scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var sgrltopHeight = document.getElementById("wdsg-top").clientHeight;
        $scope.topHeightStyle = "height:" + (totalHeight - sgrltopHeight) + "px";
    });

    // 点击全部
    $scope.allFun = function () {
        $scope.IsActive = false;
        $scope.isAll = true;
        $scope.isZQ = false;
        // 显示我的申数据
        wdslApi.dataClassification($scope);
        // 调用Sortable插件
        wdslApi.initSortableTimeout($scope);
    };

    // 点击中签
    $scope.zqFun = function () {
        $scope.IsActive = true;
        $scope.isAll = false;
        $scope.isZQ = true;
        // 显示我的申数据
        wdslApi.dataClassification($scope);
        // 调用Sortable插件
        wdslApi.initSortableTimeout($scope);
    };

    if (getLocalData('lookZQ')) {
        setTimeout(function () {
            $scope.IsActive = true;
            $scope.isAll = false;
            $scope.isZQ = true;
            // 显示我的申数据
            wdslApi.show($scope);
            removeLocalData('lookZQ');
        }, 200);
    }
});

var wdslApi = function (xgsgApi, browser) {
    /**
     * 显示申购日历列表
     */
    function show($scope) {
        xgsgApi.showWdsg($scope, componentWillMountSGRL);
    }

    /**
     * 申购日历渲染前的执行方法
     */
    function componentWillMountSGRL($scope, method) {
        $scope["wdsgData"] = $scope.queryData;
        // 刷新页面时，重置当日中签数量，以免重复累加
        $scope.drzqsl = 0;
        // 显示今日中签的新股数
        showZqsl($scope);

        // 翻译新股状态
        xgsgApi.translateXGZT($scope["zqcxData"]);

        // 添加行数据的自定义属性
        addRowAttr($scope);

        // 数据归类 - 按月
        dataClassification($scope);

        // 隐藏所有行二级信息
        allRowShow($scope, false);

        if ($scope.drzqsl > 0) {
            // 显示分享按钮
            setIsShowShareBtn(1);
        }

        // 调用Sortable插件
        initSortableTimeout($scope);
    }

    /**
     * 将初始化拖动排序插件方法延时加载
     */
    function initSortableTimeout($scope) {
        // 初始化拖动排序插件
        if ($scope.drzqsl > 1) {
            setTimeout(function () {
                initSortable();
            }, 500);
        }
    }

    /**
     * 所有行的显示
     */
    function allRowShow($scope, state) {
        var len = $scope.wdsgData.length;
        for (var i = 0; i < len; i++) {
            var months = $scope.wdsgData[i].data;
            var monthsLength = months.length;
            for (var j = 0; j < monthsLength; j++) {
                var row = months[j];
                row["show"] = state;
            }
        }
    }

    /**
     * 显示今日中签的新股数
     */
    function showZqsl($scope) {
        var len = $scope.zqcxData.length;
        var date = new Date().Format("yyyyMMdd");
        var jkje = 0;
        for (var i = 0; i < len; i++) {
            var row = $scope.zqcxData[i];
            if (row.xgzt == '7') {
                $scope.drzqsl++;
                jkje += new Number(row.zqje);
            }
        }
        $scope.jkjeCount = jkje;
        $scope.jkjeCountW = (new Number(jkje) / 10000).toFixed(2);
    }

    // 添加行数据的自定义属性
    function addRowAttr($scope) {
        var len = $scope.zqcxData.length;
        for (var i = 0; i < len; i++) {
            var row = $scope.zqcxData[i];
            // 给长数换算添加中文单位
            row["zqslF"] = addChineseUnit(row["zqsl"]); // 中签股数
            row["wtslF"] = addChineseUnit(row["wtsl"]); // 申购数量
            row["sgsxF"] = addChineseUnit(row["sgsx"]); // 申购上限
            row["fxzlF"] = addChineseUnit(row["fxzl"]); // 总发行量
            if (!isNaN(row.jg && row.jg)) {
                row["zqjesmF"] = addChineseUnit(row.zqsl * row.jg);
            }
            if (!isNaN(row.jkje)) {
                row["jkjeF"] = addChineseUnit(row.jkje);
            }
        }
        if (!isNaN($scope.zjkys)) {
            $scope["zjkyssm"] = (new Number($scope.zjkys) / 10000).toFixed(2);
        }

        if ($scope.jkjeCount <= $scope.zjkys) {
            $scope.isZHYEOK = true;
            $scope.isZHYENO = false;
        } else {
            $scope.isZHYEOK = false;
            $scope.isZHYENO = true;
        }
    }

    /**
     * 【原生】设置是否显示分享按钮
     * @param {[type]} status [状态][0: 不显示, 1: 显示]
     */
    function setIsShowShareBtn(status) {
        if (browser == 'android') {
            KDS_Native.setIsShowShareBtn(status);
        } else if (browser == 'ios') {
            loadURL("KDS_Native://setIsShowShareBtn:" + status);
        }
    }

    /*
     * 数据归类 - 按月
     */
    function dataClassification($scope, method) {
        // 今日日期
        var nowDate = new Date().Format("yyyyMMdd");
        // 今日中签数组
        var nowZqArray = [];
        // 中签查询数组
        var zqcxArray = [];
        // 月份列表
        var monthData = [];
        // 按月份归类的对象
        var monthTemp = {};
        // 组合后的数组（页面显示）
        var monthDataList = [];
        // 当前月份
        var nowMonth = nowDate.substr(0, 6);

        // 先进行数组降序排序，
        xgsgApi.sort($scope.zqcxData, "fxrq", "desc");

        // 将今日中签的数据与其它数据分别提取出来
        var len = $scope.zqcxData.length;
        for (var i = 0; i < len; i++) {
            // 当日中签
            if ($scope.zqcxData[i].xgzt == '7') {
                nowZqArray.push($scope.zqcxData[i]);
            } else {
                zqcxArray.push($scope.zqcxData[i]);
            }
        }

        // 数据按月份保存
        var len = zqcxArray.length;
        for (var i = 0; i < len; i++) {
            var row = zqcxArray[i];

            // 选择 “中签” 时，只显示从中签列表返回的数据
            if ($scope.IsActive && !row.zqSources) {
                continue;
            }

            // 设置拖动排序条件
            $scope.jssx = row.jssx;

            if (row.jysdm == "0") {
                row["sgdw"] = 500;
            } else if (row.jysdm == "1") {
                row["sgdw"] = 1000;
            }

            var fxrq = row.fxrq.substr(0, 6);
            if (monthData.indexOf(fxrq) == -1) {
                monthData.push(fxrq);
                monthTemp[fxrq] = [];
                monthTemp[fxrq].push(row);
            } else {
                monthTemp[fxrq].push(row);
            }
        }

        // 当前月份不存时，需要创建当前月份
        if (monthData.indexOf(nowMonth) == -1 && nowZqArray.length > 0) {
            monthDataList.push({
                "month": nowMonth.substr(4, 2),
                "data": [],
                "isNowMonth": true
            });
        }

        // 按月归类，将 2 个对象组合成一个
        len = monthData.length;
        for (var i = 0; i < len; i++) {
            monthDataList.push({
                "month": monthData[i].substr(4, 2),
                "data": monthTemp[monthData[i]],
                "isNowMonth": nowMonth == monthData[i] ? true : false
            });
        }

        $scope["nowZqArray"] = nowZqArray;
        $scope["wdsgData"] = monthDataList;
    }

    /**
     * 初始化拖动排序插件
     */
    function initSortable() {
        Sortable.create(document.getElementById('handle-1'), {
            handle: '.drag-handle',
            animation: 150,
            // 排序时才触发该事件
            onSort: function onSort(evt) {
                onSortEndEvent(evt);
            }
        });
    }

    /**
     * 排序发生后的事件处理方法
     */
    function onSortEndEvent(evt) {
        var jysdms = '';
        var gddms = '';
        var zqdms = '';
        var jssxs = '';
        var zqrqs = '';
        var len = evt.from.children.length;
        for (var i = 0; i < len; i++) {
            jysdms += '|' + evt.from.children[i].getAttribute('drag-jysdm');
            gddms += '|' + evt.from.children[i].getAttribute('drag-gddm');
            zqdms += '|' + evt.from.children[i].getAttribute('drag-zqdm');
            jssxs += '|' + Number(evt.from.children[i].getAttribute("drag-jssx"));
            zqrqs += '|' + evt.from.children[i].getAttribute('drag-zqrq');
        }

        // 将字符串第一位 "|" 删除
        jysdms = jysdms.substr(1);
        gddms = gddms.substr(1);
        zqdms = zqdms.substr(1);
        jssxs = jssxs.substr(1);
        zqrqs = zqrqs.substr(1);
        // 字符串转化为数组类型
        var jssx = jssxs.replace(/\|/g, ',');
        jssx = jssx.split(',');
        // 正序排列
        jssx.sort();
        jssxs = jssx.join("|");

        // 缴款优先级设置
        var request = {
            "jysdm": jysdms,
            "gddm": gddms,
            "zqdm": zqdms,
            "jssx": jssxs,
            "zqrq": zqrqs
        };

        var lastUrl = "ptjy/xgsg/plpszqjkyxjsz";
        if (params.ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/plpszqjkyxjsz";
        }

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            Dialog.successAlert("缴款优先级设置成功！", "提示信息");
            // 点击确认后，刷新列表数据
            Dialog.confirm = function () {
                window.handlePageBack();
                Dialog.closeAlert();
            };
        });
    }

    return {
        show: show,
        dataClassification: dataClassification,
        initSortableTimeout: initSortableTimeout
    };
}(xgsgApi, params.browser);