/**
 * 新股申购接口
 */
var xgsgApi = function () {
    // 当天日期
    var nowDate = new Date().Format("yyyyMMdd");

    // 是否查询 IPO 文件
    var isQueryIPO = false;
    // 是否当日新股列表查询
    var isQueryDRXGLBCX = false;
    // 是否资金查询
    var isQueryZJCX = false;
    // 是否额度查询
    var isQueryEDCX = false;
    // 是否中签查询
    var isQueryZQCX = false;
    // 是否当日中签查询
    var isQueryDRZQCX = false;
    // 是否当日委托查询
    var isqueryDRWTCX = false;
    // 是否配号查询
    var isQueryPHCX = false;
    // 渲染前回调方法
    var componentWillMount = null;

    // 是否使用中签列表数据
    var isUsedListDataZQCX = false;
    // 是申购日历功能
    var isSGRL = false;

    // 请求状态
    var REQUEST_STATE = {
        "BEGIN": 0, // 准备开始
        "START": 1, // 开始请求
        "END": 2 // 请求结束


        /**
         * 列出所有需要查询的功能，并将它的请求状态设置为 “准备开始”
         */
    };var queryState = {
        "queryIPO": REQUEST_STATE.BEGIN,
        "queryDRXGLBCX": REQUEST_STATE.BEGIN,
        "queryZJCX": REQUEST_STATE.BEGIN,
        "queryEDCX": REQUEST_STATE.BEGIN,
        "queryZQCX": REQUEST_STATE.BEGIN,
        "queryDRZQCX": REQUEST_STATE.BEGIN,
        "queryDRWTCX": REQUEST_STATE.BEGIN,
        "queryPHCX": REQUEST_STATE.BEGIN

        /**
         * 查询方法的统一入口
         */
    };function query($scope) {
        if (isQueryIPO) {
            queryState.queryIPO = REQUEST_STATE.START;
            // 查询 IPO 文件
            queryIPO($scope, query);
        }
        if (isQueryDRXGLBCX) {
            queryState.queryDRXGLBCX = REQUEST_STATE.START;
            // 当日新股列表查询
            queryDRXGLBCX($scope, query);
        }
        if (isQueryZJCX) {
            queryState.queryZJCX = REQUEST_STATE.START;
            // 资金查询
            queryZJCX($scope, query);
        }
        if (isQueryEDCX) {
            queryState.queryEDCX = REQUEST_STATE.START;
            // 额度查询
            queryEDCX($scope, query);
        }
        if (isQueryZQCX) {
            queryState.queryZQCX = REQUEST_STATE.START;
            // 中签查询
            queryZQCX($scope, query);
        }
        if (isQueryDRZQCX) {
            queryState.queryDRZQCX = REQUEST_STATE.START;
            // 当日中签查询
            queryDRZQCX($scope, query);
        }
        if (isqueryDRWTCX) {
            queryState.queryDRWTCX = REQUEST_STATE.START;
            // 当日委托查询
            queryDRWTCX($scope, query);
            isqueryDRWTCX = false;
        }
        if (isQueryPHCX) {
            queryState.queryPHCX = REQUEST_STATE.START;
            // 配号查询
            queryPHCX($scope, query);
            isQueryPHCX = false;
        }
    }

    /**
     * 查询方法之后执行的方法
     */
    function queryAfter($scope) {
        for (var state in queryState) {
            // 如果还有未完成的请求，则跳出该方法
            if (queryState[state] == REQUEST_STATE.START) {
                return false;
            }
        }

        // 数据组合 - 并行查询，然后再数据组合
        CombinedData($scope);
    }

    /**
     * 数据组合 - 并行查询，然后再数据组合
     */
    function CombinedData($scope) {
        // 解析 IPO 数据
        if (queryState.queryIPO == REQUEST_STATE.END) {
            queryState.queryIPO = REQUEST_STATE.BEGIN;
            if (isSGRL) {
                parseIPO_SGRL($scope, $scope.ipoSourceData);
            } else {
                parseIPO($scope, $scope.ipoSourceData);
            }
        }
        // 解析当日新股查询
        if (queryState.queryDRXGLBCX == REQUEST_STATE.END) {
            queryState.queryDRXGLBCX = REQUEST_STATE.BEGIN;
            parseDRXG($scope, $scope.drxglbcxSourceData);
        }
        // 解析资金查询
        if (queryState.queryZJCX == REQUEST_STATE.END) {
            queryState.queryZJCX = REQUEST_STATE.BEGIN;
            parseZJCX($scope, $scope.zjcxSourceData);
        }
        // 解析额度查询
        if (queryState.queryEDCX == REQUEST_STATE.END) {
            queryState.queryEDCX = REQUEST_STATE.BEGIN;
            parseEDCX($scope, $scope.edcxSourceData);
        }
        // 解析中签查询
        if (queryState.queryZQCX == REQUEST_STATE.END) {
            queryState.queryZQCX = REQUEST_STATE.BEGIN;
            parseZQCX($scope, $scope.zqcxSourceData);
        }
        // 解析当日委托查询
        if (queryState.queryDRWTCX == REQUEST_STATE.END) {
            queryState.queryDRWTCX = REQUEST_STATE.BEGIN;
            parseDRWTCX($scope, $scope.drwtcxSourceData);
        }
        // 解析配号查询
        if (queryState.queryPHCX == REQUEST_STATE.END) {
            queryState.queryPHCX = REQUEST_STATE.BEGIN;
            parsePHCX($scope, $scope.phcxSourceData);
        }

        CombinedDataAfter($scope);
    }

    /**
     * 数据组合之后执行的方法
     */
    function CombinedDataAfter($scope) {
        // 渲染前执行 【放在最后执行】
        if (componentWillMount) {
            componentWillMount($scope);
        }
    }

    /**
     * 资讯数据 IPO 查询接口
     */
    function queryIPO($scope, method) {
        isQueryIPO = false;

        if (!getApiUrlNews()) {
            return;
        }

        // 新版的资讯服务器地址需要将 news 改成 news20
        var ipoURL = getApiUrlNews().replace("news", "news20");
        // 组装完整的资讯服务器地址
        // $scope.req_sinceId   从第几条数据开始查询 (默认为 0，从第一条开始)
        // $scope.req_count     每次查询多少条数据 (默认为 300)
        ipoURL = ipoURL + "list?req_funType=X0&req_sinceId=" + ($scope.req_sinceId || 0) + "&req_count=" + ($scope.req_count || 300);

        // 新股数据表现查询 - 来源：有资讯服务器
        ajaxPost(ipoURL, {}, function (response) {
            $scope.ipoSourceData = response;
            queryState.queryIPO = REQUEST_STATE.END;
            queryAfter($scope);
        }, null, {
            // 资讯服务器的请求不需要验证交易服务器是否成功返回
            issuccess: false,
            // 不需要使用固定入参
            isFixedParam: false,
            // 请求资讯服务器失败后的处理
            error: function error(request, status, _error) {
                console.log("请求资讯服务器的新股列表数据失败，执行下一个请求！");
                queryState.queryIPO = REQUEST_STATE.END;
                $scope.queryData = [];
                $scope.ipoSourceData = { "news": [] };
                queryAfter($scope);
            }
        });
    }

    /**
     * 当日新股列表查询接口
     */
    function queryDRXGLBCX($scope, method) {
        isQueryDRXGLBCX = false;

        var postData = {};

        var lastUrl = "ptjy/xgsg/drxglbcxSimple";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/drxglbcxSimple";
            postData.gdlb = JSON.stringify(COMMON.getRzrqGdlb());
        } else {
            postData.gdlb = JSON.stringify(COMMON.getPtjyGdlb());
        }

        ajaxPost(getApiUrl() + lastUrl, postData, function (response) {
            $scope.drxglbcxSourceData = response;
            queryState.queryDRXGLBCX = REQUEST_STATE.END;
            queryAfter($scope);
        }, null, {
            // ajax 请求期间禁止用点击事件
            isloaddingrunNoEvent: true
        });
    }

    /**
     * 资金查询接口
     */
    function queryZJCX($scope, method) {
        isQueryZJCX = false;

        var lastUrl = "ptjy/xgsg/zjcx";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/zjcx";
        }

        ajaxPost(getApiUrl() + lastUrl, { hbdm: "" }, function (response) {
            $scope.zjcxSourceData = response;
            queryState.queryZJCX = REQUEST_STATE.END;
            queryAfter($scope);
        });
    }

    /**
     * 额度查询接口
     */
    function queryEDCX($scope, method) {
        isQueryEDCX = false;

        var lastUrl = "ptjy/xgsg/xgedcx";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/xgedcx";
        }

        var request = {
            gddm: "",
            zqdm: "",
            jysdm: "0" // 0 是查全部
        };

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            $scope.edcxSourceData = response;
            queryState.queryEDCX = REQUEST_STATE.END;
            queryAfter($scope);
        });
    }

    /**
     * 中签查询接口
     */
    function queryZQCX($scope, method) {
        isQueryZQCX = false;

        var qsrq = new Date().addMonths(-1).Format("yyyyMMdd"); // 起始日期前推一个月
        var requset = {
            "qsrq": qsrq,
            "zzrq": nowDate
        };

        var lastUrl = "ptjy/xgsg/zqcx";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/zqcx";
        }

        ajaxPost(getApiUrl() + lastUrl, requset, function (response) {
            $scope.zqcxSourceData = response;
            queryState.queryZQCX = REQUEST_STATE.END;
            queryAfter($scope);
        });
    }

    /**
     * 当日中签查询接口
     */
    function queryDRZQCX($scope, method) {
        isQueryZQCX = false;

        var requset = {
            "qsrq": nowDate,
            "zzrq": nowDate
        };

        var lastUrl = "ptjy/xgsg/zqcx";
        ajaxPost(getApiUrl() + lastUrl, requset, function (response) {
            queryState.queryDRZQCX = REQUEST_STATE.END;
            var arry = response.cxlb || [];
            $scope.zqsl = arry.length;
            queryAfter($scope);
        });
    }

    /**
     * 当日委托查询
     */
    function queryDRWTCX($scope, method) {
        var lastUrl = "ptjy/ptyw/drwtcx";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/ptyw/drwtcx";
        }

        var requset = {
            "cxfx": "1",
            "qqhs": "1000"
        };

        ajaxPost(getApiUrl() + lastUrl, requset, function (response) {
            $scope.drwtcxSourceData = response;
            queryState.queryDRWTCX = REQUEST_STATE.END;
            queryAfter($scope);
        });
    }

    /**
     * 配号查询
     */
    function queryPHCX($scope, method) {
        var lastUrl = "ptjy/xgsg/phcx";
        if (params.ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/phcx";
        }

        var request = {
            gddm: "",
            zqdm: "",
            jysdm: "",
            cxfx: "1",
            qqhs: "999",
            dwc: "",
            qsrq: new Date().addMonths(-1).Format("yyyyMMdd"),
            zzrq: new Date().Format("yyyyMMdd")
        };

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            $scope.phcxSourceData = response;
            queryState.queryPHCX = REQUEST_STATE.END;
            queryAfter($scope);
        });
    }

    /**
     * 解析资讯服务器返回来新股数据
     */
    function parseIPO($scope, response) {
        if (response.news.length == 0) {
            return;
        }

        // 对返回的新股列表数据进行非空处理
        formatNewStockData(response.news, "待定", ["jysdm", "fxrq", "zqrq", "ssrq", "ext_flag"], "array");
        // 过滤申购代码重复的数据
        response.news = filterDuplicateData(response.news, "sgdm");

        // 给资讯返回的数据设置状态
        for (var i = 0, len = response.news.length; i < len; i++) {
            var data = response.news[i];

            // 0 表示科创板
            data.stktype = data.ext_flag === '0' ? 'W' : '';

            data.ipoSources = true;
            if (nowDate < data.fxrq) {
                // 待申购
                data.xgzt = "1";
            } else if (nowDate == data.fxrq) {
                // 申购中
                data.xgzt = "2";
            } else if (data.fxrq < nowDate && nowDate < data.zqrq) {
                // 申购结束
                data.xgzt = "4";
            } else if (nowDate == data.zqrq) {
                // 未申购
                data.xgzt = "15";
            } else if (data.zqrq < nowDate && (nowDate < data.ssrq || data.ssrq == "")) {
                // 待上市
                data.xgzt = "14";
            } else if (nowDate == data.ssrq) {
                // 今日上市
                data.xgzt = "3";
            } else if (data.ssrq < nowDate) {
                // 已上市
                data.xgzt = "5";
            }
        }

        $scope.queryData = response.news;

        // 将资讯源的数据做排序处理[asc: 升序, desc: 降序]
        sort($scope.queryData, "fxrq", "desc");
    }

    /**
     * 解析资讯服务器返回来新股数据 （申购日历需要特殊处理）
     */
    function parseIPO_SGRL($scope, response) {
        if (response.news.length == 0) {
            return;
        }

        // 对返回的新股列表数据进行非空处理
        formatNewStockData(response.news, "待定", ["jysdm", "fxrq", "zqrq", "ssrq", "stktype", "ext_flag"], "array");
        // 过滤申购代码重复的数据
        response.news = filterDuplicateData(response.news, "sgdm");

        // 给资讯返回的数据设置状态
        for (var i = 0, len = response.news.length; i < len; i++) {
            var data = response.news[i];

            // 0 表示科创板
            data.stktype = data.ext_flag === '0' ? 'W' : '';

            data.ipoSources = true;
            if (nowDate < data.fxrq) {
                // 待申购
                data.xgzt = "1";
            } else if (nowDate == data.fxrq) {
                // 申购中
                data.xgzt = "2";
            } else if (data.fxrq < nowDate && (nowDate < data.ssrq || data.ssrq == "")) {
                // 申购结束
                data.xgzt = "4";
            } else if (nowDate == data.ssrq) {
                // 今日上市
                data.xgzt = "3";
            } else if (data.ssrq < nowDate) {
                // 已上市
                data.xgzt = "5";
            }
        }

        $scope.queryData = response.news;

        // 将资讯源的数据做排序处理[asc: 升序, desc: 降序]
        sort($scope.queryData, "fxrq", "desc");
    }

    /**
     * 解析当日新股查询
     */
    function parseDRXG($scope, response) {
        response.cxlb = response.cxlb.map(function (item, index) {
            item.stktype = item.zqlb === 'W' ? 'W' : '';
            return item;
        });

        var xgObj = {};
        var len = response.cxlb.length;

        $scope["todayShow"] = len > 0 ? true : false;
        $scope["drksgslTotal"] = len;
        for (var i = 0; i < len; i++) {
            var bean = response.cxlb[i];
            xgObj[bean.sgdm] = bean;
        }

        // 需要删除的新股
        var needDeleteArray = [];
        // 将柜台新股列表中一些数据放入资讯新股列表中
        len = $scope.queryData.length;

        for (var i = 0; i < len; i++) {
            var bean = $scope.queryData[i]; // 资讯新股列表中的新股对象
            var temp = xgObj[bean.sgdm]; // 柜台新股列表中的新股对象
            // 资讯新股列表的数据与柜台当日新股列表匹对成功
            // 以柜台当日新股数据为主，资讯新股列表数据为辅
            if (temp != undefined) {
                bean["fxjg"] = temp.sgjg;
                bean["sgjg"] = temp.sgjg;
                bean["fxrq"] = temp.sgrq;
                bean["sgdw"] = temp.sgdw;
                bean["sgdm"] = temp.sgdm;
                bean["gpmc"] = temp.sgdmmc;
                bean["jysdm"] = temp.jysdm;
                bean["sgzdsl"] = temp.sgzdsl;
                bean["sgzdslxg"] = temp.sgzdslxg;
                bean["sgzxsl"] = temp.sgzxsl;
                bean["sgsx"] = temp.sgzdsl;
                bean["stktype"] = temp.stktype;
                bean["gddm"] = parseGddmList(temp.jysdm)[0];
                bean["isExistGDDM"] = isExistGDDM(temp.jysdm);
                bean["drxgSources"] = true;

                if (!isNaN(bean.sgjg)) {
                    // 发行价格保留二位小数
                    bean.sgjg = new Number(bean.sgjg).toFixed(2);
                    bean.fxjg = new Number(bean.fxjg).toFixed(2);
                }

                // 申购中
                bean['xgzt'] = "2";
                delete xgObj[bean.sgdm];
            }
            // 非柜台数据，状态不能是 2 （如果真存在，那就是配置存在问题）
            else if (bean.xgzt == "2") {
                    // 将需要删除的数据放到数组中
                    needDeleteArray.push(bean.sgdm);
                }
        }

        // 删除不需要的数据
        if (needDeleteArray.length > 0) {
            $scope.queryData = deleteNotNeedData($scope.queryData, "sgdm", needDeleteArray);
        }

        // 将柜台中有的而资讯中没有新股数据放到资讯新股列表顶部显示
        // 柜台新股排序 + 资讯新股排序
        var n = 0;
        for (var i in xgObj) {
            var bean = { "dqjg": "待定", "fxjg": "待定", "fxrq": "待定", "fxzl": "待定", "xgzt": "待定", "syl": "待定", "id": "待定", "fxzl": "待定", "sgsx": "待定" };
            var temp = xgObj[i];
            bean["fxjg"] = temp.sgjg;
            bean["sgjg"] = temp.sgjg;
            bean["fxrq"] = temp.sgrq;
            bean["sgdw"] = temp.sgdw;
            bean["sgdm"] = temp.sgdm;
            bean["gpmc"] = temp.sgdmmc;
            bean["jysdm"] = temp.jysdm;
            bean["sgzdsl"] = temp.sgzdsl;
            bean["sgzdslxg"] = temp.sgzdslxg;
            bean["sgzxsl"] = temp.sgzxsl;
            bean["sgsx"] = temp.sgzdsl;
            bean["stktype"] = temp.stktype;
            bean["gddm"] = parseGddmList(temp.jysdm)[0];
            bean["isExistGDDM"] = isExistGDDM(temp.jysdm);
            bean["drxgSources"] = true;
            // 申购中
            bean["xgzt"] = "2";

            if (!isNaN(bean.sgjg)) {
                // 发行价格保留二位小数
                bean.sgjg = new Number(bean.sgjg).toFixed(2);
                bean.fxjg = new Number(bean.fxjg).toFixed(2);
            }

            $scope.queryData.splice(n++, 0, bean);
        }
    }

    /**
     * 解析资金查询
     */
    function parseZJCX($scope, response) {
        if (!response || !response.zjlb || response.zjlb.length == 0) {
            $scope["zjkys"] = "0";
        } else {
            $scope["zjkys"] = response.zjlb[0].zjkys || "0";
        }
    }

    /**
     * 解析额度查询
     */
    function parseEDCX($scope, response) {
        var edcxobj = {};
        var len = response.cxlb.length;
        for (var i = 0; i < len; i++) {
            var edcxData = response.cxlb[i];
            edcxobj[edcxData.jysdm] = edcxData;
        }

        edcxobj['kcbksged'] = response.kcbksged || null;

        // 将交易所对应的额度用对象保存起来
        $scope['edcxobj'] = edcxobj;
    }

    /**
     * 解析中签查询
     * @param 数据集
     */
    function parseZQCX($scope, response) {
        // 过滤证券代码重复的数据
        response.cxlb = filterDuplicateData(response.cxlb, "zqdm");

        // 只使用中签数据，且以中签数据为主，其它数据为辅
        if (isUsedListDataZQCX) {
            var newData = usedListDataZQCX($scope, response);
            $scope.zqcxData = newData;
            return;
        }

        var zqcxobj = {};
        var len = response.cxlb.length;
        for (var i = 0; i < len; i++) {
            var zqcx = response.cxlb[i];
            zqcxobj[zqcx.zqdm] = zqcx;
        }

        // 柜台中签数据与资讯数据同时存在的申购代码
        var concurrence = {};
        len = $scope.queryData.length;
        for (var i = 0; i < len; i++) {
            // 新股列表数据（IPO + 柜台当前新股）
            var data = $scope.queryData[i];

            // 中签数据
            var zqData = zqcxobj[data.sgdm] || {};
            // 如果存在中签数据，则更新新股列表中的数据
            if (data.sgdm == zqData.zqdm) {
                concurrence[zqData.zqdm] = true;
                data["zqsl"] = zqData.zqsl;
                data["wtrq"] = zqData.wtrq;
                data["zqrq"] = zqData.zqrq;
                data["jkje"] = zqData.jkje;
                data["zqje"] = zqData.zqje;
                data["yjksl"] = zqData.yjksl;
                data["jg"] = zqData.jg;
                data["jssx"] = zqData.jssx;
                data["lczt"] = zqData.lczt;
                data["zqdm"] = zqData.zqdm;
                data["syl"] = zqData.syl;

                // 该数据是中签查询返回的
                data["zqSources"] = true;
                if (data["xgzt"] != "2") {
                    if (data.lczt == '0') {
                        // 已中签(今日中签)
                        data["xgzt"] = "7";
                    } else if (data.lczt != '0' && (data.ssrq == null || data.ssrq == "" || nowDate < data.ssrq)) {
                        // 已中签(历史中签)
                        data["xgzt"] = "16";
                    }
                }
            } else {
                // 柜台接口返回该数据没有中签，但资讯数据状态为已中签，需要修改成未中签状态
                if (data["xgzt"] == "7") {
                    data["xgzt"] = "8";
                }
            }

            if (!isNaN(data.fxjg)) {
                // 发行价格保留二位小数
                data.fxjg = new Number(data.fxjg).toFixed(2);
            }
        }

        len = response.cxlb.length;
        for (var i = 0; i < len; i++) {
            var zqData = response.cxlb[i];
            if (!concurrence[zqData.zqdm]) {
                var data = {};
                data["zqsl"] = zqData.zqsl;
                data["wtrq"] = zqData.wtrq;
                data["fxrq"] = zqData.wtrq;
                data["zqrq"] = zqData.zqrq;
                data["jkje"] = zqData.jkje;
                data["zqje"] = zqData.zqje;
                data["yjksl"] = zqData.yjksl;
                data["jg"] = zqData.jg;
                data["fxjg"] = zqData.jg;
                data["jssx"] = zqData.jssx;
                data["lczt"] = zqData.lczt;
                data["zqdm"] = zqData.zqdm;
                data["gpdm"] = zqData.zqdm;
                data["sgdm"] = zqData.zqdm;
                data["gpmc"] = zqData.zqmc;
                data["syl"] = zqData.syl;
                data["ssrq"] = "";
                // 该数据是中签查询返回的
                data["zqSources"] = true;

                if (data.lczt == '0') {
                    // 已中签(今日中签)
                    data["xgzt"] = "7";
                } else if (data.lczt != '0' && (data.ssrq == null || data.ssrq == "" || nowDate < data.ssrq)) {
                    // 已中签(历史中签)
                    data["xgzt"] = "16";
                }

                if (!isNaN(data.fxjg)) {
                    // 发行价格保留二位小数
                    data.fxjg = new Number(data.fxjg).toFixed(2);
                }

                $scope.queryData.push(data);
            }
        }
    }

    /**
     * 解析当日委托查询
     * @des 有当日委托的数据，状态显示为 “已申购”
     *      柜台返回的数据的状态，优先级高于资讯返回的状态
     */
    function parseDRWTCX($scope, response) {
        var wtObject = {};
        var len = response.cxlb.length;
        for (var i = 0; i < len; i++) {
            var data = response.cxlb[i];
            wtObject[data.zqdm] = data;
        }

        // 我的申购需要显示的数据
        if (isUsedListDataZQCX) {
            // 已在存在申购代码
            var existSGDM = [];
            // 需要删除的数据
            var needDeleteArray = [];

            // 从中签查询到的数据
            for (var i = 0, len = $scope["zqcxData"].length; i < len; i++) {
                var data = $scope["zqcxData"][i];
                existSGDM.push(data.sgdm);
                var object = wtObject[data.sgdm];
                // 匹配到当日委托数据
                if (object != null && data.fxrq == nowDate) {
                    // 已申购
                    data["xgzt"] = '6';
                    data["wtsl"] = object.wtsl || '';
                } else if (object == null && data.drxgSources) {
                    needDeleteArray.push(data.sgdm);
                }
            }

            // 删除不需要的数据
            if (needDeleteArray.length > 0) {
                $scope.zqcxData = deleteNotNeedData($scope.zqcxData, "sgdm", needDeleteArray);
            }

            // 获取中签中不存在，资讯与当日委托存在的数据，且设置状态为
            for (var i = 0, len = $scope.queryData.length; i < len; i++) {
                var data = $scope.queryData[i];
                var object = wtObject[data.sgdm];
                // 资讯与当日委托同时存在，上面没有添加的数据，发行日期为当天设置为已申购
                if (object != null && existSGDM.indexOf(data.sgdm) == -1 && data.fxrq == nowDate) {
                    // 已申购
                    data["xgzt"] = '6';
                    data["wtsl"] = object.wtsl || '';
                    $scope["zqcxData"].push(data);
                }
            }
        }
        // 申购日历及其它需要显示的数据
        else {
                for (var i = 0, len = $scope.queryData.length; i < len; i++) {
                    var data = $scope.queryData[i];

                    var object = wtObject[data.sgdm];
                    // 匹配到当日委托数据
                    if (object != null) {
                        if (data.fxrq == nowDate) {
                            // 已申购
                            data["xgzt"] = '6';
                            data["wtsl"] = object.wtsl || '';
                        }
                    }
                }
            }
    }

    /**
     * 解析配号查询
     * @des 配号查询目的，确认 “未中签” 状态，匹配规则：已中签数据与配号数据比较，
     */
    function parsePHCX($scope, response) {
        var phObject = {};
        var len = response.cxlb.length;
        for (var i = 0; i < len; i++) {
            var data = response.cxlb[i];
            phObject[data.zqdm] = data;
        }

        // 从我的申购界面进入
        if (isUsedListDataZQCX) {
            // 匹配已中签的数据
            for (var i = 0, len = $scope["zqcxData"].length; i < len; i++) {
                var data = $scope["zqcxData"][i];

                var object = phObject[data.sgdm];
                // 今日上市和已上市，使用股票代码进行匹配
                if (data.xgzt == '3' || data.xgzt == '5') {
                    object = phObject[data.gpdm];
                }

                // 已中签的数据，需要显示配号信息
                if (object != null) {
                    data.phSources = true;
                    data.qsph = object.qsph;
                    data.wtsl = object.phsl;

                    // 该数据已经在集合数组存在，更新字段后，将在配号对象中删除
                    delete phObject[data.sgdm];
                }
            }

            // 匹配配号的数据，获取已申购、未中签、待上市状态
            for (var i = 0, len = $scope.queryData.length; i < len; i++) {
                var data = $scope.queryData[i];
                var object = phObject[data.sgdm];
                // 今日上市和已上市，使用股票代码进行匹配
                if (data.xgzt == '3' || data.xgzt == '5') {
                    var object = phObject[data.gpdm];
                }

                if (object != null) {
                    data["wtsl"] = object.phsl || '';
                    data["qsph"] = object.qsph || '';
                    data["sgph"] = object.sgph || '';
                    data["phSources"] = true;
                    if (data.fxrq < nowDate && nowDate < data.zqrq) {
                        // 已申购
                        data["xgzt"] = '6';
                        $scope["zqcxData"].push(data);
                        delete phObject[data.sgdm];
                    } else if (data.zqrq == nowDate) {
                        // 未中签
                        data["xgzt"] = 8;
                        $scope["zqcxData"].push(data);
                        delete phObject[data.sgdm];
                    } else if (data.zqrq < nowDate && (nowDate < data.ssrq || data.ssrq == '')) {
                        // 待上市
                        data["xgzt"] = 14;
                        $scope["zqcxData"].push(data);
                        delete phObject[data.sgdm];
                    } else if (data.xgzt == '3' || data.xgzt == '5') {
                        // 将今日上市和已上市的添加进来
                        $scope["zqcxData"].push(data);
                        delete phObject[data.sgdm];
                    }
                }
            }

            // 配号接口返回数据，但无法其它接口返回的数据相匹配，所以显示未知，界面显示空白
            for (var object in phObject) {
                var data = phObject[object];
                data["fxrq"] = data.cjrq;
                data["wtsl"] = data.phsl || '';
                data["qsph"] = data.qsph || '';
                data["sgph"] = data.sgph || '';
                data["phSources"] = true;
                data["xgzt"] = 100;
                $scope["zqcxData"].push(data);
            }
        }
        // 其它界面进行
        else {
                var addArray = [];
                // 匹配配号的数据，获取已申购、未中签、待上市状态
                for (var i = 0, len = $scope.queryData.length; i < len; i++) {
                    var data = $scope.queryData[i];
                    var object = phObject[data.sgdm];

                    // 不处理从当日新股、中签来的数据
                    if (object != null && !data.drxgSources && !data.zqSources) {
                        if (data.fxrq < nowDate && nowDate < data.zqrq) {
                            // 已申购
                            data["xgzt"] = '6';
                            data["wtsl"] = object.phsl || '';
                        } else if (data.zqrq == nowDate) {
                            // 未中签
                            data["xgzt"] = 8;
                            data["wtsl"] = object.phsl || '';
                        } else if (data.zqrq < nowDate && nowDate < data.ssrq) {
                            // 待上市
                            data["xgzt"] = 14;
                            data["wtsl"] = object.phsl || '';
                        }
                    }
                }
                $scope.queryData = $scope.queryData.concat(addArray);
            }
    }

    /**
     * 使用中签数据，且以中签数据为主，其它数据为辅
     */
    function usedListDataZQCX($scope, response) {
        var zqcxLen = response.cxlb.length;
        var dataLen = $scope.queryData.length;
        var newData = [];

        for (var i = 0; i < zqcxLen; i++) {
            var data = response.cxlb[i];
            for (var j = 0; j < dataLen; j++) {
                if (data.zqdm == $scope.queryData[j].sgdm) {
                    var object = $scope.queryData[j];
                    object["zqrq"] = data.zqrq;
                    object["jysdm"] = data.jysdm;
                    data = combinationData(object, data);
                    break;
                }
            }

            // 该数据是中签查询返回的
            data["zqSources"] = true;
            // 发行日期 (防止该日期为空)
            data.fxrq = data.fxrq == null ? data.wtrq : data.fxrq;
            // 申购代码 (防止该申购代码为空)
            data.sgdm = data.sgdm == null ? data.zqdm : data.sgdm;
            // 股票名称 (防止该股票名称为空)
            data.gpmc = data.gpmc == null ? data.zqmc : data.gpmc;
            // 上市日期 (防止该日期为空)
            data.ssrq = data.ssrq == null ? "" : data.ssrq;

            if (data.drxgSources) {} else if (data.lczt == '0') {
                // 已中签(今日中签)
                data["xgzt"] = "7";
            } else if (data.lczt != '0' && (data.ssrq == null || data.ssrq == "" || nowDate < data.ssrq)) {
                // 已中签(历史中签)
                data["xgzt"] = "16";
            }

            if (!isNaN(data.jg)) {
                // 发行价格保留二位小数
                data.jg = new Number(data.jg).toFixed(2);
            }

            newData.push(data);
        }

        // 防止 JSON 数据异常，先转换成字符串，再转换成 JSON
        newData = JSON.stringify(newData);
        newData = JSON.parse(newData);

        return newData;
    }

    /**
     * 是否存在股东代码
     * @param  {[type]}  jysdm [description]
     * @return {Boolean}       [description]
     */
    function isExistGDDM(jysdm) {
        return parseGddmList(jysdm).length > 0;
    }

    /**
     * 解析股东代码
     * @param  交易所代码
     */
    function parseGddmList(jysdm) {
        var gddms = [];

        var userKey = params.ywlx == "ptjy" ? "ActivePTJYUser" : "ActiveRZRQUser";

        if (getLocalData(userKey)) {
            var gdlist = JSON.parse(getLocalData(userKey))["body"].gdlb;

            for (var i = 0; i < gdlist.length; i++) {
                if (gdlist[i].jysdm == jysdm) {
                    // 主股东账号添加到数组前面，辅账号则添加到末尾
                    if (gdlist[i].zcbz == "0") {
                        gddms.unshift(gdlist[i].gddm);
                    } else {
                        gddms.push(gdlist[i].gddm);
                    }
                }
            }
        }

        return gddms;
    }

    /**
     * 翻译新股状态
     */
    function translateXGZT(array) {
        var len = array.length;
        for (var i = 0; i < len; i++) {
            array[i]["xgztsm"] = dict.xgzt[array[i]["xgzt"] || -1] || "";
        }
        return array;
    }

    /**
     * 组合数据
     * @param  {[type]} objectZ [主对象]
     * @param  {[type]} objectF [辅对象]
     */
    function combinationData(objectZ, objectF) {
        for (var key in objectF) {
            if (!objectZ[key]) {
                objectZ[key] = objectF[key];
            }
        }
        return objectZ;
    }

    /**
     * 数组排序
     * @param array 需要排序的数组
     * @parma field 排序的字段
     * @param type  排序的类型 [asc: 升序, desc: 降序] [默认降序]
     */
    function sort(array, field, type) {
        var len = array.length;
        if (type == "asc") {
            for (var i = 0; i < len; i++) {
                for (var j = 0; j < len - i - 1; j++) {
                    if (array[j][field] > array[j + 1][field]) {
                        var temp = array[j];
                        array[j] = array[j + 1];
                        array[j + 1] = temp;
                    }
                }
            }
        } else {
            for (var i = 0; i < len; i++) {
                for (var j = 0; j < len - i - 1; j++) {
                    if (array[j][field] < array[j + 1][field]) {
                        var temp = array[j];
                        array[j] = array[j + 1];
                        array[j + 1] = temp;
                    }
                }
            }
        }
    }

    /**
     * 校验是否科创板
     */
    function checkKCB(value) {
        return value === 'W';
    }

    /**
     * 过滤重复数据
     * @param  {[type]} array [需要过滤重复数据的数组对象]
     * @param  {[type]} field [根据这个字段来过滤重复数据，如果这个字段没有值，将不会去过滤]
     * @return {[type]}       [过滤重复数据后的新数组对象]
     */
    function filterDuplicateData(array, field) {
        var nowFieldValueData = {};
        var newArrray = [];
        for (var i = 0, len = array.length; i < len; i++) {
            var fieldValue = array[i][field];
            if (fieldValue != null && fieldValue != "") {
                if (!nowFieldValueData[fieldValue]) {
                    nowFieldValueData[fieldValue] = true;
                    newArrray.push(array[i]);
                }
            } else {
                nowFieldValueData[fieldValue] = array[i].gpmc;
                newArrray.push(array[i]);
            }
        }
        return newArrray;
    }

    /**
     * 删除不需要的数据
     * @param  {[type]} array           [源数组数据]
     * @param  {[type]} field           [根据该字段删除]
     * @param  {[type]} needDeleteArray [需要删除的内容]
     * @return {[type]}                 [新的数据]
     */
    function deleteNotNeedData(array, field, needDeleteArray) {
        var newArrray = [];
        for (var i = 0, len = array.length; i < len; i++) {
            if (needDeleteArray.indexOf(array[i][field]) == -1) {
                newArrray.push(array[i]);
            }
        }
        return newArrray;
    }

    /**
     * 重写弹出框 Confirm() 方法
     * @des 重写 Confirm() 方法，调用一次后还原到重写前的方法
     */
    function Confirm(method) {
        var tempMethod = window.Confirm;
        window.Confirm = function () {
            method();
            window.Confirm = tempMethod;
        };
    }

    /**
     * 重写模态框上的 Ensure() 方法, 调用一次后还原到重写前的方法
     */
    function Ensure($scope, method) {
        var tempMethod = $scope.Ensure;
        $scope.Ensure = function () {
            method();
            $scope.Ensure = tempMethod;
        };
    }

    /**
     * 显示新股日历
     */
    function showSgrl($scope, method) {
        isQueryIPO = true;
        isQueryDRXGLBCX = true;
        isQueryEDCX = true;
        isqueryDRWTCX = true;
        isQueryDRZQCX = true;
        isSGRL = true;
        componentWillMount = method || null;
        $scope["queryData"] = [];
        query($scope);
    }

    /**
     * 显示一键申购
     */
    function showYjsg($scope, method) {
        isQueryDRXGLBCX = true;
        isQueryEDCX = true;
        isqueryDRWTCX = true;
        componentWillMount = method || null;
        $scope["queryData"] = [];
        query($scope);
    }

    /**
     * 显示加入自选股
     */
    function showJrzxg($scope, method) {
        isQueryIPO = true;
        isQueryZQCX = true;
        isQueryZJCX = true;
        isQueryPHCX = true;
        isUsedListDataZQCX = true;
        componentWillMount = method || null;
        $scope["queryData"] = [];
        query($scope);
    }

    /**
     * 显示我的申购
     */
    function showWdsg($scope, method) {
        isQueryIPO = true;
        isQueryZQCX = true;
        isQueryZJCX = true;
        isQueryPHCX = true;
        isQueryDRXGLBCX = true;
        isUsedListDataZQCX = true;
        isqueryDRWTCX = true;
        componentWillMount = method || null;
        $scope["queryData"] = [];
        query($scope);
    }

    return {
        showSgrl: showSgrl,
        showYjsg: showYjsg,
        showJrzxg: showJrzxg,
        showWdsg: showWdsg,

        translateXGZT: translateXGZT,
        sort: sort,
        Confirm: Confirm,
        Ensure: Ensure,
        isExistGDDM: isExistGDDM,
        checkKCB: checkKCB
    };
}();

/**
 * app 在新股申购中需要交互的接口
 *
 * 对外提供的接口：
 *     appXgsgApi.setTitleType(tabType, rightIconType)  // 导航栏显示类型接口
 * 对原生提供的接口：
 *     shareToWechat(title, shareUrl, summary)          // 分享界面接口
 */
var appXgsgApi = function (browser) {
    /**
     * 导航栏显示类型接口
     * @param {[type]} tabType       [TAB 类型] [0: 表示不显示tab项, 1: 表示显示 TAB (选中申购日历项), 2: 表示显示TAB (选中我的申购项)]
     * @param {[type]} rightIconType [右边按钮类型] [0: 表示优问按钮图, 1: 表示更多按钮图, 2: 表示申购说明, 3: 表示搜索按钮图, 4: 表示刷新按钮图]
     */
    function setTitleType(tabType, rightIconType) {
        if (browser == 'android') {
            KDS_Native.setTitleType(tabType, rightIconType);
        } else if (browser == 'ios') {
            loadURL("KDS_Native://setTitleType:" + tabType + ":" + rightIconType);
        }
    }

    /**
     * 分享界面接口
     * @param  {[type]} title    [标题]
     * @param  {[type]} shareUrl [分享地址]
     * @param  {[type]} summary  [摘要内容]
     */
    function shareToWechat(title, shareUrl, summary) {
        if (browser == 'android') {
            KDS_Native.shareToWechat(title, shareUrl, summary);
        } else if (browser == 'ios') {
            // ios 需要比 android 多传一个入参，最后个入参用 ""
            loadURL("KDS_Native://shareToWechat:" + [title, shareUrl, summary, ""].join(":"));
        }
    }
    // 该接口供
    window["shareToWechat"] = shareToWechat;

    return {
        setTitleType: setTitleType
    };
}(params.browser);

/**
 * 字典表
 */
var dict = function () {
    return {
        // 新股状态
        "xgzt": {
            "1": "待申购",
            "2": "申购中",
            "3": "今日上市",
            "4": "申购结束",
            "5": "已上市",
            "6": "已申购",
            "7": "已中签", // 今日中签
            "8": "未中签",
            // "9": "缴款成功",
            // "10": "未缴款",
            "11": "额度不足",
            "12": "尚无权限",
            "13": "缴款失败",
            "14": "等待上市",
            "15": "未申购",
            "16": "已中签", // 历史中签
            "100": "" // 未知状态，空白显示
        }
    };
}();