var app = angular.module('yjsg', []);

app.directive('ytStringHtml', function () {
    return function (scope, el, attr) {
        if (attr.ytStringHtml) {
            scope.$watch(attr.ytStringHtml, function (html) {
                el.html(html || '');
            });
        }
    };
});

app.controller('yjsgController', function ($rootScope, $scope, $http, $compile) {
    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.openCloseText = "展开";
    $scope.openStyle = "openStyle";
    $scope.isSelect = 0;
    $scope.isAllRowShow = false;
    $scope.edbzAlert = false;
    $scope.qxAlert = false;
    // 无权限提示
    $scope.wqxts = "创业板";
    // 额度信息
    $scope.ed = {
        ss: '0 股', // 深市的额度
        hs: '0 股' // 沪市的额度


        // 设置导航栏的显示
    };appXgsgApi.setTitleType("0", "2");

    // 显示加载页面数据
    yjsgApi.show($scope);

    // 科创板数据集
    $scope.yjsgKcbData = [];
    // 科创板默认勾选按钮样式
    $scope.selectKCBStyle = '';

    /**
     * 展开/收起所有行
     */
    $scope.allRowShow = function () {
        if ($scope.isAllRowShow) {
            $scope.openCloseText = "展开";
            $scope.openStyle = "openStyle";
            $scope.isAllRowShow = false;
        } else {
            $scope.openCloseText = "收起";
            $scope.openStyle = "";
            $scope.isAllRowShow = true;
        }
        yjsgApi.allRowShow($scope, $scope.isAllRowShow);
    };

    /**
     * 点击行的事件
     */
    $scope.rowClick = function (row) {
        if (row.show) {
            row.show = false;
        } else {
            row.show = true;
        }
    };

    /**
     * 左边多选点击事件
     */
    $scope.rowSelectedClick = function (row) {
        if (row.isSelect) {
            row.isSelect = false;
            row.selectStyle = "";
        } else {
            row.isSelect = true;
            row.selectStyle = "selected";
        }

        // 统计选中数
        yjsgApi.countSelected($scope);
    };

    /**
     * 默认勾选科创板点击事件
     */
    $scope.defaultTickKCBClick = function () {
        if ($scope.selectKCBStyle) {
            $scope.selectKCBStyle = '';
            $scope.yjsgKcbData = yjsgApi.selectedAll($scope.yjsgKcbData, false);
        } else {
            $scope.selectKCBStyle = 'selected';
            $scope.yjsgKcbData = yjsgApi.selectedAll($scope.yjsgKcbData, true);
        }

        // 统计选中数
        yjsgApi.countSelected($scope);
    };

    // 申购提交
    $scope.yisgSubmit = function () {
        yjsgApi.showSgModal($scope, $compile);
    };

    $scope.Ensure = function () {
        yjsgApi.sgSubmit($scope, $compile);
    };

    // 全额申购
    $scope.rowQESG = function (row) {
        row.sgsl = parseInt(row.sged);
    };

    // [-]申购股数
    $scope.minusNum = function (row) {
        if (row.sgsl > 0) {
            row.sgsl = parseInt(row.sgsl) - parseInt(row.sgdw);
            if (row.sgsl < 0) {
                row.sgsl = 0;
            }
        }
    };

    // [+]申购股数
    $scope.addNum = function (row) {
        row.sgsl = parseInt(row.sgsl) + parseInt(row.sgdw);
    };

    // 显示自定义键盘
    $scope.showKeyboard = function (index, row, type) {
        type = type === void 0 ? '' : type + '_';

        showKeyboard("input_" + type + index, 1);

        window.fillInputContent = function (param, jysdm) {
            row.sgsl = row.sgsl.toString();
            if (param == "del") {
                row.sgsl = row.sgsl.substr(0, row.sgsl.length - 1);
            } else {
                row.sgsl = row.sgsl + param;
            }

            angular.element($("body")).scope().$apply(function () {
                row.sgsl = parseInt(row.sgsl || "0");
            });
        };
    };

    // 设置内容区域的高度
    $scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var yjsgInforh = document.getElementById("yjsg-infor").clientHeight;
        var bottomHeight = document.getElementById("buttomPart").clientHeight;
        $scope.topHeightStyle = "height:" + (totalHeight - yjsgInforh - bottomHeight) + "px";
    });

    // 我的额度
    $scope.wdsgedAlert = function () {
        $scope.edbzAlert = true;
    };

    // 尚无权限
    $scope.swqxAlert = function (row) {
        $scope.qxAlert = true;
        $scope.wqxts = row.wqxts;
    };

    // 关闭我的额度弹框
    $scope.Cancel = function () {
        $scope.edbzAlert = false;
        $scope.qxAlert = false;
    };
});

var yjsgApi = function (xgsgApi) {
    function show($scope) {
        $scope.isSelect = 0;
        xgsgApi.showYjsg($scope, componentWillMount);
    }

    function componentWillMount($scope, method) {
        $scope["yjsgData"] = $scope.queryData;

        // 给列表数据增加 `isKCB` 字段
        addIsKCB($scope["yjsgData"]);

        // 显示无权限状态
        wqxXgzt($scope, $scope["yjsgData"]);

        // 显示额度不足状态
        edbzXgzt($scope["yjsgData"]);

        // 折叠所有行
        allRowShow($scope, $scope.isAllRowShow);

        // 调查显示控制方法
        selectSatus($scope);

        // 显示用户额度信息
        showEdInfo($scope);

        // 给部分添加中文单位
        partialDataAddUnit($scope, $scope["yjsgData"]);

        // 拆分数组：非科创板数组集、科创板数组集
        splitScoreGroup($scope, $scope.yjsgData);
    }

    /**
     * 给列表数据增加 `isKCB` 字段
     */
    function addIsKCB(yjsgData) {
        var len = yjsgData.length;
        for (var i = 0; i < len; i++) {
            yjsgData[i].isKCB = xgsgApi.checkKCB(yjsgData[i].stktype);
        }
    }

    /**
     * 给部分添加中文单位
     */
    function partialDataAddUnit($scope, yjsgData) {
        var len = yjsgData.length;
        for (var i = 0; i < len; i++) {
            var yjsgData = $scope.yjsgData[i];
            yjsgData["sgzdslF"] = addChineseUnit(yjsgData["sgzdsl"]); // 申购上限
            yjsgData["sgzdslxgF"] = addChineseUnit(yjsgData["sgzdslxg"]); // 申购最大数量新股
            yjsgData["sgzxslF"] = addChineseUnit(yjsgData["sgzxsl"]); // 申购下限
            yjsgData["sgedF"] = addChineseUnit(yjsgData["sged"]); // 最大申购数
        }
    }

    /**
     * 显示无权限状态
     */
    function wqxXgzt($scope, yjsgData) {
        var len = yjsgData.length;
        for (var i = 0; i < len; i++) {
            var xgData = yjsgData[i];
            var tempksged = $scope['edcxobj'][xgData.jysdm] || {};

            if (!xgsgApi.isExistGDDM(xgData.jysdm)) {
                // 尚无权限
                xgData["xgzt"] = 12;
                xgData["wqxts"] = xgData.jysdm == '0' ? '深市' : xgData.jysdm == '1' ? '沪市' : ' -- ';
            }
            // 交易所代码相等，则申购上限跟可申购额度对比取最小值填充到数组中
            else if ((xgData.jysdm == tempksged.jysdm || xgData.isKCB) && xgData.gddm != '') {
                    var sgsx = parseInt(xgData.sgzdsl || "0");
                    var ksged = parseInt(tempksged.ksged || "0");
                    // 科创板股票需要取科创板的额度
                    if (xgData.isKCB) {
                        ksged = parseInt($scope.edcxobj.kcbksged || "0");
                        if (ksged == 0) {
                            // 没有额度时，一键申购默认勾选科创板 不勾上
                            $scope.selectKCBStyle = '';
                        }
                    }

                    xgData["sged"] = sgsx;
                }
        }
    }

    // 申购额度于小申购单位时，显示额度不足状态
    function edbzXgzt(yjsgData) {
        var len = yjsgData.length;
        for (var i = 0; i < len; i++) {
            var data = yjsgData[i];
            // 无权限状态不需要进行下面判断
            if (data.xgzt == 12) {
                continue;
            }
            if (data.sged == null) {
                data.sged = '0';
            }
        }
    }

    // 显示选中新股、交易所小图标、申购新股总数
    function selectSatus($scope) {
        var len = $scope.queryData.length;
        for (var i = 0; i < len; i++) {
            var data = $scope.queryData[i];
            data["isSelect"] = false;
            data["selectStyle"] = "";
            data["hideContent"] = false;
            // 根据交易所不同显示不同小图标
            if (data["jysdm"] == "0") {
                data["jysdmIco"] = "shen";
            } else if (data["jysdm"] == "1") {
                data["jysdmIco"] = "hu";
            }
            // 显示可申购新股总数
            if ($scope.queryData[i].xgzt == 2 && data.sged > 0) {
                data["isSelect"] = true;
                data["selectStyle"] = "selected";
                $scope.isSelect++;
            }

            // 科创板默认勾选为 false 时，不需要选中
            if (data.isSelect && data.isKCB && !$scope.selectKCBStyle) {
                data["isSelect"] = false;
                data["selectStyle"] = "";
                $scope.isSelect--;
            }

            data["sgsl"] = data.sged;
        }
    }

    /**
     * 所有行的显示
     */
    function allRowShow($scope, state) {
        var i = 0;len = $scope.yjsgData.length;
        for (; i < len; i++) {
            $scope.yjsgData[i]["show"] = state;
        }

        var j = 0;lenJ = $scope.yjsgKcbData.length;
        for (; j < lenJ; j++) {
            $scope.yjsgKcbData[j]["show"] = state;
        }
    }

    /**
     * 统计选中数
     */
    function countSelected($scope) {
        var _count = 0;
        var data = $scope.yjsgData.concat($scope.yjsgKcbData);
        for (var i = 0; i < data.length; i++) {
            if (data[i].isSelect && data[i].xgzt == 2) _count++;
        }

        $scope.isSelect = _count;
    }

    /**
     * 显示申购下单的模态框
     */
    function showSgModal($scope, $compile) {
        if (parseInt($scope.isSelect) == 0) {
            Dialog.customAlert("请选择要申购的新股！", "提示信息");
            return;
        }

        var modal = {};
        modal["title"] = "申购确认";

        modal["single"] = [{
            "value": "您确定申购所选的新股吗?"
        }];

        Dialog.alert($scope, $compile, modal);
        $scope.Ensure = function () {
            yjsgApi.sgSubmit($scope, $compile);
        };
    }

    /**
     * 显示额度信息
     */
    function showEdInfo($scope) {
        // 深市的额度
        $scope.ed.ss = ($scope['edcxobj']['0'] != null ? $scope['edcxobj']['0'].ksged : '0') + " 股";
        // 没有对应市场股东账户需要显示 “未开通权限”
        $scope.ed.ss = xgsgApi.isExistGDDM('0') ? $scope.ed.ss : "未开通权限";
        // 沪市的额度
        $scope.ed.hs = ($scope['edcxobj']['1'] != null ? $scope['edcxobj']['1'].ksged : '0') + " 股";
        // 没有对应市场股东账户需要显示 “未开通权限”
        $scope.ed.hs = xgsgApi.isExistGDDM('1') ? $scope.ed.hs : "未开通权限";
    }

    /**
     * 拆分数组：非科创板数组集、科创板数组集
     */
    function splitScoreGroup($scope, yjsgData) {
        var arr1 = [],
            arr2 = [],
            i = 0;len = yjsgData.length;
        for (; i < len; i++) {
            var item = yjsgData[i];
            if (item.isKCB) {
                arr2.push(item);
            } else {
                arr1.push(item);
            }
        }
        // 非科创板数组集
        $scope.yjsgData = arr1;
        // 科创板数组集
        $scope.yjsgKcbData = arr2;
    }

    /**
     * 选中所有或取消所有
     * @param {Array}   arr     数据集
     * @param {Boolen}  state   [true: 选中所有, false: 取消所有]
     */
    function selectedAll(arr, state) {
        var i = 0;len = arr.length;
        for (; i < len; i++) {
            if (state && arr[i].xgzt == 2) {
                arr[i].isSelect = true;
                arr[i].selectStyle = "selected";
            } else {
                arr[i].isSelect = false;
                arr[i].selectStyle = "";
            }
        }
        return arr;
    }

    /**
     * 申购下单提交
     */
    function sgSubmit($scope, $compile) {
        // 关闭模态框
        Dialog.closeAlert();
        var yjsgData = $scope.yjsgData.concat($scope.yjsgKcbData);
        var wtsls = [];
        var jysdms = [];
        var gddms = [];
        var zqdms = [];
        var wtjgs = [];
        var yjsgDetaInfo = [];

        for (var i = 0; i < yjsgData.length; i++) {
            if (yjsgData[i].isSelect == true) {
                var wtsl = yjsgData[i].sgsl;
                var jysdm = yjsgData[i].jysdm;
                var gddm = yjsgData[i].gddm;
                var zqdm = yjsgData[i].sgdm;
                var wtjg = yjsgData[i].sgjg;

                wtsls.push(wtsl);
                jysdms.push(jysdm);
                gddms.push(gddm);
                zqdms.push(zqdm);
                wtjgs.push(wtjg);
                yjsgDetaInfo.push(yjsgData[i]);
            }
        }

        // 只有一支新股提交时，调用委托下单接口，
        if (zqdms.length == 1) {
            sgOnlySubmit(jysdms[0], gddms[0], zqdms[0], wtjgs[0], wtsls[0]);
            return;
        }

        var postData = {
            "wtsl": wtsls.join("|"),
            "jysdm": jysdms.join("|"),
            "gddm": gddms.join("|"),
            "zqdm": zqdms.join("|"),
            "wtjg": wtjgs.join("|")
        };

        var lastUrl = "ptjy/xgsg/yjsg";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/yjsg";
        }
        ajaxPost(getApiUrl() + lastUrl, postData, function (response) {
            // 成功后弹出提示框
            if (response.sgjg[0].sgzt == "cg") {
                Dialog.timeOutAlert("您可在我的申购中，实时查看申购进度。我们也将及时为您推送中签相关重要消息，预祝您申购成功！", "委托申购成功", "跳转至我的申购", "1");
                Dialog.countDownAlert = function () {
                    Dialog.closeAlert("TimeOutAlert");
                    JumpInterface(params.viewKey.KDS_PTJY_WDSG, 0, 2);
                };

                console.log(yjsgDetaInfo);
                setLocalData("yjsgDetaInfo", yjsgDetaInfo);
            }
            // 失败后弹出提示框
            if (response.sgjg[0].sgzt == "sb") {
                var modalContent = [];
                var _zqlb = response.zqlb;
                var len = _zqlb.length;
                var _bean = null;
                for (var i = 0; i < len; i++) {
                    _bean = _zqlb[i];
                    modalContent.push({ "key": _bean.zqmc, "value": _bean.zqdm });
                }

                modalContent.push({ "key": " ", "value": " " });

                var modal = {};
                modal["title"] = "提示信息";
                if (modalContent.length > 0) {
                    modal["content"] = modalContent;
                }
                modal["msg"] = [{ value: "以上新股申购失败，请单独进行申购" }, { value: "失败原因：系统错误" }];

                Dialog.alert($scope, $compile, modal, { firstBtnHide: true, isBodyScroll: true });
                $scope.Ensure = function () {
                    Dialog.closeAlert("modalTips");
                    yjsgApi.show($scope);
                };
            }
        }, null, {
            // ajax 请求期间禁止用点击事件
            isloaddingrunNoEvent: true
        });
    }

    /**
     * 单支新股提交
     * @param  {[String]} jysdm [交易所代码]
     * @param  {[String]} gddm  [股东代码]
     * @param  {[String]} zqdm  [证券代码]
     * @param  {[String]} wtjg  [委托价格]
     * @param  {[String]} wtsl  [委托数量]
     */
    function sgOnlySubmit(jysdm, gddm, zqdm, wtjg, wtsl) {
        var request = {
            'jysdm': jysdm,
            'gddm': gddm,
            'mmlb': 'B',
            'zqdm': zqdm,
            'wtjg': wtjg,
            'wtsl': wtsl.toString()
        };

        var options = {
            // ajax 请求期间禁止用点击事件
            isloaddingrunNoEvent: true,
            specifyServerErrorCode: PROPER_RECONSTRUCTION_FLOOR_TRADING.SPECIFY_SERVER_ERROR_CODE,
            specifyServerErrorCodeMethod: PROPER_RECONSTRUCTION_FLOOR_TRADING.start
        };

        // 普通交易一键打新引用 CDR 模块
        CDR.init(options);
        // 普通交易一键打新引用 沪伦通 模块
        HLT.init(options);
        // 普通交易引用 科创板 模块
        KCB.init(options);

        var lastUrl = 'ptjy/xgsg/wtxd';
        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            Dialog.timeOutAlert("您可在我的申购中，实时查看申购进度。我们也将及时为您推送中签相关重要消息，预祝您申购成功！", "委托申购成功", "跳转至我的申购", "1");
            Dialog.countDownAlert = function () {
                Dialog.closeAlert("TimeOutAlert");
                JumpInterface(params.viewKey.KDS_PTJY_WDSG, 0, 2);
            };
        }, null, options);
    }

    function init() {
        var Width = $(window).width() - 50;
        $(".yjsg-right").width(Width);
    }

    init();

    return {
        show: show,
        showSgModal: showSgModal,
        sgSubmit: sgSubmit,
        allRowShow: allRowShow,
        countSelected: countSelected,
        selectedAll: selectedAll
    };
}(xgsgApi);