/*============================= 不适合在控制器中定义的全局变量 ====================*/
var ywlx = $("body").attr("data-ywlx");
var step = 1000; // 步长  沪市 1000 , 深市 500
var maxNumber = 0; // 申购限额
var xg_fxjg = 0; // 新股的发行价格
var _methodTmp = function methodTmp() {}; // 临时方法
/*================================== end ==========================================*/

var app = angular.module('xgsg', []);

app.directive('ytStringHtml', function () {
    return function (scope, el, attr) {
        if (attr.ytStringHtml) {
            scope.$watch(attr.ytStringHtml, function (html) {
                el.html(html || '');
            });
        }
    };
});

app.controller('xgsgController', function ($rootScope, $scope, $http, $compile) {

    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.tbody = []; // 新股列表数据

    //======================= 初始化 start =====================================
    var newdate = new Date().Format("yyyyMMdd"); // 当前日期
    var Currenttime = new Date().Format("hh"); // 当前时间
    var xgList = []; // 新股列表
    var xg_index = -1; // 新股列表的索引 ID

    var modal_level = 1; // 模态框级别
    var modal = {}; // 模态框
    var select_xg = {}; // 选中的新股

    $scope.isYJSG = isYJSG; // 是否一键申购
    //======================= 初始化 end =========================================

    // 新股申购列表查询
    ipo_query(xgsg_query);

    // 提供原生回调刷新页面数据
    handlePageBack = function handlePageBack() {
        ipo_query(xgsg_query);
    };

    /**
     * TAB 点击事件
     * @param  {[type]} index [description]
     */
    $scope.topTabClick = function (index) {
        topTabClick(index);
    };

    /**
     * 点击跳转到科创板申购详情页
     */
    $scope.clickItem = function (item) {
        // 将新股信息保存到本地
        setLocalData("dataList", item);
        if (params.ywlx == "rzrq") {
            JumpInterface('rzrq/xgsg/rzrq_kcbxq.html', 4, 1);
        } else {
            JumpInterface('ptjy/xgsg/ptjy_kcbxq.html', 4, 1);
        }
    };
    /**
     * 点击页面中的 [ 申购 ] 按钮
     * @param  int index 索引
     */
    $scope.showModalSG = function (index, $event) {
        $event.stopPropagation();
        onAgentEvent('新股申购_科创板申购_申购', '', '');
        // 记录新股列表中索引
        xg_index = index;

        // 显示申购的模态框
        sg_show_modal();
    };

    /**
     * 点击页面中的 [ 一键申购 ] 按钮
     */
    $scope.showModalYGSG = function () {
        onAgentEvent('新股申购_科创板申购_一键申购', '', '');
        // 显示一键申购的模态框
        yjsg_show_modal();
    };

    // 点击模态框中的 [ 确定 ] 按钮
    $scope.Ensure = function () {
        // 申购模态框点击 “确定” 按钮
        if (modal_level == 1) {

            var tips = "";

            var number = $("#number").val();
            number = number.trim() == "" ? 0 : number;

            if (number == 0) tips = "请输入申购数量";

            if (tips != "") {
                showMessageTips(tips, "40");
                return;
            }

            // 因为申购数量可能是键盘输入, 需要重新计算下显示金额
            show_price($scope, modal, "number");

            // 委托数量
            select_xg['wtsl'] = number;
            // 申购金额
            select_xg['sgje'] = modal['numbersMsg'][0].value;
            // 设置股东代码
            select_xg['gddm'] = modal["select"] != undefined ? modal["select"][0]['options']['selectVal'] : select_xg.gddm;

            // 关闭模态框
            Dialog.closeAlert();

            // 申购确认模态框
            sgqr_show_modal();
        } else if (modal_level == 10) {
            // 申购确认模态框点击 “确定” 按钮
            // 关闭模态框
            Dialog.closeAlert();

            // 委托下单
            wtxd_order();
        } else if (modal_level == 100) {
            // 委托下单后显示的模态框点击 “确定” 按钮
            // 关闭模态框
            Dialog.closeAlert();

            //刷新页面
            window.location.reload();
        } else {
            // 关闭模态框
            Dialog.closeAlert();

            _methodTmp();
        }
    };

    /**
     * 点击模态框中的 [ 取消 ] 按钮
     * # 关闭模态框
     */
    $scope.Cancel = function () {
        // 关闭模态框
        Dialog.closeAlert();
    };

    // 点击模态框中的 [ + ] 按钮
    $scope.plus = function () {
        plusMinus("number", "plus", step);

        //显示金额
        show_price($scope, modal, "number");
    };

    // 点击模态框中的 [ - ] 按钮
    $scope.minus = function () {
        if (check_number("-")) {
            plusMinus("number", "minus", step);
        }

        //显示金额
        show_price($scope, modal, "number");
    };

    // 显示APP自定义键盘
    $scope.showKeyboard = function (id) {
        showKeyboard(id, '1');
    };

    /**
     * 新股申购列表查询
     */
    function xgsg_query(ipoDataList) {
        $scope.hide_xglb = false;

        var request = {};

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
        }

        var postData = {
            // 1-只查科创板新股、2-查除科创板外所有其他新股、不送查全部
            cxlb: '1'
        };

        var lastUrl = "ptjy/xgsg/drxglbcx";
        if (params.ywlx == "rzrq") {
            lastUrl = "rzrq/xgsg/drxglbcx";
            postData.gdlb = JSON.stringify(COMMON.getRzrqGdlb());
        } else {
            postData.gdlb = JSON.stringify(COMMON.getPtjyGdlb());
        }

        ajaxPost(getApiUrl() + lastUrl, postData, function (response) {
            // 解析当日新股查询
            parseDRXG(response, ipoDataList);
        });

        // 解析当日新股查询
        var parseDRXG = function parseDRXG(response, ipoDataList) {
            xgList = [];
            var xgObj = {};
            var i = 0,
                len = response.cxlb.length;
            for (; i < len; i++) {
                var bean = response.cxlb[i];
                xgObj[bean.sgdm] = bean;
            }

            // 将柜台新股列表中一些数据放入资讯新股列表中
            i = 0, len = ipoDataList.length;
            for (; i < len; i++) {
                var bean = ipoDataList[i]; // 资讯新股列表中的新股对象
                var temp = xgObj[bean.sgdm]; // 柜台新股列表中的新股对象
                // 资讯新股列表的数据与柜台当日新股列表匹对成功
                // 以柜台当日新股数据为主，资讯新股列表数据为辅
                if (temp != undefined) {
                    bean.fxjg = temp.sgjg;
                    bean.sgxe = temp.kmsl;
                    bean.sgdw = temp.sgdw;

                    bean['disabled'] = "";

                    delete xgObj[bean.sgdm];
                } else {
                    bean['disabled'] = true;
                }
            }

            for (var i in xgObj) {
                var bean = { "fxsyl": "待定", "wsfxsl": "待定", "zfxsl": "待定", "zjjdrq": "待定", "zqgbrq": "待定", "btn_state": "", "disabled": "" };
                var temp = xgObj[i];

                bean["fxjg"] = temp.sgjg;
                bean["fxrq"] = temp.sgrq;
                bean["sgxe"] = temp.kmsl;
                bean["sgdm"] = temp.sgdm;
                bean["zqdm"] = temp.sgdm;
                bean["zqmc"] = temp.sgdmmc;
                bean["jysdm"] = temp.jysdm;
                bean["sgdw"] = temp.sgdw;

                ipoDataList.push(bean);
            }
            xgList = ipoDataList;
            showXGLB(ipoDataList);
        };

        // 显示新股列表
        var showXGLB = function showXGLB(list) {
            $scope.tbody = list;

            // 如果没有新股列表, 提示给客户
            if ($scope.tbody.length == 0) {
                $scope.hide_xglb = true;
            }

            // 防止加载等待没有关闭
            loadding.stop();
        };
    }

    function ipo_query(callback) {
        if (!getApiUrlNews()) {
            return;
        }

        var request = {},
            url = '';

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
        }

        url = getApiUrlNews() + "ipo/ipo.json";

        // 新股列表查询 - 来源：资讯服务器
        ajaxPost(url, request, function (response2) {
            try {
                // 对返回的新股列表数据进行非空处理
                formatNewStockData(response2.stock, "待定", ["jysdm", "ext_flag"], "array");
            } catch (e) {
                response2.stock = [];
            }

            // 资讯新股列表
            var newsList = [],
                i = 0,
                len = response2.stock.length;
            for (; i < len; i++) {
                // 没有申购代码的数据都是错误数据，需要过滤（PS：为了兼容测试环境）
                // 只保留科创板的股票 ext_flag [0: 科创板]
                if (response2.stock[i].sgdm == null || response2.stock[i].ext_flag !== '0') {
                    continue;
                }
                response2.stock[i]['btn_state'] = "";
                response2.stock[i]['disabled'] = "";

                // 新股前一夜申购
                var isEvePurchase = response2.stock[i].fxrq - 1 == newdate && Currenttime >= 20 ? true : false;

                // 可申购
                if (response2.stock[i].fxrq == newdate || isEvePurchase) {} else {
                    // 不可操作
                    response2.stock[i]['disabled'] = true;
                }

                newsList.push(response2.stock[i]);
            }

            if (typeof callback === 'function') {
                callback(newsList);
            }
        }, null, {
            issuccess: false,
            error: function error() {
                callback([]);
            }
        });
    }

    /**
     * 申购显示的模态框
     */
    function sg_show_modal() {
        modal_level = 1;

        showDialog();

        // 显示对话框
        function showDialog() {
            //新股信息
            select_xg = {};
            select_xg = xgList[xg_index];

            // 深市步长 500 ,  沪市步长 1000
            // 使用柜台返回的申购单位
            step = parseInt(select_xg.sgdw || '0');

            xg_fxjg = select_xg.fxjg;
            // 解析股东代码
            var gddms = parseGddmList(select_xg.jysdm);
            // 用户没有股东代码时
            if (gddms.length == 0) {
                showMessageTips("您没有 [" + select_xg.zqdm + "] 所在交易所的股东代码，不能进行申购!", "40");
                return;
            }

            // 用户在该交易所代码没有开通股东账户
            if (select_xg.nogdzh) {
                // 产品确认只有沪深A 股，那其它的类型就不考虑了
                var scmc = select_xg.jysdm == "0" ? "深证市场" : "上证市场";
                showMessageTips("当前未开通" + scmc + "的股东代码，不能申购该股票！", "40");
                return;
            }

            select_xg.gddmIndex = select_xg.gddmIndex || 0;
            // 用户股东代码数大于 1 时，显示股东代码列表由客户选择
            var gdddmlist = [];
            if (gddms.length > 1) {
                for (var i = 0, len = gddms.length; i < len; i++) {
                    gdddmlist.push({ label: gddms[i], checked: i === select_xg.gddmIndex });
                }
            }
            // 设置股东代码
            select_xg['gddm'] = select_xg.gddm || gddms[0];
            // 申购限额
            maxNumber = select_xg.sgxe;
            // 申购金额
            var sgje = calculate_price(select_xg.fxjg, maxNumber) || "0 ";

            // 准备创建模态框
            modal = {};
            modal["title"] = "申购";
            modal["content"] = [{ "key": "证券名称", "value": select_xg.zqmc }, { "key": "证券代码", "value": select_xg.zqdm }, { "key": "最多可申购", "value": select_xg.sgxe + "股" }, { "key": "当前可申购", "value": maxNumber + "股" }];
            if (gdddmlist.length > 1) {
                modal.content.push({ "key": "股东代码", "value": select_xg.gddm, "class": "dialog-gddm-ele" });
            }
            modal['numbers'] = [{
                "id": "number",
                "plus": "BtnPlusRed",
                "minus": "BtnMinusRed",
                "value": ""
            }];
            modal['numbersMsg'] = [{ "key": "金额：", "value": sgje }];
            // 创建模态框
            Dialog.alert($scope, $compile, modal);
            // 延迟加载
            setTimeout(function () {
                // 买入数量
                $("#number").val(maxNumber);

                // 点击股东代码时，显示下拉框
                var gddmElement = document.getElementsByClassName('dialog-gddm-ele');
                if (gddmElement.length > 0) {
                    gddmElement[0].getElementsByTagName('td')[1].onclick = function () {
                        Dialog.selectAlert({
                            options: gdddmlist,
                            click: function click(index, value) {
                                gdddmlist[select_xg.gddmIndex].checked = false;
                                gdddmlist[index].checked = true;
                                select_xg.gddmIndex = index;
                                select_xg.gddm = value;
                                modal.content[4].value = value;
                                controller.scope.$digest();
                            }
                        });
                    };
                }
            }, 200);
        }
    }

    /**
     * 一键申购模态框
     */
    function yjsg_show_modal() {
        var len = $scope.tbody.length;
        if (len == 0) {
            showMessageTips("没有可申购的新股！", 40);
            return;
        }

        // 显示证券名称、证券代码、申购数量
        // 当日的新股列表
        var tbodyNew = [];
        var bean = null;
        for (var i = 0; i < len; i++) {
            bean = $scope.tbody[i];
            // “非当日新股” 和 “没有股东账号” 数据不在弹框列表中显示
            if (bean.disabled == "" && !bean.nogdzh) {
                tbodyNew.push(bean);
            }
        }

        // 对比额度, 显示内容
        len = tbodyNew.length;
        if (len == 0) {
            showMessageTips("没有可申购的新股！", 40);
            return;
        }
        // var ed = 0;
        var contents = [];
        var sqje = 0;
        for (var i = 0; i < len; i++) {
            bean = tbodyNew[i];
            // ed = eds[bean["jysdm"]];

            if (isNaN(bean.sgxe) || isNaN(bean.fxjg)) {
                console.log("该新股不能进行申购！ ", JSON.stringify(bean));
                showMessageTips("新股列表数据异常, 不能进行一键申购！", 40);
                return;
            }

            // bean.sgxe = parseInt(bean.sgxe) < parseInt(ed) ? bean.sgxe : ed;
            sqje += bean.sgxe * bean.fxjg;

            contents.push({ "key": "证券名称", "value": bean.zqmc });
            contents.push({ "key": "证券代码", "value": bean.sgdm });
            contents.push({ "key": "申购数量", "value": bean.sgxe });
            // 空一行
            contents.push({ "key": "", "value": "" });
        }

        modal = {};
        modal["title"] = "申购确认";
        modal["content"] = contents;
        modal.btnBeforeDynamic = { type: 'cageTips' };
        modal['numbersMsg'] = [{ key: "全部中签所需要金额：", value: sqje + " 元" }];
        // 创建模态框
        Dialog.alert($scope, $compile, modal, { rightIcoHide: true, isBodyScroll: true });

        modal_level = 0;
        // 点击模态框中 [确认] 按钮的回调事件
        _methodTmp = function methodTmp() {
            // 一键申购委托下单
            yjsg_wtxd_order();
            _methodTmp = function methodTmp() {};
        };
    }

    /**
     * 申购确认显示的模态框
     */
    function sgqr_show_modal() {
        modal_level = 10;

        modal = {};

        modal["title"] = "申购确认";

        modal["content"] = [{
            "key": "证券代码",
            "value": select_xg.zqdm
        }, {
            "key": "证券名称",
            "value": select_xg.zqmc
        }, {
            "key": "申购数量",
            "value": select_xg.wtsl || "0"
        }, {
            "key": "申购金额",
            "value": select_xg.sgje || "0"
        }];
        modal.btnBeforeDynamic = { type: 'cageTips' };
        // 创建模态框
        Dialog.alert($scope, $compile, modal, { rightIcoHide: true });
    }

    /**
     * 委托下单
     */
    function wtxd_order() {
        var request = {
            jysdm: select_xg.jysdm,
            gddm: select_xg.gddm,
            mmlb: "B",
            zqdm: select_xg.sgdm,
            wtjg: select_xg.fxjg,
            wtsl: select_xg.wtsl
        };

        var lastUrl = "ptjy/xgsg/wtxd";
        var options = {
            specifyServerErrorCode: PROPER_RECONSTRUCTION_FLOOR_TRADING.SPECIFY_SERVER_ERROR_CODE,
            specifyServerErrorCodeMethod: PROPER_RECONSTRUCTION_FLOOR_TRADING.start
        };

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/wtxd";
        } else {
            // 普通交易新股申购引用 CDR 模块
            CDR.init(options);
        }
        // 普通交易引用 科创板 模块
        KCB.init(options);

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            wtxd_show_modal(params.message.xgsg_success);
        }, null, options);
    }

    /**
     * 一键申购 - 委托下单
     */
    function yjsg_wtxd_order() {
        var jysdmS = ""; // 交易所代码
        var gddmS = ""; // 股东代码
        var mmlbS = ""; // 买卖类别
        var zqdmS = ""; // 证券代码
        var wtslS = ""; // 委托数量
        var wtjgS = ""; // 委托价格

        var len = $scope.tbody.length;
        var bean = null;
        // 循环拼接字符串, 以 “|” 号分隔
        for (var i = 0; i < len; i++) {
            bean = $scope.tbody[i];
            // “非当日新股” 和 “没有股东账号” 数据不提交到交易服务器
            if (bean.disabled == "" && !bean.nogdzh) {
                jysdmS += bean.jysdm + "|";
                gddmS += parseGddmList(bean.jysdm)[0] + "|";
                // gddmS += (bean.jysdm == "0" ? "0002387275" : "A286552605") + "|";
                mmlbS += "B" + "|";
                zqdmS += bean.sgdm + "|";
                wtslS += bean.sgxe + "|";
                wtjgS += bean.fxjg + "|";
            }
        }

        // 去掉最后一个 “|” 号
        jysdmS = jysdmS.substr(0, jysdmS.length - 1);
        gddmS = gddmS.substr(0, gddmS.length - 1);
        mmlbS = mmlbS.substr(0, mmlbS.length - 1);
        zqdmS = zqdmS.substr(0, zqdmS.length - 1);
        wtslS = wtslS.substr(0, wtslS.length - 1);
        wtjgS = wtjgS.substr(0, wtjgS.length - 1);

        var request = {
            "jysdm": jysdmS,
            "gddm": gddmS,
            "mmlb": mmlbS,
            "zqdm": zqdmS,
            "wtsl": wtslS,
            "wtjg": wtjgS
        };

        var lastUrl = "ptjy/xgsg/yjsg";
        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/yjsg";
        }

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            var _sgzt = response.sgjg[0].sgzt;
            var modalContent = [];
            var msg = "";

            // 一键申购全部成功
            if (_sgzt == "cg") {
                msg = "一键申购成功";
            }
            // 一键申购全部或部分失败
            else if (_sgzt == "sb") {
                    var _zqlb = response.zqlb;
                    var len = _zqlb.length;
                    var _bean = null;
                    for (var i = 0; i < len; i++) {
                        _bean = _zqlb[i];
                        modalContent.push({ "key": _bean.zqmc, "value": _bean.zqdm });
                    }

                    modalContent.push({ "key": " ", "value": " " });

                    msg = "以上新股申购失败，请单独进行申购";
                }

            modal_level = 100;
            modal = {};
            modal["title"] = "一键申购";
            if (modalContent.length > 0) {
                modal["content"] = modalContent;
            }
            modal["msg"] = [{
                value: msg
            }];

            // 创建模态框
            if (_sgzt == "cg") {
                Dialog.alert($scope, $compile, modal, { firstBtnHide: true, rightIcoHide: true });
            } else if (_sgzt == "sb") {
                Dialog.alert($scope, $compile, modal, { firstBtnHide: true, wrongIcoHide: true, isBodyScroll: true });
            }
        });
    }

    /**
     *  函数功能：委托下单显示的模态框
     */
    function wtxd_show_modal(msg, title) {
        title = title == undefined ? "申购" : title;

        modal_level = 100;

        modal = {};

        modal["title"] = title;

        modal["msg"] = [{
            value: msg
        }];

        // 创建模态框
        Dialog.successAlert(modal["msg"][0].value, title, false);
    }
});

/**
 * 新股额度查询
 * @param jysdm  交易所代码 0: 查全部
 * @param method 回调方法
 */
function xgedcx(jysdm, method) {
    // 股东代码、证券代码、交易所代码
    var request = {
        gddm: "",
        zqdm: "",
        jysdm: jysdm
    };

    var lastUrl = "ptjy/xgsg/xgedcx";

    if (ywlx == "rzrq") {
        request.ywlx = "rzrq";
        lastUrl = "rzrq/xgsg/xgedcx";
    }

    ajaxPost(getApiUrl() + lastUrl, request, function (response) {
        method(response);
    });
}

function showNoRecord(id, msg) {
    // 解决重复显示的问题
    if ($("#" + id).find(".no-record").length == 0) {
        $("#" + id).find("tbody").append(noRecord.replace("{{value}}", msg));
    }
}

function hideNoRecord(id) {
    if ($("#" + id).find(".no-record").length > 0) {
        $("#" + id).find(".no-record").remove();
    }
}

// 列表无数据时显示内容
var noRecord = '<tr class="no-record">' + '<td colspan="4"><img src="../../../images/pic_nodatas.svg"><p>暂无数据</p></td>' + '</tr>';

/**
 * 计算金额
 * @param {*} number
 * @param {*} price
 */
function amount_calculation(number, price) {
    console.log("number = " + number + "  price = " + price);
    // 数量与价格不存在或不是数字时，直接返回
    if (number == undefined || isNaN(number) || price == undefined || isNaN(price)) return "";

    number = parseInt(number);
    price = parseFloat(price);

    return (number * price).toFixed(0);
}

/**
 * 解析股东代码
 */
function parseGddmList(jysdm) {
    var gddms = [];

    var userKey = ywlx == "ptjy" ? "ActivePTJYUser" : "ActiveRZRQUser";

    if (getLocalData(userKey)) {
        var gdlist = JSON.parse(getLocalData(userKey))["body"].gdlb;

        for (var i = 0; i < gdlist.length; i++) {
            if (gdlist[i].jysdm == jysdm) {
                // 主股东账号添加到数组前面，辅账号则添加到末尾
                if (gdlist[i].zcbz == "0") {
                    gddms.unshift(gdlist[i].gddm);
                } else {
                    gddms.push(gdlist[i].gddm);
                }
            }
        }
    }

    return gddms;
}

/**
 * 模态框底部文字信息
 */
function footerMsg(jysdm) {
    jysdm = typeof jysdm == "string" ? parseInt(jysdm) : jysdm;

    if (jysdm == 0 || jysdm == 2) {
        //深市
        return "深圳市场每个申购单位为500股。申购数量应为500股整数倍。";
    } else if (jysdm == 1 || jysdm == 3) {
        //沪市
        return "上海市场每个申购单位为1000股。申购数量应为1000股整数倍。";
    } else if (jysdm == 100) {
        //一键申购(深市 + 沪市)
        return "上海市场每个申购单位为1000股。\n申购数量应为1000股整数倍。\n深圳市场每个申购单位为500股。\n申购数量应为500股整数倍。";
    } else {
        return "";
    }
}

/**
 *  自定义键盘回调函数 [与APP交互使用,函数名不能随意修改] [重写]
 *  @param param  键盘输入的值
 */
function fillInputContent(param) {
    if (param == "del") {
        var _value = $("#" + params.id).val();
        if (_value.length > 0) {
            _value = _value.substring(0, _value.length - 1);
            $("#" + params.id).val(_value);

            if (params.id == "number") {
                // 显示金额
                show_price(null, null, "number");
            }
        }
    } else {
        if (params.id == "jymm") {
            $("#" + params.id).val($("#" + params.id).val() + param);
        } else {
            // 申购数量
            if (params.id == "number") {
                $("#" + params.id).val($("#" + params.id).val() + param);

                // 显示金额
                show_price(null, null, "number");
            } else {
                $("#" + params.id).val($("#" + params.id).val() + param);
            }
        }
    }
}

/**
 * 显示金额
 * @param id     ID
 * @param num    数量
 */
function show_price($scope, modal, id) {
    var num = $("#" + id).val();

    num = num == "" ? 0 : num;

    // 如果计算结果为空, 则默认 0.00
    var price = calculate_price(xg_fxjg, num) || "0.00";

    if ($scope == null || modal == null) {
        $("label.price").html(price);
    } else {
        $("label.price").html(price);
        modal['numbersMsg'][0]['value'] = price;

        $scope.modal = modal;
    }
}

/**
 * 计算金额
 * @param price  价格
 * @param num    数量
 */
function calculate_price(price, num) {
    // 字符串转数字
    price = typeof price == "string" ? parseFloat(price) : price;
    num = typeof num == "string" ? parseInt(num) : num;

    // 金额 * 数量 , 千位符
    return formatNumber(price * num, 2);
}

/**
 * 验证股数
 * @param {String} param    ['+', '-']
 * @param {String} num      值
 */
function check_number(param, num) {
    var number = $("#number").val();

    number = number == "" ? 0 : parseInt(number);

    // 点击 [ + ] 按钮时
    if (param == "+") {
        if (number == maxNumber) {
            showMessageTips("申购限额 " + maxNumber, "40");
            return false;
        }

        if (number + step > maxNumber) {
            $("#number").val(maxNumber);
            return false;
        }
    }
    // 点击 [ - ] 按钮时
    if (param == "-") {
        if (number == 0) {
            showMessageTips("申购数量不能低于 " + 0, "40");
            return false;
        }

        if (number - step < 0) {
            $("#number").val("0");
            return false;
        }
    }
    // 键盘输入时
    if (num != undefined && num != "del") {
        num = num != "" && typeof num == "string" ? parseInt(num) : num;

        if (number * 10 + num > maxNumber) {
            $("#number").val(maxNumber);
            showMessageTips("申购限额 " + maxNumber, "40");
            return false;
        }
    }

    return true;
}

/**
 * 顶部 TAB 点击事件
 * @param  {[type]} index [description]
 */
function topTabClick(index) {
    $('#NewStockUL li').eq(index).addClass("active").siblings().removeClass("active");
    if (params.ywlx == "ptjy") {
        switch (index) {
            case 0:
                // 新股申购
                onAgentEvent('新股申购_新股申购', '', '');
                JumpInterface(params.viewKey.KDS_SM_XGSG, 4, 0);
                break;
            case 1:
                // 科创板申购
                onAgentEvent('新股申购_科创板申购', '', '');
                JumpInterface(params.viewKey.KDS_PTJY_KCBSG, 4, 0);
                break;
            case 2:
                // 可转债申购
                onAgentEvent('新股申购_可转债申购', '', '');
                JumpInterface(params.viewKey.KDS_PTJY_XZSG, 4, 0);
                break;
            case 3:
                // 新股查询
                onAgentEvent('新股申购_申购查询', '', '');
                JumpInterface(params.viewKey.KDS_PTJY_XGCX, 4, 0);
                break;
        }
    } else if (params.ywlx == "rzrq") {
        switch (index) {
            case 0:
                // 新股申购
                onAgentEvent('新股申购_新股申购', '', '');
                JumpInterface(params.viewKey.KDS_RZRQ_XGSG, 4, 0);
                break;
            case 1:
                // 科创板申购
                onAgentEvent('新股申购_科创板申购', '', '');
                JumpInterface(params.viewKey.KDS_RZRQ_KCBSG, 4, 0);
                break;
            case 2:
                // 可转债申购
                onAgentEvent('新股申购_可转债申购', '', '');
                JumpInterface(params.viewKey.KDS_RZRQ_XZSG, 4, 0);
                break;
            case 3:
                // 新股查询
                onAgentEvent('新股申购_申购查询', '', '');
                JumpInterface(params.viewKey.KDS_RZRQ_XGCX, 4, 0);
                break;
        }
    }
}