
/**
 * 新股申购详细页面
 */

var ywlx = $("body").attr("data-ywlx");
var dataList = getLocalData("dataList"); //  从本地存储中获取上一页面中新股信息
var newdate = new Date().Format("yyyyMMdd"); // 当前日期
var Currenttime = new Date().Format("hh"); // 当前时间
var step = 1000; // 步长  沪市 1000 , 深市 500

var app = angular.module('xgxq', []);

app.directive('ytStringHtml', function () {
    return function (scope, el, attr) {
        if (attr.ytStringHtml) {
            scope.$watch(attr.ytStringHtml, function (html) {
                el.html(html || '');
            });
        }
    };
});

app.controller('xgxqController', function ($rootScope, $scope, $http, $compile) {

    var modal_level = 1; // 模态框级别
    dataList = dataList == null ? {} : JSON.parse(dataList);

    $scope.userAgent = navigator.userAgent;
    $scope.stockName = dataList.zqmc || "";
    $scope.stockCode = dataList.zqdm || "";
    $scope.purchase = "申购";
    $scope.dis_sq_btn = true;

    // 新股前一夜申购
    var isEvePurchase = dataList.fxrq - 1 == newdate && Currenttime >= 20 ? true : false;

    // 当天是发行日期, 可以点击申购
    if (dataList.fxrq == newdate || isEvePurchase) {
        $scope.dis_sq_btn = false;
    }

    // 网上申购上限(元)  如果服务器没有下发数据, 则 "待定" 显示.
    var wssgsx_y = isNaN(dataList.wsfxsl) ? dataList.wsfxsl : isNaN(dataList.fxjg) ? dataList.fxjg : formatNumber(amount_calculation(dataList.sgxe, dataList.fxjg), 0);

    $scope.rowDetails = [{ name: "申购日期", value: formatDate(dataList.fxrq || "", "yyyy-MM-dd") }, { name: "资金解冻日", value: formatDate(dataList.zjjdrq || "", "yyyy-MM-dd") }, { name: "发行价格", value: dataList.fxjg || "" }, { name: "发行市盈率(倍)", value: !isNaN(dataList.fxsyl) ? dataList.fxsyl + "%" : dataList.fxsyl }, { name: "总发行数量(万股)", value: parseFloatW(dataList.zfxsl) }, { name: "网上发行数量(万股)", value: parseFloatW(dataList.wsfxsl) }, { name: "网上申购上限(万股)", value: parseFloatW(dataList.sgxe) }, { name: "网上申购上限(元)", value: wssgsx_y }];

    // 新股市盈率百分号隐藏
    if (isXGSYLPerCentHide) {
        $scope.rowDetails[3].value = !isNaN(dataList.fxsyl) ? dataList.fxsyl : dataList.fxsyl;
    }

    // 屏蔽显示数据
    $scope.baseContent = "";
    $scope.newsTitles = [];

    /*==========================================================
      触发条件：点击页面 [ 申购 ] 按钮
    ===========================================================*/
    $scope.sq_btn = function () {
        onAgentEvent('新股申购_新股申购_申购', '', '');
        // 显示申购的模态框
        sg_show_modal();
    };

    /*==============================================
      触发条件：点击模态框中的 [ + ] 按钮
      执行功能：
    ===============================================*/
    $scope.plus = function () {
        plusMinus("number", "plus", step);

        //显示金额
        show_price($scope, modal, "number");
    };

    /*==============================================
      触发条件：点击模态框中的 [ - ] 按钮
      执行功能：
    ===============================================*/
    $scope.minus = function () {
        if (check_number("-")) {
            plusMinus("number", "minus", step);
        }

        //显示金额
        show_price($scope, modal, "number");
    };

    /*===========================
      显示APP自定义键盘
    ============================*/
    $scope.showKeyboard = function (id) {
        showKeyboard(id, '1');
    };

    /*==============================================
      触发条件：点击模态框中的 [ 确定 ] 按钮
      执行功能：
    ===============================================*/
    $scope.Ensure = function () {
        if (modal_level == 1) {
            // 申购模态框点击 “确定” 按钮

            var tips = "";

            var number = $("#number").val();
            number = number.trim() == "" ? 0 : number;

            if (number == 0) tips = "请输入申购数量";

            if (tips != "") {
                showMessageTips(tips, "40");
                return;
            }

            // 因为申购数量可能是键盘输入, 需要重新计算下显示金额
            show_price($scope, modal, "number");

            // 委托数量
            dataList['wtsl'] = $("#number").val();
            // 申购金额
            dataList['sgje'] = modal['numbersMsg'][0].value;

            // 关闭模态框
            Dialog.closeAlert();

            // 申购确认模态框
            sgqr_show_modal();
        } else if (modal_level == 10) {
            // 申购确认模态框点击 “确定” 按钮
            // 关闭模态框
            Dialog.closeAlert();

            // 委托下单
            wtxd_order();
        } else if (modal_level == 100) {
            // 委托下单后显示的模态框点击 “确定” 按钮
            // 关闭模态框
            Dialog.closeAlert();

            //刷新页面
            window.location.reload();
        } else {
            // 关闭模态框
            Dialog.closeAlert();
        }
    };

    /*=============================================
      函数功能：申购显示的模态框
    ==============================================*/
    function sg_show_modal() {
        modal_level = 1;
        var eds = {};

        if (isXGXECX) {
            // 新股额度查询
            xgedcx(select_xg.jysdm, function (response) {
                // 模拟数据 start
                // response = {"cljg":[{"code":"MP1B000000","message":""}],"cxlb":[{"jysdm":"1","jysjc":"沪Ａ","ksged":"52000.00"},{"jysdm":"0","jysjc":"深Ａ","ksged":"2000.00"}]};
                // 模拟数据 end
                onSuccess(response);
            });
        } else {
            showDialog();
        }

        // 额度查询成功的处理函数
        var onSuccess = function onSuccess(response) {
            var len = response.cxlb.length;
            for (var i = 0; i < len; i++) {
                eds[response.cxlb[i].jysdm] = response.cxlb[i].ksged;
            }

            showDialog();
        };

        // 显示对话框
        function showDialog() {
            //新股信息
            select_xg = dataList;

            // 深市步长 500 ,  沪市步长 1000
            // 使用柜台返回的申购单位
            step = parseInt(select_xg.sgdw || '0');

            xg_fxjg = select_xg.fxjg;
            // 解析股东代码
            var gddms = parseGddmList(select_xg.jysdm);
            // 用户没有股东代码时
            if (gddms.length == 0) {
                showMessageTips("您没有 [" + select_xg.zqdm + "] 所在交易所的股东代码，不能进行申购!", "40");
                return;
            }

            // 用户在该交易所代码没有开通股东账户
            if (select_xg.nogdzh) {
                // 产品确认只有沪深A 股，那其它的类型就不考虑了
                var scmc = select_xg.jysdm == "0" ? "深证市场" : "上证市场";
                showMessageTips("当前未开通" + scmc + "的股东代码，不能申购该股票！", "40");
                return;
            }

            select_xg.gddmIndex = select_xg.gddmIndex || 0;
            // 用户股东代码数大于 1 时，显示股东代码列表由客户选择
            var gdddmlist = [];
            if (gddms.length > 1) {
                for (var i = 0, len = gddms.length; i < len; i++) {
                    gdddmlist.push({ label: gddms[i], checked: i === select_xg.gddmIndex });
                }
            }
            // 设置股东代码
            select_xg['gddm'] = select_xg.gddm || gddms[0];
            // 交易所额度
            var ed = eds[select_xg.jysdm] || "-1";
            // 申购限额
            maxNumber = select_xg.sgxe;
            // 二者取其小
            maxNumber = ed == "-1" ? maxNumber : parseFloat(ed) < parseFloat(maxNumber) ? parseFloat(ed) : maxNumber;
            // 申购金额
            var sgje = calculate_price(select_xg.fxjg, maxNumber) || "0 " + "元";

            // 准备创建模态框
            modal = {};
            modal["title"] = "申购";
            modal["content"] = [{ "key": "证券名称", "value": select_xg.zqmc }, { "key": "证券代码", "value": select_xg.zqdm }, { "key": "最多可申购", "value": select_xg.sgxe + "股" }, { "key": "当前可申购", "value": maxNumber + "股" }];
            if (gdddmlist.length > 1) {
                modal.content.push({ "key": "股东代码", "value": select_xg.gddm, "class": "dialog-gddm-ele" });
            }
            modal['numbers'] = [{
                "id": "number",
                "plus": "BtnPlusRed",
                "minus": "BtnMinusRed",
                "value": ""
            }];
            modal['numbersMsg'] = [{ "key": "金额：", "value": sgje }];
            // 创建模态框
            Dialog.alert($scope, $compile, modal);
            // 延迟加载
            setTimeout(function () {
                // 买入数量
                $("#number").val(maxNumber);

                // 点击股东代码时，显示下拉框
                var gddmElement = document.getElementsByClassName('dialog-gddm-ele');
                if (gddmElement.length > 0) {
                    gddmElement[0].getElementsByTagName('td')[1].onclick = function () {
                        Dialog.selectAlert({
                            options: gdddmlist,
                            click: function click(index, value) {
                                gdddmlist[select_xg.gddmIndex].checked = false;
                                gdddmlist[index].checked = true;
                                select_xg.gddmIndex = index;
                                select_xg.gddm = value;
                                modal.content[4].value = value;
                                $scope.$digest();
                            }
                        });
                    };
                }
            }, 200);
        }
    }

    /*=============================================
      函数功能：可买卖数量查询
    ==============================================*/
    function kmmslcxQuery(zqdm, gddm, jysdm, wtjg, method) {
        var request = {
            zqdm: zqdm,
            gddm: gddm,
            jysdm: jysdm,
            mmlb: "P",
            wtjg: wtjg
        };

        var lastUrl = "ptjy/xgsg/kmmslcx";

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/kmmslcx";
        }

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            method(response);
        });
    }

    /*================================================
      函数功能：申购确认显示的模态框
    ================================================*/
    function sgqr_show_modal() {
        modal_level = 10;

        modal = {};

        modal["title"] = "申购确认";

        modal["content"] = [{
            "key": "证券代码",
            "value": dataList.zqdm
        }, {
            "key": "证券名称",
            "value": dataList.zqmc
        }, {
            "key": "申购数量",
            "value": dataList.wtsl || "0"
        }, {
            "key": "申购金额",
            "value": dataList.sgje || "0"
        }];
        modal.btnBeforeDynamic = { type: 'cageTips' };
        // 创建模态框
        Dialog.alert($scope, $compile, modal);
    }

    /*================================================
      函数功能：委托下单
    ================================================*/
    function wtxd_order() {
        var request = {
            jysdm: dataList.jysdm,
            gddm: dataList.gddm,
            mmlb: "B",
            zqdm: dataList.sgdm,
            wtjg: dataList.fxjg,
            wtsl: dataList.wtsl
        };

        console.log(JSON.stringify(request));
        var lastUrl = "ptjy/xgsg/wtxd";
        var options = {
            specifyServerErrorCode: PROPER_RECONSTRUCTION_FLOOR_TRADING.SPECIFY_SERVER_ERROR_CODE,
            specifyServerErrorCodeMethod: PROPER_RECONSTRUCTION_FLOOR_TRADING.start
        };

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/wtxd";
        } else {
            // 普通交易新股申购引用 CDR 模块
            CDR.initializeScope($scope, $compile);
            CDR.init(options);
            // 普通交易新股申购引用 沪伦通 模块
            HLT.initializeScope($scope, $compile);
            HLT.init(options);
        }

        ajaxPost(getApiUrl() + lastUrl, request, function (response) {
            wtxd_show_modal(params.message.xgsg_success);
        }, null, options);
    }

    /*================================================
      函数功能：委托下单显示的模态框
    ================================================*/
    function wtxd_show_modal(msg) {
        modal_level = 100;

        modal = {};

        modal["title"] = "申购";

        modal["msg"] = [{
            value: msg
        }];

        // 创建模态框
        Dialog.alert($scope, $compile, modal, { firstBtnHide: true });
    }
}); // angularjs 控制器结束