var app = angular.module('other', []);

app.controller('otherController', function ($rootScope, $scope, $http, $compile) {});

window["setOtherFun"] = function (functionKey, json) {
    if (functionKey.hasPrefix('KDS_OTHER_MY_INFO')) {
        myInfo.get(json);
    }
};

/**
 * 设置我的信息
 */
var myInfo = new function () {
    // 客户经理信息
    var accountManagerInfo = null;
    // 电话号码信息
    var phoneNumberInfo = null;
    // 登录时返回的用户信息
    var dlxx = {};

    this.get = function (json) {
        json = JSON.parse(json || '{}');

        try {
            dlxx = JSON.parse(getLocalData("ActivePTJYUser")).body.dlxx[0];
        } catch (e) {}

        // 向服务器获取电话号码信息
        ajaxPost(getApiUrl() + "ptjy/zhyw/khdhcx", {}, setPhoneNumberInfo, setPhoneNumberInfo, { error: setPhoneNumberInfo });
    };

    /**
     * 将交易服务器返回的数据放到该块的全局变量中，然后再调用原生接口（这种写法主要是可以支持多个接口同时查询）
     * @param {[type]} response [description]
     */
    function setPhoneNumberInfo(response) {
        try {
            phoneNumberInfo = response.fhxx[0];
        } catch (e) {
            phoneNumberInfo = {};
        }
        set();
    }

    /**
     * 调用原生接口，将原生需要的数据传递过去
     */
    function set() {
        if (phoneNumberInfo == null) {
            return;
        }

        var json = {
            "khdh": phoneNumberInfo.khdh, // 客户电话
            "sfzh": phoneNumberInfo.sfzh, // 客户身份证号
            "kfdh": phoneNumberInfo.kfdh, // 客服电话
            "yybdm": dlxx.yybdm, // 营业部代码
            "yybjc": dlxx.yybjc, // 营业部简称
            "zjzh": dlxx.zjzh, // 资金账号
            "khdm": dlxx.khdm // 客户代码
        };

        console.log('setMyInfo, ' + JSON.stringify(json));
        if (params.browser == 'android') {
            KDS_Native.setMyInfo(JSON.stringify(json));
        } else if (params.browser == 'ios') {
            loadURL("KDS_Native://setMyInfo:" + JSON.stringify(json));
        } else {
            console.log("只能在IOS系统与Android系统下点击自助开户");
        }

        // 清空数据，防止被重复调用
        accountManagerInfo = null;
        phoneNumberInfo = null;
    }
}();