var app = angular.module('cwzcn', []);
app.controller('cwzcnController', function ($rootScope, $scope, $http, $compile) {
    getControllerMethod($rootScope, $scope, $http, $compile);

    /**
     * 弹出委托下单确认框
     */
    $scope.showModal = function () {
        hideKeyBoard();

        if (getLocalData("pbyteData") == null) {
            showMessageTips("基金查询无份额");
            return;
        }
        var modal = {};
        if (CheckIsPlus($("#zqdm")) && CheckIsPlus($("#wtsl"), "wtsl")) {
            modal["title"] = "基金场外转场内确认";
            modal["content"] = [{
                "key": "基金代码：",
                "value": trim($("#zqdm").val())
            }, {
                "key": "基金名称：",
                "value": trim($("#zqmc").text())
            }, {
                "key": "委托数量：",
                "value": trim($("#wtsl").val())
            }];
            Dialog.alert(controller["scope"], controller["compile"], modal, { rightIcoHide: true });
        }
    };

    /**
     * 下单提示框确认按钮绑定事件
     */
    $scope.Ensure = function () {
        hideKeyBoard();

        // 关闭模态框
        Dialog.closeAlert();

        var rowData = getLocalData("pbyteData");
        rowData = rowData == null ? {} : JSON.parse(rowData);
        var url = "ptjy/cwkfsjj/jjztg";
        var title = "提示";
        var postData = {
            "zjzh": rowData.zjzh, //Y  资金账号
            "jjgs": rowData.jjgs, //Y  基金公司
            "jjdm": $("#zqdm").val().trim(), //Y  基金代码
            "jjzh": rowData.jjzh, //Y  基金账号
            "jyzh": rowData.jyzh, //Y  交易账号
            "sffs": rowData.sffs, //Y  收费方式
            "wtsl": $("#wtsl").val().trim() //Y  委托数量
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            Dialog.successAlert("基金场外转场内申请成功", title);
            Dialog.confirm = function () {
                // 提交成功，称除本地存舒畅储 pbyteData 数据
                removeLocalData("pbyteData");
                // 清除表单数据
                clearValue();
                Dialog.closeAlert();
            };
        }, function (response) {
            Dialog.errorAlert("基金场外转场内申请失败" + response.cljg[0].message, title);
        });
    };
});

/**
 * 显示基金开放式基金持仓列表
 */
function showJiJinList() {
    dynGenerateNode(controller["scope"], controller["compile"], RightWindow);
    $("#right-window .title").hide();
    $(".ptjy-rzrq-tbody").hide();
    $(".kfsjj-tbody").hide();
    angular.element($("body")).scope().$apply(function () {
        controller["scope"].thead = [{
            name: "基金名称"
        }, {
            name: "净值/盈亏"
        }];
    });

    kfsjjChaChe.postData = {
        "jjgsdm": "", //N  基金公司代码
        "jdm": "", //N  基金代码
        "cxfx": params["cxfx"], //N  查询方向
        "qqhs": "1000", //N  请求行数
        "dwc": "" //N  定位串
    };

    kfsjjChaChe.type = "jjfecx";
    kfsjjChaChe.requestUrl = getApiUrl() + "ptjy/cwkfsjj/jjfecx";

    var tableHeight = document.documentElement.clientHeight - $("#right-window .scrollTable").offset().top;
    $("#right-window .scrollTable").height(tableHeight);

    ajaxPost(kfsjjChaChe.requestUrl, kfsjjChaChe.postData, function (response) {
        if (document.title.trim() == "场外转场内") {
            kfsjjChaChe.colNames = ["jjmc", "jjdm", "jjdwjz", "yk"];
        } else {
            return;
        }
        //=====================填充持仓表格数据=========================
        controller["scope"].rowHolds = FollowOriginalDataParses(response, kfsjjChaChe.colNames, kfsjjChaChe.type);

        var nScrollHight = 0; // 滚动距离总长(注意不是滚动条的长度)
        var nScrollTop = 0; // 滚动到的当前位置
        var nDivHight = $("#right-window .scrollTable").height();

        $("#right-window .scrollTable").scroll(function () {

            nScrollHight = $(this)[0].scrollHeight;

            nScrollTop = $(this)[0].scrollTop;

            if (nScrollTop == nScrollHight - nDivHight) {
                scrollLoadMoreContent();
            }
        });
    });
};

/**
 * 滚动加载更多数据
 */
function scrollLoadMoreContent() {
    // 开放式基金--基金份额
    if (kfsjjChaChe.type == "jjfecx") {
        kfsjjChaChe.postData.dwc = kfsjjChaChe.jjfecxdwc;
    } else {
        return;
    }
    ajaxPost(kfsjjChaChe.requestUrl, kfsjjChaChe.postData, function (response) {
        var content = "";
        var tbody = "";

        tbody = FollowOriginalDataParses(response, kfsjjChaChe.colNames, kfsjjChaChe.type, "isScrollQuery");

        var len = tbody ? tbody.length : 0;

        if (kfsjjChaChe.type == "jjfecx") {
            for (var i = 0; i < len; i++) {
                var row = tbody[i];
                content += "<tr onclick='FullBargainFrom(this)' >" + "   <td> " + "     <p>" + row.key1 + "</p>" + "     <p>" + row.key2 + "</p>" + "   </td>" + "   <td>" + "      <p>" + row.key3 + "</p>" + "      <p>" + row.key4 + "</p>" + "   </td>" + "</tr>";
            }
        }
        // 查询记录不为空时,加载查询数据
        if (len > 1) {
            $(".table.table-hover tbody").append(content);
        }
    });
};

/**
 * 点击下侧,右侧背景遮罩区域,关闭悬浮层
 */
$("body").on("click", "#RightWindow .modal-backdrop", function () {
    Dialog.closeAlert("RightWindow");
    return false;
});

/**
 * 点击了基金记录后进行可数量查询
 * @param  obj 行对象
 */
function FullBargainFrom(obj) {
    Dialog.closeAlert("RightWindow");
    // 先消除页面信息
    clearValue();

    var param = {
        jjdm: $(obj).find("td").eq(0).find("p").eq(1).text(),
        jjmc: $(obj).find("td").eq(0).find("p").eq(0).text()
    };
    $("#zqdm").css({
        "width": "50%"
    });
    $("#zqdm").val(param.jjdm);
    $("#zqmc").html(param.jjmc);
    $("#wtsl").val("");
    JiJinKMMSLCX(param);
};

/**
 * 基金可买卖数量查询
 * @param  可买卖数量查询参数
 */
function JiJinKMMSLCX(param) {

    var postData = {
        "jjdm": param.jjdm, //N  基金代码
        "cxfx": params["cxfx"], //N  查询方向
        "qqhs": "1000" //Y  请求行数
    };

    ajaxPost(getApiUrl() + "ptjy/cwkfsjj/jjfecx", postData, function (response) {

        if (response.cxlb && response.cxlb.length > 0) {
            var pbyteData = { "zjzh": response.cxlb[0].zjzh, "jjgs": response.cxlb[0].jjgs, "jjzh": response.cxlb[0].jjzh, "jyzh": response.cxlb[0].jyzh, "sffs": response.cxlb[0].sffs };
            setLocalData("pbyteData", pbyteData);
            $("#wtsl").attr({
                "placeholder": "可委托" + parseInt(response.cxlb[0].jjkysl) + "份"
            });
        } else {
            console.log("基金委托数量查询返回数据为 NULL");
        }
        // 清除表单数据
        clearJJJYForm();
    });
}

/**
 * 清除基金交易表单
 */
function clearJJJYForm() {
    var showKeyboardTemp = showKeyboard;
    showKeyboard = function showKeyboard(id, type) {
        if ("zqdm" == id) {
            // 消除页面数据
            clearValue();
        }
        showKeyboardTemp(id, type);
    };
}

/**
 * 消除页面数据
 */
function clearValue() {
    $("#zqdm").val("");
    $("#zqmc").text("");
    $("#zqdm").css({
        "width": "100%"
    });
    $("#wtsl").val("");
    $("#wtsl").attr({
        "placeholder": "请输入委托数量"
    });
}

/**
 * 填充input输入内容并根据条件完成响应的事件
 * @param  点击的软键盘键值
 */
function fillInputContent(param) {
    if (param == "del") {
        var _value = $("#" + params.id).val();

        if (_value.length > 0) {
            _value = _value.substring(0, _value.length - 1);
            $("#" + params.id).val(_value);
        }
    } else {

        // 输入小数点合法性判断
        if (params.id == "price") {
            var inputVal = $("#" + params.id).val();

            // 输入的金额不允许有两个小数点
            if ((inputVal + param).split(".").length > 2) {
                return;
            }

            $("#" + params.id).val($("#" + params.id).val() + param);
        } else if (params.id == "zqdm" || params.id == "zrzqdm") {

            if ($("#" + params.id).val().length < 6) {

                $("#" + params.id).val($("#" + params.id).val() + param);
                checkStkCodeChange("#" + params.id);
            }
        } else {
            $("#" + params.id).val($("#" + params.id).val() + param);
        }
    }
}

/**
 * 检测证券代码查询条件是否满足
 */
function checkStkCodeChange(zqdm) {
    if ($(zqdm).val().length == 6) {
        var param = {
            "jjdm": $(zqdm).val() //N  基金代码
        };
        JiJinXinXiCX(param);
    }
}

/**
 * 基金信息查询
 */
function JiJinXinXiCX(jjdm) {
    jjdm = jjdm ? jjdm : "";
    var postData = {
        "jjdm": $("#zqdm").val().trim(), //N  基金代码
        "cxfx": params["cxfx"], //N  查询方向
        "qqhs": "1000" //Y  请求行数
    };

    //================================基金公司查询==========================
    ajaxPost(getApiUrl() + "ptjy/cwkfsjj/jjfecx", postData, function (response) {
        if (response.cxlb.length == 0) {
            showMessageTips("基金查询无份额");
            return;
        }

        var pbyteData = { "zjzh": response.cxlb[0].zjzh, "jjgs": response.cxlb[0].jjgs, "jjzh": response.cxlb[0].jjzh, "jyzh": response.cxlb[0].jyzh, "sffs": response.cxlb[0].sffs };
        setLocalData("pbyteData", pbyteData);
        if (response.cxlb.length == 1) {
            $("#zqdm").css({
                "width": "50%",
                "height": "42px"
            });
            // 移除焦点事件
            $("#zqdm").blur();
            $("#zqdm").val(response.cxlb[0].jjdm);
            $("#zqmc").html(response.cxlb[0].jjmc);
            $("#wtsl").attr({
                "placeholder": "可委托" + parseInt(response.cxlb[0].jjkysl) + "份"
            });
        }
        // 清除表单数据
        clearJJJYForm();
    });
}

/**
 * 按照原始数据解析服务器返回的内容
 * @param  ervData          服务器返回的值
 * @param  colNames         表格列名
 * @param  type             类型
 * @param  isIscrollQuery   否为Iscroll控件发起的查询
 */
function FollowOriginalDataParses(servData, colNames, type, isIscrollQuery) {
    var list = [];
    var len = 0;

    isIscrollQuery = isIscrollQuery ? isIscrollQuery : "NormalQuery";

    // 如果存在无数据提示语,则删除
    if ($(".table tbody .no-record").length > 0) {
        $(".table tbody .no-record").remove();
    }

    if (type == "jjfecx") {
        var response = servData.cxlb;
    } else {
        return false;
    }

    if (response.length == 0) {
        if (isIscrollQuery == "isScrollQuery") {
            return false;
        }

        if (type == "jjfecx") {
            NoRecordNote("暂无数据", 4);
        }
        return true;
    }

    len = response.length;

    if (type == "jjfecx") {
        // 由于标的证券是三个界面复用,为处理方便,每个表格不足六列都补充为6列
        var tbodyKey = ["key1", "key2", "key3", "key4", "key5", "key6"];

        for (var i = 0; i < len; i++) {
            var row = {};

            for (var j = 0; j < colNames.length; j++) {
                row[tbodyKey[j]] = dataFilter({
                    name: colNames[j],
                    value: response[i][colNames[j]]
                });
            }

            list[i] = row;
        }
    } else {
        return true;
    }

    loadMoreContent(response, len, type);

    return list;
}