var app = angular.module('jjcc', []);
app.controller('jjccController', function ($scope, $http, $compile) {
    // 上一次点击的列表行的数据对象
    $scope.lastClickRow = null;
    $scope.fields = [['jjmc', 'jjdm'], ['cbj', 'jjdwjz'], ['jjkysl'], ['sz', 'yk']];
    $scope.tbody = [];

    /**
     * 查询基金持仓列表
     */
    $scope.queryJJCC = function () {
        $scope.tbody = [];
        $scope.postData = {
            "jjgsdm": "", // N 基金公司代码
            "jjdm": "", // N 基金代码
            "cxfx": params["cxfx"], // Y 查询方向       1 1向下/0向上查询方向
            "qqhs": params["qqhs"], // Y 请求行数       每次取的行数
            "dwc": "" // N 定位串         第一次填空
        };

        ajaxPost(getApiUrl() + "ptjy/cwkfsjj/jjfecx", $scope.postData, onResponse.bind(this, $scope));
    };

    /**
     * 列表行的点击事件，实现列表扩展区域的展示与隐藏
     * @param  {[Ojbect]} row [列表行数据对象]
     */
    $scope.rowClick = function (row) {
        row.extendAreaShow = !row.extendAreaShow;

        if ($scope.lastClickRow != null && $scope.lastClickRow.key != row.key) {
            $scope.lastClickRow.extendAreaShow = false;
        }
        $scope.lastClickRow = row;
    };

    /**
     * 按钮跳转事件
     * @param {[Object]} row     [列表行数据对象]
     * @param {[String]} pageKey [按钮类型的 KEY 值]
     */
    $scope.BtnPageJump = function (row, pageKey) {
        setLocalData("jjgsdm", {
            jjmc: row.jjmc,
            jjdm: row.jjdm,
            jjgsdm: row.jjdm
        });

        if (pageKey == "jjsg") {
            setLocalData("page", "申购");
            JumpInterface(params.viewKey.KDS_KFSJJ_JJSG, 0, 1);
        } else if (pageKey == "jjsh") {
            setLocalData("page", "赎回");
            JumpInterface(params.viewKey.KDS_KFSJJ_JJSH, 0, 1);
        }
    };

    $scope.queryJJCC();
});

/**
 * 解析列表数据
 * @param  {[type]}   $scope   [description]
 * @param  {[Object]} response [服务器返回的数据对象]
 */
function onResponse($scope, response) {
    var arrLength = $scope.tbody.length;
    for (var i = 0, len = response.cxlb.length; i < len; i++) {
        var item = response.cxlb[i];
        item.key = i + arrLength;
        item.extendAreaShow = false;
        if (parseFloat(item.yk) > 0.00) {
            item.color = 'red-color';
        } else if (parseFloat(item.yk) < 0.00) {
            item.color = 'green-color';
        } else {
            item.color = '';
        }
    }
    $scope.tbody = $scope.tbody.concat(response.cxlb);
    bindLoadMoreContentEvent($scope);
}

/**
 * 绑定加载更多内容事件
 */
function bindLoadMoreContentEvent($scope) {
    var nScrollHight = 0; // 滚动距离总长(注意不是滚动条的长度)
    var nScrollTop = 0; // 滚动到的当前位置
    var nDivHight = 0; // 滚动区域的固定高度
    var selector = ".active.scroll-area";; // 界面可滚动区域选择器

    setTimeout(function () {
        nDivHight = document.documentElement.clientHeight - $(selector).offset().top;

        if ($("footer").length > 0) {
            nDivHight = nDivHight - $("footer").height();
        }

        $(selector).height(nDivHight);

        // 防止事件重复绑定
        $(selector).unbind('scroll');

        $(selector).bind('scroll', function (event) {
            nScrollHight = $(this)[0].scrollHeight;

            nScrollTop = $(this)[0].scrollTop;

            if (nScrollTop == nScrollHight - nDivHight && nScrollHight != nDivHight) {
                scrollLoadMoreContent($scope);
                return false;
            }
        });
    }, 100);
}

/**
 * 请求更多持仓数据
 */
function scrollLoadMoreContent($scope) {
    var arrLength = $scope.tbody.length;
    if (arrLength > 0) {
        var lastRow = $scope.tbody[arrLength - 1];
        $scope.postData.dwc = lastRow.dwc;
    }
    ajaxPost(getApiUrl() + "ptjy/cwkfsjj/jjfecx", $scope.postData, onResponse.bind(this, $scope));
}