var app = angular.module('dtssq', []);

app.directive('ytStringHtml', function () {
    return function (scope, el, attr) {
        if (attr.ytStringHtml) {
            scope.$watch(attr.ytStringHtml, function (html) {
                el.html(html || '');
            });
        }
    };
});

app.controller('dtssqController', function ($rootScope, $scope, $compile) {
    getControllerMethod(null, $scope, null, $compile);

    // 提交按钮置灰(适当性的功能需要等可买卖数量查询成功后才能提交)
    $scope.isDisabledSubmit = true;

    var now = new Date();
    var page = getLocalData("page");
    var jjdm = getLocalData("jjdm");
    var jjxq = getLocalData("jjxq");

    $scope.tzms_show = true; // 定投-投资描述
    $scope.qmtj_show = true; // 定投-期满条件
    $scope.ksrq_show = true; // 定投-开始日期
    $scope.zzrq_show = true; // 定投-终止日期
    $scope.qmcs_show = false; // 定投-期满次数
    $scope.qmje_show = false; // 定投-期满金额
    $scope.zebs_show = false; // 定赎-巨额标识

    // 基金净值/可赎份额
    $scope.jjjz = ["基金净值", "", "元"];
    // 每期定投金额/每期定赎份额
    $scope.mmsl = ["每期定投金额", "", "请输入定投金额", "元"];
    // 基金代码
    $scope.jjdm = "";
    // 基金名称
    $scope.jjmc = "";
    // 收费类别说明
    $scope.sflbsm = "";
    // 申请日期 默认当天, 不可修改
    $scope.sqrq = now.Format("yyyyMMdd");
    // 开始日期 默认当前天
    $scope.ksrq = now.Format("yyyyMMdd");
    // 终止日期 默认30年后的当前天
    now.addYears(30);
    $scope.zzrq = now.Format("yyyyMMdd");
    // 扣款周期/赎回周期 [0]: 显示月 [1]: 显示月 [2]: 周期文本 [3]: 周期值 [4]: 扣款周期/赎回周期
    $scope.active = ["active", "", "每月1号", "01", "扣款周期"];
    // 扣款周期/赎回周期    0:月 1:周
    $scope.kkzq = "0";
    $scope.days = [["1"], ["2"], ["3"], ["4"], ["5"], ["6"], ["7"], ["8"], ["9"], ["10"], ["11"], ["12"], ["13"], ["14"], ["15"], ["16"], ["17"], ["18"], ["19"], ["20"], ["21"], ["22"], ["23"], ["24"], ["25"], ["26"], ["27"], ["28"]];
    $scope.weeks = [["星期一", "1"], ["星期二", "2"], ["星期三", "3"], ["星期四", "4"], ["星期五", "5"]];
    // 扣款日期
    $scope.amountData = [["每月1号", "13", "active"]];

    // 期满条件
    $scope.qmtj = ["0", "日期区间"];
    // 巨额标志
    $scope.jebz = ["0", "取消"];
    // 期满金额
    $scope.qmje = "";
    // 期满次数
    $scope.qmcs = "";

    // 可买卖查询
    $scope.kmmcx = {};
    // 业务类别 定投/定赎
    $scope.sort = page == "定投申请" ? "dt" : page == "定赎申请" ? "ds" : "";
    // 操作类型 修改/新增
    $scope.czlx = jjdm != null && jjxq != null ? "update" : "add";

    $scope.amount_unit = '';

    // 因为界面默认显示的是定投, 是定赎时需要修改界面的显示内容
    if ($scope.sort == "ds") {
        $scope.isDisabledSubmit = false;
        $scope.tzms_show = false; // 定投-投资描述
        $scope.qmtj_show = false; // 定投-期满条件
        $scope.qmcs_show = false; // 定投-期满次数
        $scope.qmje_show = false; // 定投-期满金额
        $scope.zebs_show = true; // 定赎-巨额标识
        $scope.active[4] = "赎回周期";
        $scope.jjjz = ["可赎份额", "", "份"];
        $scope.mmsl = ["每期定赎份额", "", "请输入定赎份额", "份"];
    } else if ($scope.sort == "") {
        console.log("没有申请类型");
        return;
    }

    // 修改操作, 初始化部分数据
    if ($scope.czlx == "update") {
        jjxq = JSON.parse(jjxq);

        order.curzqdm = jjdm;
        dtssqApi.queryJJKMMSLCX(jjdm, $scope.sort, $scope);
        // 显示申请日期/开始日期/终止日期/扣款周期
        $scope.sqrq = jjxq.wtrq;
        $scope.ksrq = jjxq.ksrq;
        $scope.zzrq = jjxq.zzrq;
        $scope.kkzq = $scope.sort == "dt" ? jjxq.kkzq : jjxq.shzq;
        // 显示扣款周期/赎回周期
        if ($scope.kkzq == "1") {
            $scope.active[0] = "";
            $scope.active[1] = "active";
        }
        $scope.active[2] = $scope.kkzq == "0" ? "每月" + jjxq.kkrq + "号" : "每周" + $scope.weeks[jjxq.kkrq - 1][0];
        $scope.active[3] = jjxq.kkrq;
        // 显示金额/份额
        if ($scope.sort == "dt") {
            $scope.mmsl[1] = jjxq.wtje;
            // 显示期满条件
            var qmzl = ["日期区间", "期满金额", "期满次数"];
            $scope.qmtj = [jjxq.qmzl, qmzl[jjxq.qmzl]];
            if (jjxq.qmzl == "1") {
                $scope.ksrq_show = false; // 定投-开始日期
                $scope.zzrq_show = false; // 定投-终止日期
                $scope.qmje_show = true; // 定投-期满金额
                $scope.qmje = jjxq.qmcs;
            } else if (jjxq.qmzl == "2") {
                $scope.ksrq_show = false; // 定投-开始日期
                $scope.zzrq_show = false; // 定投-终止日期
                $scope.qmcs_show = true; // 定投-期满次数
                $scope.qmcs = jjxq.qmcs;
            }
        } else if ($scope.sort == "ds") {
            $scope.mmsl[1] = jjxq.jjfe;
            if (jjxq.shfs == "1") {
                $scope.jebz = ["1", "顺延"];
            }
        }
    }

    $scope.setActive = function (state) {
        if (state == 0) {
            $scope.active[0] = "active";
            $scope.active[1] = "";
        } else {
            $scope.active[0] = "";
            $scope.active[1] = "active";
        }
    };

    $scope.setDay = function (value) {
        $scope.active[2] = "每月" + value + "号";
        $scope.active[3] = value;
        $scope.kkzq = "0";
        setTimeout(function () {
            $("#d-jyrq").find(".dropdown-menu.active").hide();
        }, 100);
    };

    $scope.setWeek = function (value, value2) {
        $scope.active[2] = "每周" + value;
        $scope.active[3] = value2;
        $scope.kkzq = "1";
        setTimeout(function () {
            $("#d-jyrq").find(".dropdown-menu.active").hide();
        }, 100);
    };

    // 日期框选择事件
    dtssqApi.delegateNullClick("d-jyrq");

    // 巨额标识下拉框选择事件
    dtssqApi.delegateClick("d-zebs", function (obj) {
        console.log("message: d-zebs");
        var v0 = $(obj).attr("value");
        var v1 = $(obj).text();
        $scope.jebz = [v0, v1];

        console.log($scope.jebz);
    });

    // 投资描述下拉框选择事件
    dtssqApi.delegateClick("d-tzms", function (obj) {
        console.log("message: d-tzms");
    });

    // 期满条件下拉框选择事件
    dtssqApi.delegateClick("d-qmtj", function (obj) {
        console.log("message: d-qmtj ");
        var oText = $(obj).text();
        var oValue = $(obj).attr("value");
        $scope.qmtj = [oValue, oText];

        $scope.ksrq_show = false;
        $scope.zzrq_show = false;
        $scope.qmcs_show = false;
        $scope.qmje_show = false;

        if (oText == "日期区间") {
            $scope.ksrq_show = true;
            $scope.zzrq_show = true;
        } else if (oText == "期满次数") {
            $scope.qmcs_show = true;
        } else if (oText == "期满金额") {
            $scope.qmje_show = true;
        }
    });

    $scope.showModal = function () {
        console.log("message: showModal 基金定投/定赎申请或修改");
        // 隐藏自定义键盘
        hideKeyBoard();

        // 表单验证
        if (!dtssqApi.verificationForm($scope, $compile)) {
            return;
        }

        // 定投申请
        if ($scope.sort == "dt" && $scope.czlx == "add") {
            // 适当性改造流程
            if (PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.getFunctionOpen()) {
                if (!SMJJ.getState().show || SMJJ.getState().requestSuccess) {
                    PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.start(dtssqApi.showModalDTSQ.bind(this, $scope, $compile));
                } else {
                    SMJJ.errorAlert();
                }
            }
            // 需要进行风险提示
            else if ($scope.kmmcx.fxpp == "0" && !PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.getFunctionOpen()) {
                    $scope.kmmcx.startFXCP = true;
                    dtssqApi.showModalDTSQFXTS($scope, $compile);
                } else {
                    dtssqApi.showModalDTSQ($scope, $compile);
                }
        }
        // 定投修改
        else if ($scope.sort == "dt" && $scope.czlx == "update") {
                dtssqApi.showModalDTXG($scope, $compile, jjxq);
            }
            // 定赎申请
            else if ($scope.sort == "ds" && $scope.czlx == "add") {
                    dtssqApi.showModalDSSQ($scope, $compile);
                }
                // 定赎修改
                else if ($scope.sort == "ds" && $scope.czlx == "update") {
                        dtssqApi.showModalDSXG($scope, $compile, jjxq);
                    }
    };

    $scope.Ensure = function () {
        console.log("message: Ensure 申请确认");

        // 定投申请
        if ($scope.sort == "dt" && $scope.czlx == "add") {
            // 适当性改造流程 - 专业投资者是否需要签署CA
            if (PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.isNeedCA()) {
                Dialog.closeAlert();
                PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.signCA(dtssqApi.DTSQ.bind(this, $scope, $compile));
                return;
            }
            // 风险提示之后，定投申购弹框
            else if ($scope.kmmcx.fxpp == "0" && $scope.kmmcx.startFXCP && !PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.getFunctionOpen()) {
                    $scope.kmmcx.startFXCP = false;
                    Dialog.confirm();
                    dtssqApi.showModalDTSQ($scope, $compile);
                    return;
                } else {
                    dtssqApi.DTSQ($scope, $compile);
                }
        }
        // 定投修改
        else if ($scope.sort == "dt" && $scope.czlx == "update") {
                dtssqApi.DTXG($scope, $compile, jjxq);
            }
            // 定赎申请
            else if ($scope.sort == "ds" && $scope.czlx == "add") {
                    dtssqApi.DSSQ($scope, $compile);
                }
                // 定赎修改
                else if ($scope.sort == "ds" && $scope.czlx == "update") {
                        dtssqApi.DSXG($scope, $compile, jjxq);
                    }

        Dialog.closeAlert();
    };

    /**
     * 阅读协议
     * @param  {[type]} row [description]
     * @return {[type]}     [description]
     */
    $scope.readingProtocol = function (row) {
        console.log(row);
        switch (row.key) {
            case 0:
                // 产品合同
                openWebUrlInMobileBrowser(SMJJ.getState().cphtslj);
                break;
            case 1:
                // 风险揭示书
                openWebUrlInMobileBrowser(SMJJ.getState().cpfxjsslj);
                break;
            case 2:
                // 产品说明书
                openWebUrlInMobileBrowser(SMJJ.getState().cpsmslj);
                break;
        }
    };

    document.title = page;
});

var dtssqApi = {
    // 基金可买卖数量查询
    queryJJKMMSLCX: function queryJJKMMSLCX(jjdm, sort, $scope) {
        var lastUrl = 'ptjy/cwkfsjj/jjkmmslcx';
        var postData = {
            jjgsdm: '',
            jjdm: jjdm,
            ywlx: "1"
        };

        if ("ds" == sort) {
            // 基金定赎使用新的可买卖数量查询接口，该接口不调用柜台 411014
            lastUrl = 'ptjy/cwkfsjj/jjkmmslcx2';
        }

        ajaxPost(getApiUrl() + lastUrl, postData, function (response) {
            if (response.cxlb.length == 0) {
                console.log("message: 基金可买卖数量查询查询列表为空!");
                return;
            }

            $scope.isDisabledSubmit = false;
            // 适当性改造 - 初化始数据
            PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.init(response);

            // 显示部分数据
            var bean = response.cxlb[0];
            $scope.kmmcx = bean;
            $scope.jjdm = bean.jjdm;
            $scope.jjmc = bean.jjmc;
            $scope.sflbsm = bean.sflbsm;

            // 基金定投
            if ("dt" == sort) {
                $scope.jjjz[1] = bean.jjdwjz;

                SMJJ.start(postData.jjdm, bean.dzhtjybs);
            }
            // 基金定赎
            else if ("ds" == sort) {
                    $scope.jjjz[1] = bean.jjkys;
                }
        });
    },

    // 定投申请风险提示模态框
    showModalDTSQFXTS: function showModalDTSQFXTS($scope, $compile) {
        var modal = {};
        modal["title"] = "委托提示";
        modal["single"] = [{ "value": "基金风险等级与客户等级不匹配,你是否要继续进行交易?" }];

        Dialog.alert($scope, $compile, modal);
        // showAlert("基金风险等级与客户等级不匹配,你是否要继续进行交易?", "委托提示", true);
    },

    // 定投申请模态框
    showModalDTSQ: function showModalDTSQ($scope, $compile) {
        if (getLocalData("ptjyAccount") == null) {
            return;
        }

        var ptjyAccount = JSON.parse(getLocalData("ptjyAccount"));
        // 基金账号
        var jjzh = ptjyAccount[0].head.khbz;

        var modal = {};
        modal["title"] = "基金定投申请";
        modal["content"] = [{ "key": "操作类别", "value": "基金定投申请" }, { "key": "基金代码", "value": $scope.jjdm }, { "key": "基金名称", "value": $scope.jjmc + "(" + $scope.sflbsm + ")" }, { "key": "基金账号", "value": jjzh }, { "key": "扣款周期", "value": $scope.active[2] }, { "key": "期满条件", "value": $scope.qmtj[1] }];

        // 日期区间
        if ($scope.qmtj[0] == "0") {
            modal["content"].push({ "key": "开始日期", "value": $("#ksrq").val() });
            modal["content"].push({ "key": "终止日期", "value": $("#zzrq").val() });
        }
        // 期满次数
        else if ($scope.qmtj[0] == "2") {
                modal["content"].push({ "key": "期满次数", "value": $("#qmcs").val() });
            }
            // 期满金额
            else if ($scope.qmtj[0] == "1") {
                    modal["content"].push({ "key": "期满金额", "value": $("#qmje").val() });
                }

        if (SMJJ.getState().show) {
            modal.dynamic = [{
                type: 'tipAndlink',
                tip: '购买前请阅读以下内容：',
                linkArr: [{
                    key: 0,
                    text: '《产品合同》',
                    onClick: $scope.readingProtocol
                }, {
                    key: 1,
                    text: '《风险揭示书》',
                    onClick: $scope.readingProtocol
                }, {
                    key: 2,
                    text: '《产品说明书》',
                    onClick: $scope.readingProtocol
                }]
            }];
        }

        Dialog.alert($scope, $compile, modal, { rightIcoHide: true });
    },

    // 定投申请
    DTSQ: function DTSQ($scope, $compile, ywlsh) {
        var url = "ptjy/cwkfsjj/jjdtsq";
        // 期满参数 [1]:期满金额 [2]:期满次数
        var qmcs = ["", $("#qmje").val(), $("#qmcs").val()];

        // 如果业务流水号为空，则从开放式基金适当性改造模块获取
        ywlsh = ywlsh || PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.getYwlsh();

        var postData = {
            'jjdm': $scope.jjdm, // Y 基金代码
            'sflb': $scope.kmmcx.sflb, // Y 收费类别
            'ksrq': $("#ksrq").val(), // Y 开始日期
            'zzrq': $("#zzrq").val(), // Y 终止日期
            'kkrq': $scope.active[3], // Y 扣款日期
            'wtje': $("#price").val(), // Y 委托金额
            'qmzl': $scope.qmtj[0], // Y 期满种类   0-日期 2-次数 1-金额
            'qmcs': qmcs[$scope.qmtj[0]], // Y 期满次数   当期满种类为1,2时,该参数起作用
            'kkzq': $scope.kkzq, // Y 扣款周期   0-每月 1-每周
            'ywlsh': ywlsh // N 业务流水号 保存影像后下单需要
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].wtxh, "提示信息");
        });
    },

    // 定投修改模态框
    showModalDTXG: function showModalDTXG($scope, $compile, jjxq) {
        var modal = {};
        modal["title"] = "基金定投修改";
        modal["content"] = [{ "key": "操作类别", "value": "基金定投修改" }, { "key": "基金代码", "value": $scope.jjdm }, { "key": "基金名称", "value": $scope.jjmc + "(" + $scope.sflbsm + ")" }, { "key": "基金账号", "value": jjxq.jjzh }, { "key": "扣款周期", "value": $scope.active[2] }, { "key": "期满条件", "value": $scope.qmtj[1] }];

        // 日期区间
        if ($scope.qmtj[0] == "0") {
            modal["content"].push({ "key": "开始日期", "value": $("#ksrq").val() });
            modal["content"].push({ "key": "终止日期", "value": $("#zzrq").val() });
        }
        // 期满次数
        else if ($scope.qmtj[0] == "2") {
                modal["content"].push({ "key": "期满次数", "value": $("#qmcs").val() });
            }
            // 期满金额
            else if ($scope.qmtj[0] == "1") {
                    modal["content"].push({ "key": "期满金额", "value": $("#qmje").val() });
                }

        Dialog.alert($scope, $compile, modal);
    },

    // 定投修改
    DTXG: function DTXG($scope, $compile, jjxq) {
        var url = "ptjy/cwkfsjj/jjdtxg";
        // 期满参数 [1]:期满金额 [2]:期满次数
        var qmcs = ["", $("#qmje").val(), $("#qmcs").val()];

        var postData = {
            'jjdm': $scope.jjdm, // Y 基金代码
            'sflb': $scope.kmmcx.sflb, // Y 收费类别
            'ksrq': $("#ksrq").val(), // Y 开始日期
            'zzrq': $("#zzrq").val(), // Y 终止日期
            'kkrq': $scope.active[3], // Y 扣款日期
            'wtje': $("#price").val(), // Y 委托金额
            'qmzl': $scope.qmtj[0], // Y 期满种类   0-日期  1-金额 2-次数
            'qmcs': qmcs[$scope.qmtj[0]], // Y 期满次数   当期满种类为1,2时,该参数起作用
            'kkzq': $scope.kkzq, // Y 扣款周期   0-每月 1-每周
            'wtrq': jjxq.wtrq, // N 委托日期
            'lsh': jjxq.lsh, // N 流水号
            'wtbh': jjxq.wtbh // N 委托编号
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].wtxh, "提示信息");
        });
    },

    // 定赎申请模态框
    showModalDSSQ: function showModalDSSQ($scope, $compile) {
        if (getLocalData("ptjyAccount") == null) {
            return;
        }

        var ptjyAccount = JSON.parse(getLocalData("ptjyAccount"));
        // 基金账号
        var jjzh = ptjyAccount[0].head.khbz;

        var modal = {};
        modal["title"] = "基金定赎申请";
        modal["content"] = [{ "key": "操作类别", "value": "基金定赎申请" }, { "key": "基金代码", "value": $scope.jjdm }, { "key": "基金名称", "value": $scope.jjmc + "(" + $scope.sflbsm + ")" }, { "key": "基金账号", "value": jjzh }, { "key": "赎回周期", "value": $scope.active[2] }, { "key": "周期赎回份额", "value": $("#price").val() }, { "key": "开始日期", "value": $("#ksrq").val() }, { "key": "终止日期", "value": $("#zzrq").val() }, { "key": "巨额标志", "value": $scope.jebz[1] }];

        Dialog.alert($scope, $compile, modal, { rightIcoHide: true });
    },

    // 定赎申请
    DSSQ: function DSSQ($scope, $compile) {
        var url = "ptjy/cwkfsjj/jjdssq";

        var postData = {
            'jjdm': $scope.jjdm, // Y 基金代码
            'sflb': $scope.kmmcx.sflb, // Y 收费类别
            'ksrq': $("#ksrq").val(), // Y 开始日期
            'zzrq': $("#zzrq").val(), // Y 终止日期
            'kkrq': $scope.active[3], // Y 扣款日期
            'wtsl': $("#price").val(), // Y 委托数量
            'shzq': $scope.kkzq, // Y 赎回周期   0-每月 1-每周
            'kkzq': $scope.kkzq, // Y 扣款周期   0-每月 1-每周
            'jebz': $scope.jebz[0] // Y 巨额标志   0-取消 1-顺延
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].wtxh, "提示信息");
        });
    },

    // 定投修改模态框
    showModalDSXG: function showModalDSXG($scope, $compile, jjxq) {
        var modal = {};
        modal["title"] = "基金定赎修改";
        modal["content"] = [{ "key": "操作类别", "value": "基金定赎修改" }, { "key": "基金代码", "value": $scope.jjdm }, { "key": "基金名称", "value": $scope.jjmc + "(" + $scope.sflbsm + ")" }, { "key": "基金账号", "value": jjxq.jjzh }, { "key": "赎回周期", "value": $scope.active[2] }, { "key": "每期赎回份额", "value": $("#price").val() }, { "key": "开始日期", "value": $("#ksrq").val() }, { "key": "终止日期", "value": $("#zzrq").val() }, { "key": "巨额标志", "value": $scope.jebz[1] }];

        Dialog.alert($scope, $compile, modal);
    },

    // 定赎修改
    DSXG: function DSXG($scope, $compile, jjxq) {
        var url = "ptjy/cwkfsjj/jjdsxg";

        var postData = {
            'jjdm': $scope.jjdm, // Y 基金代码
            'sflb': $scope.kmmcx.sflb, // Y 收费类别
            'ksrq': $("#ksrq").val(), // Y 开始日期
            'zzrq': $("#zzrq").val(), // Y 终止日期
            'kkrq': $scope.active[3], // Y 扣款日期
            'wtsl': $("#price").val(), // Y 委托数量
            'shzq': $scope.kkzq, // Y 赎回周期   0-每月 1-每周
            'kkzq': $scope.kkzq, // Y 扣款周期
            'jebz': $scope.jebz[0], // Y 巨额标志   0-取消 1-顺延
            'wtrq': jjxq.wtrq, // N 委托日期
            'lsh': jjxq.lsh, // N 流水号
            'wtbh': jjxq.wtbh // N 委托编号
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].wtxh, "提示信息");
        });
    },

    /****************** 绑定事件 **********************/
    delegateClick: function delegateClick(selectId, handler) {
        $(document).delegate("#" + selectId + " .dropdown-menu > li", "click", function () {
            $("#" + selectId + " .dropdown-menu li").each(function () {
                if ($(this).hasClass("active")) {
                    $(this).removeClass("active");
                }
            });
            // 设置选中样式
            if ($(this).hasClass("active") == false) {
                $(this).addClass("active");
            }
            // 设置选中值
            $("#" + selectId + " button").text($(this).text());
            // 隐藏父div
            $(this).parent().hide();

            var obj = this;
            angular.element($("body")).scope().$apply(function () {
                // 执行回调函数
                handler(obj);
            });

            // 点击事件禁止冒泡传播
            return false;
        });
    },

    // 绑定事件 - 禁止冒泡传播
    delegateNullClick: function delegateNullClick(selectId) {
        $(document).delegate("#" + selectId + " .dropdown-menu > div", "click", function () {
            // 点击事件禁止冒泡传播
            return false;
        });
    },

    // 验证表单
    verificationForm: function verificationForm($scope, $compile) {
        var $zqdm = $("#zqdm");
        var $price = $("#price");
        var $ksrq = $("#ksrq");
        var $zzrq = $("#zzrq");
        var $qmcs = $("#qmcs");
        var $qmje = $("#qmje");

        if ($zqdm.val().trim().length < 6) {
            $zqdm.focus();
            return false;
        } else if ($price.val().trim().length == 0) {
            $price.focus();
            return false;
        } else if ($ksrq.val().trim().length == 0) {
            $ksrq.focus();
            return false;
        } else if ($zzrq.val().trim().length == 0) {
            $zzrq.focus();
            return false;
        }
        // 期满金额
        if ($scope.qmtj[0] == "1" && $qmje.val().trim().length == 0) {
            $qmje.focus();
            return false;
        }
        // 期满次数
        if ($scope.qmtj[0] == "2" && $qmcs.val().trim().length == 0) {
            $qmcs.focus();
            return false;
        }

        return true;
    }

    /*======================================
    函数功能:     清除基金交易表单
    传入参数: jjdm:代码名称 param: 是否全部清空
    =======================================*/
};function clearJJJYForm(jjdm, param) {
    if (jjdm == "zqdm") {
        angular.element($("body")).scope().$apply(function () {
            var $scope = controller.scope;
            $scope.jjdm = "";
            $scope.jjmc = "";
            $scope.sflbsm = "";
            $scope.jjjz[1] = "";
            $scope.mmsl[1] = "";
            // $scope.active[2] = "";
        });

        PROPER_RECONSTRUCTION_OPEN_END_FUND_TRADING.reset();
    }
}

// APP 自定义键盘回调函数
function fillInputContent(param) {
    var $inId = $("#" + params.id);
    if (param == "del") {
        var _value = $inId.val();
        if (_value.length > 0) {
            _value = _value.substring(0, _value.length - 1);
            $inId.val(_value);
        }
    } else {
        // 输入小数点合法性判断
        if (params.id == "price") {
            $inId.val($inId.val() + param);
        } else if (params.id == "zqdm" || params.id == "zrzqdm") {
            if ($inId.val().length < 6) {
                $inId.val($inId.val() + param);

                // 基金代码位数达到 6 位, 进行基金可买卖数量查询
                if ($inId.val().length == 6) {
                    order.curzqdm = $inId.val();
                    dtssqApi.queryJJKMMSLCX($inId.val(), controller.scope.sort, controller.scope);
                }
            }
        } else {
            $inId.val($inId.val() + param);
        }
    }

    setAmountUnit(params.id);
}

function setAmountUnit(inputId, isController) {
    if (inputId !== 'price') {
        return;
    }

    var input = $("#" + inputId);
    if (input.length === 0) {
        return;
    }
    var amount = input.val();
    var unit = getChineseUnit(amount);

    // 设置 placeholder 的字体变小后，文字将不会垂直剧中
    // 这里通过动态修改字体大小，达到 placeholder 与 input 字体可以不致的目的
    if (amount.length == 0) {
        input.addClass('empty');
    } else {
        input.removeClass('empty');
    }

    if (isController) {
        angular.element($("body")).scope().amount_unit = unit;
        return;
    }

    angular.element($("body")).scope().$apply(function ($scope) {
        $scope.amount_unit = unit;
    });
}

/**
 * 重写输入框点击事件
 */
var showKeyboardTemp = showKeyboard;
showKeyboard = function showKeyboard(id, type) {
    if (id == 'zqdm' && controller.scope.sort == "dt") {
        try {
            angular.element($("body")).scope().$apply(function () {
                controller.scope.isDisabledSubmit = true;
            });
        } catch (e) {}
    }
    showKeyboardTemp(id, type);
    setAmountUnit('price');
};

/**
 * 显示原生日期控件
 * @param  {[type]} type [description]
 * @param  {[type]} el   [description]
 * @return {[type]}      [description]
 */
window.showDateDialog = function (type, el) {
    var idName = el.getAttribute("id");
    var idValue = el.value;
    console.log("当前选中日期 ID：" + idName);
    idValue = formatDate(idValue, "yyyy-MM-dd");
    // 日期弹框，最小日期选择为当日
    var fixedStartDate = new Date().Format("yyyy-MM-dd");

    var parameters = [idValue, fixedStartDate, "", "handleShowDateDialog(value)"];
    if (params.browser == "android") {
        /**
         * 显示日期控件
         * @param time 控件显示的日期 (yyyy-MM-dd)
         * @param min  控件最小选择日期 (空字符串则不限制) (yyyy-MM-dd)
         * @param max  控件最大选择日期 (空字符串则不限制) (yyyy-MM-dd)
         * @param method 日期控件选择后回调的函数, 默认使用：handleShowDateDialog(value)  (yyyy-MM-dd)
         */
        KDS_Native.showDateDialog.apply(KDS_Native, parameters);
    } else if (params.browser == "ios") {
        loadURL("KDS_Native://showDateDialog:" + parameters.join(':'));
    } else {
        console.log('showDateDialog, ' + parameters.join(', '));
    }

    // 原生回调函数
    window.handleShowDateDialog = function (value) {
        var idName = el.getAttribute("id");
        value = new Date(value).Format("yyyyMMdd");
        console.log(idName + ": " + value);
        el.value = value;
    };
};

// 适当性改造 - 私募基金
dynamicLoading.js(getfirsthref(0) + "js/sdxgz/smjj.js");