//风险测评答题
var app = angular.module("dzqyRiskEvaluation", []);
var riskParam = {}; //风险测评，参数传递用
app.controller("dzqyRiskEvaluationController", function ($scope) {
    $scope.data = [];
    // 能否重测
    $scope.isRetest = true;
    $scope.isRetest = RESULTS_API.getIsRetest();

    requestQuestions($scope);

    /**
     * 重新测试
     */
    $scope.onRetestClick = function () {
        if ($scope.isRetest) {
            JumpInterface(params.viewKey.KDS_DZQY_RISK_EVALUATION, 8, 0);
        } else {
            Dialog.customAlert("您的账户无需重新进行风险测评，谢谢", "提示", "", { "exclamatoryIcoHide": "true" });
        }
    };

    $scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var bottomHeight = document.getElementById("fxcp-submit").clientHeight;
        $scope.topHeightStyle = "height:" + (totalHeight - bottomHeight) + "px";
    });
});

/**
 * 请求试题列表
 */
function requestQuestions($scope) {
    var url = "ptjy/zhyw/cpdacx";

    //客户属性（“0”：个人  “1”：机构）
    var khsx = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0].khsx;
    //题目类别
    var stfl = khsx == "0" ? "7" : "8";
    ajaxPost(getApiUrl() + url, { stfl: stfl, khsx: khsx }, function (response) {
        var stlb = response.stlb || [];
        var info = dealQuestion(stlb);
        $scope.data = info.result;
    });
}

/**
 * 解析柜台返回的试题数据
 */
function dealQuestion(questions) {
    var result = [],
        dic = {};
    var item, list, score, index, multipleIntValue;
    for (var i = 0, len = questions.length; i < len; i++) {
        que = questions[i];
        item = dic[que.tmbh];
        if (!item) {
            que.dxdx = que.xxlx;
            que.tmnr = que.tmnr;
            item = {
                itemId: que.tmbh, //题目Z编号
                title: que.tmbh + ". " + que.tmnr, //题目内容
                isObjective: que.zkg == '0' ? true : false, //客观题
                isMultiple: "1" === que.xxlx ? true : false //单选多选(0:单选 1:多选)
            };
            index = 0;
            result.push(item);
            dic[que.tmbh] = item;
            item.list = list = [];
            item.score = score = [];
            multipleIntValue = item.isMultiple ? 1 : 0;
        }

        //选择项 (客观题 && (柜台返回的选项 || (柜台返回的选项为空 && 默认第一项)))
        var checked = que.dabm.split(",").indexOf(que.xxbm) != -1 ? true : false;

        score.push(que.xxfz);
        list.push({
            index: index,
            wordIndex: que.xxbm,
            name: que.xxnr,
            checked: checked //选中的
        });
        index++;
    }

    return {
        result: result
    };
}

/**
 * 判断是否需要重新测评
 */
var RESULTS_API = function () {
    var localKey = "risk-evluation-info";

    var data = JSON.parse(getLocalData(localKey) || "{}");
    data = data[data.currentType] || {};

    function getIsRetest() {
        var nfcc = data.nfcc;
        return nfcc && nfcc == '1' ? true : false;
    }
    return {
        getIsRetest: getIsRetest
    };
}();