var app = angular.module("evaluationResult", []);

/*
{
    "ptjyRisk": {
        "khfxdj": "中等风险承受能力客户",
        "khfxdjsm": "中等风险承受能力客户",
        "cpdf": "49.00",
        "nfcc": "0",                                     // 0:否  1:是
        "cprq": "20171013",
        "tzzfl": "0",                                    // [0: 普通投资者, 1: 专业投资者]
    },
    "currentType": "ptjyRisk"
}
*/
app.controller("evaluationResultController", function ($scope, $compile) {
    // 测评日期
    $scope.time = '';
    // 测试
    $scope.score = '';
    $scope.typeName = '';
    // 能否重测
    $scope.isRetest = true;
    // 是否专业投资者
    $scope.isProfessionalInvestors = false;

    $scope.time = RESULTS_API.getTime();
    $scope.score = RESULTS_API.getScore();
    $scope.typeName = RESULTS_API.getTypeName();
    $scope.isRetest = RESULTS_API.getIsRetest();
    $scope.isProfessionalInvestors = RESULTS_API.getIsProfessionalInvestors();

    /**
     * 完成
     */
    $scope.onFinishClick = function () {
        if (!gotoDirectedPage()) {
            JumpInterface(params.viewKey.KDS_PTJYIndex, 8, -100);
        }
    };

    /**
     * 查看结果
     */
    $scope.onViewResults = function () {
        if ($scope.isProfessionalInvestors) {
            professionalInvestorsAlert($scope, $compile);
        } else {
            JumpInterface(params.viewKey.KDS_DZQY_RTSK_CKJG, 8, 0);
        }
    };

    /**
     * 重新测试
     */
    $scope.onRetestClick = function () {
        if ($scope.isProfessionalInvestors) {
            professionalInvestorsAlert($scope, $compile);
        } else if ($scope.isRetest) {
            JumpInterface(params.viewKey.KDS_DZQY_RISK_EVALUATION, 8, 0);
        } else {
            var data = JSON.parse(getLocalData("risk-evluation-info") || "{}");
            data = data[data.currentType] || {};
            notRetestAlert($scope, $compile, data.xckcprq);
        }
    };
});

/**
 * 不能重测的弹框
 * @param  {[String]}  date         [下次可测评日期]
 * @param  {[boolean]} handleMethod [回调方法]
 */
function notRetestAlert($scope, $compile, date) {
    var v1 = '您下次可参与风险测评时间为 {{date}}。'.replace('{{date}}', date || '');

    var modal = {
        'title': '温馨信息',
        'msg': [{ class: 'align-left', 'value': '尊敬的客户：' }, { class: 'align-left', 'value': v1 }, { class: 'align-left', 'value': '您在每次更新个人信息或提供相应证明材料后，由于客观资料变更，都可重新进行一次风险测评。' }]
    };
    var options = {
        'isController': true,
        'firstBtnHide': true,
        'rightButtonClick': function rightButtonClick() {
            Dialog.closeAlert('modalTips');
        }
    };
    Dialog.alert($scope, $compile, modal, options);
}

function professionalInvestorsAlert($scope, $compile) {
    var modal = {
        'title': '温馨信息',
        'msg': [{ class: 'align-left', 'value': '尊敬的投资者您好，该风险测评问卷是我公司为普通投资者进行风险承受能力等级划分的依据，您已成为专业投资者无需填写问卷。' }]
    };
    var options = {
        'isController': true,
        'firstBtnHide': true,
        'rightButtonClick': function rightButtonClick() {
            Dialog.closeAlert('modalTips');
        }
    };
    Dialog.alert($scope, $compile, modal, options);
}

var RESULTS_API = function () {
    var localKey = "risk-evluation-info";

    var data = JSON.parse(getLocalData(localKey) || "{}");
    data = data[data.currentType] || {};

    function getScore() {
        var cpdf = data.cpdf;
        if (!isNaN(cpdf) && cpdf !== "") {
            return parseInt(cpdf);
        } else if (cpdf === '--') {
            return cpdf;
        }
        return '';
    }

    function getTypeName() {
        return data.khfxdjsm;
    }

    function getTime() {
        var dateStr = data.cprq;
        if (dateStr) {
            if (dateStr.length == 8) {
                dateStr = formatDate(dateStr, "yyyy-MM-dd");
            }
        } else {
            dateStr = new Date().Format('yyyy-MM-dd');
        }
        return dateStr;
    }

    function getIsRetest() {
        var nfcc = data.nfcc;
        return nfcc && nfcc == '1' ? true : false;
    }

    function getIsProfessionalInvestors() {
        var tzzfl = data.tzzfl;
        return tzzfl && tzzfl == '1' ? true : false;
    }

    return {
        getScore: getScore,
        getTypeName: getTypeName,
        getTime: getTime,
        getIsRetest: getIsRetest,
        getIsProfessionalInvestors: getIsProfessionalInvestors
    };
}();

$(function () {
    $('.fxcp-btn').click(function () {});

    function checked() {
        var $inputChed = [];
        var $inputNme = [];
        $('input:radio:checked').each(function (i) {
            $inputChed.push($(this).attr('name'));
        });
        $('input').each(function (i) {
            $inputNme.push($(this).attr("name"));
        });
        $.unique($inputNme);
        if ($inputChed.length == $inputNme.length) {
            $('.fxcp-submit .fxcp-btn').addClass('submit');
        }
    }
    setInterval(checked, 200);

    // 测评分数结果页面水波效果
    var waveOneinc = 0;
    var waveTwoinc = 25;
    var waveThreeinc = 35;
    setInterval(function () {
        $('#fxcpscore-header_wave-one').css('transform', 'rotate(' + waveOneinc + 'deg)');
        waveOneinc += 1.15;
        waveTwoinc += 1.25;
        waveThreeinc += 1.35;
        $('#fxcpscore-header_wave-two').css('transform', 'rotate(' + waveTwoinc + 'deg)');
        $('#fxcpscore-header_wave-three').css('transform', 'rotate(-' + waveThreeinc + 'deg)');
    }, 20);

    var $val = parseInt($('.fxcpscore-header_score em').text());

    if ($val == 0) {
        $('#fxcpscore-header_wave-one').css('top', '-80%');
        $('#fxcpscore-header_wave-two').css('top', '-85%');
        $('#fxcpscore-header_wave-three').css('top', '-83%');
    } else {
        $('#fxcpscore-header_wave-one').css('top', -($val + 80) + '%');
        $('#fxcpscore-header_wave-two').css('top', -($val + 85) + '%');
        $('#fxcpscore-header_wave-three').css('top', -($val + 83) + '%');
        if ($val >= 70 && $val <= 100) {
            $('#fxcpscore-header_container').css('background', 'linear-gradient(to bottom, rgba(253,152,129,0.7) 0%,rgba(253,152,129,1) 100%');
        }
    }
});