//风险测评答题
var app = angular.module("dzqyRiskEvaluation", []);
var riskParam = {}; //风险测评，参数传递用
app.controller("dzqyRiskEvaluationController", ["$scope", "QuestionList", function (scope, questionList) {
    var data = requestQuestions(scope, questionList);

    scope.onCellCheck = function (item, cell) {
        console.log('题目编号：' + item.itemId + '|' + cell.index);
        // 客户题，不能选择
        if (item.isObjective) {
            return;
        }

        if (item.isMultiple) {
            cell.checked = !cell.checked;
        } else {
            var list = item.list;
            //将其他置为不选
            for (var i = 0; i < list.length; i++) {
                list[i].checked = false;
            }
            cell.checked = true;
        }

        updateSubmitBtnState(scope);
    };

    //提交数据
    scope.onBtnClick = function () {
        var data = scope.data;
        var list;
        var isAllAnswer;

        var data = scope.data;
        for (var i = 0, len = data.length; i < len; i++) {
            list = data[i].list;
            isAllAnswer = false;
            for (var j = 0, lenJ = list.length; j < lenJ; j++) {
                var cell = list[j];
                if (cell.checked) {
                    isAllAnswer = true;
                    break;
                }
            }
            if (!isAllAnswer) {
                Dialog.customAlert("第 " + data[i].itemId + " 题没有回答，请回答后提交。", "提示");
                return;
            }
        }

        console.log('提交数据验证通过，准备提交...');
        var result = getSubmitData(questionList);
        submitAnswers(result);
    };

    scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var bottomHeight = document.getElementById("fxcp-submit").clientHeight;
        scope.topHeightStyle = "height:" + (totalHeight - bottomHeight) + "px";
    });
}]);

app.service("QuestionList", ["$rootScope", function (rootScope) {
    var service = {
        data: [],
        dic: {},
        submitBtnState: true
    };
    return service;
}]);

/**
 * 获取提交试题答案的数据
 */
function getSubmitData(questionList) {
    var dic = questionList.dic;
    var value = questionList.data;
    var numStr = "",
        selectedStr = "",
        scoreStr = "";
    var checkInfo, scoreArr, data, list, cell;
    var tempJ = -1;
    var finalScore = 0;
    for (var i = 0, len = value.length; i < len; i++) {
        data = value[i];
        numStr += data.itemId;
        scoreArr = dic[data.itemId].score;
        list = data.list;
        tempJ = -1;
        for (var j = 0, jLen = list.length; j < jLen; j++) {
            cell = list[j];
            if (cell.checked == true) {
                if (tempJ != -1) {
                    selectedStr += ",";
                    scoreStr += ",";
                }
                selectedStr += cell.wordIndex;
                scoreStr += scoreArr[j] || "";
                finalScore += parseInt(scoreArr[j]);
                tempJ = j;
            }
        }
        if (i != len - 1) {
            numStr += "|";
            selectedStr += "|";
            scoreStr += "|";
        }
    }
    return {
        numStr: numStr,
        selectedStr: selectedStr,
        scoreStr: scoreStr,
        finalScore: finalScore
    };
};

/**
 * 请求试题列表
 */
function requestQuestions(scope, questionList) {
    var url = "ptjy/zhyw/hqfxcpst";

    //客户属性（“0”：个人  “1”：机构）
    var khsx = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0].khsx;
    //题目类别
    var tmlb = khsx == "0" ? "7" : "8";
    ajaxPost(getApiUrl() + url, { tmlb: tmlb, khsx: khsx }, function (response) {
        var stlb = response.stlb || [];
        if (stlb.length > 0) {
            // 试题栏组,stlz  试题编号,stbh  题目编号,tmbh  选项编号,xxbh  选项内容,xxnr  选项得分,xxdf  试题内容,stnr  选项类型,xxnx
            var info = dealQuestion(stlb);
            questionList.data = info.result;
            questionList.dic = info.dic;
            riskParam.dcbbm = stlb[0].stbh || "";
            riskParam.dcblz = stlb[0].stlz;
            scope.data = info.result;

            //更新提交按钮的状态 (防止柜台返回数据全部是客观题时，没有更新页面提交按钮状态)
            updateSubmitBtnState(scope);
        }
    });
}

/**
 * 解析柜台返回的试题数据
 */
function dealQuestion(questions) {
    //dxdx(单选多选)   tmbh(题目编号)  tmnr(题目内容) xxbh(选项编号) xxbz(选项备注) xxdf(选项得分) xxnr(选项内容)
    //[{dxdx: "0", tmbh: "1", tmnr: "您目前所处的年龄阶段", xxbh: "a", xxbz: "", xxdf: "5", xxnr: "30岁以下"}]

    var result = [],
        dic = {};
    var item, list, score, index, multipleIntValue;
    for (var i = 0, len = questions.length; i < len; i++) {
        que = questions[i];
        item = dic[que.tmbh];
        if (!item) {
            que.dxdx = que.xxnx;
            que.tmnr = que.stnr;
            item = {
                itemId: que.tmbh, //题目Z编号
                title: que.tmbh + ". " + que.tmnr, //题目内容
                isObjective: que.zkg == '0' ? true : false, //客观题
                isMultiple: "1" === que.xxnx ? true : false //单选多选(0:单选 1:多选)
            };
            index = 0;
            result.push(item);
            dic[que.tmbh] = item;
            item.list = list = [];
            item.score = score = [];
            multipleIntValue = item.isMultiple ? 1 : 0;
        }

        //选择项 (客观题 && (柜台返回的选项 || (柜台返回的选项为空 && 默认第一项)))
        var checked = item.isObjective && (que.kgtda === "" && index == 0 || que.kgtda.split(",").indexOf(que.xxbh) != -1) ? true : false;

        score.push(que.xxdf);
        list.push({
            index: index,
            wordIndex: que.xxbh,
            name: que.xxnr,
            remark: que.remark,
            checked: checked //选中的
        });
        index++;
    }

    return {
        result: result,
        dic: dic
    };
}

//提交答案
function submitAnswers(result) {
    var url = "ptjy/zhyw/fxcpdt";

    //客户属性（“0”：个人  “1”：机构）
    var cpdcbbh = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0].khsx == "0" ? "7" : "8";
    var param = setDefaultJsonData({
        dcbbm: cpdcbbh,
        dcblm: result.numStr,
        dcbdy: result.selectedStr,
        dcblz: riskParam.dcblz
    });
    ajaxPost(getApiUrl() + url, param, function (response) {
        var fhxx = response.fhxx;
        if (fhxx && fhxx.length > 0) {
            var info = fhxx[0];
            //khfxdj(客户风险等级)   khfxdjsm(客户风险等级说明)  cpdf(测评得分) cprq(测评日期) nfcc(能否重测)
            var key = "risk-evluation-info";
            var localData = getLocalData(key) ? JSON.parse(getLocalData(key)) : {};
            var ptjyRisk = 'ptjyRisk';
            localData[ptjyRisk] = {
                khfxdj: info.pjjbmc,
                khfxdjsm: info.pjjbmc,
                cpdf: info.jcfz,
                cprq: info.cprq,
                nfcc: info.ccbz,
                pjjb: info.pjjb,
                bjjb: info.pjjbmc,
                tzqx: info.tzqxmc,
                tzpzmc: info.tzpzmc

            };
            localData.currentType = ptjyRisk;
            setLocalData(key, localData);
            setLocalData("page", "评估结果告知函");

            // 首次/重新测评的标识
            info.fxcpType = '0';
            setLocalData('KDS_SET_RISK_LEVEL_INFO', JSON.stringify(info));

            JumpInterface(params.viewKey.KDS_DZQY_GZH, 8, 2);
        }
    });
};

/**
 * 更新提交按钮的状态
 */
function updateSubmitBtnState(scope) {
    var data = scope.data;
    for (var i = 0, len = data.length; i < len; i++) {
        var checked = false;
        var list = data[i].list;
        for (var j = 0, lenJ = list.length; j < lenJ; j++) {
            var cell = list[j];
            if (cell.checked) {
                checked = true;
                break;
            }
        }
        if (!checked) {
            scope.submitBtnState = false;
            return;
        }
    }

    scope.submitBtnState = true;
}