//协议签约
var app = angular.module("dzyqRiskTip", []);

app.controller("dzyqRiskTipController", ["$scope", "Agreement", "$compile", function (scope, Agreement, compile) {
    //侦听数据改变
    scope.$on("agreement.update", function (event) {
        scope.agreement = Agreement.agreement;
        // dzxyqyzt(签约状态 0:已签约 1:未签约)
        updateBtn(Agreement.agreement, scope);
    });
    var agreement = Agreement.agreement;
    scope.agreement = agreement;
    //按钮颜色
    //var colors = {red: "#ff5c57", blue: "#43acff"};
    scope.onBtnClick = function () {
        var status = agreement.dzxyqyzt.toString();
        if ("1" == status) {
            //未签收状态，直接发送协议
            agreementSigningNet(function (value) {
                if (value == true) {
                    //成功
                    Agreement.alertTextStatus = 1;
                    showBox(Agreement, scope, compile);
                }
            }, agreement);
        } else if ("0" == status) {
            //已经签署，先弹出确认框
            showBox(Agreement, scope, compile);
        }
    };

    //确定回调
    scope.Ensure = function () {
        // 关闭模态框
        Dialog.closeAlert();

        var textStatus = Agreement.alertTextStatus;
        if (textStatus == 1) {
            Agreement.updateStatus({ dzxyqyzt: 0 });
            Agreement.alertTextStatus = 2;
        } else if (textStatus == 2) {
            //已经签署过协议，点击确定了再发送协议
            revokeAgreementnet(function (value) {
                if (value == true) {
                    //撤销成功
                    Agreement.alertTextStatus = 3;
                    showBox(Agreement, scope, compile);
                }
            }, agreement);
        } else if (textStatus == 3) {
            Agreement.alertTextStatus = 1;
            Agreement.updateStatus({ dzxyqyzt: 1 });
        }
    };

    scope.$watch('$viewContentLoaded', function () {
        //设置高度
        setHeight();
    });
}]);

function setHeight() {
    // 设置表格内容区域的高度
    setTimeout(function () {
        var footer = $("footer"),
            srcollArea = $(".scroll-area"),
            height = document.documentElement.clientHeight;

        footer = footer.length > 0 ? footer.height() : 0;
        height = height - srcollArea.offset().top - footer;

        srcollArea.height(height);
    }, 200);
}

//更新按钮
function updateBtn(agreement, scope) {
    var isSigned = "0" == agreement.dzxyqyzt.toString();
    var colorbg = isSigned ? "#43acff" : "#ff5c57";
    scope.buttonColorStyle = "background:" + colorbg;
    scope.btnText = getBtnText(isSigned);
}

//将协议设置为一个公共的服务数据
app.service("Agreement", ["$rootScope", function ($rootScope) {
    var service = {
        agreement: {},
        //弹出框文字状态
        alertTextStatus: 1,
        updateStatus: function updateStatus(info) {
            agreement = service.agreement;
            for (var key in info) {
                agreement[key] = info[key];
            }
            service.alertTextStatus = "0" == agreement.dzxyqyzt.toString() ? 2 : 1;
            $rootScope.$broadcast("agreement.update");
        }
    };
    requestAgreement(service.updateStatus);
    return service;
}]);

//---------------弹出框----------------
function showBox(Agreement, $scope, $compile) {
    var alertObj = getAlertText(Agreement.alertTextStatus);
    var modal = {};

    modal['title'] = alertObj.title;

    modal['msg'] = [{ value: alertObj.context }];
    if (alertObj.cancelText) {
        Dialog.alert($scope, $compile, modal);
    } else {
        //showAlert (alertObj.title,alertObj.context);
        Dialog.successAlert(modal['msg'][0].value, modal['title'], false);
        Dialog.confirm = function () {
            requestAgreement(Agreement.updateStatus);

            // 关闭模态框
            Dialog.closeAlert();
        };
    }
}

//-----------获取弹出框（按钮）文字----------------
//获取底部按钮文字
function getBtnText(status) {
    var text;
    if (status == false) {
        text = "已阅读并接受";
    } else {
        text = "您已签约，是否需要撤销签约？";
    }
    return text;
}

//获取弹出框的文本
function getAlertText(alertTextStatus) {
    var title;
    var context;
    var cancelText;
    //1 签署协议成功弹出， 2 撤销协议弹出  3 撤销成功提示
    if (alertTextStatus == 1) {
        title = "提示";
        context = "协议签署成功";
    } else if (alertTextStatus == 2) {
        title = "撤销确认";
        context = "您确定需要撤销当前协议的签约吗";
        cancelText = "取消";
    } else if (alertTextStatus == 3) {
        title = "提示";
        context = "协议撤销成功";
    }
    return { title: title, context: context, cancelText: cancelText };
}

//------------协议部分-----------------------
//请求协议
function requestAgreement(updateStatusFun) {
    var key = "dzqy-request-agreement-info";
    //{dzqyxymc:"深交所A股退市整理",dzqyxylx:"0",filename:"dzqy - sztszl.txt",dsfzjzhxylx:"2",dsfdzqyxylx:"3",dsfqycxxylx:"3",display:"1",cpdm:"",qyzhlx:"0",gddm:"0108443026",jysdm:"0",jysjc:"深Ａ",showTitle:"深交所A股退市整理深交所A股退市整理（0108443026）",iconSrc:"../../../../images/icon_agreement_delist.svg"}
    var loadInfo = getLocalData(key);
    if (loadInfo) {
        loadInfo = JSON.parse(loadInfo);
    }
    if (loadInfo) {
        document.title = loadInfo.dzqyxymc;
        var param = {
            "qyzhlx": loadInfo.qyzhlx, //签约账户类型
            "qyzh": loadInfo.gddm, //签约账户
            "dsfdzqyxylx": loadInfo.dsfdzqyxylx, //第三方电子签约协议类型
            "dsfqycxxylx": loadInfo.dsfqycxxylx, //第三方签约查询协议类型
            "dsfzjzhxylx": loadInfo.dsfzjzhxylx, //第三方资金账号协议类型
            "filename": loadInfo.filename //协议文本名称
        };
    }
    ajaxPost(getApiUrl() + "ptjy/dzqy/xyqyqkcx", param, function (response) {
        //dzxyqyzt(签约状态)  dzxynr(协议内容)
        var info = response.cxlb[0];
        loadInfo["dzxyqyzt"] = info.dzxyqyzt;
        var str = info.dzxynr;
        var replaceStr = "\n";
        var finalStr = "<br/>";
        str = str.replace(new RegExp(replaceStr, 'g'), finalStr);
        loadInfo["dzxynr"] = str;
        $("#kmc-dzqyFxts-text").html(str);
        updateStatusFun(loadInfo);
    });
};

//发送协议签署网络请求
function agreementSigningNet(callBack, agreement) {
    var param = {
        "qyzhlx": agreement.qyzhlx, //签约账户类型
        "qyzh": agreement.gddm, //签约账户
        "dsfdzqyxylx": agreement.dsfdzqyxylx, //第三方电子签约协议类型
        "dsfzjzhxylx": agreement.dsfzjzhxylx, //第三方资金账号协议类型
        "dzqyxylx": agreement.dzqyxylx, //协议类型
        "filename": agreement.filename //协议文本名称
    };
    ajaxPost(getApiUrl() + "ptjy/dzqy/xyqs", param, function (response) {
        var fhxx = response.fhxx;
        //[ 状态,                     status,         VARCHAR,    10,           "0:成功"             ]
        if (fhxx && fhxx.length > 0) {
            callBack("0" == fhxx[0].status.toString());
        }
    });
};

//取消协议网络请求
function revokeAgreementnet(callBack, agreement) {
    ajaxPost(getApiUrl() + "ptjy/dzqy/xycx", {
        "qyzhlx": agreement.qyzhlx, //签约账户类型
        "qyzh": agreement.gddm, //签约账户
        "dsfdzqyxylx": agreement.dsfdzqyxylx, //第三方电子签约协议类型
        "dzqyxylx": agreement.dzqyxylx //协议类型
    }, function (response) {
        var fhxx = response.fhxx;
        if (fhxx && fhxx.length > 0) {
            callBack("0" == fhxx[0].status.toString());
        }
    });
};