//电子签约列表
var app = angular.module("agreementList", []);

app.controller("agreementListController", function ($scope) {
    // 获取协议列表数据
    requestData($scope);

    /**
     * 点击协议列表项的事件
     * @param  {[type]} item [项的数据]
     */
    $scope.onCellClick = function (item) {
        setLocalData("dzqy-request-agreement-info", item);
        if ("TYF" == item.dzqyxylx.toString()) {
            //综合业务风险测评（暨登录那里的测评）
            ajaxPost(getApiUrl() + "ptjy/zhyw/fxcpjgcx", {}, parseFXCPJGCX);
        } else {
            //协议签署类型
            JumpInterface(params.viewKey.KDS_DZQY_RISK_TIP, 8, 1);
        }
    };
});

//请求数据
function requestData($scope) {
    ajaxPost(getApiUrl() + "ptjy/dzqy/dzxylbcx", {}, function (response) {
        var cxlb = response.cxlb || [];
        //dzqyxyxh(协议序号)  dzqyxylx(协议类型 0:退市整理 1：ST风险警示)  dzqyxymc(协议名称)  display(是否显示 0不显示；1显示)  qyzhlx(签约账户类型)  dsfdzqyxylx(第三方电子签约协议类型)  dsfqycxxylx(第三方签约查询协议类型)  dsfzjzhxylx(第三方资金账号协议类型)  filename(协议文本名称)

        var result = [];
        var obj = getGDLVObj();
        var item;
        for (var i = 0; i < cxlb.length; i++) {
            item = cxlb[i];
            if ("1" == item.display.toString()) {
                this.setItems(item, obj, result);
            }
        }
        $scope.list = result;
    });
};

function getGDLVObj() {

    var localInfo = getLocalData("ActivePTJYUser");
    var gdlb;
    if (localInfo) {
        gdlb = JSON.parse(localInfo).body.gdlb;
    } else {
        gdlb = [];
    }
    var obj = {};
    var temp;
    for (var i = 0; i < gdlb.length; i++) {
        if (obj[gdlb[i].jysdm]) {
            temp = obj[gdlb[i].jysdm];
            temp.push(gdlb[i]);
        } else {
            temp = [];
            temp.push(gdlb[i]);
            obj[gdlb[i].jysdm] = temp;
        }
    }
    return obj;
};

function setItems(item, obj, result) {

    //答题类型，没有签约账户类型，直接加入列表
    if (!item.qyzhlx) {
        var isShow = false;
        if ("F" == item.dzqyxylx.toString()) {
            //基金风险测评
            isShow = true;
        } else if ("TYF" == item.dzqyxylx.toString()) {
            isShow = true;
            var localData = getLocalData("ActivePTJYUser");
            if (localData) {
                var zjzh = JSON.parse(localData)['head'].khbz;
                // 风险评测过滤235、237开头的资金账号，和6位及以下长度的资金账号，不做风险测评    2016.08.02 update
                if (zjzh.length < 6 || ["235", "237"].indexOf(zjzh.substr(0, 3)) > -1) {
                    var isShow = false;
                }
            }
        }
        if (isShow) {
            result.push(this.setContentProppity(item, null, false));
        }
    } else {
        //交易所代码为key
        var arr = obj[item.qyzhlx.toString()];
        if (arr) {
            if (arr.length > 1) {
                for (var i = 0; i < arr.length; i++) {
                    result.push(this.setContentProppity(getClone(item), arr[i], true));
                }
            } else {
                result.push(this.setContentProppity(item, arr[0], false));
            }
        }
    }

    function getClone(item) {
        var value = {};
        for (var key in item) {
            value[key] = item[key];
        }
        return value;
    }
};

/** 设置属性*/
function setContentProppity(item, addProp, showNumber) {
    if (addProp) {
        for (var key in addProp) {
            item[key] = addProp[key];
        }
    }
    item["showTitle"] = item.dzqyxymc;
    if (showNumber) {
        item["showTitle"] += "（" + item.gddm + "）";
    }

    var dzqyxylx = item.dzqyxylx.toString();
    var src = "../../../../images/icon_agreement_delist.svg";
    if ("1" == dzqyxylx) {
        src = "../../../../images/icon_agreement_risk_prompt.svg";
    } else if ("F" == dzqyxylx) {
        src = "../../../../images/icon_risk_evaluation.svg";
    } else if ("TYF" == dzqyxylx) {
        src = "../../../../images/icon_risk_evaluation.svg";
    }
    item.iconSrc = src;
    return item;
}

/**
 * 不能重测的弹框
 * @param  {[String]}  date         [下次可测评日期]
 * @param  {[boolean]} handleMethod [回调方法]
 */
function notRetestAlert(date, handleMethod) {
    var content = '您目前不能重复风险测评，下次可测评日期 {{date}}。'.replace('{{date}}', date || '');
    Dialog.customAlert(content, "温馨信息");
    var temp = Dialog.confirm;
    Dialog.confirm = function () {
        temp();
        handleMethod();
        Dialog.confirm = temp;
    };
}

/**
 * 解析风险测评结果查询返回的数据
 * @param  {[type]} response [服务器返回的测评结果]
 */
function parseFXCPJGCX(response) {
    var key = 'risk-evluation-info';
    var info = response.fhxx;
    var pageUrl = params.viewKey.KDS_DZQY_RISK_START;
    // 需要弹框 - 提示不能重新测评
    var isAlert = false;
    if (info && info.length > 0) {
        //客户号,khh  预约流水号,yylsh  试题编码,stbm 测试评分,cspf  评级级别,pjjb  级别名称,jbmc  评级日期,pjrq   有效日期,yxrq   系统日期,xtsj
        info = info[0];

        if (info.tzzfl === '1') {
            // 专业投资者不做强制风险测评
            var localData = {
                'currentType': 'ptjyRisk',
                'ptjyRisk': {
                    'tzzfl': info.tzzfl,
                    'cprq': '--',
                    'cpdf': '--',
                    'khfxdjsm': '专业投资者'
                }
            };
            setLocalData(key, localData);
            pageUrl = params.viewKey.KDS_DZQY_RISK_RESULT;
        } else if ('-1' == info.pjjb.toString()) {// 未签约

        } else {
            var localData = getLocalData(key) ? JSON.parse(getLocalData(key)) : {};
            var riskType = 'ptjyRisk';
            localData[riskType] = {
                khfxdj: info.jbmc,
                khfxdjsm: info.jbmc,
                cpdf: info.cspf,
                cprq: info.pjrq,
                nfcc: info.nfcc,
                xckcprq: info.xckcprq
            };
            localData['currentType'] = riskType;
            setLocalData(key, localData);
            pageUrl = params.viewKey.KDS_DZQY_RISK_RESULT;
        }
    }
    JumpInterface(pageUrl, 8, 0);
}