var app = angular.module('xgmm', []);

app.controller('xgmmController', function ($rootScope, $scope, $http, $compile) {
    $scope.userAgent = navigator.userAgent;

    //资金密码修改是否显示
    $scope.isFundPasswordChangeShow = isFundPasswordChangeShow;
    if (!isFundPasswordChangeShow) {
        document.title = "修改交易密码";
    }

    //修改状态	成功/失败
    var updata_state = false;

    //scope.title = "修改密码";

    $scope.oldPwd = "原密码";

    $scope.newPwd = "新密码";

    $scope.confirmPwd = "确认密码";

    /*  lichuan  20150529*/

    $scope.validate = function () {
        var oldPwd = $('#oldPwd').val();
        var newPwd = MyKeyboard.callNativeQueryKeyboardText('pwd_input_newPwd');
        var confirmPwd = MyKeyboard.callNativeQueryKeyboardText('pwd_input_confirmPwd');
        var newPwdLength = MyKeyboard.callNativeQueryKeyboardLength('pwd_input_newPwd');
        var confirmPwdLength = MyKeyboard.callNativeQueryKeyboardLength('pwd_input_confirmPwd');
        newPwd = newPwdLength == 0 ? '' : newPwd;
        confirmPwd = confirmPwdLength == 0 ? '' : confirmPwd;

        if (oldPwd.length == 0) {
            //showAlert("原密码不能为空!","提示信息");
            showMessageTips("请输入原密码!", "7");
            return false;
        }

        if (newPwdLength == 0) {
            //showAlert("请输入你的新密码!","提示信息");
            showMessageTips("请输入新密码!", "7");
            return false;
        }
        if (newPwdLength < 6) {
            if (isLimitPasswordLength) {
                showMessageTips("密码不能少于六位!", "7");
                return false;
            }
        }
        if (confirmPwdLength == 0) {
            //showAlert("请输入确认密码!","提示信息");
            showMessageTips("请输入确认密码!", "7");
            return false;
        }

        if (newPwd != confirmPwd) {
            //showAlert("两次输入密码不一致!","提示信息");
            showMessageTips("两次输入的新密码不一致!", "7");
            return false;
        }

        return true;
    };

    $scope.change = function () {

        var url = "";

        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_newPwd');
        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_confirmPwd');

        if (this.validate()) {
            var oldPwd = $('#oldPwd').val();
            var newPwd = MyKeyboard.callNativeQueryKeyboardText('pwd_input_newPwd');

            if (flag) {
                url = getApiUrl() + "ptjy/ptyw/xgjymm";
                var request = { xjymm: newPwd };

                // 交易密码使用新密码, 不能使用固定公共参数中的交易密码
                request.jymm = oldPwd;
            } else {
                url = getApiUrl() + "ptjy/ptyw/xgzjmm";
                var request = { xzjmm: newPwd, yzjmm: oldPwd };
            }

            request['mmjmzlx'] = '1';

            updata_state = false;

            ajaxPost(url, request, function (response) {
                updata_state = true;
                showModal(params.message.xgmm_success);
            });
        }
    };

    /*====================================================
     函数功能：显示弹出框
     ====================================================*/
    function showModal(obj) {
        var modal = {};

        modal['title'] = "修改密码";

        modal['msg'] = [{ value: obj }];

        Dialog.successAlert(modal['msg'][0].value, modal['title'], false);

        // 修改密码成功，点击确认执行的方法
        Dialog.confirm = function () {
            // 关闭弹出框
            Dialog.closeAlert('CustomAlert');
            $scope.Ensure();
        };
    }

    //====================模态框确认按钮触发事件=============================
    $scope.Ensure = function () {

        $('#oldPwd').val("");
        MyKeyboard.onBindKeyboardEmpty('pwd_input_newPwd');
        MyKeyboard.onBindKeyboardEmpty('pwd_input_confirmPwd');

        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_newPwd');
        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_confirmPwd');

        // 修改交易密码成功时跳转到登录页面
        if (updata_state && flag) {
            // 清除登录信息
            ClearLoginInfo();

            // 跳转到原生登录页面
            loginToLocalWeb('', '2');
        }
    };

    var flag = true; //默认是交易密码修改，false为资金密码的修改
    $("#pwdType li").click(function () {
        switch ($(this).attr('mmlx')) {
            case 'jymm':
                flag = true;
                break;
            case 'zjmm':
                flag = false;
                break;
        }

        $("#pwdType li.active").removeClass("active");
        $(this).addClass("active");
        $('#oldPwd').val("");
        MyKeyboard.onBindKeyboardEmpty('pwd_input_newPwd');
        MyKeyboard.onBindKeyboardEmpty('pwd_input_confirmPwd');

        hideKeyBoard();
        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_newPwd');
        MyKeyboard.callNativeQueryKeyboardHide('pwd_input_confirmPwd');
    });
});

//触发键盘
function dispatchShowKeyboard(tag) {
    MyKeyboard.callNativeQueryKeyboardHide('pwd_input_newPwd');
    MyKeyboard.callNativeQueryKeyboardHide('pwd_input_confirmPwd');
    // 中信建投弹出系统键盘
    if (!isSystemKeyboard) {
        showKeyboard(tag, "3");
    }
}

// 点击安全键盘输入框时，关闭自定义键盘
$(".fake_input_wrap").children("input").click(function () {
    hideKeyBoard();
});

// 安全键盘
var keyboardKeyX = JSON.parse(getLocalData("KDS_ENCRYPT_KEY") || '{}').keyboardKeyX || '';
var keyboardKeyY = JSON.parse(getLocalData("KDS_ENCRYPT_KEY") || '{}').keyboardKeyY || '';
var ActiveUse = {};
if (params.ywlx == 'ptjy') {
    ActiveUse = JSON.parse(getLocalData("ActivePTJYUser") || '{}');
} else if (params.ywlx == 'rzrq') {
    ActiveUse = JSON.parse(getLocalData("ActiveRZRQUser") || '{}');
}
var myKeyboardConfig = {
    "encryption": true, //是否开启加密
    "encryptionID": false, //加密是否携带ID
    "encryptTypeData": { //开启了加密就必须配置XY秘钥，如果也原生配置了，这里也配置，那么优先采用这里的配置
        "encryptType": 0, //加密类型 0为XY加密 1位不可逆XY加密方法和原生类似，具体参考原生api EncryptType类  为1 时支持salt字段
        "keyX": keyboardKeyX, //秘钥keyX
        "keyY": keyboardKeyY, //秘钥keyY
        "random": false, //是否返回随机密文
        "random_seed_Str": "" //随机字符串 长度不足则会采取默认的随机密码串。
    },
    "page": 0, //默认显示的键盘页，一般键盘至少包含2页，具体可以通过原生得知键盘页总数
    "maxLength": 99, //表示输入框最多只能输入多少字符
    "minLength": 1, //表示键盘输入框u小长度(如果不需要使用密码策略，这里设置没有任何作用)
    //random keyPreview pressEffect都支持设置所有键盘页或单独某个键盘页支持数组[ ]和true和false
    "random": false, //是否随机 支持填写键盘页 键盘页[0]代表第一页开启随机其他都不开启随机, random:"true" 代表都开启随机 random:"false"都不开启随机
    "keyPreview": true, //和random一样支持填写数组表示 支持的1个或者多个用数组[0,1,2]表示这些键盘页开启, true和false表示所有键盘页按下的时候有或者没有放大镜显示
    "pressEffect": [0, 1], //同上支持单独设置每一个键盘页或者所有 键盘, 表示按下是否按下效果
    "disableCapture": true //禁止截屏，安卓独有字段。
};

MyKeyboard.setInputConfigJSBridge("pwd_input_newPwd", JSON.stringify(myKeyboardConfig));
MyKeyboard.setInputConfigJSBridge("pwd_input_confirmPwd", JSON.stringify(myKeyboardConfig));

$(window).load(function () {

    if (isSystemKeyboard) {
        //调用系统键盘
        $("input").removeAttr("readonly");
        // 输入框按钮处理
        $("body").on("keyup", "input", function () {
            judegSystemKeyboardInput(this, "ptjy_xgmm");
        });
    }
});

// 新密码长度被限制为 6 位，旧密码长度不限
if (isLimitNewPasswordLength) {
    fillInputContent = function fillInputContent(param) {
        if (param == "del") {
            var _value = $("#" + params.id).val();

            $("#" + params.id).val(_value.substring(0, _value.length - 1));
        } else {
            $("#" + params.id).val($("#" + params.id).val() + param);
        }
    };
}