var app = angular.module('rzrqIndex', []);
app.controller('rzrqIndexController', function ($rootScope, $scope, $http, $compile) {
    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.userAgent = navigator.userAgent;
    // 交易首页风格选择
    $scope.JYStyle = JYInterfaceStyle;
    // 新股申购是否显示
    $scope.isXGSGShow = isXGSGShow;
    //西藏同信不显示合约偿还顺序设置
    $scope.isHychsxcxShow = isHychsxcxShow;
    // 是否显示交易登录页的顶部登录按钮区域
    $scope.isShowTopLoginBtn = isShowTopLoginBtn;
    //交割单查询
    $scope.isJGDCXShow = isJGDCXShow;
    //是否显示首页“可取”字段
    $scope.isHomePageKQShow = isHomePageKQShow;
    //可融券证券是否显示
    $scope.isKRQZQShow = isKRQZQShow;
    //还券是否显示
    $scope.isHQShow = isHQShow;
    //融券卖出是否显示
    $scope.isRQMCShow = isRQMCShow;
    //融资负债是否显示
    $scope.isRZFZShow = isRZFZShow;
    //融券负债是否显示
    $scope.isRQFZShow = isRQFZShow;
    //信用资产是否显示
    $scope.isXYZCShow = isXYZCShow;
    // 首页多账号登录按钮是否显示
    $scope.isMultiUserBtnShow = isMultiUserBtnShow;
    //中信建投普通交易、融资融券首页样式显示设置2016.3.30 add
    $scope.isIphonClass = isIphonClass;
    //未登录首页，点击功能菜单，登录成功后，跳转到功能页面去 2016.4.7 add
    $scope.isRedirectJump = isRedirectJump;
    //不需要登录的菜单
    $scope.notNeedLoginMenu = notNeedLoginMenu;
    //普通交易和融资融券首页只显示总资产
    $scope.isPtjyAndRzRqHomeOnlyZzcShow = isPtjyAndRzRqHomeOnlyZzcShow;
    // 首页小眼睛图标默认图片名称
    $scope.eyeUrl = 'ptjy-home_eyeopen.png';

    var mmName = "normal";
    $scope.mmName = mmName;

    // 登录日志是否显示
    var isLoginLogShow = false;
    var loginLog = getLocalData("loginLog_rzrq");
    if (loginLog) {
        loginLog = JSON.parse(loginLog);
        $scope.loginLogDate = loginLog.date;
        $scope.loginLogTime = loginLog.time;
        isLoginLogShow = true;
        removeLocalData("loginLog_rzrq");
    }
    $scope.isLoginLogShow = isLoginLogShow;

    $scope.onLoginLogClick = function () {
        $("#loginLogInfo").hide(300);
    };

    // 清除跳转到担保品划转页面的本地变量
    if (getLocalData("jumpDBPHZ")) {
        removeLocalData("jumpDBPHZ");
    }
    // 清除持仓 行情 买入 卖出界面设置的证券代码信息
    if (getLocalData("zqdm")) {
        removeLocalData("zqdm");
    }

    if (document.title.trim() == "融资融券首页") {
        $scope.isShowExitButton = false;
    } else {
        $scope.isShowExitButton = true;
    }

    /**
     * title: 列表标题
     * imgsrc： 列表图片地址
     * url： 列表跳转地址
     * hasRefresh： 列表跳转后右上角是否显示刷新按钮，0为显示，非0不显示
     * direction： 列表跳转类型 1：下一级界面；2：重定向；0: 平级切换；-1：返回上一级界面； -100：返回到最上级界面
     * notNeedLogin： 列表跳转不需要登录（不添加此字段时默认为需要登录）
     * functionKey：功能KEY值
     * isHidden： 是否隐藏到页面中（true为不显示到页面，false为显示到页面，该字段为空时默认是显示到页面）
     */

    $scope.tbodyMenuOne = [{
        'btname': '开仓',
        'list': [{
            'title': '融资买入',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/mr.png',
            'url': params.viewKey.KDS_RZRQ_RZMR,
            'hasRefresh': '8',
            'direction': '1'
        }, {
            'title': '融券卖出',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/mc.png',
            'url': params.viewKey.KDS_RZRQ_RQMC,
            'hasRefresh': '8',
            'direction': '1',
            'isHidden': !isRQMCShow
        }, {
            'title': '撤单',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/cd.png',
            'url': params.viewKey.KDS_RZRQ_WTCD,
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '持仓',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/cc.png',
            'url': params.viewKey.KDS_RZRQ_CCCX,
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '当日委托',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/drwt.png',
            'url': params.viewKey.KDS_RZRQ_WTCX,
            'hasRefresh': '8',
            'direction': '1',
            'isHidden': !isHQShow
        }, {
            'title': '当日成交',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/drwt.png',
            'url': params.viewKey.KDS_RZRQ_CJCX,
            'hasRefresh': '8',
            'direction': '1',
            'isHidden': !isHQShow
        }, {
            'title': '信用资产负债',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/xyzcfz.png',
            'url': params.viewKey.KDS_RZRQ_XYZCFZ,
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '银证转账',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/yzzz.png',
            'url': params.viewKey.KDS_RZRQ_YZZZ,
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '查询',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/cx.png',
            'url': 'rzrq/cx/home.html',
            'hasRefresh': '8',
            'direction': '1',
            'notNeedLogin': true
        }, {
            'title': '风险提示',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/cx.png',
            'url': 'rzrq/fxts/fxts.html',
            'hasRefresh': '8',
            'direction': '1',
            'notNeedLogin': true
        }]
    }];

    $scope.tbodyMenuTwo = [{
        'btname': '偿还',
        'list': [{
            'title': '还款',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/hk.png',
            'url': params.viewKey.KDS_RZRQHuanKuan,
            'hasRefresh': '8',
            'direction': '1'
        }, {
            'title': '还券',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/hq.png',
            'url': params.viewKey.KDS_RZRQHuanQuan,
            'hasRefresh': '8',
            'direction': '1',
            'isHidden': !isHQShow
        }, {
            'title': '合约偿还顺序设置',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/hychsxsz.png',
            'url': params.viewKey.KDS_RZRQ_HYCHSXSX_Query,
            'hasRefresh': '0',
            'direction': '1',
            'isMoveLable': true,
            'isHidden': !isHychsxcxShow
        }, {
            'title': '合约展期',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/hyzq.png',
            'url': params.viewKey.KDS_RZRQ_HYZQ_Query,
            'hasRefresh': '0',
            'direction': '1'
        }]
    }, {
        'btname': '担保物买卖',
        'list': [{
            'title': '担保物买入',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/dbwmr.png',
            'url': params.viewKey.KDS_RZRQ_PTMR,
            'hasRefresh': '8',
            'direction': '1'
        }, {
            'title': '担保物卖出',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/dbwmc.png',
            'url': params.viewKey.KDS_RZRQ_PTMC,
            'hasRefresh': '8',
            'direction': '1'
        }, {
            'title': '担保物划转',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/dbwhz.png',
            'url': params.viewKey.KDS_RZRQ_DBPHZ,
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '新股申购',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/xgsg.png',
            'url': params.viewKey.KDS_RZRQ_XGSG,
            'hasRefresh': '0',
            'direction': '1',
            'isHidden': !isXGSGShow
        }, {
            'title': '可融资查询',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/krzcx.png',
            'url': 'rzrq/krzcx/krzcx.html',
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '可融券查询',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/krqcx.png',
            'url': 'rzrq/krqcx/krqcx.html',
            'hasRefresh': '0',
            'direction': '1'
        }, {
            'title': '可充抵保证金证券',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/kcdbzjzq.png',
            'url': 'rzrq/kcdbzjzq/kcdbzjzq.html',
            'hasRefresh': '0',
            'direction': '1'
        }]
    }, {
        'btname': '其他',
        'list': [{
            'title': '风险测评',
            'imgsrc': '../../../images/icon_ptjy/menu_icon/dzqy.png',
            'url': params.viewKey.KDS_RZRQ_DZQY_RISK_RESULT,
            'hasRefresh': '0',
            'direction': '1',
            'beforeClick': riskAssessmentCallback
        }, {
            'title': '额度申请',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/edsq.png',
            'url': params.viewKey.KDS_RZRQ_EDSQ,
            'hasRefresh': '8',
            'direction': '1'
        }, {
            'title': '修改密码',
            'imgsrc': '../../../images/icon_rzrq/menu_icon/xgmm.png',
            'url': params.viewKey.KDS_RZRQ_XGMM,
            'hasRefresh': '8',
            'direction': '1'
        }]
    }];

    // 点击盈亏分析按钮的事件
    $scope.handleProfitLossAnalysis = function () {
        var userInfo = null;
        try {
            userInfo = JSON.parse(getLocalData('ActiveRZRQUser'));
        } catch (e) {}

        if (!userInfo) {
            return;
        }

        var dlxx = userInfo.body.dlxx[0];
        var paramJson = {
            'khdm': dlxx.khdm,
            'khbzlx': userInfo.head.khbzlx,
            'khbz': userInfo.head.khbz,
            'jymm': userInfo.head.jymm,
            'sessionid': dlxx.sessionid || '0',
            'yybdm': dlxx.yybdm,
            'token': dlxx.token || '0',
            'khdbbh': userInfo.head.khdbbh,
            'lhxx': userInfo.head.lhxx
        };
        dsztgtzjzhsb(dlxx);
        onAgentEvent('交易_融资融券_盈亏分析', '', '');
        APP.jumpToNativeInterface('0', 'KDS_Native_Profit_Loss_Analysis', JSON.stringify(paramJson));
    };

    if ($("body").hasClass("rzrq-header")) {
        $scope.itemClick = function (row) {
            var pageText = row.title;
            setLocalData("page", pageText);

            // 埋点
            onAgentEvent('交易_融资融券_' + row.title, '', '');

            // 没有手机号码注册且不在不需要登录的数组中
            if (!getIsRegister() && !row.notNeedLogin) {
                Dialog.customAlert("请先进行手机号码登录", "登录提示", true);

                // 手机号注册认证点击确定按钮事件
                Dialog.confirm = function () {
                    showRegisterView();
                    $("#CustomAlert").remove();
                };

                return;
            } else {
                // 如果存在快捷跳转, 就删除快捷跳转标识
                if (getLocalData("quickJump")) {
                    removeLocalData("quickJump");
                }

                // 不需要登录就可以跳转
                if (row.notNeedLogin) {
                    JumpInterface(row.url, row.hasRefresh, row.direction);
                } else {
                    var url = row.url || '';
                    // 跳转到原生登录页面
                    loginToLocalWeb(url, '3');
                }
            }

            return false;
        };
    } else if ($("body").hasClass("rzrq-index")) {
        // 解决 IOS 上 angularjs 与 jquery 冲突的
        setTimeout(function () {
            ZJCX(true);
        }, 300);

        // 提供原生回调刷新页面数据
        handlePageBack = function handlePageBack() {
            RestoreTimeOut();
            ZJCX(true);
        };

        MultiAccountInit("rzrq");

        $scope.refreshBtn = $scope.refreshBtnTemp = function () {
            ZJCX(!$scope.isPtjyAndRzRqHomeOnlyZzcShow);
            // 30 秒后才能再次点击刷新按钮
            $scope.refreshBtn = null;
            setTimeout(function () {
                $scope.refreshBtn = $scope.refreshBtnTemp;
            }, 30 * 1000);
        };

        $scope.Logout = function () {
            var modal = {};

            modal["title"] = "退出确认";

            modal["msg"] = [{
                value: "确定要退出当前信用交易账号?"
            }];

            Dialog.alert($scope, $compile, modal);
        };

        $scope.Ensure = function () {
            onAgentEvent('交易_融资融券_退出登录', '', '');
            Logout();
        };

        $scope.itemClick = function (row) {
            if (typeof row.beforeClick === 'function') {
                row.beforeClick(row, $scope.itemClick);
                return;
            }

            // 重定向功能初始化（条件满足才执行）2016.04.07 add
            setLocalData("page", row.title);

            // 埋点
            onAgentEvent('交易_融资融券_' + row.title, '', '');

            JumpInterface(row.url, row.hasRefresh, row.direction);
        };
    }
    // 不同版本界面初始化
    setTimeout(function () {
        $("#contractMenu").text("合约查询");
    }, 500);

    $scope.DropPage = function () {
        var bool = $scope.isPtjyAndRzRqHomeOnlyZzcShow;
        $scope.isPtjyAndRzRqHomeOnlyZzcShow = !bool;
        ZJCX(bool);
        // 提供原生回调刷新页面数据
        handlePageBack = function handlePageBack() {
            ZJCX(bool);
        };
    };

    // 首页头部小眼睛按钮的状态
    if (getLocalData("rzrqZzcState") == 'true') {
        $scope.isShowEyeButton = true;
        $scope.eyeUrl = 'ptjy-home_eyeopen.png';
    } else if (getLocalData("rzrqZzcState") == 'false') {
        $scope.isShowEyeButton = false;
        $scope.eyeUrl = 'ptjy-home_eyeclose.png';
    } else {
        $scope.isShowEyeButton = true;
    }

    function isEyeTrue(bool, url) {
        $scope.isShowEyeButton = bool;
        setLocalData("rzrqZzcState", $scope.isShowEyeButton);
        $scope.eyeUrl = url;
    }

    $scope.ShoworHidden = function () {
        var getrzrqZzcState = getLocalData("rzrqZzcState");

        if (getrzrqZzcState == "false") {
            isEyeTrue(true, "ptjy-home_eyeopen.png");
            onAgentEvent('融资融券', '睁眼', '');
        } else {
            isEyeTrue(false, "ptjy-home_eyeclose.png");
            onAgentEvent('融资融券', '闭眼', '');
        }
    };
});

/**
 * 风险测评回调方法
 * @param  {[type]}   row      [菜单对象]
 * @param  {Function} callback [回调方法]
 */
function riskAssessmentCallback(row, callback) {
    if (window.isQueryFxcpjgcx) {
        return;
    } else {
        window.isQueryFxcpjgcx = true;
    }
    ajaxPost(getApiUrl() + "rzrq/zhyw/fxcpjgcx", {}, parseFXCPJGCX.bind(this, row, callback), null, {
        completeMethod: function completeMethod() {
            window.isQueryFxcpjgcx = undefined;
        }
    });
}

/**
 * 解析风险测评结果查询返回的数据
 * @param  {[type]} response [服务器返回的测评结果]
 */
function parseFXCPJGCX(row, callback, response) {
    var rowClone = clone(row);
    rowClone.beforeClick = null;
    rowClone.url = params.viewKey.KDS_RZRQ_DZQY_RISK_START;

    var key = 'risk-evluation-info';
    var info = response.fhxx;
    // 需要弹框 - 提示不能重新测评
    var isAlert = false;
    if (info && info.length > 0) {
        //客户号,khh  预约流水号,yylsh  试题编码,stbm 测试评分,cspf  评级级别,pjjb  级别名称,jbmc  评级日期,pjrq   有效日期,yxrq   系统日期,xtsj
        info = info[0];

        if (info.tzzfl === '1') {
            // 专业投资者不做强制风险测评
            var localData = {
                'currentType': 'rzrqRisk',
                'rzrqRisk': {
                    'tzzfl': info.tzzfl,
                    'cprq': '--',
                    'cpdf': '--',
                    'khfxdjsm': '专业投资者'
                }
            };
            setLocalData(key, localData);
            rowClone.url = params.viewKey.KDS_RZRQ_DZQY_RISK_RESULT;
        } else if ('-1' == info.pjjb.toString()) {// 未签约

        } else {
            var localData = getLocalData(key) ? JSON.parse(getLocalData(key)) : {};
            var riskType = 'rzrqRisk';
            localData[riskType] = {
                khfxdj: info.jbmc,
                khfxdjsm: info.jbmc,
                cpdf: info.cspf,
                cprq: info.pjrq,
                nfcc: info.nfcc,
                xckcprq: info.xckcprq
            };
            localData['currentType'] = riskType;
            setLocalData(key, localData);
            rowClone.url = params.viewKey.KDS_RZRQ_DZQY_RISK_RESULT;
        }
    }

    callback(rowClone);
}

//交易首页属性区域
app.directive("attributearea", function () {
    var attHtml = "rzrq_attributeThree.html";
    return {
        restrict: 'E',
        templateUrl: attHtml,
        replace: true
    };
});

//渲染完毕，调用
app.directive('onFinishRender', function ($timeout) {
    return {
        restrict: 'A',
        link: function link(scope, element, attr) {
            $timeout(function () {
                changeItemName();
            }, 50);
        }
    };
});

//改变项名称
function changeItemName() {
    if (!isRQMCShow) {
        $("#isRQMCShow").remove();
    }
    if (!isHQShow) {
        //还券是否显示
        $("#isHQShow").remove();
    }
    $("#dbphz").text("担保物划转");
    $("#dbpzq").text("可充抵保证金证券");

    //圆形按钮布局宽带平均分配
    var percent = parseInt(100 / $(".ul-main.cols-5 li").length);
    $(".ul-main.cols-5 li").each(function (index, item) {
        $(item).css("width", percent + "%");
    });
}

// 电商中台柜台资金账号申报
function dsztgtzjzhsb(dlxx) {
    var postData = {
        khzs: dlxx.khzs || dlxx.khdm || '',
        //[dlxx.khsx, 'jysm', 'gddm', dlxx.zjzh, dlxx.khdm].join(':')
        sbsj: ['', '', '', '', ''].join(':')
    };
    var options = {
        isloaddingrun: false,
        iserror: false,
        issuccess: false
    };

    ajaxPost(getApiUrl() + 'ptjy/ptyw/dsztgtzjzhsb', postData, function (response) {
        console.log(response);
    }, null, options);
}

app.directive('rzrqmenu', function () {
    return {
        restrict: 'E',
        templateUrl: "rzrq_menu.html",
        replace: true
    };
});

$(window).load(function () {
    FastClick.attach(document.body);
    //给个延时确保dom加载完成
    setTimeout(function () {
        bindMultiUserSwitchEvent();
        changeItemName();
    }, 200);
});