app.controller('rzrqDbphz', function ($rootScope, $scope, $http, $compile) {
    // 将angularJS变量全局化
    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.defaultState = function () {
        return {
            USER_KEY: "ActiveRZRQUser",

            page: getLocalData("page"),
            zqdm: '',
            marketId: '',
            subtype: '',
            zqmc: '',
            zqdmStyle: { 'width': '100%' },
            zqdmStyle50: { 'width': '50%' },
            price: '',
            volume: '',

            plus: "BtnPlusRed",
            minus: "BtnMinusRed",
            btn_color: "btn-buy",
            btn_name: "买入",
            type: "买入数量",
            mmlb: "B",
            volumePlaceholder: "请输入划转数量",
            volumePlaceholderDynamic: "请划转$1$2",

            // 可买卖数量查询接口
            kmmslcxUrl: 'rzrq/ptyw/dbphzkmmslcx2',

            // 当前使用的股东代码对象
            gddmCurrent: { gddm: '' },
            // 股东代码列表
            gddmList: [],
            // 当前使用的委托类型对象
            consignTypeCurrent: { value: '0', text: '限价委托', class: 'active' },
            // 委托类型列表
            consignTypeList: [],
            // 是否禁止委托价格输入框
            isDisabledPrice: false,
            // 是否停牌
            isTP: false,
            // 资金转入链接是否显示
            assetTransInShow: false,

            // 当前的担保品划转类型
            dbphzTypeCurrent: { value: '0', text: '普通转信用', class: 'active', wtlx: '28' },
            // 担保品划转类型列表
            dbphzTypeList: [{ value: '0', text: '普通转信用', class: 'active', wtlx: '28' }, { value: '1', text: '信用转普通', class: '', wtlx: '29' }],
            // 不需要开启定时刷新五档
            openInterval: false,
            // 防止重复提交标识
            isSubmit: false
        };
    };

    $scope.defaultTable = function () {
        return {
            url: 'rzrq/ptyw/dbpptzxycccx',
            thead: ['持仓股票', '盈亏/盈亏率', '持仓/可用', '成本/现价'],
            tbody: [['zqmc', 'zqdm'], ['yk', 'ykbl'], ['ccsl', 'kysl'], ['cbjg', 'dqjg']],
            data: null,
            emptyHint: '暂无数据'
        };
    };

    $scope.state = $scope.defaultState();
    $scope.table = $scope.defaultTable();

    // 自定义键盘输入回调方法
    window.fillInputContent = function (oldFillInputContent) {
        return function (param, marketId, subtype) {
            if (['zqdm', 'price', 'volume'].indexOf(params.id) > -1) {
                angular.element($("body")).scope().$apply(function () {
                    MMWD.fillInputContent($scope, param, marketId, subtype);
                });
            } else {
                if (typeof oldFillInputContent === 'function') {
                    oldFillInputContent(param, marketId, subtype);
                }
            }
        };
    }(window.fillInputContent);

    // 回原进入该界面后，再传入证券代码信息
    window.jumpToView = function (viewKey, zqdm, marketId, subtype) {
        $scope.clear();
        params.id = 'zqdm';
        window.fillInputContent(zqdm, marketId, subtype);
    };

    $scope.showKeyboard = function (id, type) {
        showKeyboard(id, type);
    };

    $scope.dbphzTypeClick = function (row, type) {
        if (type != 'clear') {
            $scope.clear('typeClick');
        }
        $scope.state.dbphzTypeList = $scope.state.dbphzTypeList.map(function (item) {
            item.class = row.value == item.value ? 'active' : '';
            return item;
        });
        $scope.state.dbphzTypeCurrent = row;
        if (row.value === '1') {
            $scope.table.url = 'rzrq/ptyw/cccx';
            $scope.table.data = null;
            $scope.cccx();
        } else {
            $scope.table.url = 'rzrq/ptyw/dbpptzxycccx';
            $scope.table.data = null;
            $scope.cccx();
        }
    };

    $scope.cccx = function () {
        var url = $scope.table.url;
        var postData = {
            cxfx: "1",
            dwc: "",
            qqhs: "1000",
            ywlx: "rzrq"
        };
        ajaxPost(getApiUrl() + url, postData, function (response) {
            $scope.table.data = response.cclb.map(function (item) {
                if (!isNaN(item.yk) && parseFloat(item.yk || '0') > 0) {
                    item.color = 'buy-color';
                } else if (!isNaN(item.yk) && parseFloat(item.yk || '0') < 0) {
                    item.color = 'green-color';
                } else {
                    item.color = '';
                }
                return item;
            });
        });
    };

    $scope.rowClick = function (row) {
        console.log('rowClick===', row);
        // getHZSL();

        $scope.clear();
        params.id = 'zqdm';
        MMWD.fillInputContent($scope, row.zqdm, row.hqscdm, row.hqgplx);
    };

    // 点击股东代码列表项
    $scope.selectedGddm = function (item) {
        $scope.state.gddmCurrent = item;
        MMWD.queryKMMSLCX();
    };

    $scope.showModal = function () {
        hideKeyBoard();
        if ($scope.state.isTP) {
            Dialog.customAlert("该股票已经停牌", "提示信息");
            return;
        }
        if ($scope.checkForm()) {
            var gddm = $scope.state.gddmCurrent.jysjc + ' ' + $scope.state.gddmCurrent.gddm;
            var modal = {};
            modal.title = '划转确认';
            modal.content = [{ key: '划转方向', value: $scope.state.dbphzTypeCurrent.text }, { key: '证券代码', value: $scope.state.zqdm }, { key: '证券名称', value: $scope.state.zqmc }, { key: '股东代码', value: gddm }, { key: '划转数量', value: $scope.state.volume }];
            modal.btnBeforeDynamic = { type: 'cageTips' };
            $scope.state.isSubmit = true;
            Dialog.alert($scope, $compile, modal, {
                rightIcoHide: true,
                rightButtonClick: $scope.showModalConfirm.bind(this)
            });
        }
    };

    $scope.showModalConfirm = function () {
        Dialog.closeAlert();
        console.log('$scope.showModalConfirm');
        // 防止重复提交
        if (!$scope.state.isSubmit) {
            return false;
        }
        $scope.state.isSubmit = false;

        var zjzh = '';
        try {
            zjzh = JSON.parse(getLocalData($scope.state.USER_KEY)).body.dlxx[0].zjzh;
        } catch (e) {}

        var postData = {
            zqdm: $scope.state.zqdm,
            wtsl: $scope.state.volume,
            zjzh: zjzh,
            jysdm: MMWD.getJysdm(),
            gddm: MMWD.getGddm()
        };

        var url = "rzrq/ptyw/dbpptzxy";
        // 信用转普通
        if ($scope.state.dbphzTypeCurrent.value == '1') {
            url = 'rzrq/ptyw/dbpxyzpt';
        }
        var title = '提示';
        ajaxPost(getApiUrl() + url, postData, function (response) {
            addUserStock($scope.state.consignTypeCurrent.text, $scope.state.zqdm, MMWD.getJysdm());
            Dialog.successAlert("委托提交成功,流水号：" + response.fhxx[0].wtxh, title);
            $scope.clear();
        }, function (response) {
            Dialog.errorAlert("委托提交失败：" + response.cljg[0].message, title);
        });
    };

    // 验证表单数据
    $scope.checkForm = function () {
        if ($scope.state.zqdm == '') {
            $("#zqdm").focus();
            return false;
        } else if ($scope.state.volume == '') {
            $("#volume").focus();
            return false;
        }
        return true;
    };

    $scope.clear = function (type) {
        var typeValue = $scope.state.dbphzTypeCurrent.value;
        var state = $scope.defaultState();
        $scope.state = state;
        if (typeValue != '0' && type != 'typeClick') {
            $scope.dbphzTypeClick($scope.state.dbphzTypeList[typeValue], 'clear');
        }
    };

    MMWD.queryKMMSLCX = function () {
        console.log('MMWD.queryKMMSLCX');
        var url = $scope.state.kmmslcxUrl;
        var postData = {
            zqdm: $scope.state.zqdm,
            jysdm: '',
            gddm: MMWD.getGddm(),
            wtjg: '',
            wtlx: $scope.state.dbphzTypeCurrent.wtlx,
            mmlb: 'S',
            hqscdm: $scope.state.marketId,
            hqgplx: $scope.state.subtype
        };

        var errorCallback = function errorCallback(response) {
            Dialog.customAlert(response.cljg[0].message, "提示信息");
            MMWD.clearZsl();
        };

        ajaxPost(getApiUrl() + url, postData, function (response) {
            var kmmxx = response.kmmxx[0];
            var gfkys = kmmxx.gfkys ? kmmxx.gfkys : '--';

            MMWD.setGddmList(kmmxx);
            MMWD.setZsl(kmmxx);
            $scope.state.volumePlaceholder = "可划转" + gfkys + "股";

            // lof 划转提示标志：0-不用提示, 1-需要提示
            if (kmmxx.lofhztsbz === '1') {
                DBPHZ.lofAlert($scope, $compile, kmmxx);
            }
        }, errorCallback);
    };

    $scope.$watch('$viewContentLoaded', function () {
        $scope.cccx();
        setTimeout(function () {
            calcScrollAreaHeight('.scroll-area');
        }, 0);
        MMWD.initZqdm($scope);
    });
});

/**
 * 1. 只与担保品划转业务逻辑相关；
 * 2. angularjs 之外的逻辑；
 */
var DBPHZ = function () {
    return {
        // LOF 担保品划转增加弹窗提示
        lofAlert: function lofAlert($scope, $compile, kmmxx) {
            var msg = ($scope.state.dbphzTypeCurrent.value == '0' ? kmmxx.lofhztshsptzxy : kmmxx.lofhztshsxyzpt) || '';
            var modal = {
                title: '温馨提示',
                msg: [{ value: msg }]
            };
            var options = {
                isController: true,
                firstBtnHide: true,
                rightButtonText: '知道了',
                rightButtonClick: function rightButtonClick() {
                    Dialog.closeAlert('modalTips');
                }
            };
            Dialog.alert($scope, $compile, modal, options);
        }
    };
}();