app.controller('rzrqHuanQuan', function ($rootScope, $scope, $http, $compile) {
    // 将angularJS变量全局化
    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.defaultState = function () {
        return {
            page: getLocalData("page"),
            zqdm: '',
            marketId: '',
            subtype: '',
            zqmc: '',
            zqdmStyle: { 'width': '100%' },
            zqdmStyle50: { 'width': '50%' },
            price: '',
            volume: '',

            plus: "BtnPlusRed",
            minus: "BtnMinusRed",
            btn_color: "btn-buy",
            btn_name: "买入",
            type: "买入数量",
            mmlb: "B",
            pricePlaceholder: '请输入委托价格',
            volumePlaceholder: "请输入买卖数量",
            volumePlaceholderDynamic: "",

            // 可买卖数量查询接口
            kmmslcxUrl: 'rzrq/ptyw/mqhqkmmslcx2',
            // 市价可买卖数量查询接口
            sjkmmslcxUrl: 'rzrq/ptyw/mqhqsjkmmslcx2',

            // 当前使用的股东代码对象
            gddmCurrent: { gddm: '' },
            // 股东代码列表
            gddmList: [],
            // 当前使用的委托类型对象
            consignTypeCurrent: { value: '0', text: '限价委托', class: 'active' },
            // 委托类型列表
            consignTypeList: [],
            // 是否禁止委托价格输入框
            isDisabledPrice: false,
            // 是否停牌
            isTP: false,
            // 资金转入链接是否显示
            assetTransInShow: true,
            // 是否科创板
            isKeChuangBan: false,

            // 当前的还款类型
            huanQuanTypeCurrent: { value: '0', text: '卖券还款', class: 'active' },
            // 还款类型列表
            huanQuanTypeList: [{ value: '0', text: '买券还券', class: 'active' }, { value: '1', text: '现券还券', class: '' }],

            // 资产负债信息
            zcfz: {
                // 可还资金
                zjkysF: '',
                // 融资金额
                rzjeF: '',
                // 融资利息及费用
                rzfyF: '',
                // 需还款额
                zfzjehjF: ''
            },

            // 还款金额
            hkje: '',
            // 防止重复提交标识
            isSubmit: false
        };
    };

    $scope.state = $scope.defaultState();

    // 自定义键盘输入回调方法
    window.fillInputContent = function (oldFillInputContent) {
        return function (param, marketId, subtype) {
            if (['zqdm', 'price', 'volume'].indexOf(params.id) > -1) {
                angular.element($("body")).scope().$apply(function () {
                    MMWD.fillInputContent($scope, param, marketId, subtype);
                });
            } else {
                if (typeof oldFillInputContent === 'function') {
                    oldFillInputContent(param, marketId, subtype);
                }
            }
        };
    }(window.fillInputContent);

    // 回原进入该界面后，再传入证券代码信息
    window.jumpToView = function (viewKey, zqdm, marketId, subtype) {
        $scope.clear();
        params.id = 'zqdm';
        window.fillInputContent(zqdm, marketId, subtype);
    };

    // 还款类型点击事件
    $scope.huanQuanTypeClick = function (row, type) {
        if (type != 'clear') {
            $scope.clear('typeClick');
        }
        $scope.state.huanQuanTypeList = $scope.state.huanQuanTypeList.map(function (item) {
            item.class = row.value == item.value ? 'active' : '';
            return item;
        });
        $scope.state.huanQuanTypeCurrent = row;
        if (row.value == '1') {
            $scope.state.volumePlaceholder = '请输入还券数量';
            $scope.state.volumePlaceholderDynamic = '可还券$1$2';
            $scope.state.kmmslcxUrl = 'rzrq/ptyw/zjhqkmmslcx2';
        }
    };

    $scope.showKeyboard = function (id, type) {
        var isSJWT = $scope.state.consignTypeCurrent.value != 0 && $scope.state.consignTypeCurrent.value != 30;
        if (id == 'price' && isSJWT && !$scope.state.isKeChuangBan) {
            return false;
        }
        showKeyboard(id, type);
    };

    // 显示持仓列表
    $scope.showHold = function () {
        // showHold();
        dynGenerateNode($scope, $compile, RightWindowDynamic);

        $scope.isTitleHide = true;
        $scope.thead = [{ name: '应还证券' }, { name: '负债' }];
        $scope.tbody = [['zqmc', 'zqdm'], ['dqfzsl']];
        $scope.emptyHint = '你没有应还券记录!';

        setTimeout(function () {
            var tableHeight = document.documentElement.clientHeight - $(".scrollTable").offset().top;
            $(".scrollTable").height(tableHeight);
        }, 0);

        var url = 'rzrq/ptyw/wpchycx';
        var postData = {
            qqhs: '1000',
            dwc: '',
            cxfx: params.cxfx
        };
        ajaxPost(getApiUrl() + url, postData, function (response) {
            var rowHolds = response.cxlb;
            $scope.rowHolds = rowHolds;
        });
    };

    // 关闭持仓列表的弹框
    $scope.closeModal = function () {
        Dialog.closeAlert("RightWindow");
    };

    // 点击持仓列表项
    $scope.fullBargainFrom = function (row) {
        $scope.closeModal();
        $scope.clear();
        params.id = 'zqdm';
        MMWD.fillInputContent($scope, row.zqdm, row.hqscdm, row.hqgplx);
    };

    // 点击委托类型列表项
    $scope.consignType = function (item) {
        $scope.state.consignTypeCurrent = item;
        var isSJWT = item.value != 0 && item.value != 30;
        if (isSJWT) {
            if ($scope.state.isKeChuangBan) {
                MMWD.updateWtjg('');
                $scope.state.isDisabledPrice = false;
                $scope.state.pricePlaceholder = '保护限价';
            } else {
                $scope.state.priceTemp = $scope.state.price;
                MMWD.updateWtjg('市价委托');
                $scope.state.isDisabledPrice = true;
                $scope.state.pricePlaceholder = '请输入委托价格';
            }
        } else {
            MMWD.updateWtjg($scope.state.realTimePrice || '');
            $scope.state.isDisabledPrice = false;
            $scope.state.pricePlaceholder = '请输入委托价格';
        }
    };

    // 点击股东代码列表项
    $scope.selectedGddm = function (item) {
        $scope.state.gddmCurrent = item;
        MMWD.queryKMMSLCX();
    };

    // 委托价格修改(按钮)
    $scope.wtjgChang = function (type) {
        MMWD.wtjgChang(type);
    };

    $scope.inputPriceBlur = function () {
        if ($scope.state.zqdm != '' && $scope.state.price != '') {
            MMWD.queryKMMSLCX(false, { isloaddingrun: false });
        }
    };

    // 修改委托价格 (最新价、涨停、跌停、五档)
    $scope.updateWtjg = function (value) {
        if (value == '' || value == '--') {
            return;
        }
        if (MMWD.isSJWT() && !$scope.state.isKeChuangBan) {
            return;
        }
        MMWD.updateWtjg(value);
    };

    // 委托数量修改(按钮)
    $scope.wtslChang = function (type) {
        MMWD.wtslChang(type);
    };

    // 仓位按钮
    $scope.calcDepot = function (type) {
        MMWD.calcDepot(type);
    };

    $scope.showModal = function () {
        hideKeyBoard();
        if ($scope.state.isTP) {
            Dialog.customAlert("该股票已经停牌", "提示信息");
            return;
        }
        if ($scope.checkForm()) {
            var wtlx = $scope.state.consignTypeCurrent.value;
            var isSJWT = wtlx != 0 && wtlx != 30;
            var modal = {};
            modal.title = '买券还券确认';
            modal.content = [{ key: '证券代码', value: $scope.state.zqdm }, { key: '证券名称', value: $scope.state.zqmc }, { key: '委托价格', value: $scope.state.price }, { key: '委托数量', value: $scope.state.volume }];
            if (isSJWT && $scope.state.isKeChuangBan) {
                modal.content[modal.content.length - 2].key = '保护限价';
                modal.content.splice([modal.content.length - 2], 0, { key: '委托价格', value: '市价委托' });
            }
            modal.btnBeforeDynamic = { type: 'cageTips' };
            $scope.state.isSubmit = true;
            Dialog.alert($scope, $compile, modal, {
                rightIcoHide: true,
                rightButtonClick: $scope.showModalConfirm.bind(this)
            });
        }
    };

    $scope.showModalConfirm = function () {
        // 防止重复提交
        if (!$scope.state.isSubmit) {
            return false;
        }
        $scope.state.isSubmit = false;
        Dialog.closeAlert();
        var postData = {
            zqdm: $scope.state.zqdm,
            jysdm: MMWD.getJysdm(),
            gddm: MMWD.getGddm(),
            wtlx: $scope.state.consignTypeCurrent.value,
            wtjg: $scope.state.price,
            wtsl: $scope.state.volume
        };

        var isSJWT = postData.wtlx != 0 && postData.wtlx != 30;
        // 市价委托
        if (isSJWT && !$scope.state.isKeChuangBan) {
            postData.wtjg = '1';
        }

        var options = {
            specifyServerErrorCode: [],
            specifyServerErrorCodeMethod: function specifyServerErrorCodeMethod() {}
        };
        // 普通交易引用 科创板 模块
        KCB.init(options);

        var url = 'rzrq/ptyw/mqhq';
        var title = '提示';
        ajaxPost(getApiUrl() + url, postData, function (response) {
            addUserStock($scope.state.consignTypeCurrent.text, $scope.state.zqdm, MMWD.getJysdm());
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].htxh, title);
            $scope.clear();
        }, function (response) {
            Dialog.errorAlert("委托提交失败：" + response.cljg[0].message, title);
        }, options);
    };

    // 点击参考价格回调事件
    $scope.onClickReferencePriceValue = function (value) {
        if (value) {
            MMWD.updateWtjg(value);
        }
    };

    // 点击参考价格旁边问号的回调事件
    $scope.onClickReferencePricWenhao = function () {
        Dialog.customAlert($scope.state.kcbLimitMessage, "温馨提示", false, { rightButtonText: "知道了" });
    };

    // 点击 `全仓` 旁边问号的回调事件，跳转到 `交易规则` 页面
    $scope.onClickJygzWenhao = function () {
        openThirdPartyWebInterface('0', params.THIRD_PARTY_WEB_URL.JYGZ_KEY_URL);
    };

    // 验证表单数据
    $scope.checkForm = function () {
        if ($scope.state.zqdm == '') {
            $("#zqdm").focus();
            return false;
        } else if ($scope.state.price == '') {
            $("#price").focus();
            MMWD.kcbWarning($scope.state.mmlb);
            return false;
        } else if ($scope.state.volume == '') {
            $("#volume").focus();
            return false;
        }
        return true;
    };

    // 现金还款查询
    $scope.zcfzcx = function () {
        var url = getApiUrl() + 'rzrq/ptyw/zcfzcx';
        var postData = {
            hbdm: '0',
            ywlx: 'rzrq'
        };
        ajaxPost(url, postData, function (response) {
            var item = response.cxlb[0];
            $scope.state.zcfz = {
                zjkys: item.zjkys,
                zjkysF: formatNumber(item.zjkys),
                rzje: item.rzbj,
                rzjeF: formatNumber(item.rzbj),
                rzfy: item.rzfzxf,
                rzfyF: formatNumber(item.rzfzxf),
                zfzjehj: item.zfzjehj,
                zfzjehjF: formatNumber(item.zfzjehj)
            };
        });
    };

    // 现券还券确认框
    $scope.showModalXqhq = function () {
        if ($scope.state.volume != '') {
            var modal = {};
            modal.title = '现券还券确认';
            modal.content = [{ key: '证券代码', value: $scope.state.zqdm }, { key: '证券名称', value: $scope.state.zqmc }, { key: '还券数量', value: $scope.state.volume }];
            $scope.state.isSubmit = true;
            Dialog.alert($scope, $compile, modal, {
                rightIcoHide: true,
                rightButtonClick: $scope.showModalXqhqConfirm.bind(this)
            });
        }
    };

    // 现券还券提交
    $scope.showModalXqhqConfirm = function () {
        Dialog.closeAlert();
        console.log('$scope.showModalConfirm');
        // 防止重复提交
        if (!$scope.state.isSubmit) {
            return false;
        }
        $scope.state.isSubmit = false;

        var postData = {
            zqdm: $scope.state.zqdm,
            jysdm: MMWD.getJysdm(),
            gddm: MMWD.getGddm(),
            wtsl: $scope.state.volume
        };

        var url = 'rzrq/ptyw/zjhq';
        var title = '提示';
        ajaxPost(getApiUrl() + url, postData, function (response) {
            addUserStock($scope.state.consignTypeCurrent.text, $scope.state.zqdm, MMWD.getJysdm());
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].htxh, title);
            $scope.clear();
        }, function (response) {
            Dialog.errorAlert("委托提交失败：" + response.cljg[0].message, title);
        });
    };

    $scope.clear = function (type) {
        var typeValue = $scope.state.huanQuanTypeCurrent.value;
        var state = $scope.defaultState();
        $scope.state = state;
        if (typeValue != '0' && type != 'typeClick') {
            $scope.huanQuanTypeClick($scope.state.huanQuanTypeList[typeValue], 'clear');
        }
    };

    $scope.$watch('$viewContentLoaded', function () {
        MMWD.initZqdm($scope);
    });
});