app.controller('rzrqRzmc', function ($rootScope, $scope, $http, $compile) {
    // 将angularJS变量全局化
    getControllerMethod($rootScope, $scope, $http, $compile);

    $scope.defaultState = function () {
        return {
            page: getLocalData("page"),
            zqdm: '',
            marketId: '',
            subtype: '',
            zqmc: '',
            zqdmStyle: { 'width': '100%' },
            zqdmStyle50: { 'width': '50%' },
            price: '',
            volume: '',

            plus: "BtnPlusBlue",
            minus: "BtnMinusBlue",
            btn_color: "btn-sell",
            btn_name: "卖出",
            type: "卖出数量",
            mmlb: "S",
            volumePlaceholder: "请输入买卖数量",

            // 可买卖数量查询接口
            kmmslcxUrl: 'rzrq/ptyw/rqmckmmslcx2',

            // 当前使用的股东代码对象
            gddmCurrent: { gddm: '' },
            // 股东代码列表
            gddmList: [],
            // 当前使用的委托类型对象
            consignTypeCurrent: { value: '0', text: '限价委托', class: 'active' },
            // 委托类型列表
            consignTypeList: [],
            // 是否禁止委托价格输入框
            isDisabledPrice: false,
            // 是否停牌
            isTP: false,
            // 融券卖出没有高价委托和盘后固定价
            isSetWtlx: false,
            // 资金转入链接是否显示
            assetTransInShow: false,
            // 防止重复提交标识
            isSubmit: false
        };
    };

    $scope.state = $scope.defaultState();

    // 自定义键盘输入回调方法
    window.fillInputContent = function (oldFillInputContent) {
        return function (param, marketId, subtype) {
            if (['zqdm', 'price', 'volume'].indexOf(params.id) > -1) {
                angular.element($("body")).scope().$apply(function () {
                    MMWD.fillInputContent($scope, param, marketId, subtype);
                });
            } else {
                if (typeof oldFillInputContent === 'function') {
                    oldFillInputContent(param, marketId, subtype);
                }
            }
        };
    }(window.fillInputContent);

    // 回原进入该界面后，再传入证券代码信息
    window.jumpToView = function (viewKey, zqdm, marketId, subtype) {
        $scope.clear();
        params.id = 'zqdm';
        window.fillInputContent(zqdm, marketId, subtype);
    };

    $scope.showKeyboard = function (id, type) {
        var isSJWT = $scope.state.consignTypeCurrent.value != 0 && $scope.state.consignTypeCurrent.value != 30;
        if (id == 'price' && isSJWT) {
            return false;
        }
        showKeyboard(id, type);
    };

    // 显示持仓列表
    $scope.showHold = function () {
        // showHold();
        dynGenerateNode($scope, $compile, RightWindowDynamic);

        $scope.isTitleHide = true;
        $scope.thead = [{ name: '名称/代码' }, { name: '可用' }];
        $scope.tbody = [['zqmc', 'zqdm'], ['rqky']];
        $scope.emptyHint = '未查询到融券标的证券!';

        setTimeout(function () {
            var tableHeight = document.documentElement.clientHeight - $(".scrollTable").offset().top;
            $(".scrollTable").height(tableHeight);
        }, 0);

        var url = 'rzrq/ptyw/rqbdzqtccx';
        var postData = {};
        ajaxPost(getApiUrl() + url, postData, function (response) {
            var rowHolds = response.cxlb.map(function (item, index) {
                item.key = index;
                item.rqye = item.rqye || '--';
                item.rqky = item.rqky || '--';
                return item;
            });
            $scope.rowHolds = rowHolds;
        });
    };

    // 关闭持仓列表的弹框
    $scope.closeModal = function () {
        Dialog.closeAlert("RightWindow");
    };

    // 点击持仓列表项
    $scope.fullBargainFrom = function (row) {
        $scope.closeModal();
        $scope.clear();
        params.id = 'zqdm';
        MMWD.fillInputContent($scope, row.zqdm, row.hqscdm, row.hqgplx);
    };

    // 点击委托类型列表项
    $scope.consignType = function (item) {
        $scope.state.consignTypeCurrent = item;
        if (item.value != 0 && item.value != 30) {
            $scope.state.priceTemp = $scope.state.price;
            MMWD.updateWtjg('市价委托');
            $scope.state.isDisabledPrice = true;
        } else {
            MMWD.updateWtjg($scope.state.realTimePrice || '');
            $scope.state.isDisabledPrice = false;
        }
    };

    // 点击股东代码列表项
    $scope.selectedGddm = function (item) {
        $scope.state.gddmCurrent = item;
        MMWD.queryKMMSLCX();
    };

    // 委托价格修改(按钮)
    $scope.wtjgChang = function (type) {
        MMWD.wtjgChang(type);
    };

    $scope.inputPriceBlur = function () {
        if ($scope.state.zqdm != '' && $scope.state.price != '') {
            MMWD.queryKMMSLCX(false, { isloaddingrun: false });
        }
    };

    // 修改委托价格 (最新价、涨停、跌停、五档)
    $scope.updateWtjg = function (value) {
        if (value == '' || value == '--') {
            return;
        }
        if (MMWD.isSJWT() && !$scope.state.isKeChuangBan) {
            return;
        }
        MMWD.updateWtjg(value);
    };

    // 委托数量修改(按钮)
    $scope.wtslChang = function (type) {
        MMWD.wtslChang(type);
    };

    // 仓位按钮
    $scope.calcDepot = function (type) {
        MMWD.calcDepot(type);
    };

    $scope.showModal = function () {
        hideKeyBoard();
        if ($scope.state.isTP) {
            Dialog.customAlert("该股票已经停牌", "提示信息");
            return;
        }
        if ($scope.checkForm()) {
            var modal = {};
            modal.title = '卖出确认';
            modal.content = [{ key: '委托方式', value: $scope.state.consignTypeCurrent.text }, { key: '证券代码', value: $scope.state.zqdm }, { key: '证券名称', value: $scope.state.zqmc }, { key: '委托价格', value: $scope.state.price }, { key: '委托数量', value: $scope.state.volume }];
            if ($scope.state.gddmList.length > 1) {
                modal.content.splice(1, 0, { key: '股东代码', value: $scope.state.gddmCurrent.gddm });
            }
            modal.btnBeforeDynamic = { type: 'cageTips' };
            $scope.state.isSubmit = true;
            Dialog.alert($scope, $compile, modal, {
                rightIcoHide: true,
                rightButtonClick: $scope.showModalConfirm.bind(this)
            });
        }
    };

    $scope.showModalConfirm = function () {
        Dialog.closeAlert();
        console.log('$scope.showModalConfirm');
        // 防止重复提交
        if (!$scope.state.isSubmit) {
            return false;
        }
        $scope.state.isSubmit = false;
        var postData = {
            zqdm: $scope.state.zqdm,
            jysdm: MMWD.getJysdm(),
            gddm: MMWD.getGddm(),
            wtlx: $scope.state.consignTypeCurrent.value,
            wtjg: $scope.state.price,
            wtsl: $scope.state.volume,
            mmlb: $scope.state.mmlb
        };

        var url = "rzrq/ptyw/rqmc";
        var options = {
            specifyServerErrorCode: PROPER_RECONSTRUCTION_FLOOR_TRADING.SPECIFY_SERVER_ERROR_CODE,
            specifyServerErrorCodeMethod: PROPER_RECONSTRUCTION_FLOOR_TRADING.start
        };
        // 普通交易引用 科创板 模块
        KCB.init(options);

        var title = '提示';
        ajaxPost(getApiUrl() + url, postData, function (response) {
            addUserStock($scope.state.consignTypeCurrent.text, $scope.state.zqdm, MMWD.getJysdm());
            Dialog.successAlert("委托提交成功,流水号：" + response.htxx[0].htxh, title);
            $scope.completeOrder();
        }, function (response) {
            Dialog.errorAlert("委托提交失败：" + response.cljg[0].message, title);
        }, options);
    };

    // 点击参考价格回调事件
    $scope.onClickReferencePriceValue = function (value) {
        if (value) {
            MMWD.updateWtjg(value);
        }
    };

    // 点击参考价格旁边问号的回调事件
    $scope.onClickReferencePricWenhao = function () {
        Dialog.customAlert($scope.state.kcbLimitMessage, "温馨提示", false, { rightButtonText: "知道了" });
    };

    // 点击 `全仓` 旁边问号的回调事件，跳转到 `交易规则` 页面
    $scope.onClickJygzWenhao = function () {
        openThirdPartyWebInterface('0', params.THIRD_PARTY_WEB_URL.JYGZ_KEY_URL);
    };

    // 验证表单数据
    $scope.checkForm = function () {
        if ($scope.state.zqdm == '') {
            $("#zqdm").focus();
            return false;
        } else if ($scope.state.price == '') {
            $("#price").focus();
            return false;
        } else if ($scope.state.volume == '') {
            $("#volume").focus();
            return false;
        }
        return true;
    };

    $scope.clear = function () {
        var state = $scope.defaultState();
        $scope.state = state;
    };

    // 完成下单
    $scope.completeOrder = function () {
        $scope.state.volume = '';
        MMWD.queryKMMSLCX();
    };

    $scope.$watch('$viewContentLoaded', function () {
        MMWD.initZqdm($scope);
    });
});