var app = angular.module('rzrqWTXD', []);

app.directive('ytStringHtml', function () {
    return function (scope, el, attr) {
        if (attr.ytStringHtml) {
            scope.$watch(attr.ytStringHtml, function (html) {
                el.html(html || '');
            });
        }
    };
});

/**
 * 买卖五档 (仅支持融资融券的修改)
 */
var MMWD = function () {
    var hqInterval = null;

    var $scope = defaultState();

    function defaultState(scope, object) {
        scope = scope == null ? {} : scope;
        object = object == null ? {} : object;

        var defaultObject = {
            USER_KEY: "ActiveRZRQUser",

            // 可买卖数量查询接口
            kmmslcxUrl: 'rzrq/ptyw/rzmrkmmslcx2',
            // 市价可买卖数量查询接口
            sjkmmslcxUrl: 'rzrq/ptyw/rzmrsjkmmslcx2',

            // 委托数量默认显示 (动态)
            volumePlaceholderDynamic: '',

            // 当前使用的股东代码对象
            gddmCurrent: { jysjc: '', gddm: '' },
            // 股东代码列表
            gddmList: [],
            // 当前使用的委托类型对象
            consignTypeCurrent: {},
            // 委托类型列表
            consignTypeList: [],

            // 主动输入股票代码
            isActiveInput: false,
            // 买卖类别  [B: 买入, S: 卖出]
            mmlb: 'B',
            // 委托价格的最小价差
            zxjc: '',
            // 输入框中的显示的委托价格
            price: '',
            // 委托价格未输入时的提示语
            pricePlaceholder: '请输入委托价格',
            // 输入框中显示委托数量
            volume: '',
            // 用户可以进行的买卖数量
            mmsl: '',
            // 是否设置委托类型
            isSetWtlx: true,
            // 是否科创板
            isKeChuangBan: false,
            // 是否停牌
            isTP: false,
            // 资金转入链接是否显示
            assetTransInShow: false,
            // 开启定时刷新五档
            openInterval: true,
            // 科创板参考价上下限开关
            kcbLimitSwitch: false,
            // 科创板参考价上限
            kcbLimitUpper: '',
            // 科创板参考价下限
            kcbLimitLower: '',
            // 科创板参考价上下限提示语
            kcbLimitMessage: '',
            // 实时价格
            realTimePrice: ''
        };

        scope.state = $.extend(defaultObject, object);

        return scope;
    }

    function init(scope) {
        $scope = defaultState(scope, scope.state);
        if (hqInterval != null) {
            stopInterval();
        }

        if ($scope.state.zqdm.length === 6) {
            // if ($scope.state.zqdm.length === 6 && CheckIsPlus($scope.state.zqdmObj)) {
            startInterval();
        }
    }

    function startInterval() {
        $scope.state.isActiveInput = true;

        queryAppHq();

        // 设置默认股东代码列表
        setGddmList({});

        if ($scope.state.openInterval) {
            hqInterval = setInterval(queryAppHq, getHqTime());
        }
    }

    function stopInterval() {
        clearInterval(hqInterval);
    }

    function queryAppHq() {
        if (isLevel1() && typeof APP_HQ.getWdhq === 'function' && APP_HQ.getWdhq($scope, MMWD.appCallback)) {} else if (isLevel2() && typeof APP_HQ.getSdhqNew === 'function' && APP_HQ.getSdhqNew($scope, MMWD.appCallback)) {} else {
            stopInterval();
        }
    }

    /**
     * APP 回调方法的处理，用于个性化显示
     * @param {*} scope     angularJS 作用域, 不需要传，这是 bind 绑定的值
     * @param {*} data      行情数据 PS: 这是原生传入的值
     * @param {*} kmmxx     可买卖信息 PS：根据行情数据组装的对象
     */
    function appCallback(scope, data, kmmxx) {
        var _data = data.data || {};
        if (_data.stockCode === scope.state.zqdm && _data.marketID === scope.state.marketId) {
            setZqmc(scope, data);
            setKeChuangBanState(data);

            $scope.state.subtype = data.hq_subtype;

            // 下面四个值是 科创板 价格笼子 参考价格 需要使用的
            $scope.state.kcbLimitSwitch = data.kcbLimitSwitch;
            $scope.state.kcbLimitUpper = data.kcbLimitUpper;
            $scope.state.kcbLimitLower = data.kcbLimitLower;
            $scope.state.kcbLimitMessage = data.kcbLimitMessage;

            setKcbLimitStyle(data);

            if ($scope.state.isSetWtlx) {
                setWtlx();
            }
            angular.element($("body")).scope().$apply(function () {
                setWtjg(scope, data, kmmxx);
                scope.state.kmmxx = kmmxx;
            });

            if ($scope.state.isActiveInput) {
                checkTP(data);
                MMWD.queryHQGDDM();
                // MMWD.queryKMMSLCX(true);
            }

            // 扩大买卖五档价格点击区域
            setTimeout(function () {
                ExpendClickArea();
            }, 100);
        }

        $scope.state.isActiveInput = false;
    }

    // 获取股东代码
    function queryHQGDDM() {
        var url = 'rzrq/ptyw/hqgddm';
        var gdlb = COMMON.getRzrqGdlb();
        var postData = {
            zqdm: $scope.state.zqdm,
            hqscdm: $scope.state.marketId,
            hqgplx: $scope.state.subtype,
            gdlb: JSON.stringify(gdlb)
        };

        var successCallback = function successCallback(response) {
            var data = response.fhlb[0];
            if (response.gdlb && response.gdlb.length > 0) {
                data.gdlb = response.gdlb;
            }
            setGddmList(data, MMWD.queryKMMSLCX.bind(MMWD, true));
        };

        var errorCallback = function errorCallback(response) {
            setGddmList({ gdlb: gdlb }, MMWD.queryKMMSLCX.bind(MMWD, true));
        };

        var options = {
            error: function error(xhr, status, _error) {
                setGddmList({ gdlb: gdlb }, MMWD.queryKMMSLCX.bind(MMWD, true));
            }
        };

        ajaxPost(getApiUrl() + url, postData, successCallback, errorCallback, options);
    }

    function queryKMMSLCX(isAppHq, options) {
        if (!$scope.state.zqdm) {
            return;
        }

        var url = isSJWT() ? $scope.state.sjkmmslcxUrl : $scope.state.kmmslcxUrl;
        var postData = {
            zqdm: $scope.state.zqdm,
            hqscdm: $scope.state.marketId,
            hqgplx: $scope.state.subtype,
            gddm: getGddm(),
            wtjg: getWtjg(),
            wtlx: getWtlx(),
            mmlb: $scope.state.mmlb
        };

        var errorCallback = function errorCallback(response) {
            Dialog.customAlert(response.cljg[0].message, "提示信息");
            clearZsl();
        };

        options = options || {};

        ajaxPost(getApiUrl() + url, postData, function (response) {
            var kmmxx = response.kmmxx[0];
            if (isAppHq && $scope.state.mmlb === "B") {
                showRiskWarningFJJJ(response);
            }
            setMmsl(kmmxx);
            setZsl(kmmxx);
        }, errorCallback, options);
    }

    // 设置折算率
    function setZsl(kmmxx) {
        clearZsl();
        $scope.state.zsl = kmmxx.zsl || '';
        $scope.state.rzbzjbl = kmmxx.rzbzjbl ? kmmxx.rzbzjbl + '(融资)' : '';
        $scope.state.rqbzjbl = kmmxx.rqbzjbl ? kmmxx.rqbzjbl + '(融券)' : '';
    }

    // 重置折算率
    function clearZsl() {
        $scope.state.zsl = '';
        $scope.state.rzbzjbl = '';
        $scope.state.rqbzjbl = '';
    }

    // 设置证券名称
    function setZqmc(scope, data) {
        scope.state.zqmc = data.hq_name;
    }

    // 设置科创板的状态
    function setKeChuangBanState(data) {
        if (data.hq_subtype === '129') {
            $scope.state.isKeChuangBan = true;
        }
    }

    // 验证是否停牌
    function checkTP(data) {
        if (data.hq_status === '1') {
            $scope.state.isTP = true;
            Dialog.customAlert("该股票已经停牌", "提示信息");
        }
    }

    // 设置委托价格  (包括最新价、涨跌停价)
    function setWtjg(scope, data, kmmxx) {
        var wtjg = calcWTJG(data, kmmxx);

        scope.state.realTimePrice = wtjg;

        if ($scope.state.isActiveInput) {
            $scope.state.price = wtjg;
            scope.state.zxjc = getSmallCountUnit(wtjg);
        } else {
            wtjg = $scope.state.price + '';
        }

        scope.state.market = {
            // 最近成交价
            zjcjj: data.data.currentPrice || '--',
            // 涨停价
            ztjg: data.hq_limitUp || '--',
            // 跌停价
            dtjg: data.hq_limitDown || '--'
        };
    }

    // 修改委托价格
    function updateWtjg(value) {
        if (Number(value) < 0) {
            value = '';
        }
        $scope.state.price = value + '';
        MMWD.queryKMMSLCX();
    }

    // 获取委托价格
    function getWtjg() {
        var value = '';
        if (!isSJWT()) {
            value = $scope.state.price;
            // 停牌股票 委托价格为零,未对停牌股票信息进行清除
            if (parseFloat(value) == 0) {
                value = '';
            }
        } else {
            if ($scope.state.isKeChuangBan) {
                value = $scope.state.price;
            }
        }
        return value;
    }

    // 设置委托类型
    function setWtlx() {
        appendConsignType();
    }

    // 获取委托类型
    function getWtlx() {
        var value = $scope.state.consignTypeCurrent.value;
        return value;
    }

    // 修改委托数量
    function updateWtsl(value) {
        if (Number(value) < 0) {
            value = '';
        }
        $scope.state.volume = value + '';
    }

    // 设置股东代码列表
    function setGddmList(data, callback) {
        var gddms = [];
        if (data.gdlb && Object.prototype.toString.call(data.gdlb) === "[object Array]") {
            gddms = data.gdlb;
        } else {
            gddms = COMMON.getRzrqGdlb();
        }
        var selectedIndex = gddms.findIndex(function (item) {
            return item.gddm === data.gddm;
        });

        selectedIndex = selectedIndex === -1 ? 0 : selectedIndex;

        $scope.state.gddmCurrent = gddms[selectedIndex] || { jysjc: '', gddm: '' };
        $scope.state.gddmList = gddms;

        if (typeof callback === "function") {
            callback();
        }
    }

    // 获取股东代码
    function getGddm() {
        return $scope.state.gddmCurrent.gddm || '';
    }

    // 获取交易所代码
    function getJysdm() {
        return $scope.state.gddmCurrent.jysdm || '';
    }

    // 设置买卖数量
    function setMmsl(kmmxx) {
        var wtdw = kmmxx.wtdw || '股';
        var isGz = isGZ($scope.state.zqdm);
        var isGznhg = isZQHG($scope.state.zqdm);
        var mmslPlaceholder = '';
        var mmsl = '';
        var prefix = '';

        if (isGz || isGznhg) {
            wtdw = '张';
        }

        // 服务器返回的可买卖数量字段名称有时为kmmsl,有时为kmsl,哪个字段名称存在,
        // 可买卖数量就取哪个字段名称
        if (kmmxx.kmmsl) {
            mmsl = kmmxx.kmmsl;
        } else if (kmmxx.kmsl) {
            mmsl = kmmxx.kmsl;
        }

        if (isGznhg) {
            mmsl = ($scope.state.mmlb === "B" ? kmmxx.kmsl : kmmxx.gfkys) || 0;
            prefix = '可卖出';
        } else if ($scope.state.mmlb === "B") {
            prefix = '可买入';
        } else {
            mmsl = kmmxx.gfkys;
            prefix = '可卖出';
        }

        $scope.state.mmsl = mmsl;

        if (mmsl === void 0 || mmsl === '') {
            mmsl = '--';
        }

        mmslPlaceholder = prefix + mmsl + wtdw;

        if ($scope.state.volumePlaceholderDynamic != '') {
            mmslPlaceholder = $scope.state.volumePlaceholderDynamic.replace("$1", parseInt(mmsl)).replace("$2", wtdw);
        }

        $scope.state.volumePlaceholder = mmslPlaceholder;
    }

    /**
     * 根据 marketId 获取普通交易的股东代码 (优先取主股东代码)
     * @param {String} marketId
     */
    function getPtjyGddmMarketId(marketId) {
        if (Number(marketId).toString() == 'NaN') {
            return '';
        }

        var gddms = getPtjyGdlbMarketId(marketId);

        return gddms.length > 0 ? gddms[0].gddm : '';
    }

    /**
     * 根据 marketId 获取普通交易的股东代码列表 (优先取主股东代码)
     * @param {String} marketId
     */
    function getPtjyGdlbMarketId(marketId) {
        try {
            var user = JSON.parse(getLocalData($scope.state.USER_KEY));
            var arr = user.body.gdlb;
            var gddms;
            // 过滤出该 marketId 对应股东代码列表
            // gddms = arr.filter(item => item.hqscdm === marketId);
            gddms = arr.filter(function (item) {
                return item.hqscdm === marketId;
            });
            // 排序，主股东代码显示最上面
            // gddms = gddms.sort((a, b) => b.zcbz === '0'  ? 0 : -1);
            gddms = gddms.sort(function (a, b) {
                return b.zcbz === '0' ? 0 : -1;
            });

            return gddms;
        } catch (e) {}
        return [];
    }

    // 添加委托类型列表
    function appendConsignType() {
        var consignTypeListSz = [{ value: '0', text: '限价委托', class: 'active' }, { value: '1', text: '对方最优价格', class: '' }, { value: '2', text: '本方最优价格', class: '' }, { value: '3', text: '即时成交剩余撤销', class: '' }, { value: '4', text: '五档即成撤销', class: '' }, { value: '5', text: '全额成交或撤销', class: '' }];

        var consignTypeListSh = [{ value: '0', text: '限价委托', class: 'active' }, { value: '4', text: '最优五档即时成交剩余撤销', class: '' }, { value: '6', text: '最优五档即时成交剩余转限价', class: '' }];

        var consignTypeListKcb = [{ value: '1', text: '对方最优价格', class: '' }, { value: '2', text: '本方最优价格', class: '' }];

        if ($scope.state.marketId === '1') {
            // 深圳交易所
            $scope.state.consignTypeList = consignTypeListSz;
        } else if ($scope.state.marketId === '2') {
            // 上海交易所
            $scope.state.consignTypeList = consignTypeListSh;
            if ($scope.state.isKeChuangBan) {
                $scope.state.consignTypeList = consignTypeListSh.concat(consignTypeListKcb);
            }
        } else {
            $scope.state.consignTypeList = [];
        }

        // 设置默认选择项
        // $("#consign .consign-type").text($("#consign").find(".dropdown-menu.active li").eq(0).text());

        // 切换市场时,委托类型默认为限价委托,如果禁用了价格输入框,则应恢复正常输入功能
        // $("#price").removeAttr("disabled");
        // $(".btn-price").removeAttr("disabled");
    }

    /**
     * 计算出委托价格
     * @param  {[Arrar]}    kmmxx 可买卖信息
     * @return {[String]}   委托价格
     */
    function calcWTJG(data, kmmxx) {
        var wtjg = '';
        var jg1 = kmmxx[0] || {};
        if ($scope.state.mmlb == 'B') {
            if (jg1.sell != '' && jg1.sell != '--' && jg1.sell > 0) {
                wtjg = jg1.sell;
            } else if (data.data.currentPrice != '' && data.data.currentPrice > 0) {
                wtjg = data.data.currentPrice;
            } else {
                wtjg = data.data.closePrice;
            }
        } else if ($scope.state.mmlb == 'S') {
            if (jg1.buy != '' && jg1.buy != '--' && jg1.buy > 0) {
                wtjg = jg1.buy;
            } else if (data.data.currentPrice != '' && data.data.currentPrice > 0) {
                wtjg = data.data.currentPrice;
            } else {
                wtjg = data.data.closePrice;
            }
        }

        wtjg = wtjg == null || wtjg == '--' ? '' : wtjg;

        return wtjg;
    }

    /**
     * 是国债代码
     * @param  {[String]}  zqdm [证券代码]
     * @return {Boolean}        [true: 是国债, false: 非国债]
     */
    function isGZ(zqdm) {
        if (zqdm >= '010107' && zqdm <= '010713' || // 上海 国债
        zqdm >= '019002' && zqdm <= '019932' || // 上海 国债
        zqdm >= '020125' && zqdm <= '020151' || // 上海 国债
        zqdm >= '130077' && zqdm <= '140903' || // 上海 地方债
        zqdm >= '120201' && zqdm <= '132007' || // 上海 公司债
        zqdm >= '110030' && zqdm <= '113010' || // 上海 可转换债列表
        zqdm >= '100213' && zqdm <= '128013' || // 深圳 债券
        zqdm >= '128009' && zqdm <= '128012' || // 深圳 可转换债
        zqdm == '123001' // 深圳 可转换债
        ) {
                return true;
            }

        return false;
    }

    /**
     * 是债券回购
     * 融出去还能回来，合约到期后就回来
     * @param  {[String]}  zqdm [证券代码]
     * @return {Boolean}        [true: 是, false: 否]
     */
    function isZQHG(zqdm) {
        // 债券逆回购虽为卖出,但委托数量取的是可买卖数量
        if (zqdm >= '131800' && zqdm <= '131899' || // 深圳 债券回购
        zqdm >= '201000' && zqdm <= '204999' // 上海 债券回购
        ) {
                return true;
            }

        return false;
    }

    /**
     * 是否市价委托
     */
    function isSJWT() {
        var item = $scope.state.consignTypeCurrent;
        return !(item.value == '0' || item.value == '30');
    }

    /**
     * 委托价格自动加减值
     * @param {String} type
     */
    function wtjgChang(type) {
        if (isSJWT() && !$scope.state.isKeChuangBan) {
            return;
        }
        var zxjc = Number($scope.state.zxjc);
        var wtjg = Number($scope.state.price);
        console.log(type, zxjc);
        switch (type) {
            case '+':
                {
                    updateWtjg(add(wtjg, zxjc));
                    break;
                }
            case '-':
                {
                    updateWtjg(sub(wtjg, zxjc));
                    break;
                }
        }
    }

    /**
     * 委托数量自动加减值
     * @param {String} type
     */
    function wtslChang(type) {
        var zxjc = $scope.state.isKeChuangBan ? 1 : 100;
        var volume = Number($scope.state.volume);
        console.log(type, zxjc);
        switch (type) {
            case '+':
                {
                    updateWtsl(add(volume, zxjc));
                    break;
                }
            case '-':
                {
                    updateWtsl(sub(volume, zxjc));
                    break;
                }
        }
    }

    /**
     * 仓位按钮
     * @param {*} type
     */
    function calcDepot(type) {
        switch (Number(type)) {
            case 1:
                {
                    updateWtsl($scope.state.mmsl);
                    break;
                }
            case 2:
            case 3:
            case 4:
                {
                    var mmsl = '';
                    if ($scope.state.mmsl === '') {} else if ($scope.state.isKeChuangBan) {
                        mmsl = parseInt(divi($scope.state.mmsl, Number(type)));
                    } else {
                        mmsl = parseInt(divi($scope.state.mmsl, Number(type)) / 100) * 100;
                    }
                    updateWtsl(mmsl);
                    break;
                }
        }
    }

    // 科创板保护限价的提示
    function kcbWarning(mmlb) {
        if (isSJWT() && $scope.state.isKeChuangBan) {
            var msg = mmlb == 'B' ? '请输入保护限价，科创板市价委托买入申报的成交价格和转限价的价格不高于保护限价。' : '请输入保护限价，科创板市价委托卖出申报的成交价格和转限价的价格不低于保护限价。';
            Dialog.customAlert(msg, "", false, {
                titleHide: true,
                rightButtonText: '知道了'
            });
        }
    }

    // 本地存储中存在证券代码则需要初始加载
    function initZqdm($scope) {
        var zqdm = getLocalData('zqdm');
        if (zqdm != null) {
            removeLocalData('zqdm');
            zqdm = zqdm.split("|");
            params.id = 'zqdm';
            fillInputContent($scope, zqdm[0], zqdm[1] || '', zqdm[2] || '');
        }
    }

    function fillInputContent($scope, param, marketId, subtype) {
        console.log(['fillInputContent', param, marketId, subtype].join(', '));

        switch (param) {
            case 'del':
                {
                    if ($scope.state[params.id]) {
                        var _value = $scope.state[params.id];
                        if (typeof _value === 'number') {
                            _value = _value.toString();
                        }
                        $scope.state[params.id] = _value.substring(0, _value.length - 1);
                    }
                    break;
                }
            case '1/4仓':
                {
                    calcDepot(4);
                    break;
                }
            case '1/3仓':
                {
                    calcDepot(3);
                    break;
                }
            case '1/2仓':
                {
                    calcDepot(2);
                    break;
                }
            case '全仓':
                {
                    calcDepot(1);
                    break;
                }
            default:
                {
                    if ($scope.state[params.id] != null) {
                        switch (params.id) {
                            case 'zqdm':
                                {
                                    $scope.state.zqdm = $scope.state.zqdm + param;
                                    $scope.state.marketId = marketId;
                                    $scope.state.subtype = subtype;
                                    MMWD.init($scope);
                                    break;
                                }
                            case 'price':
                                {
                                    var price = $scope.state.price;
                                    if (typeof price === 'number') {
                                        price = price.toString();
                                    }
                                    if (price.indexOf('.') > -1 && param == '.') {
                                        // showMessageTips('委托价格不允许输入两位小数点!');
                                    } else {
                                        $scope.state.price = price + param;
                                    }
                                    break;
                                }
                            case 'volume':
                                {
                                    // 委托数量的最大长度，服务器只支持 10 位
                                    var maxWtslLength = 10;
                                    var volume = $scope.state.volume;
                                    if (typeof volume === 'number') {
                                        volume = volume.toString();
                                    }
                                    // 是否支持小数点   默认不支持小数点，需要在页面设置属性才能支持
                                    var supportDecimalPoint = document.getElementById(params.id).getAttribute('attr-decimal-point') === 'true' ? true : false;
                                    if (param == "." && !supportDecimalPoint) {
                                        // showMessageTips('委托数量不允许有小数点!');
                                    } else if (volume.length < maxWtslLength) {
                                        $scope.state.volume = volume + param;
                                    }
                                    break;
                                }
                        }
                    }
                    break;
                }
        }
    }

    /**
     * 功能：  除法函数
     * 传参：  a:被除数     b:除数
     * 返回：  a除以b的精确结果
     */
    function divi(a, b) {
        var t1 = 0,
            t2 = 0,
            r1,
            r2;

        try {
            t1 = a.toString().split(".")[1].length;
        } catch (e) {}

        try {
            t2 = b.toString().split(".")[1].length;
        } catch (e) {}

        r1 = Number(a.toString().replace(".", ""));
        r2 = Number(b.toString().replace(".", ""));
        var reslut = r1 / r2 * Math.pow(10, t2 - t1);
        return reslut;
    }

    /**
     * 设置科创板价格笼子提示价格的颜色值
     */
    function setKcbLimitStyle(data) {
        var closePrice = parseFloat(data.data.closePrice);
        var kcbLimitUpper = parseFloat(data.kcbLimitUpper);
        var kcbLimitLower = parseFloat(data.kcbLimitLower);
        $scope.state.buyStyle = kcbLimitUpper > closePrice ? ' up-color' : kcbLimitUpper < closePrice ? ' down-color' : '';
        $scope.state.sellStyle = kcbLimitLower > closePrice ? ' up-color' : kcbLimitLower < closePrice ? ' down-color' : '';
    }

    return {
        initZqdm: initZqdm,
        init: init,
        appCallback: appCallback,
        wtjgChang: wtjgChang,
        updateWtjg: updateWtjg,
        wtslChang: wtslChang,
        calcDepot: calcDepot,
        queryHQGDDM: queryHQGDDM,
        queryKMMSLCX: queryKMMSLCX,
        getGddm: getGddm,
        getJysdm: getJysdm,
        fillInputContent: fillInputContent,
        setGddmList: setGddmList,
        kcbWarning: kcbWarning,
        isSJWT: isSJWT,
        setZsl: setZsl,
        clearZsl: clearZsl
    };
}();